/* macCellGroup.h --
 *
 *      June Wang
 *      Wei-ming Dai
 *      (Prof. E. S. Kuh)
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Include/macCellGroup.h,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $
 */

#ifndef _MAC_CELL_GROUP
#define _MAC_CELL_GROUP

typedef struct _LinkedCell
{
    struct _GenericCell     *cellPtr;   /* Pointer to generic cell type     */
    struct _LinkedCell      *nextPtr;   /* Pointer to another linked cell   */
} LinkedCell;

typedef struct _CellGroup
{
    LinkedCell *cellList;       /* A list of generic cells (cell
                                         * instances or routing cells)
                     */
} CellGroup;

extern struct _LinkedCell *Mac_MakeLinkedCell ();

extern BearStatus Mac_CreateCellGroup(/* cellClass, cellPtr, cellGroupPtrPtr */);
/*
 *  CellClass   *cellClass;
 *  ClientData  *cellPtr;
 *  CellGroup   **cellGroupPtrPtr;
 */

extern bool Mac_IsGroupedCell(/* cellClass, cellPtr */);
/*
 * CellClass    cellClass;
 * ClientData   cellPtr;
 */

extern bool
Mac_IsMemberOfCellGroup(/* cellClass, cellPtr, cellGroupPtr */);
/*
 * CellClass   cellClass;
 * ClientData  *cellPtr;
 * CellGroup   *cellGroupPtr;
 */

extern BearStatus Mac_MergeCellGroup(/* cellGroup1Ptr, cellGroup2Ptr, 
                     newGroupPtrPtr */);
/*
 * CellGroup    *cellGroup1Ptr; 
 * CellGroup    *cellGroup2Ptr; 
 * CellGroup    **newGroupPtrPtr;
 */

extern BearStatus Mac_ItrCellGroup (/* cellGroupPtr, func, clientData */);
/*
 *  CellGroup   *cellGroupPtr;
 *  BearStatus  (*func)();
 *  ClientData  clientData;
 */

#endif _MAC_CELL_GROUP
