
/* macRPinPrim.h --
 *
 *     Wei-ming Dai
 *     June Wang
 *     (Professor E. S. Kuh)
 *
 * It declares the external subroutines used to retrieve and update the
 * information in routing pins.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Include/macRPinPrim.h,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $
 */

#ifndef _MAC_RPIN_PRIM
#define _MAC_RPIN_PRIM

extern void Mac_MarkRPin(/* rpinPtr */); 
/*
 *  RoutePin  *rpinPtr;
 */
  
extern BearId Mac_GetIdOfRPin(/*rpinPtr*/); 
/*
 *  RoutePin  *rpinPtr;
 */
  
extern void Mac_PutIdOfRPin(/*id, rpinPtr*/); 
/*
 *  BearId  id;
 *  RoutePin  *rpinPtr;
 */
  
extern BearId Mac_GetIntNetIdOfRPin(/*rpinPtr*/); 
/*
 *  RoutePin  *rpinPtr;
 */
  
extern void Mac_PutIntNetIdOfRPin(/*intNetId, rpinPtr*/); 
/*
 *  BearId  intNetId;
 *  RoutePin  *rpinPtr;
 */
  
extern BearId Mac_GetExtNetIdOfRPin(/*rpinPtr*/); 
/*
 *  RoutePin  *rpinPtr;
 */
  
extern void Mac_PutExtNetIdOfRPin(/*extNetId, rpinPtr*/); 
/*
 *  BearId  extNetId;
 *  RoutePin  *rpinPtr;
 */
  
extern BearId Mac_GetHExtNetIdOfRPin(/*rpinPtr*/);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutHExtNetIdOfRPin(/*id, rpinPtr*/);
/*
 *  BearId    id;
 *  RoutePin  *rpinPtr;
 */

extern BearId Mac_GetVExtNetIdOfRPin(/*rpinPtr*/);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutVExtNetIdOfRPin(/*id, rpinPtr*/);
/*
 *  BearId    id;
 *  RoutePin  *rpinPtr;
 */

extern Point *Mac_GetRelPosOfRPin(/*rpinPtr*/);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutRelPosOfRPin(/*relPos, rpinPtr*/);
/*
 *  Point   *relPos;
 *  RoutePin  *rpinPtr;
 */

extern void Mac_GetAbsPosOfRPin(/*rpinPtr, absPos*/);
/*
 *  RoutePin  *rpinPtr;
 *  Point   *absPos;
 */

extern PinDirection Mac_GetDirectionOfRPin(/* rpinPtr */);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutDirectionOfRPin(/* direction, rpinPtr */);
/*
 * PinDirection direction;
 * RoutePin     *rpinPtr;
 */

extern float Mac_GetPinWidthOfRPin(/* rpinPtr */);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutPinWidthOfRPin(/* width, rpinPtr*/);
/*
 *  float  width;
 *  RoutePin  *rpinPtr;
 */

extern float Mac_GetSegmWidthOfRPin(/* rpinPtr */);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutSegmWidthOfRPin(/* segmWidth, rpinPtr*/);
/*
 *  float  segmWidth;
 *  RoutePin  *rpinPtr;
 */

extern float *Mac_GetWidthVectOfRPin(/* rpinPtr */);
/* 
 * RoutePin  *rpinPtr;
 */

extern void Mac_PutWidthVectOfRPin(/* widthVect, rpinPtr */);
/* 
 * float    *widthVect;
 * RoutePin *rpinPtr;
 */

extern Flexibility Mac_GetFlexOfRPin(/* rpinPtr */);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutFlexOfRPin(/* positionFlag, rpinPtr */);
/*
 *  Flexibility positionFlag;
 *  RoutePin    *rpinPtr;
 */

extern LayerVector Mac_GetLayerofRPin(/* rpinPtr */);
/*
 *  RoutePin    *rpinPtr;
 */

extern void Mac_PutLayerOfRPin(/* layer, rpinPtr */);
/*
 *  int         layer;
 *  RoutePin    *rpinPtr;
 */

extern Net *Mac_GetNetPtrOfRPin(/* rpinPtr */);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutNetPtrOfRPin(/* netPtr, rpinPtr */);
/*
 *  Net *netPtr;
 *  RoutePin  *rpinPtr;
 */

extern int Mac_GetOrderOfRPin(/* rpinPtr */);
/*
 *  RoutePin  *rpinPtr;
 */

extern void Mac_PutOrderOfRPin(/* order, rpinPtr */);
/*
 *  int order;
 *  RoutePin  *rpinPtr;
 */

extern ClientData Mac_GetPinOfRPin(/* rpinPtr */);
/*
 * RoutePin    *rpinPtr;
 */

extern void Mac_PutPinOfRPin(/* pinPtr, rpinPtr */);
/*
 * ClientData    pinPtr;
 * RoutePin      *rpinPtr;
 */

#endif _MAC_RPIN_PRIM

