
/* bfpInterface.h --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 * Definitions external to the bfpInterface (bear floor planning
 * interface) module.
 *
 * Copyright (C) 1991 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/bfpInterface/bfpInterface.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef BFP_INTERFACE_EXPORT_H
#define BFP_INTERFACE_EXPORT_H /* once-only latch */

#include "ansi.h"

#define BFP_MOD_NAME    "bfpInterface"

#define BFP_VERSION     "1.0"

typedef struct _Bfp_ReadOptions Bfp_ReadOptions;
struct _Bfp_ReadOptions {
    BearDummy dummy;                /* currently not used */
};

typedef struct _Bfp_WriteOptions Bfp_WriteOptions;
struct _Bfp_WriteOptions {
    bool        pinFlag;
    double      xScale, yScale;     
    bool        scaleFlag;          /* TRUE if both xScale and yScale do
                                     * NOT equal one.
                                     */
};


/* ---------- External procedures for the bfpInterface module ---------- */

EXTERN BearStatus Bfp_BearFPToMac 
    ARGS((BearString bearFPFileName, Bfp_ReadOptions *readOptsPtr, 
        CellMaster **coreMasterPtrPtr));

EXTERN BearStatus Bfp_MacToBearFP
     ARGS((BearString bearFPFileName, Bfp_WriteOptions *writeOptsPtr,
        CellMaster *coreMasterPtr));

#endif /* BFP_INTERFACE_EXPORT_H */

