
/* geoChDecomposerInt.h --
 *
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1989 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/geoChDecomposer/geoChDecomposerInt.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _GEO_CH_DECOMPOSER_INT
#define _GEO_CH_DECOMPOSER_INT

typedef enum _BoundStatus
{
    UNSTARTED,
    STARTED,
    ENDED
} BoundStatus;

typedef struct _BoundSrInfo
{
    BoundStatus trBoundStatus;
    BoundStatus blBoundStatus;
    Point       *trTLPointPtr;
    Point       *blTLPointPtr;
    LinkedPoint **trBoundPtr;
    LinkedPoint **blBoundPtr;
    Rect        prevTileRect;
} BoundSrInfo;


extern BearStatus GcdTraceLeftEndBoundary(/* lJunctPtr, lBnRectPtr, domRectPtr,
                       topBoundPtr, bottomBoundPtr */);
/*
 * WallJunction    *lJunctPtr;
 * Rect            *lBnRectPtr;
 * Rect            *domRectPtr;
 * LinkedPoint     **topBoundPtr;
 * LinkedPoint     **bottomBoundPtr;
 */

extern BearStatus GcdTraceHorzMidBoundary(/* lBnRectPtr, rBnRectPtr, domRectPtr,
                       topBoundPtr, bottomBoundPtr */);
/*
 * Rect            *lBnRectPtr;
 * Rect            *rBnRectPtr;
 * Rect            *domRectPtr;
 * LinkedPoint     **topBoundPtr;
 * LinkedPoint     **bottomBoundPtr;
 */

extern BearStatus GcdTraceRightEndBoundary(/* rJunctPtr, rBnRectPtr, domRectPtr,
                        topBoundPtr, bottomBoundPtr */);
/* WallJunction    *rJunctPtr;
 * Rect            *rBnRectPtr;
 * Rect            *domRectPtr;
 * LinkedPoint     **topBoundPtr;
 * LinkedPoint     **bottomBoundPtr;
 */

extern  BearStatus GcdTraceTopEndBoundary(/* tJunctPtr, tBnRectPtr, domRectPtr,
                           leftBoundPtr, rightBoundPtr */);
/*
 * WallJunction    *tJunctPtr;
 * Rect            *tBnRectPtr;
 * Rect            *domRectPtr;
 * LinkedPoint     **leftBoundPtr;
 * LinkedPoint     **rightBoundPtr;
 */

extern BearStatus GcdTraceVertMidBoundary(/* tBnRectPtr, bBnRectPtr, domRectPtr,
                       leftBoundPtr, rightBoundPtr */);
/*
 * Rect            *tBnRectPtr;
 * Rect            *bBnRectPtr;
 * Rect            *domRectPtr;
 * LinkedPoint     **leftBoundPtr;
 * LinkedPoint     **rightBoundPtr;
 */

extern  BearStatus GcdTraceBottomEndBoundary(/* bJunctPtr, bBnRectPtr, domRectPtr,
                            leftBoundPtr, rightBoundPtr */);
/*
 * WallJunction    *bJunctPtr;
 * Rect            *bBnRectPtr;
 * Rect            *domRectPtr;
 * LinkedPoint     **leftBoundPtr;
 * LinkedPoint     **rightBoundPtr;
 */

extern BearStatus
GcdTraceNWCornerBoundary(/* horzBnRectPtr, vertBnRectPtr, junctPtr,
                          * loBoundPtr, hiBoundPtr
                          */);
/*
 * Rect         *horzBnRectPtr;
 * Rect         *vertBnRectPtr;
 * WallJunction *junctPtr;
 * LinkedPoint  **loBoundPtr;
 * LinkedPoint  **hiBoundPtr;
 */

extern BearStatus
GcdTraceSWCornerBoundary(/* horzBnRectPtr, vertBnRectPtr, 
                          * junctPtr, loBoundPtr, hiBoundPtr
                          */);
/* 
 * Rect         *horzBnRectPtr;
 * Rect         *vertBnRectPtr;
 * WallJunction *junctPtr;
 * LinkedPoint  **loBoundPtr;
 * LinkedPoint  **hiBoun
 */

extern BearStatus GcdTraceSECornerBoundary();
extern BearStatus GcdTraceNECornerBoundary();

extern void GcdGetShapeOfRouteCell(/* rCellPtr, pointList */);

extern PlaneData   *gcdPlaneDataPtr;
extern Plane       *gcdHorzPlanePtr;
extern Plane       *gcdVertPlanePtr;

#endif _GEO_CH_DECOMPOSER_INT

