
/* grStorage.h --
 *
 *     Malgorzata Marek-Sadowska
 *     (Professor E. S. Kuh)
 *
 * Copyright (C) 1988 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/grEditor/grStorage.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _GR_STORAGE
#define _GR_STORAGE

typedef struct _grEd_Node
{
    BearId              name;
    WallJunction        *jPtr;
    struct _grEd_Node   *nextNode;

} grEd_Node;

typedef struct _grEd_Btn
{
    Tile                *tilePtr;
    BearId              name;
    int                 ltmark;
    int                 rbmark;
    struct _grEd_Btn    *nextBtn;

}  grEd_Btn;

typedef struct _grEd_BtnLine
{
    Tile                    *tilePtr;
    BNLine                  *bnLinePtr;
    int                     cross;
    struct _grEd_BtnLine    *nextBtnLine;

} grEd_BtnLine;

typedef struct _greLinkedDomTile
{
    Tile                        *tilePtr;
    struct _greLinkedDomTile    *nextPtr;

} greLinkedDomTile;

/*
 * Here are local functions used by the code that store the global
 * routing in the mac data base, and the tile plane.
 */

extern Tile  *grEd_GetPtrOfDomTileCoveringPin();
extern Tile  *grEd_GetPtrOfDomTileLeftTopFromPin();
extern Tile  *grEd_GetPtrOfDomTileRightBotFromPin();
extern Tile  *grEd_GetContainingPinDomTile();

extern grEd_Btn     *grEd_FindEd_Btn();
extern grEd_BtnLine *grEd_FindEd_BtnLine();
extern grEd_Node    *grEd_FindEd_Node();
     
extern WallSegment *grEd_GetCoveringWallSegment();

extern void grEd_FillInBtncks();
extern void grEd_FillInBtnLines();

extern void grEd_StoreJunctData();
extern void grEd_FreeJunctData();

extern void GreCreateLinkedDomTiles();
extern void GreDisposeLinkTiles();

extern PseudoPin *grEd_InsertPPinToBtnLine();
extern PseudoPin *grEd_InsertPPinToLeftTopSide();
extern PseudoPin *grEd_InsertPPinToRightBotSide();

extern int grEd_GetBtn();
extern BearStatus grEd_GetBnLines();
extern BearStatus grEd_InsertEdgeOfGraph();
extern int GreLinkTiles();


/* 
 * Here are global variables for files which insert data to Mac
 */

extern grEd_Node        *greNodeListHeadPtr;
extern grEd_Btn         *greBtnListHeadPtr;
extern grEd_BtnLine     *greBtnLineHeadPtr;
extern greLinkedDomTile *greHeadLinkedDomTiles;
extern PlaneData        *grePlaneDataPtr;
extern FloorPlanGraph   *greFpgPtr;
extern Net              *greNetPtr;

#endif _GR_STORAGE

