
/* gtGraphInt.h --
 *
 *     George Carvalho
 *     Wei-ming Dai
 *     June Wang
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1990 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/gtGraph/gtGraphInt.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 *
 */

#ifndef _GT_GRAPH_INT
#define _GT_GRAPH_INT /* once-only latch */

#include "array.h"
#include "list.h"
#include "graph.h"


typedef struct _Gt_GraphInt {
    graph_t      g;             /* For internal use only            */
    BearId       id;            /* The graphs identification number */
    unsigned int numOfNodes;    /* Number of nodes in the graph     */
    unsigned int numOfEdges;    /* Number of edges in the graph     */
    BearGeneric  graphData;     /* User supplied data               */
} Gt_GraphInt;

typedef struct _Gt_GraphNodeInt {
    vertex_t    v;              /* For internal use only            */
    BearId      id;             /* The nodes identification number  */
    int         index;          /* For internal use only            */
    int         mark;           /* For internal use only            */
    BearGeneric nodeData;       /* User supplied data               */
} Gt_GraphNodeInt;

typedef struct _Gt_GraphEdgeInt {
    edge_t      e;              /* For internal use only            */
    BearId      id;             /* The nodes identification number  */
    int         mark;           /* For internal use only            */
    BearGeneric edgeData;       /* User supplied data               */
} Gt_GraphEdgeInt;

typedef enum _Gt_NodeStatus {
    INTREE, FRINGE, UNSEEN
} Gt_NodeStatus;

typedef struct _Gt_AlgDataInt {
    Gt_GraphNodeInt *intNodePtr;

    Gt_NodeStatus   status;
    int             fringe;
    int             weight;
    int             parent;

    lsList          adjList; /* adjacency node list */
} Gt_AlgDataInt;

typedef struct _Gt_AdjNode { /* adjacent node structure */
    int             weight;
    int             index;
} Gt_AdjNode;


#endif _GT_GRAPH_INT

