/*
 * macGPin.h --
 *
 *     Wei-Ming Dai
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * needs: magic.h bear.h ...
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/mac/macGPin.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _MAC_GPIN
#define _MAC_GPIN

typedef enum _PinType
{
    PIN_INST,       /* Pin instance */
    ROUTE_PIN       /* Route pin    */
} PinType;

typedef struct _GenericPin
{
    PinType      pinType;     
    union
    {
    PinInst          *pinInstPtr;     /* pinType = PIN_INST  */
    struct _RoutePin *routePinPtr;    /* pinType = ROUTE_PIN */
    } pinPtrUn;
} GenericPin;

typedef struct _LinkedGPin
{
    GenericPin         *gPinPtr;    /* Pointer to a generic pin              */
    struct _LinkedGPin *nextPtr;    /* Pointet to another linked generic pin */
} LinkedGPin;

BearStatus Mac_CreateGPin(/* pinType, pinPtr, gPinPtrPtr */);
/*
 * PinType     pinType;
 * ClientData  pinPtr;
 * GenericPin  **gPinPtrPtr;
 */

#endif _MAC_GPIN
