
/* magInterfaceInt.h --
 *
 *     Francisco Wei
 *     (Professor E. S. Kuh)
 *
 * Copyright (C) 1989 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/magInterface/magInterfaceInt.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _MAGIC_INTERFACE_INT
#define _MAGIC_INTERFACE_INT

/*--------------------------------------------------------------------
 *  magic2bear.h
 *--------------------------------------------------------------------
 */

#define MAXLEN 256
#define WORDLEN 40 
#define HORI_TRACK_SPACE 1
#define VERT_TRACK_SPACE 1
#define HORI_EDGE_CLEAR 1
#define VERT_EDGE_CLEAR 1

#define  abs(x)   ( (x)>0 ? (x) : -(x) )

#define   CLOCK0       0 
#define   CLOCK90      1 
#define   CLOCK180     2 
#define   CLOCK270     3 

char buffer[MAXLEN],
     layer[WORDLEN],
     label[WORDLEN],
     word[WORDLEN],
     key[WORDLEN];



/*--------------------------------------------------------------------
 * Structure definition for a terminal
 * direction for routing: 0:left, 1:down, 2:right, 3:up
 * type:0(floating),1(edge fixed),2(fixed),3(routing fixed);
 * layer: layer type
 *--------------------------------------------------------------------
 */
typedef struct _terminal {
    char         termName[MAXLEN],   /* name of terminal on cell      */
                 layer[MAXLEN];      /* m1, m2 or poly.  not used yet */ 
    Point        location;           /* x,y position of terminal      */
    int          netNum,             /* net number terminal conn. to  */
                 width,
                 type,               /* preset to 2                   */
                 direction;          /* direction for routing         */ 
    struct _module    *parent;       /* cell containing terminal      */
    struct _terminal  *next;
} Terminal;

/*--------------------------------------------------------------------
 * Structure definition for a module to be routed
 *--------------------------------------------------------------------
 */
typedef struct _module {
    char              instance[MAXLEN], /* name of cell instance */
                      cellname[MAXLEN]; /* name of cell */
    Rect              bbox;             /* bounding box info */
    int               type;             /* 0:parent; 1:internal module */
    Transform         transform;        /*   */
    Terminal         *termptr;
    struct _module   *nextModule;
} Module;

#endif _MAGIC_INTERFACE_INT

