
/* newGInt.h --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 * Definitions internal to the newG (new global router) module.
 *
 * Copyright (C) 1990 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/newG/newGInt.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _NEW_GLOBAL_ROUTER_INT_H
#define _NEW_GLOBAL_ROUTER_INT_H

#define Bear_PrintFatalErr You_should_use_the_procedure_NgrPrintFatalErr instead

#define NGR_LOWER_PIN_CUT_OFF 20

#define BASE_NODE_OF_PIN(X) \
    (((PinData *) (X)->ngrModulePtr)->baseNode)

#define COMP_NODE_OF_PIN(X) \
    (((PinData *) (X)->ngrModulePtr)->compNode)

typedef struct _PinData {
    Gt_GraphNode baseNode;
    Gt_GraphNode compNode;
} PinData;

typedef struct _BldTreeDataInt {
    CellMaster      *cellMasterPtr;
    PlaneData       *planeDataPtr;
    FloorPlanGraph  *fpgPtr;

    Net             *netPtr;
    int             pinCount;  /* The number of pins in the net. */
    Gt_Graph        baseGraph;
    Gt_Graph        compGraph;
    bool            haveTreeFlag;

    int             nodeNum;
    int             edgeNum;
} BldTreeDataInt;

typedef struct _Ngr_BaseEdgeData {
    int     distance;
    int     mark;
} Ngr_BaseEdgeData;

typedef struct _Ngr_CompEdgeData {
    Gt_Path *pathPtr;
} Ngr_CompEdgeData;

/* ---------- Internal procedures for the newGlobalRouter module ---------- */

extern void NgrPrintFatalErr(/* message */);
/*
 * BearString message;
 */

extern void NgrFreeBaseEdgeData();
extern void NgrFreeCompEdgeData();

#endif _NEW_GLOBAL_ROUTER_INT_H

