
/* tpTilePrim.h --
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/Installed/tileProp/tpTilePrim.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _TP_TILEPRIM
#define _TP_TILEPRIM

/* ---------- Tile Property Primitives ---------- */

extern bool Tp_IsSpaceTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsSolidTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsTileFilled(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsSpacePropTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsCellInstTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsRCellTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsRingTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsDCellTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsHorzTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsVertTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsBottleneckTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsSBNTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsDominantTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsDominantSBNTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsGenericTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool Tp_IsGenericSBNTile(/* tilePtr */);
/* Tile *tilePtr; */

extern bool
Tp_IsPairOfSBNTiles(/* tlTilePtrPtr, brTilePtrPtr, bnLineTypePtr */);
/*
 * Tile         **tlTilePtrPtr, **brTilePtrPtr;
 * BNLineType   *bnLineTypePtr;
 */

extern void Tp_MarkTile(/* tilePtr */);
/* Tile *tilePtr; */

extern void Tp_UnMarkTile(/* tilePtr */);
/* Tile *tilePtr; */

extern BearString Tp_GetTypeNameOfTile(/* tilePtr */);
/*
 * Tile *tilePtr;
 */

extern BearString Tp_GetTypeNameOfBnLine(/* bnLinePtr */);
/*
 * BNLine *bnLinePtr;
 */

extern void Tp_PutHorzPlaneBnd(/* planeData, horzPlaneBnd */);
/*
 * PlaneData    *planeData;
 * Rect         *horzPlaneBnd;
 */

extern void Tp_PutVertPlaneBnd(/* planeData, vertPlaneBnd */);
/*
 * PlaneData    *planeData;
 * Rect         *vertPlaneBnd;
 */

extern int Tp_GetTypeOfSpaceTile(/* tile */);
/*
 * Tile *tile;
 */

extern void Tp_PutTypeOfSpaceTile(/* type, tile */);
/*
 * int  type;
 * Tile *tile;
 */

extern struct _CellInst *Tp_GetCellInstOfTile(/* tile */);
/* Tile *tile; */

extern void Tp_PutCellInstOfTile(/* cellInst, tile */);
/*
 * struct _CellInst *cellInst;
 * Tile             *tile; 
 */

extern struct _DummyCell *Tp_GetDCellOfTile(/* tile */);
/* Tile *tile; */

extern void Tp_PutDCellOfTile(/* dcell, tile */);
/*
 * struct _DummyCell    *dcell;
 * Tile                 *tile; 
 */

extern struct _RouteCell *Tp_GetRCellOfTile(/* tile */);
/* Tile *tile; */

extern void Tp_PutRCellOfTile(/* rcell, tile */);
/*
 * struct _RouteCell    *rcell;
 * Tile                 *tile; 
 */

extern struct _Ring *Tp_GetRingOfTile(/* tile */);
/* 
 * Tile *tile; 
 */

extern void Tp_PutRingOfTile(/* ringPtr, tile */);
/*
 * struct _Ring    *ringPtr;
 * Tile            *tile; 
 */

extern SpaceProp *Tp_GetSpacePropOfTile(/* tile */);
/* Tile     *tile; */

extern void Tp_PutSpacePropOfTile(/* spaceProp, tile */);
/*
 * SpaceProp            *spaceProp;
 * Tile                 *tile; 
 */

extern int Tp_GetIdOfTile(/*tile*/);
/* Tile     *tile; */

extern void Tp_PutIdOfTile(/*id, tile*/);
/*
 * BearId   id;
 * Tile     *tile; 
 */

extern int Tp_GetJunctTableIndexOfDomTile(/* tile */);
/*
 * Tile *tile;
 */

extern void Tp_PutJunctTableIndexOfDomTile(/* index, tile */);
/*
 * int  index;
 * Tile *tile;
 */

extern int Tp_GetCapacityOfTile(/*tile*/);
/* Tile *tile; */

extern void Tp_PutCapacityOfTile(/*capacity, tile*/);
/*
int     capacity;
Tile    *tile; 
*/

extern int Tp_GetDensityOfTile(/*tile*/);
/* Tile *tile; */

extern void Tp_PutDensityOfTile(/*density, tile*/);
/*
 * int  density;
 * Tile *tile; 
 */

extern int Tp_GetRidgeWidthOfTile(/*tile*/);
/* Tile *tile; */

extern void Tp_PutRidgeWidthOfTile(/*ridgeWidth, tile*/);
/*
 * int     ridgeWidth;
 * Tile    *tile; 
 */

extern Tile *Tp_GetPrevTileOfTile(/*tile*/);
/* Tile *tile; */

extern void Tp_PutPrevTileOfTile(/*prevTile, tile*/);
/* Tile *prevTile, *tile; */

extern struct _WallSegment *Tp_GetWallSegmentOfBnTile(/* bnTile */);
/*
 * Tile *bnTile;
 */

extern void Tp_PutWallSegmentOfBnTile(/* seg, bnTile */);
/*
 * struct _WallSegment  *seg;
 * Tile                 *bnTile; 
 */


extern int Tp_GetCapacityOfBnLine(/* bnLinePtr */);
/*
 * BNLine *bnLinePtr;
 */

extern void Tp_PutCapacityOfBnLine(/* capacity, bnLinePtr */);
/*
 * int    capacity;
 * BNLine *bnLinePtr;
 */

extern int Tp_GetDensityOfBnLine(/* bnLinePtr */);
/*
 * BNLine *bnLinePtr;
 */

extern void Tp_PutDensityOfBnLine(/* density, bnLinePtr */);
/*
 * int    density;
 * BNLine *bnLinePtr;
 */

/* ---------- Macros for the BNLine structure ---------- */

#define Tp_GetIdOfBnLine(bnLine)            ((bnLine)->id)
#define Tp_GetLineOfBnLine(bnLine)          (&(bnLine)->line)
#define Tp_GetBnLineTypeOfBnLine(bnLine)    ((bnLine)->bnLineType)
#define Tp_GetTLTileOfBnLine(bnLine)        ((bnLine)->tlTilePtr)
#define Tp_GetBRTileOfBnLine(bnLine)        ((bnLine)->brTilePtr)
#define Tp_GetWallSegmentOfBnLine(bnLine)   ((bnLine)->segPtr)
#define Tp_PutWallSegmentOfBnLine(seg, bnLine) \
    ((bnLine)->segPtr = (seg))

/* ---------- Macros for the PlaneData structure ---------- */

#define Tp_GetHorzPlane(pd)                 ((pd)->pd_horzPlanePtr)
#define Tp_GetVertPlane(pd)                 ((pd)->pd_vertPlanePtr)

#define Tp_GetHorzPlaneBnd(pd)              (&(pd)->pd_horzPlaneBnd)
#define Tp_GetVertPlaneBnd(pd)              (&(pd)->pd_vertPlaneBnd)

#define Tp_GetHorzBnLineList(pd)            ((pd)->pd_horzBnLineList)
#define Tp_GetVertBnLineList(pd)            ((pd)->pd_vertBnLineList)
#define Tp_GetDCellList(pd)                 ((pd)->pd_dcellList)
#define Tp_GetFpg(pd)                       ((pd)->pd_fpgPtr)

#define Tp_PutHorzBnLineList(pd, bnLineList) \
    ((pd)->pd_horzBnLineList = (bnLineList))
#define Tp_PutVertBnLineList(pd, bnLineList) \
    ((pd)->pd_vertBnLineList = (bnLineList))
#define Tp_PutDCellList(pd, dcellList) \
    ((pd)->pd_dcellList = (dcellList))
#define Tp_PutFpg(pd, fpgPtr) ((pd)->pd_fpgPtr = (fpgPtr))

/* ---------- Miscellaneous Macros ---------- */

#define Tp_GetKindOfTile(tilePtr) (((TileProp *)((tilePtr)->ti_client))->unType)

#endif _TP_TILEPRIM

