
/* bearReadLine.c --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/bearMisc/bearReadLine.c,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $";
#endif  not lint

#define BEAR

#ifdef BEAR
#include "bearCopyRight.h"
#include "port.h"
#include "utility.h"
#else
#include <stdio.h>
#include <strings.h>
#include <ctype.h>
#define Bear_PrintErr(S) fprintf (stderr, "Error : %s\n", S)
#endif BEAR

#include "bearReadLine.h"


bool
Bear_AllWhiteSpace(string)
register char string[];     /* IN  */
{
    register int i;

    for (i = 0; string[i] != '\0' ;i++) {
        if (isspace(string[i]) == FALSE) {
            return (FALSE);
        }
    }
    return (TRUE);
}


BearStatus
Bear_ReadLine(line, maxLineSize, filePtr, eofFlagPtr)
char    line[];             /* OUT */
int     maxLineSize;        /* IN  */
FILE    *filePtr;           /* IN  */
bool    *eofFlagPtr;        /* OUT */
/*
 * This procedure will skip over blank lines.
 */
{
    char *stringPtr;

    while (TRUE) {
        if (fgets(line, maxLineSize, filePtr) == (char *) NULL) {
            *eofFlagPtr = TRUE;
            return (BEAR_OK);
        }
        else if ((stringPtr = strchr(line, '\n')) == (char *) NULL) {
            Bear_PrintErr("Bear_ReadLine() failed : buffer overflow.");
            return (BEAR_ERROR);
        }

        /* Remove the new line character. */
        *stringPtr = '\0';

        if (Bear_AllWhiteSpace(line) == TRUE) {
            /* Blank line. */
            continue;
        }
        else if (line[0] == '#') {
            /* Comment line. */
            continue;
        }
        else {
            return (BEAR_OK);
        }
    }
    /* NOTREACHED */
}


