
/*
 * grBitmap.c --
 *
 *     Malgorzata Marek-Sadowska
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalRouter/grBitmap.c,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $";
#endif  not lint

#include "grInt.h"

/*
*-----------------------------------------------------------------------
*	Function in this block are related to bitMap.
*-----------------------------------------------------------------------
*/



/*
*-----------------------------------------------------------------------
*	Gr_PutBlock()
*	This function is called when a bitmap of the initial placement
*	is created.
*	Results : none.                                           
*	Side effect : block i is put into its place in the Bitmap
*-----------------------------------------------------------------------
*/


void Gr_PutBlock(i)

int i;                              /* i is a key number of a block*/

{

	int xv,yv,wv,hv,l,u;

	xv= (grKeyToBlocksHeadPtr+i)->blockPtr->xvirt;
	yv= (grKeyToBlocksHeadPtr+i)->blockPtr->yvirt;
	wv= xv + (grKeyToBlocksHeadPtr+i)->blockPtr->wvirt;
	hv= yv + (grKeyToBlocksHeadPtr+i)->blockPtr->hvirt;

	for (l=(xv+1);l<= wv;l++)
		for (u=(yv+1);u<= hv;u++)
		{
			((gr_Bitmap+Gr_WhoAmI(u,l))->number)=i;
		}
}


/*
*-----------------------------------------------------------------------
*	Next functions are used to access various places in bitMap.
*------------------------------------------------------------------------
*/


/*
*------------------------------------------------------------------------
*	Gr_WhoAmI
	Results      : for a row "row" and column "col" returns position 
*		       in Bitmap.
	Side effects : none.                                              
*-------------------------------------------------------------------------
*/


int Gr_WhoAmI(row,col)

int row,col;		/* row is a number of a row in grBitmap array,
			   col is a number of a column */

{
	return (gr_totxgrid*(row-1)+col);
}



/*
*------------------------------------------------------------------------
*	Gr_UpLeft(xv,yv)
*	Results      : returns the content of the upper left cell
*	               from grid point xv,yv.        
*	Side effects : none.                                     
*------------------------------------------------------------------------
*/

int Gr_UpLeft(xv,yv)

int xv,yv;		/* xv is a position of an x coordinate of
			   a grid point imposed on gr_Bitmap array,
			   yv is its y coordinate . */

{

	int row,col,pom;

	col=xv;
	row=yv+1;
	if ((col<=0)||(row>gr_totygrid))
	{
		pom=0;
	}
	else
	{
		pom=((gr_Bitmap+Gr_WhoAmI(row,col))->number);
	}
	return (pom);
}


/*
*-----------------------------------------------------------------------
*	Gr_ReverseUpLeft
*	Results : none                      
*	Side effects : reverses the content of the upper left cell
*	from the grid point (xv,yv)                                
*-----------------------------------------------------------------------
*/


void Gr_ReverseUpLeft(xv,yv)

int xv,yv;		/* xv is a position of an x coordinate of
			   a grid point imposed on gr_Bitmap array,
			   yv is its y coordinate . */

{

	int pom,row,col,a;

	col=xv;
	row=yv+1;
		pom=Gr_WhoAmI(row,col);
		a=((gr_Bitmap+pom)->number);
		(gr_Bitmap+pom)->number= 0-a;
}


/*
*-----------------------------------------------------------------------
*	Gr_UpRight(xv,yv)
*	Results : returns the content of the upper right cell from 
*	grid point (xv,yv)                  
*	Side effects : none     
*-----------------------------------------------------------------------
*/

int Gr_UpRight(xv,yv)

int xv,yv;		/* xv is a position of an x coordinate of
			   a grid point imposed on gr_Bitmap array,
			   yv is its y coordinate . */

{

	int row,col,pom;

	col=xv+1;
	row=yv+1;
	if ((col>gr_totxgrid)||(row>gr_totygrid))
	{
		pom=0;
	}
	else
	{
		pom=((gr_Bitmap+Gr_WhoAmI(row,col))->number);
	}

	return (pom);
}


/* 
*-----------------------------------------------------------------------
*	Gr_ReverseUpRight(xv,yv)
*	Results : none                     
*	Side effect: reverses the content of the upper right cell   
*	from grid point (xv,yv)                                       
*-----------------------------------------------------------------------
*/


int Gr_ReverseUpRight(xv,yv)

int xv,yv;		/* xv is a position of an x coordinate of
			   a grid point imposed on gr_Bitmap array,
			   yv is its y coordinate . */

{

	int row,col,pom,a;

	col=xv+1;
	row=yv+1;
		pom=Gr_WhoAmI(row,col);
		a=((gr_Bitmap+pom)->number);
		(gr_Bitmap+pom)->number= 0-a;
}


/*
*-----------------------------------------------------------------------
*	Gr_BotLeft
*	Results :  returns the content of the bottom left cell 
*	from grid point (xv,yv)                                    
*	Side effects :  none                                       
*-----------------------------------------------------------------------
*/



int Gr_BotLeft(xv,yv)

int xv,yv;		/* xv is a position of an x coordinate of
			   a grid point imposed on gr_Bitmap array,
			   yv is its y coordinate . */

{

	int row,col,pom;

	col=xv;
	row=yv;
	if ((col>=gr_totxgrid)||(row>=gr_totygrid))
	{
		pom=0;
	}
	else
	{
		pom=((gr_Bitmap+Gr_WhoAmI(row,col))->number);
	}
	return pom;
}


/*
*-----------------------------------------------------------------------
*	Gr_BotRight
*	Results : returns the content of the bottom right cell
*	from grid point (xv,yv)    
*	Side effects : none                                          
*-----------------------------------------------------------------------
*/


int Gr_BotRight(xv,yv)

int xv,yv;		/* xv is a position of an x coordinate of
			   a grid point imposed on gr_Bitmap array,
			   yv is its y coordinate . */

{
	int row,col,pom;

	col=xv+1;
	row=yv;
	if ((col>gr_totxgrid)||(row<=0))
	{
		pom=0;
	}
	else
	{
		pom=((gr_Bitmap+Gr_WhoAmI(row,col))->number);
	}
	return pom;
}


/*
*-----------------------------------------------------------------------
*	Gr_ReverseBotRight(xv,yv)
*	Results : none      
*	Side effects : reverses the content of bottom right cell
*	from grid point (xv,yv)      
*------------------------------------------------------------------------
*/



void Gr_ReverseBotRight(xv,yv)

int xv,yv;		/* xv is a position of an x coordinate of
			   a grid point imposed on gr_Bitmap array,
			   yv is its y coordinate . */

{
	int row,col,pom,a;

	col=xv+1;
	row=yv;
		pom=Gr_WhoAmI(row,col);
		a=((gr_Bitmap+pom)->number);
		(gr_Bitmap+pom)->number= 0-a;
}


/*
*--------------------------------------------------------------------------
*	Gr_MkeBitMap()
*	Results      :  none      
*	Side effects : puts blocks numbered from 1 to grBottleneckTileCount
*	into Bitmap.                                                
*--------------------------------------------------------------------------
*/


void Gr_MkeBitMap()

{

	int i;

	Gr_Clean2();

	for (i=1;i<=grBottleneckTileCount;i++)
		Gr_PutBlock(i);
}


/*
*--------------------------------------------------------------------
*	Gr_Clean2()
*	Results      : none .    
*	Side effects : cleans the Bitmap (sets all elements to 0) .     
*--------------------------------------------------------------------
*/



void Gr_Clean2()

{

	int pom,del;

	del=(grBottleneckTileCount+1)*(grBottleneckTileCount+1);
	for (pom=0;pom<=del;pom++)
		(gr_Bitmap+pom)->number=0;
}
