
/* grInt.h --
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/globalRouter/grInt.h,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $
 */

#include "bearCopyRight.h"
#include "port.h"
#include "malloc.h"
#include "magic.h"
#include "geometry.h"
#include "bear.h"
#include "tile.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "globalSpacer.h"

#include "grStrTags.h"
#include "grExtern.h"
#include "grAGlo.h"
#include "grNetGlobs.h"
#include "globalRouter.h"

#define LARGE_NEGATIVE  (-100)

/* --------- Internal global variables for the globalRouter module --------- */

extern PlaneData    *grPlaneDataPtr;
extern CellMaster   *grCellMasterPtr;
extern int grSolidTileCount; /*number of solid tiles seen by the global router*/
extern int grHorzBottlNumber; /*number of Horz bottlnecks*/
extern int grVertBottlNumber; /*number of Vert bottlenecks*/
extern int bnLineCount; /* number of btln lines */
extern int hbnLCount; /* number of horz btln lines */
extern int vbnLCount; /* number of vert btln lines */
extern int grBottleneckTileCount; /* the last name of bottleneck tile*/
extern Rect *planeBndPtr;
extern int gr_xShift;
extern int gr_yShift;
extern grBlock *grHeadBlockPtr; /*pointer to the first block on the list of */
                         /*solid blocks*/
extern grBnLine *grBnLineList; /* pointer to the head of btln line list */
extern grBlock *grLastBlockPtr; /*pointer to the last solid block*/
extern grKeyBlock *grKeyToBlocksHeadPtr;
extern grPrimit *gr_Bitmap;
extern grPrimit *gr_xcoord;
extern grPrimit *gr_ycoord;
extern int gr_totxgrid;
extern int gr_totygrid;

extern grRoom *gr_RoomPlan;

extern grRegion *grHeadRegionPtr;
extern grRegion *grTailRegionPtr;
extern int m; /* number of virtual nets in each region for assignment*/
extern int n; /* number of holes for assignment*/
extern int neff;
extern grHole *grHeadHolePtr;
extern grIndex *vNetHead; /* array of pointers to virtual nets */
extern float gr_congestionFactor;
extern int gr_horzDesRule;
extern int gr_vertDesRule;
extern char debug;

extern grLayer *gr_HeadCurLayer;
extern grLayer *gr_TailCurLayer;
extern grLayer *gr_Pending;
extern grLayer *gr_HeadNewLayer;
extern grLayer *gr_TailNewLayer;

extern int gr_Timing; /* 0 regular mode, 1 timing mode*/
extern int gr_BearConnection;

extern float gr_HorVertWire; /* a number to multiply vert wire length*/

extern grDeadRegion *grHeadDeadRegion;

extern bool gr_FreeMemFlag;
extern bool grPrintFlag;

extern BearStatus GrMkeSortedPins();

extern BearStatus GrInitializeNets();

#define GR_FREE(cp) { if (gr_FreeMemFlag == TRUE) { free(cp); } }

#define GR_DONT_FREE(cp)

