/*
 * grPinRoom.c --
 *
 *     Author
 *	Malgorzata Marek-Sadowska
 *	( Professor E.S.Kuh )
 *
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalRouter/grPinRoom.c,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $";
#endif  not lint




#include "grInt.h"


/*
*-----------------------------------------------------------------------------
*	This file contains various functions related to virtual grid
*	(rooms) and relationship between rooms and pins.
*-----------------------------------------------------------------------------
*/

/*
*-----------------------------------------------------------------------------
*	Gr_AssignRoomToPin
*	Results		: none.
*	Side effects	: attaches room to regular pin 
*-----------------------------------------------------------------------------
*/

void Gr_AssignRoomToPin(gPin)

grPin *gPin;


{

	int i,yv,xv,x,y;

	x=gPin->x;
	y=gPin->y;

	for (i=0;i<=gr_totxgrid;i++)
	{
		if ((gr_xcoord+i)->number >= x)
		{
			xv=i;
			goto lab1;
		}
	}

lab1:;

	for (i=0;i<=gr_totygrid;i++)
	{
		if ((gr_ycoord+i)->number >= y)
		{
			yv=i;
			goto lab2;
		}
	}


lab2:;
	if (xv==0)
	{
		/*pin is on the left boundary of the chip */
		if ((gr_ycoord+yv)->number > y)
		{
			gPin->room=Gr_GetRoom(yv,1);
			return;
		}
		else
		{
			if (Gr_IsRoomBtn((yv+1),1)&&(!Gr_IsRoomBtn(yv,1)))
			{
				gPin->room=Gr_GetRoom((yv+1),1);
				return;
			}
			else
			{
				gPin->room=Gr_GetRoom(yv,1);
				return;
			}
		}
	}

	if (yv==0)
	{
		/* pins on the bottom boundary of the chip*/

		if ((gr_xcoord+xv)->number > x)
		{
			gPin->room=Gr_GetRoom(1,xv);
			return;
		}
		else
		{
			if (Gr_IsRoomBtn(1,(xv+1))&&(!Gr_IsRoomBtn(1,xv)))
			{
				gPin->room=Gr_GetRoom(1,(xv+1));
				return;
			}
			else
			{
				gPin->room=Gr_GetRoom(1,xv);
				return;
			}
		}
	}
	if (((gr_xcoord+xv)->number > x)&&((gr_ycoord+yv)->number ==y))
	{
		if (gPin->shade == SOUTH_PIN)
		{
			gPin->room=Gr_GetRoom(yv,xv);
			return;
		}
		if (gPin->shade==NORTH_PIN)
		{ 
			gPin->room=Gr_GetRoom((yv+1),xv);
			return;
		}
		if (Gr_IsRoomBtn((yv+1),xv)&&(!Gr_IsRoomBtn(yv,xv)))
		{
			gPin->room=Gr_GetRoom((yv+1),xv);
			return;
		}
		else
		{
			gPin->room=Gr_GetRoom(yv,xv);
			return;
		}
	}
	if (((gr_xcoord+xv)->number == x)&&((gr_ycoord+yv)->number >y))
	{
		if (gPin->shade ==WEST_PIN)
		{
			gPin->room=Gr_GetRoom(yv,xv);
			return;
		}
		if (gPin->shade==EAST_PIN)
		{
			gPin->room=Gr_GetRoom(yv,(xv+1));
			return;
		}
		if (Gr_IsRoomBtn(yv,(xv+1))&&(!Gr_IsRoomBtn(yv,xv)))
		{
			gPin->room=Gr_GetRoom(yv,(xv+1));
			return;
		}
		else
		{
			gPin->room=Gr_GetRoom(yv,xv);
			return;
		}
	}

	/* position at intersection */

	if (gPin->shade == SOUTH_PIN)
	{
		if (Gr_IsRoomBtn(yv,(xv+1))&&(!Gr_IsRoomBtn(yv,xv)))
		{
			gPin->room=Gr_GetRoom(yv,(xv+1));
			return;
		}
		else
		{
			gPin->room=Gr_GetRoom(yv,xv);
			return;
		}
	}
	if (gPin->shade==NORTH_PIN)
	{
		if (Gr_IsRoomBtn((yv+1),(xv+1))&&(!Gr_IsRoomBtn((yv+1),xv)))
		{
			gPin->room=Gr_GetRoom((yv+1),(xv+1));
			return;
		}
		else
		{
			gPin->room=Gr_GetRoom((yv+1),xv);
			return;
		}
	}

	if (gPin->shade == EAST_PIN)
	{
		if (Gr_IsRoomBtn((yv+1),(xv+1))&&(!Gr_IsRoomBtn(yv,(xv+1))))
		{
			gPin->room=Gr_GetRoom((yv+1),(xv+1));
			return;
		}
		else
		{
			gPin->room=Gr_GetRoom(yv,(xv+1));
			return;
		}
	}
	if (gPin->shade==WEST_PIN)
	{
		if (Gr_IsRoomBtn((yv+1),xv)&&(!Gr_IsRoomBtn(yv,xv)))
		{
			gPin->room=Gr_GetRoom((yv+1),xv);
			return;
		}
		else
		{
			gPin->room=Gr_GetRoom(yv,xv);
			return;
		}
	}
}


/*
*----------------------------------------------------------------------------
*	Gr_GetRoomForPPinPosition
*	Results		: for a pseudo pin position it returns a room ptr.
*	Side effects	: none.
*----------------------------------------------------------------------------
*/



grRoom *Gr_GetRoomForPPinPosition(x,y,shade)

int x,y;		/* Position of pseudo pin.		*/
PinDirection shade;	/* Routing direction.			*/

{


	int i,yv,xv;

	for (i=0;i<=gr_totxgrid;i++)
	{
		if ((gr_xcoord+i)->number >= x)
		{
			xv=i;
			goto lab1;
		}
	}
lab1:;

	for (i=0;i<=gr_totygrid;i++)
	{
		if ((gr_ycoord+i)->number >= y)
		{
			yv=i;
			goto lab2;
		}
	}
lab2:;

	if ((gr_xcoord+xv)->number ==x)
	{

	      if ((shade == EAST_WEST_PIN)||(shade==EAST_PIN)||(shade==WEST_PIN))
		{
			if (Gr_IsRoomBtn(yv,xv)&&(!Gr_IsRoomBtn(yv,(xv+1))))
			{
				return (Gr_GetRoom(yv,(xv+1)));
			}
			else
			{
				return (Gr_GetRoom(yv,xv));
			}
		}
		else
		{
			if (Gr_IsRoomBtn(yv,xv)&&(!Gr_IsRoomBtn((yv+1),xv)))
			{
				return (Gr_GetRoom((yv+1),xv));
			}
			else
			{
				return (Gr_GetRoom(yv,xv));
			}
		}
	}
	if ((gr_ycoord+yv)->number == y)
	{
		if ((shade== NORTH_SOUTH_PIN)||(shade==NORTH_PIN)
		||(shade==SOUTH_PIN))
		{
			if (Gr_IsRoomBtn(yv,xv)&&(!Gr_IsRoomBtn((yv+1),xv)))
			{
				return (Gr_GetRoom((yv+1),xv));
			}
			else
			{
				return (Gr_GetRoom(yv,xv));
			}
		}
		else
		{
			if (Gr_IsRoomBtn(yv,xv)&&(!Gr_IsRoomBtn(yv,(xv+1))))
			{
				return (Gr_GetRoom(yv,(xv+1)));
			}
			else
			{
				return (Gr_GetRoom(yv,xv));
			}
		}
	}
}

/*
*----------------------------------------------------------------------------
*	Gr_AssignRoomToPPin(gPPin)
*	Results		: none.
*	Side effects	: attaches room to pseudo pin
*----------------------------------------------------------------------------
*/


void Gr_AssignRoomToPPin(gPPin)

grPin *gPPin;		/* Pointer to pseudo pin.		*/

{

	gPPin->room=Gr_GetRoomForPPinPosition(gPPin->x,gPPin->y,gPPin->shade);

}
