/*
 * grPrerouted.c --
 *
 *     Author
 *	Malgorzata Marek-Sadowska
 *	( Professor E.S.Kuh )
 *
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalRouter/grPrerouted.c,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $";
#endif  not lint




#include "grInt.h"




/*
*-----------------------------------------------------------------------------
*	Results		: none.
*	Side effects	:
*	Partially prerouted net is put to the children subregions of kPtr.     
*	The net intersects the current cutline only by means of prerouted  
*	segments which are already in the bottleneck and in the centr.database 
*	No new cut points are added.                                           
*-----------------------------------------------------------------------------
*/


void Gr_DropNetToBothRegions(kPtr,sNet)

grRegion *kPtr;		/* Pointer to parent region.		*/
grSubNet *sNet;		/* Pointer to subnet.			*/


{

	grPinRectangle *new;
	grRootTree *rTree,*pending;
	BearId nname;
	grRegion *nRegion;
	grSubNet *newNet;
	grSuperNode *current;

	Gr_MkeRootTree(sNet,1);
	Gr_SplitRootTreeAtCutBranches(sNet);
	Gr_GiveNamesToRootTreeNodes(sNet);
	Gr_ClearMarksOfDecomposedTrees(sNet);

	rTree=sNet->tree;

	while(rTree!=NULL)
	{
		nname=rTree->nodePtr->nodeName;
		if (rTree->nodePtr->side==1)
		{
			nRegion=kPtr->leftPtr;
		}
		else
		{
			nRegion=kPtr->rightPtr;
		}

		Gr_CreateNewSubnet(nRegion);
		newNet=nRegion->subNetsPtr;
		newNet->netname=sNet->netname;
		newNet->subname=nname;
		newNet->decCandidate=sNet->decCandidate;
		newNet->active=0;
		newNet->tree=NULL;
		newNet->children=NULL;
		newNet->NodeList=NULL;
		newNet->noComponents=0;
		newNet->noLoosePins=0;

		pending=rTree;
		/* iterate over tree branches*/

		while(pending!=NULL)
		{
lab2: 
			if (pending->mark==0)
			{
				pending->mark=1;
				current=pending->nodePtr;
				new=pending->nodePtr->contentsPtr;

				/* link pin rectangles*/
				if (nRegion->firstPinRectanglePtr==NULL)
				{
					nRegion->firstPinRectanglePtr=new;
					nRegion->lastPinRectanglePtr=new;
					new->nextOnList=NULL;
				}
				else
				{
					new->nextOnList=
					nRegion->firstPinRectanglePtr;
					nRegion->firstPinRectanglePtr=new;
				}    /* end link*/

				if (current->kind==1)  /* to be connected*/
				{
					new->nextInNet=NULL;
					newNet->toBeConnected=new;
					newNet->noLoosePins=new->count;
				}
				else
				{
					if (newNet->areConnected==NULL)
					{
						new->nextInNet=NULL;
						newNet->areConnected=new;
						newNet->noComponents ++;
					}
					else
					{
						new->nextInNet=
						newNet->areConnected;
						newNet->areConnected=new;
						newNet->noComponents++;
					}
				}
			}
			/*end root node*/
			if (pending->childPtr!=NULL)
			{
				if (pending->childPtr->mark==0)
				{
					pending=pending->childPtr;
					goto lab2;
				}
			}

			if (pending->siblingPtr!=NULL)
			{
				if (pending->siblingPtr->mark==0)
				{
					pending=pending->childPtr;
					goto lab2;
				}
			}

			pending=pending->fatherPtr;

		}  /* end while*/

		rTree=rTree->nextInSubnet;

	} /* end while*/

}


