
/*
 * grRs.c --
 *
 *     Malgorzata Marek-Sadowska
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalRouter/grRs.c,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $";
#endif  not lint

#include "grInt.h"

 
/*
*---------------------------------------------------------------------------
*	This file contains a number of subroutines for graphic    
*	display on the HP2648a.                                   
*	the subroutines are :sgtext(),closepl(),openpl(),erase(), 
*	                  move(x,y),verti(),horiz(),draw(),cross() 
*	For descriptions of those routines see the comments for    
*	the function concerned.                                                 
*----------------------------------------------------------------------------
*/



#ifdef HP_PLOT

#define ESC 033
#define CR 015



/*
*----------------------------------------------------------------------------
*	Gr_sgtext()     
*	Results      : none;
*	Side effects : set terminal to graphic text mode.
*----------------------------------------------------------------------------
*/

void Gr_sgtext()     


{
	printf("%c*dS",ESC);
}



/*
*---------------------------------------------------------------------------
*	Gr_closepl()
*	Results      : none.
*	Side effects : change terminal status from graphic mode
*	to alpha mode.
*---------------------------------------------------------------------------
*/


void Gr_closepl()

{
	printf("%c*dT",ESC);
	printf("%c*ddE",ESC);
}

/*
------------------------------------------------------------------------------
*	Gr_erase()
*	Results      : none.
*	Side effects : erase graphic display.
*-----------------------------------------------------------------------------
*/


void Gr_erase()
{

	printf("%c*dA",ESC);
}



/*
*------------------------------------------------------------------------------
*	Gr_move(xi,yi)
*	Results      : none.
*	Side effects : move pen to (x,y) pixel  position.
*-----------------------------------------------------------------------------
*/


void Gr_move(xi,yi)

int xi,yi;

{
	printf("%c*paf%d %dB",ESC,xi,yi);
}

/*
*----------------------------------------------------------------------------
*	Gr_openpl()
*	Results       : none;
*	Side effects  : change from alpha mode to graphic mode.
*----------------------------------------------------------------------------
*/


void Gr_openpl()


{
	printf("%c*dfC",ESC);
}

/*
*-----------------------------------------------------------------------------
*	Gr_verti(x,y1,y2,width)
*	Results     : none;
*	Side effects: draw a bar of width =(2*width+1)
*		      from (x,y1) to (x,y2).
*----------------------------------------------------------------------------
*/


void Gr_verti(x,y1,y2,width)

int x,y1,y2,width;


{
	printf("%c*m 2a1b %d,%d %d,%dE",ESC,x-width,y1,x+width,y2);
}



/*
*---------------------------------------------------------------------------
*	Gr_horiz(y,x1,x2,width)
*	Results      : none;
*	Side effects : draw a bar of width=(2*width+1) 
*		       from (x1,y) to (x2,y).
*---------------------------------------------------------------------------
*/


void Gr_horiz(y,x1,x2,width)

int y,x1,x2,width;


{
	printf("%c*m 2a1b %d,%d %d,%dE",ESC,x1,y-width,x2,y+width);
}



/*
*-----------------------------------------------------------------------------
*	Gr_draw(x,y)  
*	Results       : none;
*	Side effects  : draw a line from the current pen position to (x,y)
*----------------------------------------------------------------------------
*/


void Gr_draw(x,y)  

int x,y;


{
	printf("%c*pf%d %dZ",ESC,x,y);
}


/*
*---------------------------------------------------------------------------
*	Gr_cross(x,y)
*	Results       : none;
*	Side effects  : draw a cross at (x,y) .
*--------------------------------------------------------------------------
*/


void Gr_cross(x,y)

int x,y;

{
        Gr_move(x-1,y-1);
	Gr_draw(x+1,y+1);
	Gr_move(x-1,y+1);
	Gr_draw(x+1,y-1);
}

/*-------------------------------------------------------------------------
*	GrSelect...Pattern()
*	functions are for choosing line pattern : solid, dashed and dotted.
*--------------------------------------------------------------------------
*/

void Gr_SelectOnePattern()

{
	printf("%c*m 1b",ESC);
}

void Gr_SelectFourPattern()

{
	printf("%c*m 7b",ESC);
}


void Gr_SelectSevenPattern()

{
	printf("%c*m 10b",ESC);
}

#endif HP_PLOT

