
/* mmsPrint.c --
 *
 *     Malgorzata Marek-Sadowska
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalRouter/mmsPrint.c,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include "grInt.h"


void
Gr_PrBlock(blockPtr)
grBlock *blockPtr;
{
    int a,b;

    if (grPrintFlag == FALSE) {
        return;
    }

    (void) fprintf (bearout, "\n name=%4d",blockPtr->name);
    (void) fprintf (bearout, "  xpos=%4d  ypos=%4d",
        blockPtr->xpos,blockPtr->ypos);
    (void) fprintf (bearout, "  height=%4d  width=%4d",
        blockPtr->height,blockPtr->width);
    (void) fprintf (bearout, "  persona=%4d",blockPtr->persona);
    (void) fprintf (bearout, "  cap=%4d",blockPtr->avCap);

    if ((blockPtr->persona > 1)&&(blockPtr->persona < 6))
    {
        a=Tp_GetCapacityOfTile(blockPtr->tilePtr);
        b=Tp_GetDensityOfTile(blockPtr->tilePtr);
        (void) fprintf (bearout, "\n cap=%4d   den=%4d",a,b);
    }
}


void
Gr_BlocksOut()
{
    grBlock *nextPtr;

    nextPtr=grHeadBlockPtr;

    while(nextPtr != NULL)
    {
        if ((nextPtr->persona == 2)||(nextPtr->persona == 3))
        {
            Gr_PrBlock(nextPtr);
        }
        nextPtr=nextPtr->nextBlockPtr;
    }
}


void
Gr_PrDeadRegion(new)
grDeadRegion *new;
{
    if (grPrintFlag == FALSE) {
        return;
    }

    if (new!=NULL) {
        (void) fprintf (bearout, "\n  xleft=%4d",new->xleft);
        (void) fprintf (bearout, "    xright=%4d",new->xright);
        (void) fprintf (bearout, "    ybot=%4d",new->ybot);
        (void) fprintf (bearout, "    ytop=%4d",new->ytop);
        (void) fprintf (bearout, "\n  blhl=%4d",new->botLeftHoleNr); 
        (void) fprintf (bearout, "    trhl=%4d",new->topRightHoleNr); 
        (void) fprintf (bearout, "    side=");
        if (new->side == 0)
        {
            (void) fprintf (bearout, " left");
        }
        else
        {
            (void) fprintf (bearout, " right");
        }
        (void) fprintf (bearout, "\n pullConttrol =%d", new->pullControl);
    }
}


void
Gr_PrDeadRegionLists()
{
    grDeadRegion *new;

    if (grPrintFlag == FALSE) {
        return;
    }

    new = grHeadDeadRegion;

    (void) fprintf (bearout, "\n stright list :\n");
    while(new!=NULL)
    {
        Gr_PrDeadRegion(new);
        if (new->partner !=NULL)
        {
            (void) fprintf (bearout, "\n partner:");
            Gr_PrDeadRegion(new->partner);
        }
        new=new->next;
    }
    (void) fprintf (bearout, "\n list in assignment order");
    new= grHeadDeadRegion;
    while(new!=NULL)
    {
        Gr_PrDeadRegion(new);
        if (new->partner !=NULL)
        {
            (void) fprintf (bearout, "\n partner :");  
            Gr_PrDeadRegion(new->partner);
        }
        new=new->dr_inline;
    }
}


void
Gr_prgrid()
{
    int i,j;
    int pom;

    if (grPrintFlag == FALSE) {
        return;
    }

    j=0;
    (void) fprintf (bearout, "\n xpositions");
    for (i=0;i<=gr_totxgrid;i++)
    {
        pom=(gr_xcoord+i)->number;
        if ((j%10)!=NULL) (void) fprintf (bearout, "%6d",pom);
        else (void) fprintf (bearout, "\n%6d",pom);
        j++;
    }
    (void) fprintf (bearout, "\n ypositions");
    j=0;
    for (i=0;i<=gr_totygrid;i++)
    {
        pom=(gr_ycoord+i)->number;
        if ((j%10)!=NULL) (void) fprintf (bearout, "%6d",pom);
        else (void) fprintf (bearout, "\n%6d",pom);
        j++;
    }
}


void
Gr_pBitMap(lcol, rcol, brow, trow)
int lcol, rcol, brow, trow;
{
    int i, j, pom, col, row;

    if (grPrintFlag == FALSE) {
        return;
    }

    (void) fprintf (bearout, "\n Bitmap");
    for (i=brow;i<=trow;i++)
    {
        row=trow+brow-i;
        (void) fprintf (bearout, "\n");
        for (j=lcol;j<=rcol;j++)
        {
            col=j;
            pom=Gr_WhoAmI(row,col);
            pom=((gr_Bitmap+pom)->number);
            (void) fprintf (bearout, "%3d",pom);
        }
    }
    (void) fprintf (bearout, "\n\n");
    (void) fflush (bearout);
}


void
Gr_PrintRooms()
{
    int i,j,pom,col,row;

    if (grPrintFlag == FALSE) {
        return;
    }

    printf("\n Rooms");
    for (i=1;i<=gr_totygrid;i++)
    {
        row=gr_totygrid-i+1;
        printf("\n");
        for (j=1;j<=gr_totxgrid;j++)
        {
            col=j;
            pom=Gr_WhoAmI(row,col);
            pom=((gr_RoomPlan+pom)->who);
            printf("%3d",pom);
        }
    }
    printf("\n\n");

}


void
Gr_PrintRegion(kPtr)
grRegion *kPtr;
{
    if (grPrintFlag == FALSE) {
        return;
    }

    printf("\n");
    if (kPtr!=NULL)
    {
        printf("xvirt=%4d",kPtr->xvirt);
        printf("  yvirt=%4d",kPtr->yvirt);
        printf("  whvirt=%4d",kPtr->whvirt);
        printf("  hvirt=%4d",kPtr->hvirt);
    }
    else
    {
        printf("\n call to NULL region");
    }
}


void
Gr_Print_grNet(num)
int num;
{
    /* prints out the num-th grNet along with accompanying structures*/

    grSortedPin     *sortPtr;
    grPinRectangle  *recPtr;
    int             globRoutName;
    BearString      name;

    if (grPrintFlag == FALSE) {
        return;
    }

    printf("\n num=%4d",num);
    printf("\n");
    globRoutName=(gr_HeadGrNets+num)->name;
    name=(gr_HeadKeyToNets+globRoutName)->name;
    printf("\n global router name = %4d  ",globRoutName);
    printf("   external name =");
    puts(name);
    printf("\n");
    /*
    printf("number of loose pins = %4d  ",(gr_HeadGrNets+num)->noLoosePins);
    printf("number of components = %4d  ",(gr_HeadGrNets+num)->noComponents);
    recPtr=(gr_HeadGrNets+num)->loosePins;
    printf("\n");
    printf("bounding box: xleft=%4d  ",recPtr->minx);
    printf("  xright=%4d  ",recPtr->maxx);
    printf("  ybot=%4d  ",recPtr->miny);
    printf("  ytop=%4d  ",recPtr->maxy);
    printf("\n");
    printf("x-sorted pins");
    sortPtr=(recPtr->firstxPin);
    while(sortPtr!=NULL)
    {
        printf("\n x=%4d  y=%4d  ",sortPtr->pinPtr->x,sortPtr->pinPtr->y);
        sortPtr=sortPtr->nextxPin;
    }
    printf("\ny-sorted pins");
    sortPtr=recPtr->firstyPin;
    while(sortPtr!=NULL)
    {
        printf("\n x=%4d  y=%4d  ",sortPtr->pinPtr->x,sortPtr->pinPtr->y);
        sortPtr=sortPtr->nextyPin;
    }
    printf("\n");
    printf("\n hard links");
    sortPtr=(gr_HeadGrNets+num)->firstXPin;
    while(sortPtr!=NULL)
    {
        printf("\n x=%4d y=%4d",sortPtr->pinPtr->x,sortPtr->pinPtr->y);
        sortPtr=sortPtr->nextXPin;
    }
    printf("\n y-sort");
    sortPtr=(gr_HeadGrNets+num)->firstYPin;
    while(sortPtr!=NULL)
    {
        printf("\n x=%4d y=%4d",sortPtr->pinPtr->x,sortPtr->pinPtr->y);
        sortPtr=sortPtr->nextYPin;
    }
    printf("\n");
    */
}


/*void Gr_PrintXSortedPins()
{

    grSortedPin *current;

    current=gr_FirstXSortedPinPtr;
    if (current==NULL)
    {
        printf("\n Pins are not sorted along x coordinate ");
    }
    else
    {
        while(current!=NULL)
        {
            printf("\n");
            printf("net=%4d",current->pinPtr->netname);
            printf("x=%4d",current->pinPtr->x);
            printf("y=%4d",current->pinPtr->y);
            current=current->nextXPin;
        }
    }
} */

/*void Gr_PrintYSortedPins()


{

    grSortedPin *current;

    current = gr_FirstYSortedPinPtr;
    if (current == NULL)
    {
        printf("\n pins are not sorted yet along y coordinate" );
    }
    else
    {
        while(current!=NULL)
        {
            printf("\n");
            printf("net=%4d",current->pinPtr->netname);
            printf("x=%4d",current->pinPtr->x);
            printf("y=%4d",current->pinPtr->y);
            current=current->nextYPin;
        }
    }
}*/


void
Gr_Print_grPin(pinPtr)
grPin *pinPtr;
{
    int xv,yv;
    
    if (grPrintFlag == FALSE) {
        return;
    }

    printf("\n");
if (pinPtr!=NULL)
{
    printf(" x=%4d  y=%4d",pinPtr->x,pinPtr->y);
    printf("  type=");
    if (pinPtr->type == 0)
    {
        printf("unspecified");
    }
    if (pinPtr->type == 1)
    {
        printf("regular");
    }
    if (pinPtr->type == 2)
    {
        printf("pseudo");
    }
    if (pinPtr->type == 3)
    {
        printf("imaginary");
    }
    printf("  shade=");
    if (pinPtr->shade==NORTH_PIN)
    {
        printf("north pin");
    }
    if (pinPtr->shade==SOUTH_PIN)
    {
        printf("south pin");
    }
    if (pinPtr->shade==EAST_PIN)
    {
        printf("east pin");
    }
    if (pinPtr->shade==WEST_PIN)
    {
        printf("west pin");
    }
    if (pinPtr->shade==NORTH_SOUTH_PIN)
    {
        printf("north-south pin");
    }
    if (pinPtr->shade==EAST_WEST_PIN)
    {
        printf("east-west pin");
    }
    if (pinPtr->shade==ALL_DIRECTION_PIN)
    {
        printf("all-directions pin");
    }
    printf(" netname=%4d",pinPtr->netname);
    printf("\n  intname=%4d",pinPtr->intname);
    printf("  extname=%4d",pinPtr->extname);
    if (pinPtr->room!=NULL)
    {
        xv=pinPtr->room->xv;
        yv=pinPtr->room->yv;
        printf("  xv=%4d,yv=%4d",xv,yv);
    }
    printf("\n ");
  }
  else
  {
   printf("\n call of nonexistent grPin");
  }
}


void
Gr_Print_grSortedPin(spinPtr)
grSortedPin *spinPtr;
{
    if (grPrintFlag == FALSE) {
        return;
    }

   if (spinPtr!=NULL)
   {
    if (spinPtr->pinPtr!=NULL) Gr_Print_grPin(spinPtr->pinPtr);
/*  printf(" side=");
    if (spinPtr->side == 0)
    {
        printf("internal");
    }
    else
    {
        if (spinPtr->side == 1)
        {
            printf(" left");
        }
        else
        {
            if (spinPtr->side == 2)
            {
                printf(" top");
            }
            else
            {
                if (spinPtr->side ==3)
                {
                    printf(" right");
                }
                else
                {
                    if (spinPtr->side == 4)
                    {
                        printf(" bottom");
                    }
                    else
                    {
                        printf(" bug in assignment");
                    }
                }
            }
        }
    } */
}
else
{
    printf("\n call to nonexistent grSortedPin");
}

}


void
Gr_PrintBoundBox(boxPtr)
grPinRectangle  *boxPtr;
{
    if (grPrintFlag == FALSE) {
        return;
    }

if (boxPtr!=NULL)
{
    printf("\n");
    printf(" bounding box : xmin=%4d",boxPtr->minx);
    printf("  xmax=%4d",boxPtr->maxx);
    printf("  ymin=%4d",boxPtr->miny);
    printf("  ymax=%4d",boxPtr->maxy);
}
else
{
    printf("\n call to nonexistent bbox");
}
fflush(stdout);
} 


void Gr_PrintPinRectangle(pinRectanglePtr)

grPinRectangle *pinRectanglePtr;

{

grSortedPin *current;

    if (pinRectanglePtr!=NULL)
    {
        printf("\n pins sorted along x coordinate :");
        current=pinRectanglePtr->firstxPin;
        while(current!=NULL)
        {
            printf("\n");
            Gr_Print_grSortedPin(current);
            current=current->nextxPin;
        }
        /*  printf("\n");
            printf("\n  pins sorted along y coordinate :");
            current=pinRectanglePtr->firstyPin;
            while(current!=NULL)
            {
                printf("\n");
                Gr_Print_grSortedPin(current);
                current=current->nextyPin;
            }
        */
            Gr_PrintBoundBox(pinRectanglePtr);
            printf(" count=%4d",pinRectanglePtr->count);
            printf("  cutMark=%4d",pinRectanglePtr->cutMark);
            printf("  pRecname=%4d",pinRectanglePtr->name);
            printf("\n ");
        
            printf("\n");
    }
    else
    {
        printf("\n call to nonexistent pinRectangle");
    }
}
    
    
void Gr_Print_grSuperNode(sNodePtr)
    
grSuperNode *sNodePtr;
    
{
    
    if (sNodePtr!=NULL)
    {
        /*Gr_PrintPinRectangle(sNodePtr->contentsPtr);*/
        printf("\n kind = ");

        if (sNodePtr->kind == 0 )
        {
            printf("prerouted net");
        }
        else
        {  
            printf("pins to be connected");
        }

        printf("  node name = %4d",sNodePtr->nodeName);
        printf("\n sits on ");
        if (sNodePtr->side == 1 )
        {
            printf("left");
        }
        else
        {
            if (sNodePtr->side == 2 )
            {
                printf("right");
            }
            else
            {
                printf("undecided");
            }
        }
    
        Gr_PrintPinRectangle(sNodePtr->contentsPtr);
    }
    else
    {
        printf("\n call to nonexistent super node");
    }
}


void Gr_PrintShade(dirPtr)

PinDirection *dirPtr;

{

    printf("  direction = ");

    if (*dirPtr==NORTH_PIN)
    {
        printf("NORTH_PIN");
    }

    if (*dirPtr==SOUTH_PIN)
    {
        printf("SOUTH_PIN");
    }

    if (*dirPtr==WEST_PIN)
    {
        printf("WEST_PIN");
    }
    if (*dirPtr==EAST_PIN)
    {
        printf("EAST_PIN");
    }

    if (*dirPtr==EAST_WEST_PIN)
    {
        printf("EAST_WEST_PIN");
    }

    if (*dirPtr==ALL_DIRECTION_PIN)
    {
        printf("ALL_DIRECTIONS_PIN");
    }

}


void Gr_PrintAll_grPins()

{

grPin *current;

    current=gr_PinHeadPtr;
    Gr_Print_grPin(current);

    while(current!=gr_LastPinPtr)
    {
        current=current->nextPtr;
        Gr_Print_grPin(current);
    }

}

void Gr_PrintRootTree(rootTreePtr)

grRootTree *rootTreePtr;

{

grSuperNode *sNodePtr;
grRootTree *pending;

if (rootTreePtr!=NULL)
{
    printf("\n root tree data \n");

    pending=rootTreePtr;

    while(pending->nextInSubnet!=NULL)
    {
        pending=pending->nextInSubnet;
    }

    while(pending!=NULL)
    {
        sNodePtr=pending->nodePtr;
        /*Gr_Print_grSuperNode(sNodePtr);*/
        Gr_PrintBoundBox(sNodePtr->contentsPtr);
        printf("\n");
        printf("distance to the best not marked =%4d",pending->distance);
        printf("\n");
        printf("mark=%4d,cut=%4d",pending->mark,pending->cut);
        printf("\n");
        printf("\n my pointer=%10d",pending);
        printf("best not marked=%10d",pending->bestNotMarked);
        printf("child ptr=%10d",pending->childPtr);
        printf("\n");
        printf("siblingPtr=%10d",pending->siblingPtr);
        printf("fatherPtr=%10d",pending->fatherPtr);
        printf("\n");
        pending = pending->nextOnList;

    }
}
else
{
    printf("\n call to nonexistent roottree");
}
}


void
Gr_PrintVirtNet(virtNet)
grVirtNet  *virtNet;
{
    grSuperNode  *sNodePtr;

    if (grPrintFlag == FALSE) {
        return;
    }

    if (virtNet!=NULL) {
        printf("\n virtual net data:");
        printf("\n netName=%4d,subnetName=%4d",
            virtNet->netName, virtNet->subNetName);
        printf("assiName=%4d,hole=%4d",virtNet->assiName,virtNet->hole);
        printf("\n left super node \n");
        sNodePtr=virtNet->leftNode;
        Gr_Print_grSuperNode(sNodePtr);
        printf("\n right super node \n");
        sNodePtr=virtNet->rightNode;
        Gr_Print_grSuperNode(sNodePtr);

        printf("\n");
    }
    else {
        printf("\n call to nonexistent virtual net");
    }
}


void Gr_PrintLongSubNets(kPtr)

grRegion *kPtr;

{

grSubNet *headSubNet;
grPinRectangle *pending;
grSuperNode *sNode;
grRootTree *rootTree;
grVirtNet  *virtNet;

headSubNet =kPtr->subNetsPtr;

while(headSubNet != NULL)
{
    printf("\n");
    printf("\nsub net data :\n");
    printf(" net name=%4d", headSubNet->netname);
    printf(" subname = %4d",headSubNet->subname);
    printf(" decCand=%4d", headSubNet->decCandidate);
    printf(" active =%4d", headSubNet->decCandidate);
    printf(" noLooseP=%4d",headSubNet->noLoosePins);
    printf(" action:");
    if (headSubNet->active == 0)
        printf(" : net unassesed    ");
    if (headSubNet->active == 1)
        printf(" : needs assignment ");
    if (headSubNet->active == 2)
        printf(" : no ass intersect occurs");
    if (headSubNet->active ==3)
        printf(" : net on left ");
    if (headSubNet->active ==4)
        printf(" : net on right");
    printf(" noComponents=%4d",headSubNet->noComponents);
    printf("\n");
    if (headSubNet->decomposed==NULL)
    {
        pending=headSubNet->toBeConnected;
        printf("pins to be connected :\n");

        if (pending!=NULL)
            Gr_PrintPinRectangle(pending);

        printf("\n are Connected data:");
        printf("\n");
        pending=headSubNet->areConnected;

        while(pending!=NULL)
        {
            Gr_PrintPinRectangle(pending);
            pending=pending->nextOnList;
        }
    }

    printf("\n decomposed:\n");            
    pending=headSubNet->decomposed;                 

    while(pending!=NULL)                            
    {                                              
        Gr_PrintPinRectangle(pending);          
        pending=pending->nextInNet;            
    }                                               

    /*printf("\n bounding box:");*/

    printf("\n super nodes:");
    sNode=headSubNet->NodeList;
    while(sNode!=NULL)
    {
        Gr_Print_grSuperNode(sNode);
        sNode = sNode->nextOnList;
    }

    rootTree=headSubNet->tree;
    if (rootTree!=NULL) Gr_PrintRootTree(rootTree);

    virtNet=headSubNet->children;
    while(virtNet!=NULL)
    {
        Gr_PrintVirtNet(virtNet);
        virtNet=virtNet->nextInNet;
    }

    headSubNet = headSubNet->nextOnList;
}
printf("\n");
}


void Gr_PrintChain(chainPtr)

grChain *chainPtr;

{

int licz;
grChain *current;

current = chainPtr;
licz = 0;
printf("\n");

while(current!=NULL)
{
    if (licz==10)
    {
        printf("\n");
        licz=0;
    }
    licz++;
    printf(" %4d ",current->name);
    current=current->nextPtr;
}
}


Gr_PrintHole(i)
int i;
{
    grBlock *blockPtr;
    grChain *chainPtr;

    if (grPrintFlag == FALSE) {
        return;
    }

    printf("\n hole number =%4d",i);
    printf("\n left block");
    blockPtr=(grHeadHolePtr+i)->leftBlockPtr;
    if (blockPtr != NULL)
        Gr_PrBlock(blockPtr);
        else 
        printf(" no left block");
    printf("\n right block");
    blockPtr=(grHeadHolePtr+i)->rightBlockPtr;
    if (blockPtr!=NULL)
        Gr_PrBlock(blockPtr);
        else
        printf(" no right block");
    printf("\n status :");
    if ((grHeadHolePtr+i)->status == 0)  printf("  proper bottleneck ");
    if ((grHeadHolePtr+i)->status == 1)  printf(" improper bottln    ");
    if ((grHeadHolePtr+i)->status == 2)  printf("  no bottleneck  ");
    if ((grHeadHolePtr+i)->status == 3)  printf("  bn line  ");
/*
printf("\n bounding points");
printf("\n xtopOrRight=%4d",(grHeadHolePtr+i)->topOrRight_p_x);
printf("   ytopOrRight=%4d",(grHeadHolePtr+i)->topOrRight_p_y);
printf("\n xbotOrRight=%4d",(grHeadHolePtr+i)->botOrLeft_p_x);
printf("   ybotOrRight=%4d",(grHeadHolePtr+i)->botOrLeft_p_y);
printf("\n signal capacity=%4d",(grHeadHolePtr+i)->signalCapacity);
printf("   channel density=%4d",(grHeadHolePtr+i)->chDensity);
printf("\n resident nets");
chainPtr=(grHeadHolePtr+i)->netsInHole;
Gr_PrintChain(chainPtr);
printf("\n");
*/
}


void
Gr_PrintSubNets(kPtr)
grRegion *kPtr;
{
    grSubNet *headSubNet;
    grPinRectangle *pending;
    grSuperNode *sNode;
    grRootTree *rootTree;
    grVirtNet  *virtNet;

    if (grPrintFlag == FALSE) {
        return;
    }

    headSubNet = kPtr->subNetsPtr;

    if (headSubNet == NULL)
    {
        printf("\n REGION HAS NO SUBNETS");
    }

    while(headSubNet != NULL)
    {
         if (headSubNet->netname == 1 ) 
        {
            printf("netname=%4d", headSubNet->netname);
            printf("subname=%4d", headSubNet->subname);
            printf("noLoosePins", headSubNet->noLoosePins);
            printf("\n active =%4d", headSubNet->active);
            if (headSubNet->decomposed==NULL)
            {
                printf(" before decomposition");
                printf(" resident pinrectangle");
                pending=headSubNet->toBeConnected;
                if (pending!=NULL)
                    Gr_PrintPinRectangle(pending);
            }
            else
            {
                printf("after decomposition resident superNodes");
                sNode=headSubNet->NodeList;
                while(sNode!=NULL)
                {
                    Gr_Print_grSuperNode(sNode);
                    sNode=sNode->nextOnList;
                }
            }
            if (headSubNet->critical >0)
            {
                printf("\n net is critical");
                printf("  current status=%4d",headSubNet->critical);
                printf("\n xapprox=%4d",headSubNet->xapprox);
                printf("\n yapprox=%4d",headSubNet->yapprox);
                printf("\n approxLength=%.2f",headSubNet->approxLength);
            }
            rootTree=headSubNet->tree;
            if (rootTree!=NULL) Gr_PrintRootTree(rootTree);

            virtNet=headSubNet->children;
            while(virtNet!=NULL)
            {
                Gr_PrintVirtNet(virtNet);
                virtNet=virtNet->nextInNet;
            }
        }
    headSubNet=headSubNet->nextOnList;
}
printf("\n");
}


void
Gr_PrintFinalResult(num)
int num;
{
    grSortedPin *gSPin;

    if (grPrintFlag == FALSE) {
        return;
    }

    (void) fprintf (bearout, "\n internal name=%4d",(gr_HeadGrNets+num)->name);
    (void) fprintf (bearout, "\n   external name = ");
    puts(((gr_HeadKeyToNets+(gr_HeadGrNets+num)->name)->name));

/*
 *  (void) fprintf (bearout, "\n x sorted pins");
 *
 *  gSPin=(gr_HeadGrNets+num)->firstXPin;
 *
 *  while(gSPin!=NULL)
 *  {
 *      (void) fprintf (bearout, "\n x=%4d  y=%4d   ",
 *          gSPin->pinPtr->x,gSPin->pinPtr->y);
 *      (void) fprintf (bearout, "int name=%4d  extname=%4d",
 *          gSPin->pinPtr->intname,gSPin->pinPtr->extname);
 *
 *      gSPin=gSPin->nextXPin;
 *  }
 *
 *  (void) fprintf (bearout, "\n y sorted pins");
 *
 *  gSPin=(gr_HeadGrNets+num)->firstYPin;
 *
 *  while(gSPin!=NULL)
 *  {
 *      (void) fprintf (bearout, "\n x=%4d  y=%4d",
 *          gSPin->pinPtr->x,gSPin->pinPtr->y);
 *      gSPin=gSPin->nextYPin;
 *  }
 */
}


void
Gr_PrintEndResults()
{
    int i;

    if (grPrintFlag == FALSE) {
        return;
    }

    for (i=1;i<=gr_NetCount;i++)
        Gr_PrintFinalResult(i);
}


void
Gr_PrintEstimatesInBtn()
{
    int i;
    grHole *gHole;

    if (grPrintFlag == FALSE) {
        return;
    }

    printf("\n estimated lengths in btn");

    for (i=1;i<=n;i++)
    {
        gHole=(grHeadHolePtr+i);

        printf("\n btn number %4d",i);
        printf("  leftEst=%4d",gHole->leftEst);
        printf("  rightEst=%4d",gHole->rightEst);
        printf("  height=%4d",gHole->height);

    }
    printf("\n");
}


void Gr_PrintCurrentLengthsOfNets()

{

int i,gRName;
grNet *gNet;
BearString name;

if (gr_Timing ==1)
{
/* nets calculated and printed only in timing mode*/
printf("\n Current Lengths of Nets");
printf("\n gr_NetCount=%4d",gr_NetCount);
printf("\n");

    for (i=1;i<=gr_NetCount;i++)
    {
        gNet=(gr_HeadGrNets+i);


        gRName=gNet->name;
        name=(gr_HeadKeyToNets+gRName)->name;
        printf("\n net number %4d",gRName);
        printf("  originally  ");
        puts(name);
        printf("  current status %4d",gNet->critical);
        printf("\n currentLength=%.2f",gNet->currentLength);
        printf("    xfixed=%4d",gNet->xfixed);
        printf("    yfixed=%4d",gNet->yfixed);
        printf("    xapprox=%4d",gNet->xapprox);
        printf("    yapprox=%4d",gNet->yapprox);
        if (gNet->critical > 0)
        {
             printf("\n maxlength=%.2f",gNet->maxlength);
        }
                printf("\n");
    }
printf("\n");
}
}


void Gr_PrintHoleBoundsForCriticalNets(dir)

int dir;

{
    int i,gRName;
    grNet *gNet;
    BearString name;

    if (dir>0)
    {
    printf("\n Hole bounds for criticalnets");
        for (i=1;i<=gr_NetCount;i++)
        {
            gNet=(gr_HeadGrNets+i);
            if (gNet->critical >0)
                {
                gRName=gNet->name;
                name=(gr_HeadKeyToNets+gRName)->name;
                printf("\n net number %4d",gRName);
                printf("  originally");
                puts(name);
                printf("\n top=%4d",gNet->topHole);
                printf("   bot=%4d",gNet->botHole);
                }
        }
        printf("\n");
    }
}



void Gr_PrintBnLines()

{

    int i;
    grBnLine *gBLine;

    gBLine=grBnLineList;
    i=0;
    printf("\n bottleneck lines:\n");

    while(gBLine!=NULL)
    {
        i++;
        printf("\n bnline nr=%4d",i);
        printf("   type=%4d",gBLine->type);
        printf("   base=%4d",gBLine->base);
        printf("   lb=%4d",gBLine->lb);
        printf("   rt=%4d",gBLine->rt);
        printf("   cover=%4d",gBLine->cover);
        printf("   bntype=%4d",gBLine->bntype);

        gBLine=gBLine->nextBnLine;

    }

    printf("\n");

}
