
/* mmsVNetSupport.c --
 *
 *     Malgorzata Marek-Sadowska
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalRouter/mmsVNetSupport.c,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $";
#endif  not lint

#include "grInt.h"


void Gr_SetBoundBox(sNet)

grSubNet *sNet;

/*
	For a newly created subnet pointed to by sNet the bounding box is set
	Bounding box considered here is for the entire subnet                
*/


{

	grPinRectangle *current;

	if ((sNet->toBeConnected != NULL)||(sNet->areConnected != NULL)) 
	{
		/*net is !=0*/
		/*initialize*/
		if (sNet->toBeConnected != NULL)
		{
			sNet->minx=sNet->toBeConnected->minx;
			sNet->maxx=sNet->toBeConnected->maxx;
			sNet->miny=sNet->toBeConnected->miny;
			sNet->maxy=sNet->toBeConnected->maxy;

			current=sNet->areConnected;

		}
		else
		{
			sNet->minx=sNet->areConnected->minx;
			sNet->maxx=sNet->areConnected->maxx;
			sNet->miny=sNet->areConnected->miny;
			sNet->maxy=sNet->areConnected->maxy;

			current=sNet->areConnected->nextInNet;

		}

		while(current!=NULL)
		{
			if (sNet->minx > current->minx )
				sNet->minx = current->minx;

			if (sNet->maxx < current->maxx )
				sNet->maxx = current->maxx;

			if (sNet->miny > current->miny )
				sNet->miny = current->miny;

			if (sNet->maxy < current->maxy )
				sNet->maxy = current->maxy;

			current=current->nextInNet;

		}  /*end while*/
	}
}


void Gr_UpdateBoundingBox(pRectPtr)

grPinRectangle *pRectPtr;

/*
	The bounding box for a single pinRectangle pointed to by pRectPtr is   
	updated. Also number of pins resident in the pinRectangle is determined
*/
{

	int cnt;
	grSortedPin *run;

	/*initialize*/
        if (pRectPtr->firstxPin!=NULL)
        {
	pRectPtr->minx = pRectPtr->firstxPin->pinPtr->x;
	pRectPtr->miny = pRectPtr->firstyPin->pinPtr->y;
	/*end initialization*/

	run=pRectPtr->firstxPin;
	cnt=0;

	while(run!=NULL)
	{
		cnt++;
		if (run->nextxPin==NULL)
		{
			pRectPtr->maxx = run->pinPtr->x;
		}
		run=run->nextxPin;
	}

	pRectPtr->count = cnt;
	run=pRectPtr->firstyPin;

	while(run!=NULL)
	{
		if (run->nextyPin == NULL)
		{
			pRectPtr->maxy = run->pinPtr->y;
		}
		run=run->nextyPin;
	}

        }
        else
        {
        pRectPtr->count=0;
        }
}



grSortedPin  *Gr_DeleteSortedPinFromXLinksInPinRectangle(current,pending,before)

grSuperNode *current;
grSortedPin *pending,*before;


/*
The sorted pin pending which has sorted pin before in front is removed   
from the pinRectangle of SuperNode current. Removal is only with respect 
to internal x links. The pointer to a new sorted pin which follows before
is returned .                                                            
*/

{

	if (before == NIL(grSortedPin))
	{
		current->contentsPtr->firstxPin=pending->nextxPin;
		pending=current->contentsPtr->firstxPin;
	}
	else
	{
		before->nextxPin=pending->nextxPin;
		pending=before->nextxPin;
	}

	return  (pending);

}



grSortedPin  *Gr_DeleteSortedPinFromYLinksInPinRectangle(current,pending,before)

grSuperNode  *current;
grSortedPin *pending,*before;



/*
Deletes pending which follows before from y links of pin rectangle of     
current. Returns a sorted pin which is now after before.  
*/

{

	if (before==NULL)
	{
		current->contentsPtr->firstyPin=pending->nextyPin;
		pending=current->contentsPtr->firstyPin;
	}
	else
	{
		before->nextyPin=pending->nextyPin;
		pending=before->nextyPin;
	}

	return (pending);
}



void Gr_CreatePseudoPin(sNet,sNode,iname,x,y,side,tilePtr)

grSubNet *sNet;
grSuperNode *sNode;
BearId iname;
int x,y,side;
Tile *tilePtr;


/*
	Creates a new grPin and grSortedPin and inserts them into the lists  
	of all grPins, all grSortedPins and puts grSortedPin into a proper    
	place sorted for x,y,X,Y.                                             
*/



{
	grPin *gPin;
	grSortedPin *gSPin;
	grNet *gNet;
	Net *net;
	PseudoPin *ppinPtr;

	gNet=(gr_HeadGrNets+(sNet->netname));
	net=gNet->netBear;

	/*create new grPin*/
        gPin=Gr_CreateGrPin();

	gPin->x=x;
	gPin->y=y;
	gPin->type=2;

       if (side==1)
       {
          gPin->shade = EAST_PIN;
       }

       if (side == 3)
       {
          gPin->shade = WEST_PIN;
       }

       if (side == 2)
       {
          gPin->shade = SOUTH_PIN;
       }

       if (side == 4)
       {
          gPin->shade = NORTH_PIN;
       }
	gPin->netname=sNet->netname;
	gPin->extname=0;
	gPin->intname=iname;

	Gr_AssignRoomToPPin(gPin);

	/* end new grPin*/
	/*no pseudo pin created in bear database yet*/

    if (gr_BearConnection ==1)
    {
        /* create pseudo pin in the bear database*/
        if (side==1)
        { 
            /* pseudo pin on the right side */
            (void) Tp_CreatePPin(tilePtr, TOP_RIGHT_SIDE, TP_BOTTOM,
                &ppinPtr);
        }
        if (side==2)
        {
            /* pseudo pin at the bottom*/
            (void) Tp_CreatePPin(tilePtr, BOTTOM_LEFT_SIDE, TP_BOTTOM,
                &ppinPtr);
        }
        if (side==3)
        {
            /* pseudo pin at the left*/
            (void) Tp_CreatePPin(tilePtr, BOTTOM_LEFT_SIDE, TP_BOTTOM,
                &ppinPtr);
        }
        if (side==4)
        {
            /* pseudo pin at the top */
            (void) Tp_CreatePPin(tilePtr, TOP_RIGHT_SIDE, TP_BOTTOM,
                &ppinPtr);
        }

        gPin->PinPtr.pseudoPin= ppinPtr;

        Tp_PutIntNetIdOfPPin(iname, ppinPtr);
        Tp_PutNetOfPPin(net, ppinPtr);
       
        /* end pseudo pin created in bear database */
	}
	
	/* Create new grSortedPin */

        gSPin=Gr_CreateSortedPin();

	gSPin->pinPtr=gPin;
	gSPin->side=side;
	/* end new grSortedPin*/

	/* Establish links */
	Gr_InsertXGeneral(gNet,gSPin);
	Gr_InsertYGeneral(gNet,gSPin);
	Gr_InsertXToPinRectangle(gSPin,(sNode->contentsPtr));
	Gr_InsertYToPinRectangle(gSPin,(sNode->contentsPtr));
        Gr_UpdateBoundingBox((sNode->contentsPtr));

}


void Gr_CreateBnPseudoPin(sNet,sNode,iname,x,y,side,tilePtr,bnLinePtr)

grSubNet *sNet;
grSuperNode *sNode;
BearId iname;
int x,y,side;
Tile *tilePtr;
BNLine  *bnLinePtr;


/*
	Creates a new grPin and grSortedPin and inserts them into the lists  
	of all grPins, all grSortedPins and puts grSortedPin into a proper    
	place sorted for x,y,X,Y.                                             
	Partial link to bear here.PPin created for right-bottom side .        
*/


{


	grPin		*gPin;
	grSortedPin	*gSPin;
	grNet		*gNet;
	PseudoPin	*ppinPtr;
	Rect		rect;
	Net		*net;

	gNet=(gr_HeadGrNets+(sNet->netname));
	net=gNet->netBear;

	/*create new grPin*/
        gPin=Gr_CreateGrPin();

	gPin->x=x;
	gPin->y=y;

/* was 2 changed to 4 to please Tim   */
	if ((side==1)||(side==4))
	{
		gPin->type=5;
	}
	else
	{
		gPin->type=4;
	}

        if ((side==1)||(side==3))
        {
	   gPin->shade=EAST_WEST_PIN;
        }
        else
        {
           gPin->shade=NORTH_SOUTH_PIN;
        }
	gPin->netname=sNet->netname;
	gPin->extname=0;
	gPin->intname=iname;

	Gr_AssignRoomToPPin(gPin);

	/* end new grPin*/
	/*no pseudo pin created in bear database yet*/

	if ((gr_BearConnection ==1)&&(gPin->type == 5))
	{
	/*
		CHANGE TO THE SAME RULE AS IN tpPPin.c

		if (Tp_IsHorzTile(tilePtr))
		{
			Tp_HorzTileToRect(grPlaneDataPtr,tilePtr,&rect);

			if ((gPin->y >= (rect.r_ybot + gr_yShift - 1)) &&
				(gPin->y <= (rect.r_ybot + gr_yShift + 1)))
			{
				(void) Tp_CreatePPin(tilePtr,
					BOTTOM_LEFT_SIDE,TP_BOTTOM,&ppinPtr);
			}
			else
			{
				if ((gPin->y >= (rect.r_ytop +gr_yShift - 1)) &&
				(gPin->y <= (rect.r_ytop +gr_yShift + 1)))
				{
					(void) Tp_CreatePPin(tilePtr,
					TOP_RIGHT_SIDE,TP_BOTTOM,&ppinPtr);
				}
			}
		}
		else
		{
			Tp_VertTileToRect(grPlaneDataPtr,tilePtr,&rect);
			if ((gPin->x >= (rect.r_xbot +gr_xShift - 1)) &&
				(gPin->x <= (rect.r_xbot +gr_xShift + 1)))
			{
				(void) Tp_CreatePPin(tilePtr,
					BOTTOM_LEFT_SIDE,TP_BOTTOM,&ppinPtr);
			}
			else
			{
				if ((gPin->x >= (rect.r_xtop +gr_xShift - 1)) &&
				(gPin->x <= (rect.r_xtop +gr_xShift + 1)))
				{
					(void) Tp_CreatePPin(tilePtr,
					TOP_RIGHT_SIDE,TP_BOTTOM,&ppinPtr);
				}
			}
		}
	*/

		Tp_CreatePPinOfBnLine(bnLinePtr, &ppinPtr);
	
		gPin->PinPtr.pseudoPin= ppinPtr;

		Tp_PutNetOfPPin(net,ppinPtr);
       
	}
	
	
	/* Create new grSortedPin */

        gSPin=Gr_CreateSortedPin();

	gSPin->pinPtr=gPin;
	gSPin->side=side;

	/* end new grSortedPin*/

	/* Establish links */
	Gr_InsertXGeneral(gNet,gSPin);
	Gr_InsertYGeneral(gNet,gSPin);
	Gr_InsertXToPinRectangle(gSPin,(sNode->contentsPtr));
	Gr_InsertYToPinRectangle(gSPin,(sNode->contentsPtr));
        Gr_UpdateBoundingBox((sNode->contentsPtr));
}


void Gr_InsertIdToBtnPPins()



/*
	Inserts internal id's for left -top ppins in bn lines   
	Has to be called after routing has been completed       
*/



{

int i;
BearId lname,iname;
grSortedPin *gSPin,*run;
PseudoPin *ppinPtr;

for (i=1;i<=gr_NetCount;i++)
{
	gSPin=(gr_HeadGrNets+i)->firstXPin;

	while(gSPin!=NULL)
	{
		if (gSPin->pinPtr->type==5)
		{
			ppinPtr=gSPin->pinPtr->PinPtr.pseudoPin;
			iname=gSPin->pinPtr->intname;

			run=(gr_HeadGrNets+i)->firstXPin;
			while(run!=NULL)
			{

				if ((run->pinPtr->type == 4)&&
				(run->pinPtr->intname == iname))
				{
					/* JULY 20 : */
					run->pinPtr->PinPtr.pseudoPin=ppinPtr;
					/* up to here */
					lname=run->pinPtr->extname;
					Tp_PutIntNetIdOfPPin(lname,ppinPtr); 
					/* external put in GiveNamesToPins*/
					goto lab1;
				}
			run=run->nextXPin;
			}
		}
		lab1:;
	gSPin=gSPin->nextXPin;
	}
}

}

void Gr_CreateImaginaryPins(sNet,lNode,rNode,lName,rName,x,y,dir)

grSubNet *sNet;
grSuperNode *lNode,*rNode;
BearId lName,rName;
int x,y,dir;

/*
	Create a new grPin and 2 grSortedPins at position x,y. One        
	grSortedPin is inserted into lNode, the other one into rNode      
	dir=1 : vertical cut, dir = 2 : horz cut. Side of grSortedPin is  
	determined based on dir.                                          
*/

{

	grPin *gPin;
	grSortedPin *gLSPin,*gRSPin;
	grNet *gNet;

	gNet=(gr_HeadGrNets+(sNet->netname));

	/*create a new pin */

        gPin=Gr_CreateGrPin();

	gPin->x=x;
	gPin->y=y;
	gPin->type=3;
	if (dir==1)
	{
		gPin->shade=EAST_WEST_PIN;
	}
	if (dir==2)
	{
		gPin->shade=NORTH_SOUTH_PIN;
	}
	gPin->netname=sNet->netname;
	gPin->intname=lName;
	gPin->extname=rName;
	gPin->PinPtr.pseudoPin=NULL; 
	/* imaginary pin does not point to the bear*/
	/* data base                               */

	/* Create new grSorted pins */

        gLSPin=Gr_CreateSortedPin();
        gRSPin=Gr_CreateSortedPin();
        

	gLSPin->pinPtr=gPin;
	gRSPin->pinPtr=gPin;

	if (dir==1)
	{
		gLSPin->side=3;
		gRSPin->side=1;
	}
	if (dir==2)
	{
		gLSPin->side=4;
		gRSPin->side=2;
	}
	/* end new grSortedPins */

	/* Establish links */

	Gr_InsertXGeneral(gNet,gLSPin);
	Gr_InsertYGeneral(gNet,gLSPin);
	Gr_InsertXToPinRectangle(gLSPin,(lNode->contentsPtr));
	Gr_InsertYToPinRectangle(gLSPin,(lNode->contentsPtr));
        Gr_UpdateBoundingBox((lNode->contentsPtr));

	Gr_InsertXGeneral(gNet,gRSPin);
	Gr_InsertYGeneral(gNet,gRSPin);
	Gr_InsertXToPinRectangle(gRSPin,(rNode->contentsPtr));
	Gr_InsertYToPinRectangle(gRSPin,(rNode->contentsPtr));
        Gr_UpdateBoundingBox((rNode->contentsPtr));

}



void Gr_ClearMarksOfDecomposedTrees(sNet)

grSubNet  *sNet;



/*
In decomposed rootTrees removed edges are marked 2. Those marks are not
cleared. All other marks are set to 0.                                 
*/

{

	grRootTree  *current;

	current=sNet->tree;

        if (current!=NULL)
        {
          while(current->nextInSubnet!=NULL)
           {
            current=current->nextInSubnet;
           }
        }

	while(current!=NULL)
	{
		if (current->mark != 2)
			current->mark =0;

		current=current->nextOnList;
	}
}



void  Gr_GiveNamesToRootTreeNodes(sNet)

grSubNet *sNet;


/*
After root tree has been decomposed  each subtree will become eventually 
a subnet in the subregion. These subnets are recognized by the names given
to their nodes.                                                          
The node names are given here.                                           
*/

{

	BearId newname;
	grRootTree *rTree,*hTree;

	newname = Gr_GetNewSubNetName();
	rTree=sNet->tree;
        hTree=rTree;

	Gr_ClearMarksOfDecomposedTrees(sNet);

	while(rTree!=NULL)
	{
		rTree->nodePtr->nodeName=newname;
		if (rTree->mark!=2)  rTree->mark=1;

lab1:    

		if (rTree->childPtr!=NULL)
		{
			if (rTree->childPtr->mark == 0)
			{
				rTree=rTree->childPtr;
				rTree->mark=1;
				rTree->nodePtr->nodeName=newname;
				goto lab1;
			}
		}

		if (rTree->siblingPtr!=NULL)
		{
			if (rTree->siblingPtr->mark==0)
			{
				rTree=rTree->siblingPtr;
				rTree->mark=1;
				rTree->nodePtr->nodeName=newname;
				goto lab1;
			}
		}

		if ((rTree->fatherPtr!=NULL)&&(rTree->mark!=2))
		{
			rTree=rTree->fatherPtr;
			goto lab1;
		}
		else
		{
			/* get new subtree */
			rTree=hTree->nextInSubnet;
                        hTree=rTree;
                       /* get head of the new tree */
                        if (hTree!=NULL)
                        {
                          while((hTree->fatherPtr!=NULL)&&(rTree->mark!=2)) 
                            {
                              hTree=hTree->fatherPtr;
                            }
                        }
                      rTree=hTree;
                        /* get head of the new sub tree*/
                        if (hTree!=NULL)
                        {
                           while((hTree->fatherPtr!=NULL)&&(rTree->mark!=2))
                           {
                              hTree=hTree->fatherPtr;
                           }
                        }
                        rTree=hTree;
			newname=Gr_GetNewSubNetName();
		}

	}  /* end while*/

}


void Gr_NameSuperNodesAfterVirtualNetsWereCreated(sNet)

/*
All the super nodes get their names. It is needed at the next level  
of the hierarchy to recognize new subnets                             
*/

grSubNet  *sNet;


{

	BearId nme1,nme2;
	grSuperNode *current;

	if ((sNet->active==5)||(sNet->active==6))
	{
		nme1=Gr_GetNewSubNetName();
		nme2=Gr_GetNewSubNetName();
		current=sNet->NodeList;

		while(current!=NULL)
		{
			if (current->side==1)
			{
				current->nodeName=nme1;
			}
			else
			{
				current->nodeName=nme2;
			}
			current=current->nextOnList;
		}
	}
	if (sNet->active==7)
	{
		Gr_GiveNamesToRootTreeNodes(sNet);
	}

}



void Gr_PutInitialBoundBox(i,gPRect)

int i; /* grnet number */
grPinRectangle *gPRect; /* pointer to rect from which to copy box*/

{

grNet *gNet;

	gNet=(gr_HeadGrNets+i);

	gNet->xLor=gPRect->minx;
	gNet->xRor=gPRect->maxx;
	gNet->yTor=gPRect->maxy;
	gNet->yBor=gPRect->miny;


}
