
/* gsCalcCapDenOfTilePlane.c --
 *
 *     M. Kobayashi
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalSpacer/gsCalcCapDenOfTilePlane.c,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "gtGraph.h"
#include "fpg.h"
#include "tileProp.h"
#include "mac.h"


static int GsItrTiles();
static BearStatus GsItrBnLines();



/* ----------------------------------------------------------------------------
 *
 * Gs_CalcCapDenOfTilePlnae() --
 *
 * Results:
 *  None.
 *
 * Side effects:
 *  None.
 *
 * ----------------------------------------------------------------------------
 */

BearStatus
Gs_CalcCapDenOfTilePlane(parentCellPtr)
CellMaster *parentCellPtr;
{

    PlaneData *planeDataPtr;

    planeDataPtr = Mac_GetCellPlaneOfCell(parentCellPtr);

    TiSrArea(NIL(Tile),
        Tp_GetHorzPlane(planeDataPtr),
        Tp_GetHorzPlaneBnd(planeDataPtr),
        GsItrTiles,
        (ClientData) parentCellPtr);
    TiSrArea(NIL(Tile),
        Tp_GetVertPlane(planeDataPtr),
        Tp_GetVertPlaneBnd(planeDataPtr),
        GsItrTiles,
        (ClientData) parentCellPtr);

    Tp_ItrHorzBnLine(planeDataPtr, GsItrBnLines, (ClientData) NULL);
    Tp_ItrVertBnLine(planeDataPtr, GsItrBnLines, (ClientData) NULL);

    return (BEAR_OK);
}



static int
GsItrTiles(tilePtr, parentCellPtr)
Tile       *tilePtr;
CellMaster *parentCellPtr;
{

    if (Tp_IsBottleneckTile(tilePtr)) {
        Gs_CalcCapDenOfBnTile(parentCellPtr, tilePtr);
#ifdef DEBUG
{
        int tileCap, tileDen;

        tileCap = Tp_GetCapacityOfTile(tilePtr);
        tileDen = Tp_GetDensityOfTile(tilePtr);
        if (tileCap < 0 || tileDen < 0) {
            Bear_PrintFatalErr("GsItrTiles() failed : negative number");
        }
}
#endif DEBUG
    }

    return (MAGIC_CONTINUE_SEARCH);
}



/* ARGSUSED */
static BearStatus
GsItrBnLines(bnLinePtr,clientData)
BNLine     *bnLinePtr;
ClientData clientData;
{
    Gs_CalcCapDenOfBnLine(bnLinePtr);
#ifdef DEBUG
{
    int tileCap, tileDen;

    tileCap = Tp_GetCapacityOfBnLine(bnLinePtr);
    tileDen = Tp_GetDensityOfBnLine(bnLinePtr);
    if (tileCap < 0 || tileDen < 0) {
        Bear_PrintFatalErr("GsItrBnLines() failed : negative number");
    }
}
#endif DEBUG

    return (BEAR_CONTINUE_SEARCH);
}


