
/* gsInitSpaceTile --
 *
 *     Wei-Ming Dai
 *     (Professor E. S. Kuh)
 *
 * This module preprocesses tiles for global spacer.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/globalSpacer/gsInit.c,v 1.1.1.1 2002/12/31 15:51:09 saj Exp $";
#endif  not lint

#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"


static PlaneData  *globalPlaneDataPtr;
static Rect       planeSearchRect;
static CellMaster *globalParentCellPtr;


/* ---------- Local Procedures ---------- */
static int InitHorzSpaceTile(), InitVertSpaceTile();
static int ClearSpaceTile();


/* ARGSUSED */
static int
InitHorzSpaceTile(horzTilePtr, clientData)

register Tile *horzTilePtr;
ClientData    clientData;
{
    Rect tileRect;
    int  tileCapacity;
    int  tileDensity;
    long random();

/*
printf ("Enter  InitHorzSpaceTile ()\n");
fflush (stdout);
*/


    if (Tp_IsSpaceTile (horzTilePtr))
    {
    if (Tp_IsBottleneckTile (horzTilePtr))
    {

/*
printf ("Is bottleneck tile\n");
fflush (stdout);
*/

    /*
    Tp_HorzTileToRect(globalPlaneDataPtr, horzTilePtr, &tileRect);
        TITORECT (horzTilePtr, &tileRect);
        GeoClip (&tileRect, &planeSearchRect);
    */

/*
Mac_PrintRect (&tileRect);
*/

        /*
        tileCapacity = tileRect.r_xtop - tileRect.r_xbot;
        tileDensity = tileCapacity * (((float)((random () % 200))) / 100.0);
        tileDensity = 0;
        Tp_PutDensityOfTile (tileDensity, horzTilePtr);
        Tp_PutCapacityOfTile (tileCapacity, horzTilePtr);
        */

    /*
    if (Tp_GetCapacityOfTile(horzTilePtr) == 0 &&
        Tp_GetDensityOfTile(horzTilePtr) == 0)
    {
        (void) Gs_CalcCapDenOfBnTile(globalParentCellPtr, horzTilePtr);
    */
    /*
    }
    else
    {
        tileCapacity = tileRect.r_xtop - tileRect.r_xbot;
        Tp_PutCapacityOfTile (tileCapacity, horzTilePtr);
    }
    */
    }
    else
    {

/*
printf ("Is non-bn space tile\n");
fflush (stdout);
*/

        Tp_PutCapacityOfTile (INFINITY, horzTilePtr);
        Tp_PutDensityOfTile (0, horzTilePtr);
    }

/*
printf ("Tile Cap = %d\n", Tp_GetCapacityOfTile (horzTilePtr));
printf ("Tile Den = %d\n", Tp_GetDensityOfTile (horzTilePtr));
fflush (stdout);
*/

Tp_PutPrevTileOfTile(NIL(Tile), horzTilePtr);
    }
    else
    {

/*
printf ("Is solid tile\n");
fflush (stdout);
*/

    }
    return (MAGIC_CONTINUE_SEARCH);
}



/* ARGSUSED */
static int
InitVertSpaceTile(vertTilePtr, clientData)

register Tile *vertTilePtr;
ClientData    clientData;
{
    Rect tileRect;
    int  tileCapacity;
    int  tileDensity;
    long random();

/*
printf ("Enter  InitVertSpaceTile ()\n");
fflush (stdout);
*/

    if (Tp_IsSpaceTile (vertTilePtr))
    {

    if (Tp_IsBottleneckTile (vertTilePtr))
    {

/*
printf ("Is bottleneck tile\n");
fflush (stdout);
*/

    /*
    Tp_VertTileToRect(globalPlaneDataPtr, vertTilePtr, &tileRect);
        TITORECT (vertTilePtr, &tileRect);
        GeoClip (&tileRect, &planeSearchRect);
    */

/*
Mac_PrintRect (&tileRect);
*/

        /*
        tileCapacity = tileRect.r_xtop - tileRect.r_xbot;
        tileDensity = tileCapacity * (((float)((random () % 200))) / 100.0);
        tileDensity = 0;
        Tp_PutDensityOfTile (tileDensity, vertTilePtr);
        Tp_PutCapacityOfTile (tileCapacity, vertTilePtr);
    if (Tp_GetCapacityOfTile(vertTilePtr) == 0 &&
        Tp_GetDensityOfTile(vertTilePtr) == 0)
    {
        (void) Gs_CalcCapDenOfBnTile(globalParentCellPtr, vertTilePtr);
        */
    /*
    }
    else
    {
        tileCapacity = tileRect.r_xtop - tileRect.r_xbot;
        Tp_PutCapacityOfTile (tileCapacity, vertTilePtr);
    }
    */
    }
    else
    {

/*
printf ("Is non-bn space tile\n");
fflush (stdout);
*/
        Tp_PutCapacityOfTile (INFINITY, vertTilePtr);
        Tp_PutDensityOfTile (0, vertTilePtr);
    }

/*
printf ("Tile Cap = %d\n", Tp_GetCapacityOfTile (vertTilePtr));
printf ("Tile Den = %d\n", Tp_GetDensityOfTile (vertTilePtr));
fflush (stdout);
*/

    Tp_PutPrevTileOfTile(NIL(Tile), vertTilePtr);
    }
    else
    {

/*
printf ("Is solid tile\n");
fflush (stdout);
*/

    }

    return (MAGIC_CONTINUE_SEARCH);
}



/*
 * ----------------------------------------------------------------------------
 *
 * Gs_InitSpaceTile() --
 *
 * Results:
 *     None.
 *
 * Side effects:
 *     None.
 *
 * ----------------------------------------------------------------------------
 */

void 
Gs_InitSpaceTile(planeDataPtr, parentCellPtr)
PlaneData   *planeDataPtr;
CellMaster  *parentCellPtr;
{
   Plane *planePtr;
   Rect  *planeBndPtr;
   Rect  *horzPlaneBndPtr;

   globalPlaneDataPtr = planeDataPtr; 
   globalParentCellPtr = parentCellPtr;

   srandom (getpid ());

/*
printf ("Enter  Gs_InitSpaceTile ()\n");
fflush (stdout);
*/

/*
printf ("TiSrArea in horz. plane\n");
fflush (stdout);
*/

   planePtr = Tp_GetHorzPlane(planeDataPtr);
   /*
   Tp_FindBBoxForAllCells(planeDataPtr, &planeSearchRect);
   */
   horzPlaneBndPtr = Tp_GetHorzPlaneBnd(planeDataPtr);
   Mac_CopyRect(&planeSearchRect, horzPlaneBndPtr);

/*
printf ("plane rect: ");
fflush (stdout);
Mac_PrintRect (&planeSearchRect);
*/

   (void) TiSrArea((Tile *) NULL,
            planePtr,
            &planeSearchRect,
            InitHorzSpaceTile,
            (ClientData) NULL);

/*
printf ("TiSrArea on vert. plane\n");
fflush (stdout);
*/

   planePtr = Tp_GetVertPlane (planeDataPtr);
   /*
   Tp_FindBBoxForAllCells (planeDataPtr, &planeSearchRect1);
   */
   Tp_HRectToVRect(horzPlaneBndPtr, &planeSearchRect);

/*
printf ("plane rect: ");
fflush (stdout);
Mac_PrintRect(&planeSearchRect);
*/

   (void) TiSrArea(NIL(Tile),
            planePtr,
            &planeSearchRect,
            InitVertSpaceTile,
            (ClientData) NULL);
}



/* ARGSUSED */
static int
ClearSpaceTile(tilePtr, clientData)

register Tile *tilePtr;
ClientData    clientData;
{

/*
printf ("Enter  ClearSpaceTile()\n");
fflush (stdout);
*/

    if (Tp_IsSpaceTile(tilePtr) == TRUE)
    {
        Tp_PutRidgeWidthOfTile(0, tilePtr);
        Tp_PutPrevTileOfTile(NIL(Tile), tilePtr);
    }
    return (MAGIC_CONTINUE_SEARCH);
}



void 
Gs_ClearHorzSpaceTile(planeDataPtr)
PlaneData   *planeDataPtr;
{
   Plane *planePtr;
   Rect  *planeBndPtr;

   globalPlaneDataPtr = planeDataPtr; 

/*
printf ("Enter  Gs_ClearHorzSpaceTile ()\n");
fflush (stdout);
*/

/*
printf ("TiSrArea in horz. plane\n");
fflush (stdout);
*/

   planePtr = Tp_GetHorzPlane (planeDataPtr);
   planeBndPtr = Tp_GetHorzPlaneBnd(planeDataPtr);

   (void) TiSrArea((Tile *) NULL,
            planePtr,
            planeBndPtr,
            ClearSpaceTile,
            (ClientData) NULL);
}

void 
Gs_ClearVertSpaceTile(planeDataPtr)
PlaneData   *planeDataPtr;
{
   Plane *planePtr;
   Rect  *planeBndPtr;

   globalPlaneDataPtr = planeDataPtr; 

/*
printf ("Enter  Gs_ClearVertSpaceTile ()\n");
fflush (stdout);
*/

/*
printf ("TiSrArea on vert. plane\n");
fflush (stdout);
*/

   planePtr = Tp_GetVertPlane(planeDataPtr);
   planeBndPtr = Tp_GetVertPlaneBnd(planeDataPtr);

   (void) TiSrArea((Tile *) NULL,
            planePtr,
            planeBndPtr,
            ClearSpaceTile,
            (ClientData) NULL);
}

