
/* greNetToDataBase.c --
 *
 *     Malgorzata Marek-Sadowska
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/grEditor/greNetToDataBase.c,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include "port.h"
#include "malloc.h"
#include "magic.h"
#include "geometry.h"
#include "bear.h"
#include "tile.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "grEditor.h"
#include "grEditorInt.h"
#include "grStorage.h"


/*
 *  Here are functions which build internal data structures for the
 *  part which puts data into Mac.
 */


/* ---------- Local Procedures ---------- */
static BearStatus StoreJunctData();


void
grEd_FillInBtncks()
{
    greBtnListHeadPtr = NULL;
    (void) TiSrArea(NIL(Tile), Tp_GetHorzPlane(grePlaneDataPtr),
        Tp_GetHorzPlaneBnd(grePlaneDataPtr), grEd_GetBtn, (ClientData) NULL);

    (void) TiSrArea(NIL(Tile), Tp_GetVertPlane(grePlaneDataPtr),
        Tp_GetVertPlaneBnd(grePlaneDataPtr), grEd_GetBtn, (ClientData) NULL);
}


/* ARGSUSED */
int grEd_GetBtn(tilePtr,clientData)

register Tile *tilePtr;
ClientData clientData;

{
    grEd_Btn *current;

    current = greBtnListHeadPtr;
    if (Tp_IsBottleneckTile(tilePtr));
    {
        MALLOC(grEd_Btn*,greBtnListHeadPtr,sizeof (grEd_Btn));
        greBtnListHeadPtr->nextBtn = current;
        greBtnListHeadPtr->ltmark = 0;
        greBtnListHeadPtr->rbmark = 0;
        greBtnListHeadPtr->tilePtr = tilePtr;
        greBtnListHeadPtr->name = Mac_GenerateId();
    }

    return (0); /* continue search */
}


void grEd_FillInBtnLines()

{
    greBtnLineHeadPtr = NULL;

    (void) Tp_ItrHorzBnLine(grePlaneDataPtr, grEd_GetBnLines,
        (ClientData) NULL);
    (void) Tp_ItrVertBnLine(grePlaneDataPtr, grEd_GetBnLines,
        (ClientData) NULL);
}


/* ARGSUSED */
BearStatus
grEd_GetBnLines(bnLine,clientData)
BNLine      *bnLine;
ClientData  clientData;
{
    grEd_BtnLine   *current;
    BNLineType     bnLineType;

    current = greBtnLineHeadPtr;

    MALLOC(grEd_BtnLine*,greBtnLineHeadPtr,sizeof (grEd_BtnLine));
    greBtnLineHeadPtr->nextBtnLine = current;
    greBtnLineHeadPtr->bnLinePtr = bnLine;
    greBtnLineHeadPtr->cross = 0;

    bnLineType = Tp_GetBnLineTypeOfBnLine(bnLine);

    if (bnLineType == (BNLineType) TP_HORZ_B_RIGHT)
    {
        greBtnLineHeadPtr->tilePtr = Tp_GetBRTileOfBnLine(bnLine);
    }

    if (bnLineType == (BNLineType) TP_HORZ_B_LEFT)
    {
        greBtnLineHeadPtr->tilePtr = Tp_GetTLTileOfBnLine(bnLine);
    }

    if (bnLineType == (BNLineType) TP_VERT_R_UP)
    {
        greBtnLineHeadPtr->tilePtr = Tp_GetBRTileOfBnLine(bnLine);
    }

    if (bnLineType == (BNLineType) TP_VERT_R_DOWN)
    {
        greBtnLineHeadPtr->tilePtr = Tp_GetTLTileOfBnLine(bnLine);
    }

    return (BEAR_CONTINUE_SEARCH);

}
    

void
grEd_StoreJunctData()
{
    greNodeListHeadPtr = NIL(grEd_Node);
    (void) Fpg_ItrWallJunctSeq(greFpgPtr, StoreJunctData, (ClientData) NULL);
}


void
grEd_FreeJunctData()
{
    register grEd_Node *nodePtr;

    while ((nodePtr = greNodeListHeadPtr) != NIL(grEd_Node)) {
        greNodeListHeadPtr = nodePtr->nextNode;
        FREE((char *) nodePtr);
    }
}


/* ARGSUSED */
static BearStatus
StoreJunctData(junctPtr, clientData)
WallJunction    *junctPtr;
ClientData      clientData;
{
    grEd_Node *nodePtr;

    MALLOC(grEd_Node *, nodePtr, sizeof (grEd_Node));

    nodePtr->jPtr = junctPtr;
    nodePtr->nextNode = greNodeListHeadPtr;
    nodePtr->name = Mac_GenerateId();

    greNodeListHeadPtr = nodePtr;

    return (BEAR_CONTINUE_SEARCH);
}


WallSegment *
grEd_GetCoveringWallSegment(pinPtr)
PinInst *pinPtr;
{
    Tile *cover,*lt,*rb;
    WallSegment *segPtr;

    /*
    printf("\n GetCoveringWallSegment");
    */
    cover=grEd_GetPtrOfDomTileCoveringPin(pinPtr);
/*
    if (cover==NULL) {
        printf("\n cover not found");
    }
    else {
        printf("\n cover found");
    }
*/

    lt=grEd_GetPtrOfDomTileLeftTopFromPin(pinPtr);
    /*
    printf("\n lt found");
    */
    rb=grEd_GetPtrOfDomTileRightBotFromPin(pinPtr);
    /*
    printf("\n rb found");
    */

    if (Tp_IsHorzTile(cover)) {
    /*
        printf("\ is horz tile");
    */

        Fpg_FindWallSeg(
            Fpg_GetWallJunctWhereDomTilesCross(greFpgPtr, cover, lt),
            Fpg_GetWallJunctWhereDomTilesCross(greFpgPtr, cover, rb),
            &segPtr);
    }
    else {
    /*
        printf("\ is vert tile");
    */
        Fpg_FindWallSeg(
            Fpg_GetWallJunctWhereDomTilesCross(greFpgPtr, lt, cover),
            Fpg_GetWallJunctWhereDomTilesCross(greFpgPtr, rb, cover),
            &segPtr);
    }
    /*
    printf("\n leaving GetCoveringWallSegment");
    */
    return (segPtr);
}


PseudoPin *
grEd_InsertPPinToBtnLine(bnLinePtr,iname,ename,tilePtr)

BNLine *bnLinePtr;
BearId iname,ename;
Tile *tilePtr;

{
    PseudoPin *ppinPtr;

    if (Tp_IsVertTile(tilePtr))  /* also vert bnline*/
    {
        if (bnLinePtr->bnLineType == (BNLineType) TP_VERT_R_UP)
        {
            (void) Tp_CreatePPin(tilePtr,BOTTOM_LEFT_SIDE,TP_BOTTOM,&ppinPtr);
        }
        else
        {
            (void) Tp_CreatePPin(tilePtr,TOP_RIGHT_SIDE,TP_BOTTOM,&ppinPtr);
        }
    }
    else
    {
        if (bnLinePtr->bnLineType== (BNLineType) TP_HORZ_B_RIGHT)
        {
            (void) Tp_CreatePPin(tilePtr,TOP_RIGHT_SIDE,TP_BOTTOM,&ppinPtr);
        }
        else
        {
            (void) Tp_CreatePPin(tilePtr,BOTTOM_LEFT_SIDE,TP_BOTTOM,&ppinPtr);
        }
    }

    Tp_PutNetOfPPin(greNetPtr,ppinPtr);

    if (Tp_IsVertTile(tilePtr))
    {
        Tp_PutIntNetIdOfPPin(iname,ppinPtr);
        Tp_PutExtNetIdOfPPin(ename,ppinPtr);
    }
    else
    {
    /* change made to please Tim */
        Tp_PutIntNetIdOfPPin(ename,ppinPtr);
        Tp_PutExtNetIdOfPPin(iname,ppinPtr);
    }
    return (ppinPtr);
}


PseudoPin *
grEd_InsertPPinToLeftTopSide(bnTilePtr, iname, ename)
Tile    *bnTilePtr;
BearId  iname, ename;
{
    PseudoPin *ppinPtr;

    (void) Tp_CreatePPinOfBnTile(bnTilePtr,
        (Tp_IsVertTile(bnTilePtr) == TRUE) ? BOTTOM_LEFT_SIDE : TOP_RIGHT_SIDE,
        &ppinPtr);

    Tp_PutIntNetIdOfPPin(iname, ppinPtr);
    Tp_PutExtNetIdOfPPin(ename, ppinPtr);
    Tp_PutNetOfPPin(greNetPtr, ppinPtr);

    return (ppinPtr);
}


PseudoPin *
grEd_InsertPPinToRightBotSide(bnTilePtr, iname, ename)
Tile    *bnTilePtr;
BearId  iname, ename;
{
    PseudoPin *ppinPtr;

    (void) Tp_CreatePPinOfBnTile(bnTilePtr,
        (Tp_IsVertTile(bnTilePtr) == TRUE) ? TOP_RIGHT_SIDE : BOTTOM_LEFT_SIDE,
        &ppinPtr);

    Tp_PutIntNetIdOfPPin(iname, ppinPtr);
    Tp_PutExtNetIdOfPPin(ename, ppinPtr);
    Tp_PutNetOfPPin(greNetPtr, ppinPtr);

    return (ppinPtr);
}


