
/* greSupport.c --
 *
 *     Malgorzata Marek-Sadowska
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/grEditor/greSupport.c,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "grEditor.h"
#include "grEditorInt.h"
#include "grStorage.h"

/*
 * Here are some supplementary functions for global router.
 * They mostly deal with dominant tiles in the closest proximity
 * of a pin.
 */

Tile *grEd_GetContainingPinDomTile(pinPtr)

PinInst *pinPtr;

{

/*
    If pin is covered by a dominant tile, it returns 1;
    otherwise it returns 0.
*/


    Point   hpinPos,vpinPos;
    Tile    *tilePtr;

    Mac_GetAbsPosOfPin(pinPtr,&hpinPos);

    /*
    printf("\n hpin: xpos= %4d ypos=%4d",hpinPos.p_x,hpinPos.p_y);
    */

/*
    Initial point is moved from the cell boundary into the space tile.
*/

    if (Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)
    {
    /*
        printf("\n NORTH_PIN");
    */
        hpinPos.p_y = hpinPos.p_y +1;
    /*
    printf("\n hpin: xpos= %4d ypos=%4d",hpinPos.p_x,hpinPos.p_y);
    */
    }

    if (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN)
    {
    /*
        printf("\n SOUTH_PIN");
    */
        hpinPos.p_y = hpinPos.p_y -1;
    /*
    printf("\n hpin: xpos= %4d ypos=%4d",hpinPos.p_x,hpinPos.p_y);
    */
            
    }

    if (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN)
    {
    /*
        printf("\n WEST_PIN");
    */
        hpinPos.p_x =hpinPos.p_x -1;
    /*
    printf("\n hpin: xpos= %4d ypos=%4d",hpinPos.p_x,hpinPos.p_y);
    */
    }


    if (Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)
    {
    /*
        printf("\n EAST_PIN");
    */
        hpinPos.p_x = hpinPos.p_x +1;
    /*
    printf("\n hpin: xpos= %4d ypos=%4d",hpinPos.p_x,hpinPos.p_y);
    */
    }
/* End point moving.

   Now horizontal point (hpinPos) is transformed into vpinPos.

*/

    Tp_HPointToVPoint(&hpinPos,&vpinPos);


    /*
    printf("\n vpin: xpos= %4d ypos=%4d",vpinPos.p_x,vpinPos.p_y);
    */
/* search for the NORTH_PIN : tricky part - it is like a checking for
   a horizintal dominant tile covering vertical transformation
   of a point. 
*/


    tilePtr = NIL(Tile);
    if (Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetVertPlane(grePlaneDataPtr),&vpinPos);

        if (Tp_IsDominantTile(tilePtr)==FALSE)
        {
            return (NIL(Tile));
        }
        else
        {
            return (tilePtr);
        }

    }


/* search for the SOUTH_PIN : tricky part - it is like a checking for
   a horizintal dominant tile covering vertical transformation
   of a point. 
*/
    if (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetVertPlane(grePlaneDataPtr),&vpinPos);

        if (Tp_IsDominantTile(tilePtr)==FALSE)
        {
            return (NIL(Tile));
        }
        else
        {
            return (tilePtr);
        }
    }

/* search for the WEST_PIN :  */ 

    if (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetHorzPlane(grePlaneDataPtr),&hpinPos);

        if (Tp_IsDominantTile(tilePtr)==FALSE)
        {
            return (NIL(Tile));
        }
        else
        {
            return (tilePtr);
        }
    }


/* search for the EAST_PIN :  */ 

    if (Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetHorzPlane(grePlaneDataPtr),&hpinPos);

        if (Tp_IsDominantTile(tilePtr)==FALSE)
        {
            return (NIL(Tile));
        }
        else
        {
            return (tilePtr);
        }
    }

    return (NIL(Tile));
}



Tile *grEd_GetPtrOfDomTileCoveringPin(pinPtr)

PinInst *pinPtr;

{

    Point hpinPos,vpinPos;
    Tile *tilePtr;

    Mac_GetAbsPosOfPin(pinPtr,&hpinPos);

/*
    Initial point is moved from the cell boundary into the space tile.
*/

    if (Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)
    {
        hpinPos.p_y = hpinPos.p_y +1;
    }

    if (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN)
    {
        hpinPos.p_y = hpinPos.p_y -1;
            
    }

    if (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN)
    {
        hpinPos.p_x =hpinPos.p_x -1;
    }


    if (Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)
    {
        hpinPos.p_x = hpinPos.p_x +1;
    }
/* End point moving.

   Now horizontal point (hpinPos) is transformed into vpinPos.

*/

    Tp_HPointToVPoint(&hpinPos,&vpinPos);

/*  Search for the NORTH_PIN  */

    tilePtr=NIL(Tile);
    if (Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetHorzPlane(grePlaneDataPtr),&hpinPos);

        while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=RT(tilePtr);
        }
    }

/* search for the SOUTH_PIN */

    if (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetHorzPlane(grePlaneDataPtr),&hpinPos);

        while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=LB(tilePtr);
        }
    }

/* search for the WEST_PIN : tricky part - it is like a search for
   a horizintal dominant tile covering vertical transformation
   of a point. We are moving up in the transformed plane.
*/

    if (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetVertPlane(grePlaneDataPtr),&vpinPos);

        while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=RT(tilePtr);
        }
    }


/* search for the EAST_PIN : tricky part - it is like a search for
   a horizintal dominant tile covering vertical transformation
   of a point. We are moving down in the transformed plane.
*/

    if (Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)
    {
        tilePtr=TiSrPoint(NIL(Tile),Tp_GetVertPlane(grePlaneDataPtr),&vpinPos);

        while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=LB(tilePtr);
        }
    }

    return (tilePtr);
}

void GreCreateLinkedDomTiles(cover)

Tile *cover;

{
    Rect rect1,rect2;

    greHeadLinkedDomTiles = NULL;

    if (Tp_IsHorzTile(cover))
    {
        Tp_HorzTileToRect(grePlaneDataPtr,cover,&rect1);
        Tp_HRectToVRect(&rect1,&rect2);

        (void) TiSrArea(NIL(Tile), Tp_GetVertPlane(grePlaneDataPtr),
            &rect2, GreLinkTiles, (ClientData) NULL);
    }
    else
    {
        Tp_VertTileToRect(grePlaneDataPtr,cover,&rect1);

        (void) TiSrArea(NIL(Tile), Tp_GetHorzPlane(grePlaneDataPtr),
            &rect1, GreLinkTiles, (ClientData) NULL);
    }
}

/* ARGSUSED */
int GreLinkTiles(tilePtr, clientData)

Tile        *tilePtr;
ClientData  clientData;

{
    greLinkedDomTile *current;

    if (Tp_IsDominantTile(tilePtr))
    {
       current = greHeadLinkedDomTiles;

       MALLOC(greLinkedDomTile *, greHeadLinkedDomTiles,
           sizeof (greLinkedDomTile));

       greHeadLinkedDomTiles->nextPtr = current;
       greHeadLinkedDomTiles->tilePtr = tilePtr;
    }

    return (0); /* continue search */
}

void GreDisposeLinkTiles()

{
    greLinkedDomTile *current,*save;

    current = greHeadLinkedDomTiles;

    while(current!= NULL)
    {
        save=current->nextPtr;

        FREE((char*)current);
        current = save;
    }
}


Tile *grEd_GetPtrOfDomTileLeftTopFromPin(pinPtr)

PinInst *pinPtr;

{
    Point pinPos;
    Tile *tilePtr, *cover, *lastBest;
    Rect rect,rect2;
    greLinkedDomTile  *linkedTile;

    lastBest = NULL;
    cover = grEd_GetPtrOfDomTileCoveringPin(pinPtr);
    Mac_GetAbsPosOfPin(pinPtr,&pinPos);

    GreCreateLinkedDomTiles(cover);
    linkedTile = greHeadLinkedDomTiles;
    
    if (Tp_IsVertTile(cover))
    {
    while(linkedTile != NULL)
    {
    Tp_HorzTileToRect(grePlaneDataPtr,linkedTile->tilePtr,&rect);

    if ((rect.r_ybot <= pinPos.p_y)&&(rect.r_ytop >= pinPos.p_y))
    {
        tilePtr = linkedTile->tilePtr;
        GreDisposeLinkTiles();
        return (tilePtr);
    }

    if (rect.r_ybot > pinPos.p_y)
    {
        if (lastBest == NULL)
        {
            lastBest = linkedTile->tilePtr;
        }
        else
        {
            Tp_HorzTileToRect(grePlaneDataPtr,lastBest,&rect2);

            if (rect2.r_ybot > rect.r_ybot)
            {
            lastBest = linkedTile ->tilePtr;
            }
        }
    }
    linkedTile = linkedTile->nextPtr;
    }
    }
    else
    {
        while(linkedTile !=NULL)
        {
        Tp_VertTileToRect(grePlaneDataPtr,linkedTile->tilePtr,&rect);
        if ((rect.r_xtop >= pinPos.p_x)&&(rect.r_xbot <= pinPos.p_x))
        {
            tilePtr = linkedTile->tilePtr;
            GreDisposeLinkTiles();
            return (tilePtr);
        }

        if (rect.r_xtop < pinPos.p_x)
        {
            if (lastBest == NULL)
            {
                lastBest = linkedTile->tilePtr;
            }
            else
            {
            Tp_VertTileToRect(grePlaneDataPtr,lastBest,&rect2);

            if (rect.r_xtop > rect2.r_xtop)
            {
                lastBest=linkedTile->tilePtr;
            }
            }
        }
        linkedTile = linkedTile->nextPtr;
        }
    }

    GreDisposeLinkTiles();
    return (lastBest);
}
    


Tile   *grEd_GetPtrOfDomTileRightBotFromPin(pinPtr)

PinInst  *pinPtr;

{
    Point pinPos;
    Tile *tilePtr, *cover, *lastBest;
    Rect rect,rect2;
    greLinkedDomTile  *linkedTile;

    lastBest = NULL;
    cover = grEd_GetPtrOfDomTileCoveringPin(pinPtr);
    Mac_GetAbsPosOfPin(pinPtr,&pinPos);

    GreCreateLinkedDomTiles(cover);
    linkedTile = greHeadLinkedDomTiles;
    
    if (Tp_IsVertTile(cover))
    {
    while(linkedTile != NULL)
    {
    Tp_HorzTileToRect(grePlaneDataPtr,linkedTile->tilePtr,&rect);

    if ((rect.r_ybot <= pinPos.p_y)&&(rect.r_ytop >= pinPos.p_y))
    {
        tilePtr = linkedTile->tilePtr;
        GreDisposeLinkTiles();
        return (tilePtr);
    }

    if (rect.r_ytop < pinPos.p_y)
    {
        if (lastBest == NULL)
        {
            lastBest = linkedTile->tilePtr;
        }
        else
        {
            Tp_HorzTileToRect(grePlaneDataPtr,lastBest,&rect2);

            if (rect2.r_ytop  < rect.r_ytop)
            {
            lastBest = linkedTile ->tilePtr;
            }
        }
    }
    linkedTile = linkedTile->nextPtr;
    }
    }
    else
    {
        while(linkedTile !=NULL)
        {
        Tp_VertTileToRect(grePlaneDataPtr,linkedTile->tilePtr,&rect);
        if ((rect.r_xtop >= pinPos.p_x)&&(rect.r_xbot <= pinPos.p_x))
        {
            tilePtr = linkedTile->tilePtr;
            GreDisposeLinkTiles();
            return (tilePtr);
        }

        if (rect.r_xbot > pinPos.p_x)
        {
            if (lastBest == NULL)
            {
                lastBest = linkedTile->tilePtr;
            }
            else
            {
            Tp_VertTileToRect(grePlaneDataPtr,lastBest,&rect2);

            if (rect.r_xbot < rect2.r_xbot)
            {
                lastBest=linkedTile->tilePtr;
            }
            }
        }
        linkedTile = linkedTile->nextPtr;
        }
    }

    GreDisposeLinkTiles();
    return (lastBest);
}



/*  This function commented out because it containes philosphical error.
    Works only for SOUTH_PINs and EAST_PINs.

Tile   *grEd_GetPtrOfDomTileLeftTopFromPin(pinPtr)

PinInst  *pinPtr;

{

    Point hpinPos,vpinPos;
    Tile *tilePtr;

    Mac_GetAbsPosOfPin(pinPtr,&hpinPos);


    if (Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)
    {
        hpinPos.p_y = hpinPos.p_y +1;
    }

    if (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN)
    {
        hpinPos.p_y = hpinPos.p_y -1;
            
    }

    if (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN)
    {
        hpinPos.p_x =hpinPos.p_x -1;
    }


    if (Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)
    {
        hpinPos.p_x = hpinPos.p_x +1;
    }

    Tp_HPointToVPoint(&hpinPos,&vpinPos);

    
    tilePtr = NIL(Tile);

    if ((Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)||
    (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN))
    {
    tilePtr=TiSrPoint(NIL(Tile),Tp_GetVertPlane(grePlaneDataPtr),&vpinPos);
    while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=RT(tilePtr);
        }
    }


    if ((Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)||
    (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN))
    {
    tilePtr=TiSrPoint(NIL(Tile),Tp_GetHorzPlane(grePlaneDataPtr),&hpinPos);
    while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=RT(tilePtr);
        }
    }

    return (tilePtr);

}
*/

/*  This function commented out because it containes philosphical error.
    Works only for SOUTH_PINs and EAST_PINs.

Tile   *grEd_GetPtrOfDomTileRightBotFromPin(pinPtr)

PinInst  *pinPtr;

{

    Point hpinPos,vpinPos;
    Tile *tilePtr;

    Mac_GetAbsPosOfPin(pinPtr,&hpinPos);

    if (Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)
    {
        hpinPos.p_y = hpinPos.p_y +1;
    }

    if (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN)
    {
        hpinPos.p_y = hpinPos.p_y -1;
            
    }

    if (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN)
    {
        hpinPos.p_x =hpinPos.p_x -1;
    }


    if (Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)
    {
        hpinPos.p_x = hpinPos.p_x +1;
    }


    Tp_HPointToVPoint(&hpinPos,&vpinPos);

    
    tilePtr = NULL;

    if ((Mac_GetDirectionOfPin(pinPtr)==NORTH_PIN)||
    (Mac_GetDirectionOfPin(pinPtr)==SOUTH_PIN))
    {
    tilePtr=TiSrPoint(NIL(Tile),Tp_GetVertPlane(grePlaneDataPtr),&vpinPos);
    while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=LB(tilePtr);
        }
    }


    if ((Mac_GetDirectionOfPin(pinPtr)==EAST_PIN)||
    (Mac_GetDirectionOfPin(pinPtr)==WEST_PIN))
    {
    tilePtr=TiSrPoint(NIL(Tile),Tp_GetHorzPlane(grePlaneDataPtr),&hpinPos);
    while(Tp_IsDominantTile(tilePtr)==FALSE)
        {
            tilePtr=LB(tilePtr);
        }
    }

    return (tilePtr);

}

*/

/* Here are some local functions which are used by iterators building
   local structures.
*/


grEd_Btn  *grEd_FindEd_Btn(btnPtr)

Tile *btnPtr;

{
    grEd_Btn *edBtnPtr;

    edBtnPtr=greBtnListHeadPtr;

    while(edBtnPtr != NULL)
    {
        if (edBtnPtr->tilePtr == btnPtr)
        {
            return (edBtnPtr);
        }
        else
        {
            edBtnPtr=edBtnPtr->nextBtn;
        }
    }

    edBtnPtr = NULL;
    return  (edBtnPtr);
}


grEd_Node *
grEd_FindEd_Node(junctPtr)
WallJunction *junctPtr;
{
    grEd_Node *nodePtr;

    /*
    printf("\n enter FindNode ");
    */

    for (nodePtr = greNodeListHeadPtr;
        nodePtr != NIL(grEd_Node);
        nodePtr = nodePtr->nextNode) {

        if (nodePtr->jPtr == junctPtr) {
        /*
            printf("\n good exit from find node");
        */
            return (nodePtr);
        }
    }

    /*
    printf("\n exit from find node");
    */
    return (NIL(grEd_Node));
}



grEd_BtnLine  *
grEd_FindEd_BtnLine(btnPtr)

BNLine *btnPtr;

{
    grEd_BtnLine *edBtnLinePtr;

    edBtnLinePtr = greBtnLineHeadPtr;

    while (edBtnLinePtr != NULL)
    {
        if (edBtnLinePtr->bnLinePtr == btnPtr)
        {
            return (edBtnLinePtr);
        }
        else
        {
            edBtnLinePtr=edBtnLinePtr->nextBtnLine;
        }
    }

    edBtnLinePtr = NULL;
    return  (edBtnLinePtr);
}



