
/* macDCellPrim.c --
 *
 *      June Wang
 *      (Advising Professor - E. S. Kuh)
 *
 * It has all the operations to retrieve and update the fields in 
 * dummy cell.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/mac/macDCellPrim.c,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "macInt.h"

DCellClass
Mac_GetClassOfDCell(dcellPtr)
DummyCell *dcellPtr;
{
#ifdef DEBUG
    if (dcellPtr == NIL(DummyCell))
    {
        MacPrintFatalErr("Mac_GetClassOfDCell() failed: no dummy cell given");
    }
#endif DEBUG

    return (dcellPtr->class);
}

void
Mac_PutClassOfDCell(class, dcellPtr)
DCellClass  class;
DummyCell   *dcellPtr;
{
#ifdef DEBUG
    if (dcellPtr == NIL(DummyCell))
    {
        MacPrintFatalErr("Mac_PutClassOfDCell() failed: no dummy cell given");
    }
#endif DEBUG

    dcellPtr->class = class;
}



BearId
Mac_GetIdOfDCell(dcellPtr)
DummyCell *dcellPtr;

{
#ifdef DEBUG
    if (dcellPtr == NIL(DummyCell))
    {
        MacPrintFatalErr("Mac_GetIdOfDCell() failed: no dummy cell given");
    }
#endif DEBUG

    return (dcellPtr->id);
}

void
Mac_PutIdOfDCell(id, dcellPtr)
BearId    id;
DummyCell *dcellPtr;

{
#ifdef DEBUG
    if (dcellPtr == NIL(DummyCell))
    {
        MacPrintFatalErr("Mac_PutIdOfDCell() failed: no dummy cell given");
    }
#endif DEBUG

    dcellPtr->id = id;
}



Rect *
Mac_GetShapeOfDCell(dcellPtr)

DummyCell *dcellPtr;
{
    return (Mac_GetBBoxOfDCell(dcellPtr));
}

void
Mac_PutShapeOfDCell(shapePtr, dcellPtr)

Rect      *shapePtr;
DummyCell *dcellPtr;
{
    Mac_PutBBoxOfDCell(shapePtr, dcellPtr);
}



Rect *
Mac_GetBBoxOfDCell(dcellPtr)  

DummyCell *dcellPtr;
{
#ifdef DEBUG
    if (dcellPtr == NIL(DummyCell))
    {
        MacPrintFatalErr("Mac_GetBBoxOfDCell() failed: no dummy cell given");
    }
#endif DEBUG

    return (&dcellPtr->bbox);
}

void
Mac_PutBBoxOfDCell(bboxPtr, dcellPtr)  

Rect        *bboxPtr;
DummyCell   *dcellPtr;
{
#ifdef DEBUG
    if (bboxPtr == NIL(Rect))
    {
        MacPrintFatalErr("Mac_PutBBoxOfDCell() failed: no BBox given");
    }
    else if (dcellPtr == NIL(DummyCell))
    {
        MacPrintFatalErr("Mac_PutBBoxOfDCell() failed: no dummy cell given");
    }
#endif DEBUG

    Mac_CopyRect(&dcellPtr->bbox, bboxPtr);
}



Tile *
Mac_GetTileOfDCell(dcellPtr)

DummyCell    *dcellPtr;
{
#ifdef DEBUG
    if (dcellPtr == NIL(DummyCell))
    {
    MacPrintFatalErr("Mac_GetTileOfDCell() failed: no dummy cell given");
    }
    else if (dcellPtr->tilePtr == NIL(Tile))
    {
 MacPrintFatalErr("Mac_GetTileOfDCell() failed: no tile for the dummy cell");
    }
#endif DEBUG

    return (dcellPtr->tilePtr);
}

void
Mac_PutTileOfDCell(tilePtr, dcellPtr)

Tile        *tilePtr;
DummyCell   *dcellPtr;
{
#ifdef DEBUG
    if (dcellPtr == NIL(DummyCell))
    {
    MacPrintFatalErr("Mac_PutTileOfDCell() failed: no dummy cell given");
    }
#endif DEBUG

    dcellPtr->tilePtr = tilePtr;
}



