
/* macGCell.h --
 *
 *     Wei-Ming Dai
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * needs: magic.h bear.h ...
 * 
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/mac/macGCell.h,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $
 */

#ifndef _MAC_GCELL
#define _MAC_GCELL

typedef enum _CellClass
{
    CELL_INST,                          /* Cell instance                    */
    ROUTE_CELL,                         /* Routing cell                     */
    DUMMY_CELL,                         /* Dummy cell in empty room         */
    UNDEF_CELL                          /* Undefined cell                   */
} CellClass;

typedef struct _GenericCell
{
    CellClass               unType;
    union       
    {
        CellInst            *cellInstPtr;   /* unType = CELL_INST           */
        struct _RouteCell   *routeCellPtr;  /* unType = ROUTE_CELL          */
        struct _DummyCell   *dummyCellPtr;  /* unType = DUMMY_CELL          */
    } unValue;
} GenericCell;

extern BearStatus Mac_CreateGCell(/* cellClass, cellPtr, gCellPtrPtr */);
/*
 * CellClass       cellClass;
 * ClientData      cellPtr;
 * GenericCell     **gCellPtrPtr;
 */

#endif _MAC_GCELL
