
/* MacGPinPrim.c --
 *
 *     Wei-Ming Dai
 *     (Advising Professor - E. S. Kuh)
 *
 *    Accessors, modifier, and presicates related to generic cells.
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/mac/macGPinPrim.c,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "macInt.h"

PinType
Mac_GetTypeOfGPin(gPinPtr)

GenericPin *gPinPtr;
{
#ifdef DEBUG
    if (gPinPtr == NIL(GenericPin))
    {
        MacPrintFatalErr("Mac_GetTypeOfGPin() failed : no generic pin is given");
    }
#endif DEBUG
    return (gPinPtr->pinType);
}


PinInst *
Mac_GetPinInstOfGPin(gPinPtr)

GenericPin *gPinPtr;
{
#ifdef DEBUG
    if (gPinPtr == NIL(GenericPin))
    {
        MacPrintFatalErr("Mac_GetPinInstOfGPin() failed : no generic pin is given");
    }
#endif DEBUG
    return (gPinPtr->pinPtrUn.pinInstPtr);
}


RoutePin *
Mac_GetRoutePinOfGPin(gPinPtr)

GenericPin *gPinPtr;
{
#ifdef DEBUG
    if (gPinPtr == NIL(GenericPin))
    {
        MacPrintFatalErr("Mac_GetRoutePinOfGPin() failed : no generic pin is given");
    }
#endif DEBUG
    return (gPinPtr->pinPtrUn.routePinPtr);
}

