
/* macHash.h --
 *
 *     George Carvalho
 *     June Wang
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1989 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/mac/macHash.h,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $
 */

#ifndef _MAC_HASH
#define _MAC_HASH /* once-only latch */

#define CELL_MASTER_HT      0
#define CELL_INSTANCE_HT    1
#define NET_HT              2
#define PORT_MASTER_HT      3
#define PORT_INSTANCE_HT    4
#define PIN_MASTER_HT       5
#define PIN_INSTANCE_HT     6
#define NUM_OF_HASH_TABLES  7


extern bool Mac_IsMember(/* hashTableIndex, keyPtr */);
/*
 * int     hashTableIndex;
 * char    *keyPtr;
 */

extern void Mac_Insert(/* hashTableIndex, keyPtr, valuePtr */);
/*
 * int     hashTableIndex;
 * char    *keyPtr;
 * char    *valuePtr;
 */

extern void Mac_Delete(/* hashTableIndex, keyPtr */);
/*
 * int     hashTableIndex; 
 * char    *keyPtr;
 */

extern char *Mac_LookUp(/* hashTableIndex, keyPtr */);
/*
 * int     hashTableIndex;
 * char    *keyPtr;
 */

EXTERN bool Mac_LookUpPinInst
    ARGS((char              *piNamePtr,         /* pin instance name    */
          char              *ciNamePtr,         /* cell instance name   */
          struct _PinInst   **pinInstPtrPtr));

#endif /* _MAC_HASH */

