
/*
 * macRCellPrim.h --
 *
 *    Wei-ming Dai
 *    June Wang
 *    (Professor E. S. Kuh)
 *
 *    It declares the operations to retrieve and update the attributes
 *    of routing cells.
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/mac/macRCellPrim.h,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $
 */

#ifndef _MAC_RCELL_PRIM
#define _MAC_RCELL_PRIM

extern BearId Mac_GetIdOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern void Mac_PutIdOfRCell(/* id, rCellPtr */);
/*
 * BearId     id;
 * RouteCell  *rCellPtr;
 */

extern RCellType Mac_GetTypeOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern BearStatus Mac_PutTypeOfRCell(/* type, rCellPtr */);
/*
 * RCellType type;
 * RouteCell *rCellPtr;
 */

extern void Mac_MarkRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern void Mac_UnmarkRCell(/* rCellPtr */);
/*
 * RouteCell *rCellPtr;
 */

extern BearStatus Mac_IsRCellMarked(/* rCellPtr */);
/*
 * RouteCell *rCellPtr;
 */

extern LinkedPoint * Mac_GetBLBoundOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern LinkedPoint * Mac_GetTRBoundOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern Rect * Mac_GetBBoxOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern void Mac_CreateBBoxOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern Point * Mac_GetOriginOfRCell(/* rCellPtr */);
/*
 * RouteCell *rCellPtr;
 */

extern void Mac_PutOriginOfRCell(/* originPtr, rCellPtr */);
/*
 * Point    *originPtr;
 * RouteCell *rCellPtr;
 */

extern Transform * Mac_GetTransformOfRCell(/* rCellPtr */);
/*
 * RouteCell *rCellPtr;
 */

extern void Mac_PutTransformOfRCell(/* transPtr, rCellPtr */);
/*
 * Transform    *transPtr; 
 * RouteCell    *rCellPtr;
 */

extern CellMaster * Mac_GetCellOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

extern CellGroup * Mac_GetGroupOfRCell(/* rCellPtr */);
/*
 * RouteCell    *rCellPtr;
 */

extern int Mac_GetNumOfNetsOfRCell(/* rCellPtr */);
/*
 * RouteCell  *rCellPtr;
 */

#endif _MAC_RCELL_PRIM

