
/* newGlobalRouter.h --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 * Definitions external to the newG (new global router) module.
 *
 * Copyright (C) 1990 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/newG/newG.h,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $
 */

#ifndef NEWG_EXPORT_H
#define NEWG_EXPORT_H /* once-only latch */

#define NGR_MOD_NAME "newGlobalRouter"

#define NGR_UPPER_PIN_CUT_OFF 40

typedef BearDummy *Ngr_BldTreeDataPtr;

typedef BearDummy Ngr_BldOptions; /* for future expansion */


/* ---------- External procedures for the newP module ---------- */

/*
 * ngrMain.c
 */
extern BearStatus   Ngr_BldTreeBegin();
extern BearStatus   Ngr_BldTreeEnd();
extern BearStatus   Ngr_BuildBaseGraph();
extern BearStatus   Ngr_FindSteinerTree();
extern BearStatus   Ngr_NewGlobalRouter();

/*
 * ngrCompGraph.c
 */
extern BearStatus   Ngr_BuildCompGraph();

/*
 * ngrFindMST.c
 */
extern BearStatus   Ngr_FindMST();

/*
 * ngrUtils.c
 */
extern int          Ngr_GetBaseEdgeWeight();
extern int          Ngr_GetCompEdgeWeight();
extern void         Ngr_DeleteBaseGraph();
extern void         Ngr_DeleteCompGraph();
extern BearStatus   Ngr_CalcEdgeLenOfGraph();

/*
 * ngrWrite.c
 */
extern void         Ngr_WriteGraph();


/* ---------- External global variables for the newG module ---------- */

extern bool ngr_DebugFlag;

#endif NEWG_EXPORT_H

