
/* nplGeoPen.c --
 *
 *     Massoud Pedram
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1990 Regents of the University of Calif or nia
 * All rights reserved.
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/newP/nplGeoPen.c,v 1.1.1.1 2002/12/31 15:51:08 saj Exp $";
#endif not lint

#include "bearCopyRight.h"
#include "newPInt.h"

void
NplGeoPen(rmDimX, rmDimY, ndDimX, ndDimY, areaCostPtr, aspCostPtr)
int     rmDimX, rmDimY, ndDimX, ndDimY;
float   *areaCostPtr, *aspCostPtr;
{
    int     bigSide = NPLMAX(rmDimX, rmDimY);
    int     smallSide = NPLMIN(rmDimX, rmDimY);
    float   rmAsp = (float) bigSide / (float) smallSide;
    float   ndAsp;
    float   penX, penY, aspPen;

    *areaCostPtr = 0.0;
    /* 
     * Heuristic factor ---
     *
     * If the cell is smaller than the room, that reduces the penalty.
     * However, it has to be 5 units smaller to make up 1 unit overlap. 
     */
    penX = (ndDimX - rmDimX) * ncl_ClusterTree->nd_dim.p_y;
    if (ndDimX < rmDimX) {
        penX /= 5.0;
    }
    penY = (ndDimY - rmDimY) * ncl_ClusterTree->nd_dim.p_x;
    if (ndDimY < rmDimY) {
        penY /= 5.0;
    }
    *areaCostPtr += (penX + penY);

    ndAsp = (ndDimX > ndDimY) ?
        (float) ndDimX / (float) ndDimY : (float) ndDimY / (float) ndDimX;
    /* 0.33 is a HEURISTIC factor. MP */
    *aspCostPtr = 0.33 * ABS(ndAsp - rmAsp) * bigSide * smallSide;
}


