
/* pbIVNewPlaceWins.c --
 *
 *     George Carvalho, Esq.
 *     Benjamin Chen
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/polarBear/pbIVNewPlaceWins.c,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $";
#endif  not lint

#if !defined(BEAR_BLACK_BOX) && defined(USE_NEWP_CODE)
/*
 * This file does not need to be compiled when the black box version of
 * the BEAR-FP system is built.
 */

#include "bearCopyRight.h"
#include "port.h"
#include "malloc.h"
#include "magic.h"
#include "geometry.h"
#include "bear.h"
#include "tile.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "mac.h"
#include "ezPlot.h"
#include "newC.h"
#include "newP.h"
#include "bearIV.h"
#include "pbDialogs.h"
#include "polarBear.h"


BearStatus
PbNewClusterAlgDialog(parmsPtr)
Ncl_UserParms *parmsPtr;
/*
 * Dialog used to pick the clustering algorithum.
 */
{
#define FILE_NAME_SIZE 40

    IVWindow    *ivWinPtr;
    XEvent      theEvent;
    char        command[80], *ctreeFileName;
    bool        ivRanFlag, loopRanFlag;
    bool        ivGreFlag, loopGreFlag;
    bool        ivMatFlag, loopMatFlag;
    bool        ivSimFlag, loopSimFlag;
    bool        ivFilFlag, loopFilFlag;
    bool        okayFlag;
    bool        abortFlag;

    ivRanFlag = loopRanFlag = FALSE;
    ivGreFlag = loopGreFlag = FALSE;
    ivMatFlag = loopMatFlag = TRUE;
    ivSimFlag = loopSimFlag = FALSE;
    ivFilFlag = loopFilFlag = FALSE;
    okayFlag = FALSE;
    abortFlag = FALSE;

    if (parmsPtr->clusterFileName != NIL(char)) {
        MALLOC(char *, ctreeFileName,
            (strlen (parmsPtr->clusterFileName) + 1) * sizeof (char));
        strcpy (ctreeFileName, parmsPtr->clusterFileName);
    }
    else {
        MALLOC(char *, ctreeFileName, FILE_NAME_SIZE * sizeof (char));
        ctreeFileName[0] = '\0';
    }

    ivWinPtr = iv_InitWindow(ez_Display, BEAR_PROG_NAME,
        "New Cluster Package Algorithums", FILE_NAME_SIZE);

    (void) iv_AddVar(ivWinPtr, "Random    ", 
        &ivRanFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

    (void) iv_AddVar(ivWinPtr, "Greedy    ", 
        &ivGreFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

    (void) iv_AddVar(ivWinPtr, "Matching  ", 
        &ivMatFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

    (void) iv_AddVar(ivWinPtr, "Annealing ", 
        &ivSimFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

    (void) iv_AddVar(ivWinPtr, "File In   ", 
        &ivFilFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);
    (void) iv_AddVar(ivWinPtr, "file name ", 
        (int *) &ctreeFileName, IV_STRING, IV_NO_OPT, IV_NULL_FUNCTION);
    (void) iv_SetEnableFlag(ivWinPtr, (int *) &ctreeFileName, 0);

    (void) iv_AddVar(ivWinPtr, "Okay      ", 
        &okayFlag, IV_TOGGLE, IV_NO_OPT, IV_NULL_FUNCTION);
    (void) iv_AddVar(ivWinPtr, "Exit      ", 
        &abortFlag, IV_TOGGLE, IV_NO_OPT, IV_NULL_FUNCTION);

    (void) iv_MapWindow(ivWinPtr, IV_NO_OPT, IV_NO_OPT, IV_MOUSE);

    while (TRUE) {
        XNextEvent(ez_Display, &theEvent);
        (void) iv_HandleEvent(&theEvent);
        Ez_XEventHandler(&theEvent);

        if (ivRanFlag != loopRanFlag) {

            ivRanFlag = loopRanFlag = TRUE;
            ivGreFlag = loopGreFlag = FALSE;
            ivMatFlag = loopMatFlag = FALSE;
            ivSimFlag = loopSimFlag = FALSE;
            ivFilFlag = loopFilFlag = FALSE;

            (void) iv_UpdateVar(ivWinPtr, &ivRanFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivGreFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivMatFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivSimFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFilFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &ctreeFileName, 0);
            continue;
        } 

        if (ivGreFlag != loopGreFlag) {

            ivRanFlag = loopRanFlag = FALSE;
            ivGreFlag = loopGreFlag = TRUE;
            ivMatFlag = loopMatFlag = FALSE;
            ivSimFlag = loopSimFlag = FALSE;
            ivFilFlag = loopFilFlag = FALSE;

            (void) iv_UpdateVar(ivWinPtr, &ivRanFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivGreFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivMatFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivSimFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFilFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &ctreeFileName, 0);
            continue;
        } 

        if (ivMatFlag != loopMatFlag) {

            ivRanFlag = loopRanFlag = FALSE;
            ivGreFlag = loopGreFlag = FALSE;
            ivMatFlag = loopMatFlag = TRUE;
            ivSimFlag = loopSimFlag = FALSE;
            ivFilFlag = loopFilFlag = FALSE;

            (void) iv_UpdateVar(ivWinPtr, &ivRanFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivGreFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivMatFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivSimFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFilFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &ctreeFileName, 0);
            continue;
        } 

        if (ivSimFlag != loopSimFlag) {

            ivRanFlag = loopRanFlag = FALSE;
            ivGreFlag = loopGreFlag = FALSE;
            ivMatFlag = loopMatFlag = FALSE;
            ivSimFlag = loopSimFlag = TRUE;
            ivFilFlag = loopFilFlag = FALSE;

            (void) iv_UpdateVar(ivWinPtr, &ivRanFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivGreFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivMatFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivSimFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFilFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &ctreeFileName, 0);
            continue;
        } 

        if (ivFilFlag != loopFilFlag) {

            ivRanFlag = loopRanFlag = FALSE;
            ivGreFlag = loopGreFlag = FALSE;
            ivMatFlag = loopMatFlag = FALSE;
            ivSimFlag = loopSimFlag = FALSE;
            ivFilFlag = loopFilFlag = TRUE;

            (void) iv_UpdateVar(ivWinPtr, &ivRanFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivGreFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivMatFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivSimFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFilFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &ctreeFileName, 1);
            continue;
        } 

        if (okayFlag == TRUE) {
            break;
        }

        if (abortFlag == TRUE) {
            iv_FreeWindow(ivWinPtr);
            FREE((char *) ctreeFileName);
            return (BEAR_ERROR);
        }
    }
    iv_FreeWindow(ivWinPtr);

    if (ivRanFlag == TRUE) {
        parmsPtr->algorithm = RANDOM;
        (void) sprintf (command, "    -alg r\n");
    }
    else if (ivGreFlag == TRUE) {
        parmsPtr->algorithm = GREEDY;
        (void) sprintf (command, "    -alg g\n");
    }
    else if (ivMatFlag == TRUE) {
        parmsPtr->algorithm = MATCHING;
        (void) sprintf (command, "    -alg m\n");
    }
    else if (ivSimFlag == TRUE) {
        parmsPtr->algorithm = SIM_ANNEAL;
        (void) sprintf (command, "    -alg a\n");
    }
    else if (ivFilFlag == TRUE) {
        parmsPtr->algorithm = FILE_IN;

        if (Bear_AllWhiteSpace(ctreeFileName) == TRUE) {
            PbPrint(EZ_ITALIC_FONT, "No cluster tree file name given.\n");
            FREE((char *) ctreeFileName);
            return (BEAR_ERROR);
        }

        MALLOC(char *, parmsPtr->clusterFileName,
            (strlen (ctreeFileName) + 1) * sizeof (char));
        strcpy (parmsPtr->clusterFileName, ctreeFileName);

        (void) sprintf (command, "    -alg f %s\n", parmsPtr->clusterFileName);
    }
    else {
        FREE((char *) ctreeFileName);
        return (BEAR_ERROR);
    }
    FREE((char *) ctreeFileName);
    
    PbPrint(EZ_BOLD_FONT, command);

    return (BEAR_OK);

#undef FILE_NAME_SIZE
}



BearStatus
PbNewClusterVarDialog(cellMasterPtr, parmsPtr)
CellMaster      *cellMasterPtr;
Ncl_UserParms   *parmsPtr;
{
#define FILE_NAME_SIZE 40

    IVWindow    *ivWinPtr;
    XEvent      theEvent;
    char        *stFileName, *tmFileName;
    bool        ivTMFlag, loopTMFlag;
    bool        ivSTFlag, loopSTFlag;
    bool        okayFlag;
    bool        abortFlag;
    
    if (parmsPtr->algorithm == FILE_IN) {
        Ncl_BearInterface(cellMasterPtr, parmsPtr, (BearGeneric) NULL);
    }
    else {
        if (parmsPtr->storageFileName != NIL(char)) {
            MALLOC(char *, stFileName,
                (strlen (parmsPtr->storageFileName) + 1) * sizeof (char));
            strcpy (stFileName, parmsPtr->storageFileName);
        }
        else {
            MALLOC(char *, stFileName, FILE_NAME_SIZE * sizeof (char));
            stFileName[0] = '\0';
        }

        if (parmsPtr->timingFileName != NIL(char)) {
            MALLOC(char *, tmFileName,
                (strlen (parmsPtr->timingFileName) + 1) * sizeof (char));
            strcpy (tmFileName, parmsPtr->timingFileName);
        }
        else {
            MALLOC(char *, tmFileName, FILE_NAME_SIZE * sizeof (char));
            tmFileName[0] = '\0';
        }

        ivWinPtr = iv_InitWindow(ez_Display, BEAR_PROG_NAME,
            "New Cluster Package Variables", FILE_NAME_SIZE);

        (void) iv_AddVar(ivWinPtr, "Quick route estimate    ",
            &parmsPtr->quickRtEstFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);
        (void) iv_AddVar(ivWinPtr, "Channel free style      ",
            &parmsPtr->chanFreeFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

        ivTMFlag = loopTMFlag = parmsPtr->timingFlag;
        (void) iv_AddVar(ivWinPtr, "Timing driven           ",
            &ivTMFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

        (void) iv_AddVar(ivWinPtr, "Timing Filename         ",
            (int *) &tmFileName, IV_STRING, IV_NO_OPT, IV_NULL_FUNCTION);
        if (ivTMFlag == FALSE) {
            (void) iv_SetEnableFlag(ivWinPtr, (int *) &tmFileName, 0);
        }

        if ((parmsPtr->algorithm == MATCHING) ||
            (parmsPtr->algorithm == SIM_ANNEAL)) {
            (void) iv_AddVar(ivWinPtr, "Maximum Dimension Ratio ",
                (int *) parmsPtr->dimRatioPtr,
                IV_INT, IV_NO_OPT, IV_NULL_FUNCTION);
            (void) iv_AddVar(ivWinPtr, "Maximum Area Ratio      ",
                (int *) parmsPtr->areaRatioPtr,
                IV_INT, IV_NO_OPT, IV_NULL_FUNCTION);
        }

        if (parmsPtr->algorithm == MATCHING) {
            (void) iv_AddVar(ivWinPtr, "Prompting               ",
                &parmsPtr->promptFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);
        }
     
        ivSTFlag = loopSTFlag = parmsPtr->storeFlag;
        (void) iv_AddVar(ivWinPtr, "Store Clustering Tree   ",
            &ivSTFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);
        (void) iv_AddVar(ivWinPtr, "Storage Filename        ",
            (int *) &stFileName, IV_STRING, IV_NO_OPT, IV_NULL_FUNCTION);
        if (ivSTFlag == FALSE) {
            (void) iv_SetEnableFlag(ivWinPtr, (int *) &stFileName, 0);
        }

        okayFlag = FALSE;
        (void) iv_AddVar(ivWinPtr, "Okay                    ",
            &okayFlag, IV_TOGGLE, IV_NO_OPT, IV_NULL_FUNCTION);
        abortFlag = FALSE;
        (void) iv_AddVar(ivWinPtr, "Exit                    ",
            &abortFlag, IV_TOGGLE, IV_NO_OPT, IV_NULL_FUNCTION);
    
        (void) iv_MapWindow(ivWinPtr, IV_NO_OPT, IV_NO_OPT, IV_MOUSE);
    
        while (TRUE) {
            XNextEvent(ez_Display, &theEvent);
            (void) iv_HandleEvent(&theEvent);
            Ez_XEventHandler(&theEvent);

            if (ivTMFlag != loopTMFlag) {
                (void) iv_SetEnableFlag(ivWinPtr, (int *) &tmFileName,
                    ((ivTMFlag == TRUE) ? 1 : 0));

                loopTMFlag = ivTMFlag;
            }

            if (ivSTFlag != loopSTFlag) {
                (void) iv_SetEnableFlag(ivWinPtr, (int *) &stFileName,
                    ((ivSTFlag == TRUE) ? 1 : 0));

                loopSTFlag = ivSTFlag;
            }

            if (okayFlag == TRUE) {
                break;
            }

            if (abortFlag == TRUE) {
                iv_FreeWindow(ivWinPtr);
                return (BEAR_ERROR);
            }
        }

        if ((parmsPtr->timingFlag = ivTMFlag) == TRUE) {
            if (Bear_AllWhiteSpace(tmFileName) == TRUE) {
                PbPrint(EZ_ITALIC_FONT, "No timing tree file name given.\n");

                iv_FreeWindow(ivWinPtr);
                return (BEAR_ERROR);
            }

            parmsPtr->timingFileName = tmFileName;
        }
        else {
            FREE((char *) tmFileName);
            parmsPtr->timingFileName = NIL(char);
        }
        if ((parmsPtr->storeFlag = ivSTFlag) == TRUE) {
            if (Bear_AllWhiteSpace(stFileName) == TRUE) {
                PbPrint(EZ_ITALIC_FONT, "No storage tree file name given.\n");

                iv_FreeWindow(ivWinPtr);
                return (BEAR_ERROR);
            }

            parmsPtr->storageFileName = stFileName;
        }
        else {
            FREE((char *) stFileName);
            parmsPtr->storageFileName = NIL(char);
        }

       Ncl_EchoUserParms("Cluster parameters values after iv variable window.", 
            parmsPtr);

        if (parmsPtr->promptFlag == TRUE) {
            if (Ncl_BearInterface(cellMasterPtr, parmsPtr, 
                (BearGeneric) ivWinPtr) != BEAR_OK) {
                iv_FreeWindow(ivWinPtr);
                return (BEAR_ERROR);
            }
            iv_FreeWindow(ivWinPtr);
        } 
        else {
            iv_FreeWindow(ivWinPtr);
            Ez_EmptyXEventQue();

            if (Ncl_BearInterface(cellMasterPtr, parmsPtr, 
                (BearGeneric) NULL) != BEAR_OK) {
                return (BEAR_ERROR);
            }
        }
    }

    return (BEAR_OK);

#undef FILE_NAME_SIZE
}



BearStatus
PbNewPlacerVarDialog(modeValuePtr, defDimValue, defARValue, parmsPtr)
double          *modeValuePtr;  /* mode value                  (OUT)      */
double          defDimValue;    /* default dimension value     (IN)       */
double          defARValue;     /* default aspect ratio value  (IN)       */
Npl_UserParms   *parmsPtr;      /*                             (IN / OUT) */
{
    IVWindow    *ivWinPtr;
    XEvent      theEvent;
    double      tolerance, areaWeight, wireWeight, critWeight;
    int         enable;
    bool        ivQPFlag, loopQPFlag; /* quick plan flags       */
    bool        ivFEFlag, loopFEFlag; /* full enumeration flags */
    bool        ivFXFlag, loopFXFlag;
    bool        ivFYFlag, loopFYFlag;
    bool        ivARFlag, loopARFlag;
    bool        okayFlag;
    bool        abortFlag;
    char        command[80];

    ivWinPtr = iv_InitWindow(ez_Display, BEAR_PROG_NAME,
        "New Placement Package Variables", 15);

    ivQPFlag = loopQPFlag = parmsPtr->p_quickPlanFlag;
    (void) iv_AddVar(ivWinPtr, "Quick plan        ",
        &ivQPFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

    (void) iv_AddVar(ivWinPtr, "Maximum loop count", 
        (int *) &parmsPtr->p_maxLoopCnt, IV_INT, 0, IV_NULL_FUNCTION);
    (void) iv_AddVar(ivWinPtr, "Final optimization",
        &parmsPtr->p_finalOptFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

    ivFEFlag = loopFEFlag = parmsPtr->p_fullEnumFlag;
    (void) iv_AddVar(ivWinPtr, "Full enumeration  ",
        &ivFEFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);

    tolerance = parmsPtr->p_fullEnum.tolerance;
    (void) iv_AddVar(ivWinPtr, "Tolerance         ",
        (int *) &tolerance, IV_DOUBLE, 2, IV_NULL_FUNCTION);
    wireWeight = parmsPtr->p_fullEnum.wireWeight;
    (void) iv_AddVar(ivWinPtr, "Wire Weight       ",
        (int *) &wireWeight, IV_DOUBLE, 2, IV_NULL_FUNCTION);
    areaWeight = parmsPtr->p_fullEnum.areaWeight;
    (void) iv_AddVar(ivWinPtr, "Area Weight       ",
        (int *) &areaWeight, IV_DOUBLE, 2, IV_NULL_FUNCTION);
    if (ncl_TimingFlag == TRUE) {
        critWeight = parmsPtr->p_fullEnum.critWeight;
        (void) iv_AddVar(ivWinPtr, "Critical Weight   ", 
            (int *) &critWeight, IV_DOUBLE, 2, IV_NULL_FUNCTION);
    }

    if (ivQPFlag == TRUE) {
        parmsPtr->p_maxLoopCnt = 0;
        parmsPtr->p_finalOptFlag = FALSE;
        ivFEFlag = loopFEFlag = FALSE;
        (void) iv_UpdateVar(ivWinPtr, &parmsPtr->p_maxLoopCnt);
        (void) iv_UpdateVar(ivWinPtr, &parmsPtr->p_finalOptFlag);
        (void) iv_UpdateVar(ivWinPtr, &ivFEFlag);

        (void) iv_SetEnableFlag(ivWinPtr, (int *) &parmsPtr->p_maxLoopCnt, 0);
        (void) iv_SetEnableFlag(ivWinPtr, (int *) &parmsPtr->p_finalOptFlag, 0);
        (void) iv_SetEnableFlag(ivWinPtr, (int *) &ivFEFlag, 0);
    }

    if (ivFEFlag == FALSE) {
        tolerance = parmsPtr->p_partEnum.tolerance;
        wireWeight = parmsPtr->p_partEnum.wireWeight;
        (void) iv_UpdateVar(ivWinPtr, &tolerance);
        (void) iv_UpdateVar(ivWinPtr, &wireWeight);

        if (ncl_TimingFlag == TRUE) {
            critWeight = parmsPtr->p_partEnum.critWeight;
            (void) iv_UpdateVar(ivWinPtr, &critWeight);
        }

        (void) iv_SetEnableFlag(ivWinPtr, (int *) &areaWeight, 0);
    }

    ivFXFlag = loopFXFlag = FALSE;
    (void) iv_AddVar(ivWinPtr, "Fixed X           ", 
        &ivFXFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);
    ivFYFlag = loopFYFlag = FALSE;
    (void) iv_AddVar(ivWinPtr, "Fixed Y           ", 
        &ivFYFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);
    (void) iv_AddVar(ivWinPtr, "Dimension Value   ",
        (int *) &defDimValue, IV_DOUBLE, 2, IV_NULL_FUNCTION);

    ivARFlag = loopARFlag = FALSE;
    (void) iv_AddVar(ivWinPtr, "Aspect Ratio      ", 
        &ivARFlag, IV_BOOLEAN, IV_NO_OPT, IV_NULL_FUNCTION);
    (void) iv_AddVar(ivWinPtr, "Aspect Ratio Value", 
        (int *) &defARValue, IV_DOUBLE, 2, IV_NULL_FUNCTION);

    switch (parmsPtr->p_mode) {
    case NPL_FIXED_X: 
        ivFXFlag = loopFXFlag = TRUE;
        (void) iv_UpdateVar(ivWinPtr, &ivFXFlag);
        (void) iv_SetEnableFlag(ivWinPtr, (int *) &defARValue, 0);
        break;
    case NPL_FIXED_Y: 
        ivFYFlag = loopFYFlag = TRUE;
        (void) iv_UpdateVar(ivWinPtr, &ivFYFlag);
        (void) iv_SetEnableFlag(ivWinPtr, (int *) &defARValue, 0);
        break;
    case NPL_UNDEF_MODE: 
    case NPL_ASPECT_RATIO: 
        ivARFlag = loopARFlag = TRUE;
        (void) iv_UpdateVar(ivWinPtr, &ivARFlag);
        (void) iv_SetEnableFlag(ivWinPtr, (int *) &defDimValue, 0);
        break;
    default: 
        Bear_PrintErr("NplBeginPlacerInt() : unknown mode");
        return (BEAR_ERROR);
        break;
    }

    okayFlag = FALSE;
    (void) iv_AddVar(ivWinPtr, "Okay              ",
        &okayFlag, IV_TOGGLE, IV_NO_OPT, IV_NULL_FUNCTION);
    abortFlag = FALSE;
    (void) iv_AddVar(ivWinPtr, "Exit              ",
        &abortFlag, IV_TOGGLE, IV_NO_OPT, IV_NULL_FUNCTION);

    (void) iv_MapWindow(ivWinPtr, IV_NO_OPT, IV_NO_OPT, IV_MOUSE);

    while (TRUE) {
        XNextEvent(ez_Display, &theEvent);
        (void) iv_HandleEvent(&theEvent);
        Ez_XEventHandler(&theEvent);

        if (ivQPFlag != loopQPFlag) {
            if (ivQPFlag == TRUE) {
                enable = 0;

                parmsPtr->p_maxLoopCnt = 0;
                parmsPtr->p_finalOptFlag = FALSE;
                ivFEFlag = loopFEFlag = FALSE;
                (void) iv_UpdateVar(ivWinPtr, &parmsPtr->p_maxLoopCnt);
                (void) iv_UpdateVar(ivWinPtr, &parmsPtr->p_finalOptFlag);
                (void) iv_UpdateVar(ivWinPtr, &ivFEFlag);

                (void) iv_SetEnableFlag(ivWinPtr, (int *) &areaWeight, 0);
            }
            else {
                enable = 1;
            }
            (void) iv_SetEnableFlag(ivWinPtr,
                (int *) &parmsPtr->p_maxLoopCnt, enable);
            (void) iv_SetEnableFlag(ivWinPtr,
                (int *) &parmsPtr->p_finalOptFlag, enable);
            (void) iv_SetEnableFlag(ivWinPtr,
                (int *) &ivFEFlag, enable);

            loopQPFlag = ivQPFlag;
        }

        if (ivFEFlag != loopFEFlag) {
            (void) iv_SetEnableFlag(ivWinPtr, (int *) &areaWeight,
                ((ivFEFlag == TRUE) ? 1 : 0));

            loopFEFlag = ivFEFlag;
        }

        if (ivFXFlag != loopFXFlag) {

            ivFXFlag = loopFXFlag = TRUE;
            ivFYFlag = loopFYFlag = FALSE;
            ivARFlag = loopARFlag = FALSE;

            (void) iv_UpdateVar(ivWinPtr, &ivFXFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFYFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivARFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &defDimValue, 1);
            (void) iv_SetEnableFlag(ivWinPtr, (int *) &defARValue, 0);

            continue;
        }

        if (ivFYFlag != loopFYFlag) {

            ivFXFlag = loopFXFlag = FALSE;
            ivFYFlag = loopFYFlag = TRUE;
            ivARFlag = loopARFlag = FALSE;

            (void) iv_UpdateVar(ivWinPtr, &ivFXFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFYFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivARFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &defDimValue, 1);
            (void) iv_SetEnableFlag(ivWinPtr, (int *) &defARValue, 0);

            continue;
        }

        if (ivARFlag != loopARFlag) {

            ivFXFlag = loopFXFlag = FALSE;
            ivFYFlag = loopFYFlag = FALSE;
            ivARFlag = loopARFlag = TRUE;

            (void) iv_UpdateVar(ivWinPtr, &ivFXFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivFYFlag);
            (void) iv_UpdateVar(ivWinPtr, &ivARFlag);

            (void) iv_SetEnableFlag(ivWinPtr, (int *) &defDimValue, 0);
            (void) iv_SetEnableFlag(ivWinPtr, (int *) &defARValue, 1);

            continue;
        }

        if (okayFlag == TRUE) {
            break;
        }

        if (abortFlag == TRUE) {
            iv_FreeWindow(ivWinPtr);
            ivWinPtr = NIL(IVWindow);
            return (BEAR_ERROR);
        }
    }
    iv_FreeWindow(ivWinPtr);
    ivWinPtr = NIL(IVWindow);

    parmsPtr->p_quickPlanFlag = ivQPFlag;

    if ((parmsPtr->p_fullEnumFlag = ivFEFlag) == TRUE) {
        parmsPtr->p_fullEnum.tolerance = tolerance;
        parmsPtr->p_fullEnum.areaWeight = areaWeight;
        parmsPtr->p_fullEnum.wireWeight = wireWeight;
        if (ncl_TimingFlag == TRUE) {
            parmsPtr->p_fullEnum.critWeight = critWeight;
        }
    }
    else {
        parmsPtr->p_partEnum.tolerance = tolerance;
        parmsPtr->p_partEnum.wireWeight = wireWeight;
        if (ncl_TimingFlag == TRUE) {
            parmsPtr->p_partEnum.critWeight = critWeight;
        }
    }

    if (ivFXFlag == TRUE) {
        parmsPtr->p_mode = NPL_FIXED_X;
        *modeValuePtr = defDimValue;
        sprintf (command, "    -m x %.2f\n", *modeValuePtr);
    }
    else if (ivFYFlag == TRUE) {
        parmsPtr->p_mode = NPL_FIXED_Y;
        *modeValuePtr = defDimValue;
        sprintf (command, "    -m y %.2f\n", *modeValuePtr);
    }
    else if (ivARFlag == TRUE) {
        if (defARValue <= 0.0) {
            PbPrint(EZ_ITALIC_FONT, "Illegal aspect ratio value.\n");
            return (BEAR_ERROR);
        }

        parmsPtr->p_mode = NPL_ASPECT_RATIO;
        *modeValuePtr = defARValue;
        sprintf (command, "    -m r %.2f\n", *modeValuePtr);
    }
    else {
        return (BEAR_ERROR);
    }

    PbPrint(EZ_BOLD_FONT, command);
    return (BEAR_OK);
}

#endif /* BEAR_BLACK_BOX */


