
/* polarBear.h --
 *
 *     George Carvalho, Esq.
 *     (Advising Professor - E. S. Kuh)
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/polarBear/polarBear.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _POLARBEAR_H
#define _POLARBEAR_H /* once-only latch */

#ifdef USE_OLDP_CODE
#include "cluster.h"
#endif /* USE_OLDP_CODE */

#include "hash.h"
#include "pbCommands.h"
#include "pbGraphics.h"

#define PB_HOST_NAME_LEN        32      /* The maximum number of letters the
                                         * hostname may have.
                                         */

#define PB_HELP_STRING_LEN      4000    /* help string length               */

#define PB_CMD_LINE_LEN         1028    /* The length of a line containing
                                         * a command.
                                         */

#define PB_BUSY                 0x001
#define GLOBAL_ROUTED           0x002
#define CLUSTERED               0x004

typedef struct _MailData MailData;
struct _MailData {
    char *userPtr;
    char *subjectPtr;
    char *fileNamePtr;
};


/* ---------- Internal procedures for the polarBear program ---------- */

extern BearStatus PbBeginChip();
extern BearStatus PbEndChip();

extern void PbMailUser();
extern char *PbGetDate();

extern void PbPrint(/* whichFont, string */);
/*
 * int   whichFont;  ( EZ_BOLD_FONT | EZ_ITALIC_FONT | EZ_NORMAL_FONT )
 * char  *stringPtr;
 */

extern char *PbGetVersion();

extern void PbPrompt(/* promptPtr */);
/*
 * char *promptPtr;
 */

extern BearStatus   PbDoHorzCompact();
extern BearStatus   PbDoVertCompact();
extern BearStatus   PbDoHorzDecompact();
extern BearStatus   PbDoVertDecompact();

extern BearStatus   PbRouteChannel();
extern BearStatus   PbRouteLChannel();

extern void BuildFloorPlan();
extern void BuildDCells();

extern BearStatus PbCreateChipFromBFPData();

#ifdef USE_BBL_CODE
extern BearStatus PbCreateChipFromBBLData();
#endif /* USE_BBL_CODE */

#ifdef USE_OCT_CODE
extern BearStatus PbCreateChipFromOCTData();
#endif /* USE_OCT_CODE */


/* ---------- Internal global variables for the polarBear program ---------- */

extern bool             pbBlackBoxFlag;
extern CellMaster       *pbCellMasterPtr;

extern FILE             *pbLogFilePtr;

extern bool             pbCmdLoop;
extern bool             pbBusyFlag;
extern bool             pbDebugFlag;
extern bool             pbScriptFlag;

extern MailData         pbMailData;
extern HashTable        pbCmdHashTable;
extern Command          pbCommand[];
extern int              pbNumOfCmds;
extern char             pbConsPrompt[];
extern char             pbHelpString[];
extern char             pbHostName[];

#endif /* _POLARBEAR_H */

