
/* rsSlice.c --
 *
 *     Tim Collins
 *     (Advising Professor - E. S. Kuh)
 *
 * These are the functions common to rsHorzRectSlice and rsVertRectSlice
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/rectSlice/rsSlice.c,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "tile.h"
#include "bear.h"
#include "rectSlice.h"
#include "rectSliceInt.h"

/*
 * ----------------------------------------------------------------------------
 *
 * RsInsertRectList() --
 *
 * Inserts a new rectangle at the end of the list, rectList.
 *
 * Results:
 *   None.
 *
 * Side effects:
 *   A new rectangle has been added to the end of rectList.
 * ----------------------------------------------------------------------------
 */

void
RsInsertRectList(rectList, rectPtr)
LinkedRect   **rectList;
LinkedRect   *rectPtr;

{
    LinkedRect  *lrPtr;

    if (*rectList != NIL(LinkedRect))
    {
        lrPtr = *rectList;
        while (lrPtr->r_next != NIL(LinkedRect))
        {
            lrPtr = lrPtr->r_next;
        }
        lrPtr->r_next = rectPtr;
    }
    else
    {
        *rectList = rectPtr;
    }
}


/*
 * ----------------------------------------------------------------------------
 *
 * RsGetFirstLine() --
 *
 * The first boundary line for a rectangle that will be sliced is found.
 *
 * Results:
 *   Returns the first boundary line.
 *
 * Side effects:
 *   The line is removed from the list.
 * ----------------------------------------------------------------------------
 */

LinkedLine *
RsGetFirstLine(orderedLineListPtr)
OrderedLine **orderedLineListPtr;
{
    LinkedLine  *linePtr;
    OrderedLine *orderedLinePtr;

    linePtr = (*orderedLineListPtr)->linePtr;
    if (linePtr->nextPtr == NIL(LinkedLine))
    {
    orderedLinePtr = *orderedLineListPtr;
    *orderedLineListPtr = (*orderedLineListPtr)->nextPtr;
    FREE((char *) orderedLinePtr);
    }
    else
    {
    (*orderedLineListPtr)->linePtr = linePtr->nextPtr;
    }
    return (linePtr);
}
