
/* ringRouter.h --
 *
 *     (Professor E. S. Kuh)
 *
 * Copyright (C) 1989 Regents of the University of California
 * All rights reserved.
 *
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/ringRouter/ringRouter.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _RING_ROUTER
#define _RING_ROUTER

#define MAXLIN  80
#define BUFSIZE 128

#define CORNER_PIN 0   /* gterm.placg */
#define OUTER_PIN  1
#define INNER_PIN  2

#define SIGNAL_PIN 0   /* gterm.clasg */
#define GROUND_PIN 1
#define POWER_PIN  2

#define YES        1   /* gterm.vcflag */
#define NO         0
#define TEMPORARY  2

#define OUT        1   /* term.mark */
#define IN         0

#define Rr_LEFT       0
#define DOWN       1
#define Rr_RIGHT      2
#define UP         3

#define NumSide     4
#define    Rr_TOP_SIDE    0
#define    Rr_RIGHT_SIDE    1
#define    Rr_BOTTOM_SIDE    2
#define    Rr_LEFT_SIDE    3

#define    XINDEX        0
#define    YINDEX        1

#define    MAXVCTRC    20


/* struct signal has been changed too. */
typedef struct sspan {
	struct term *span1;
	struct term *span2;
	struct Signal *sig;
	int edge ;
	int edge2 ;
	int track ;
	} sspan;


extern int bugflag;
extern struct Signal *vddsigp, *gndsigp;

extern int sigsigcc;   /* signal to signal's contact-to-contact clearance */
extern int sigsigcl;   /* signal to signal's contact-to-line    clearance */
extern int sigvddcl;   /* signal to vdd's    contact-to-line    clearance */
extern int siggndcl;   /* signal to gnd's    contact-to-line    clearance */
extern int vddgndll;   /* vdd    to gnd's       line-to-line    clearance */
extern int pgcc, sigpgcc;
extern int numvddout, numgndout;


extern debug1(/* modulePtr */);
extern debug2(/* modulePtr */);
extern printgterm(/*gtermPtr */);


extern BearStatus Rr_InputChannel();

extern BearStatus
Rr_RouteRing(/* inputFile, ringPtr, adjust, flag, ciffile, viaReduceFlag */);
/*
 * char *inputFile;
 * Ring *ringPtr;
 * int  adjust[NumSide];
 * int  flag;
 * char *ciffile;
 * int  viaReduceFlag;
 */

extern BearStatus Rr_ResizeRing(/* coreMasterPtr, adjust */);
/*
 * CellInst    *coreInstPtr;
 * int         adjust[4];
 */

/* ---------- External global variables for the ringRouter module ---------- */
extern bool rr_DebugFlag;

#endif _RING_ROUTER

