
/* tileMappingInt.h --
 *
 *     Tim Collins
 *     (Professor E. S. Kuh)
 *
 * Copyright (C) 1987 Regents of the University of California
 * All rights reserved.
 *
 * needs: magic.h bear.h ...
 * 
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/tileMapping/tileMappingInt.h,v 1.1.1.1 2002/12/31 15:51:10 saj Exp $
 */

#ifndef _TILEMAPPING_INT
#define _TILEMAPPING_INT

#define Bear_PrintFatalErr You_should_use_the_procedure_TmPrintFatalErr instead

typedef enum _ZoneType {
    NULL_ZONE_TYPE,
    JUNCTION,
    DJUNCTION,
    DCELL,
    V_TILE,
    V_LINE,
    H_TILE,
    H_LINE,
    H_FACE,
    V_FACE,
    C_LINE
} ZoneType;

typedef struct _ZoneData {
    LinkedPPin          *pPinList;
    LinkedRPin          *rPinList;
    LinkedPinInst       *pinInstList;
    ZoneType            zoneType;
    DummyCell           *dCellPtr;
    BottleNeck          *bnPtr;
    struct _ZoneData    *nextPtr;
} ZoneData;

typedef struct _Table {
    BearId        id;
    float         width;
    int           startZone;
    int           endZone;
    BearId        currentId;
    BearId        pinId;
    Net           *netPtr;
    struct _Table *nextPtr;
} Table;

/*
 * code change : by george : on 24 oct 89
 *
typedef enum _PinInstIdType {
    EXTERNAL,    
    H_EXTERNAL,
    V_EXTERNAL
} PinInstIdType;

typedef enum _PPinIdType {
    PP_INTERNAL,    
    PP_EXTERNAL    
} PPinIdType;
 */


/* ---------- Internal procedures for the tileMapping module ---------- */

extern void TmGetHSBnTilesOfDCell(/* dCellPtr, tSBnTilePtr, bSBnTilePtr */);
/*
 * DummyCell *dCellPtr;
 * Tile      **tSBnTilePtr;
 * Tile      **bSBnTilePtr;
 */

extern void TmGetVSBnTilesOfDCell(/* dCellPtr, rSBnTilePtr, lSBnTilePtr */);
/*
 * DummyCell *dCellPtr;
 * Tile      **rSBnTilePtr;
 * Tile      **lSBnTilePtr;
 */

extern void TmGetLAndRTiles(/* dCellPtr, leftBnTilePtr, rightBnTilePtr */);
/*
 * DummyCell *dCellPtr;
 * Tile      **leftBnTilePtrPtr;
 * Tile      **rightBnTilePtrPtr;
 */

extern void TmGetTAndBTiles(/* dCellPtr, bottomBnTilePtr, topBnTilePtr */);
/*
 * DummyCell *dCellPtr;
 * Tile      **bottomBnTilePtrPtr;
 * Tile      **topBnTilePtrPtr;
 */

extern void TmGetLAndRBnTilesOfDCell(/* dCellPtr, leftBnTilePtr, rightBnTilePtr */);
/*
 * DummyCell *dCellPtr;
 * Tile      **leftBnTilePtrPtr;
 * Tile      **rightBnTilePtrPtr;
 */

extern void TmGetBAndTBnTilesOfDCell(/* dCellPtr, bottomBnTilePtr, topBnTilePtr */);
/*
 * DummyCell *dCellPtr;
 * Tile      **bottomBnTilePtrPtr;
 * Tile      **topBnTilePtrPtr;
 */

extern void TmSplitDTile(/* dmntTilePtr, planeDataPtr */);
/*
 * Tile      *dmntTilePtr;
 * PlaneData *planeDataPtr;
 */

extern void TmVSplitByZones(/* numOfZones, tablePtr, zoneDataPtr */);
/*
 * int      numOfZones;
 * Table    tablePtr;
 * ZoneData *zoneDataPtr;
 */

extern void TmHSplitByZones(/* numOfZones, tablePtr, zoneDataPtr */);
/*
 * int      numOfZones;
 * Table    tablePtr;
 * ZoneData *zoneDataPtr;
 */

extern void TmHRectUnify(/* planeDataPtr, dmntRect */);
/* PlaneData *planeDataPtr;
 * Rect      dmntRect;
 */

extern void TmVRectUnify(/* planeDataPtr, dmntRect */);
/* PlaneData *planeDataPtr;
 * Rect      dmntRect;
 */

extern void TmNumberTable(/* tableList, id, netPtr, numOfZone */);
/* 
 * Table  **tableList;
 * BearId id;
 * Net    *netPtr;
 * int    numOfZone;
 */

extern BearId TmGetTempIntNetIdOfPPin(/* pPinPtr */);
/* 
 * PseudoPin    *pPinPtr;
 */

extern BearId TmGetTempExtNetIdOfPPin(/* pPinPtr */);
/* 
 * PseudoPin    *pPinPtr;
 */

extern void TmPutTempIntNetIdOfPPin(/* intNetId, pPinPtr */);
/* 
 * BearId       intNetId;
 * PseudoPin    *pPinPtr;
 */


extern void TmPutTempExtNetIdOfPPin(/* extNetId, pPinPtr */);
/* 
 * BearId       extNetId;
 * PseudoPin    *pPinPtr;
 */

extern ZoneData *TmMakeZoneData();

extern void TmFreeZoneData(/* zoneDataPtrPtr */);
/*
 * ZoneData **zoneDataPtrPtr;
 */

extern void TmPrintFatalErr(/* message */);
/*
 * BearString message;
 */


/* --------- Internal global variables for the tileMapping module --------- */

CellMaster *tmGlobalParentCellPtr;
PlaneData  *tmGlobalPlaneDataPtr;

#endif _TILEMAPPING_INT

