
/* tilePropInt.h --
 *
 *     George Carvalho
 *     (Professor E. S. Kuh)
 *
 * Copyright (C) 1986 Regents of the University of California
 * All rights reserved.
 *
 * rcsid $Header: /home/cvs/octtools/src/BearFP-1.1/src/tileProp/tilePropInt.h,v 1.1.1.1 2002/12/31 15:51:11 saj Exp $
 */

#ifndef _TILEPROPINT
#define _TILEPROPINT /* once-only latch */

#include "database.h"

#define Bear_PrintFatalErr You_should_use_the_procedure_TpPrintFatalErr instead

#define TILE_PROP_PTR ((TileProp *) tilePtr->ti_client)

typedef struct _CheckData {
    bool        strong;                 /* If TRUE use strong checking else
                                         * use weak checking.
                                         */
    int         tileType;
    char        *namePtr;               /* Only needs to be filled in for
                                         * weak checking.
                                         */

    Plane       *planePtr;
    Rect        *bndPtr;                /* Boundary that must surround the
                                         * rectangle list.
                                         */
    LinkedRect  *rectList;
    Transform   *transPtr;
} CheckData;

typedef struct _LinkedCellInst {
    struct _LinkedCellInst  *nextPtr;
    struct _CellInst        *cellInstPtr;
} LinkedCellInst;

extern void TpPaintRectList(/* planePtr, rectList, transPtr, gcellPtr */);
/*
 * Plane       *planePtr;
 * LinkedRect  *rectList;
 * Transform   *transPtr;
 * GenericCell *gcellPtr;
 */

extern void TpUnpaintRectList(/* planePtr, rectList, transPtr, tileType */);
/* 
 * Plane       *planePtr;
 * LinkedRect  *rectList;
 * Transform   *transPtr;
 * TileType    tileType;
 */

extern bool TpCheckPlaneUnderRectList();

extern int TpPaintProc(/* oldTileType, paintTileType */);
/*
 * int    oldTileType; 
 * int    paintTileType;
 */

extern BearStatus TpDuplicateLineSeg(/* origCellInstPtr, dupCellInstPtr */);
/*
 * CellInst *origCellInstPtr;
 * CellInst *dupCellInstPtr;
 */

extern BearStatus
TpDuplicatePinOfLineSeg(/* origCellInstPtr, dupCellInstPtr */);
/*
 * CellInst *origCellInstPtr;
 * CellInst *dupCellInstPtr;
 */

extern void TpPrintFatalErr(/* message */);
/*
 * BearString message;
 */

#endif _TILEPROPINT

