
/* tpDelete.c --
 *
 *     George Carvalho
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/tileProp/tpDelete.c,v 1.1.1.1 2002/12/31 15:51:11 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "bear.h"
#include "tile.h"
#include "fpg.h"
#include "gtGraph.h"
#include "tileProp.h"
#include "tilePropInt.h"
#include "mac.h"


/*
 * ----------------------------------------------------------------------------
 *
 * Tp_DeleteCell() --
 *
 *   Delete cell instance.
 *
 *   ASKING FOR THIS CELL AGAIN, IS TO INVITE DISASTER !
 *
 * Results:
 *   BEAR_OK is returned if everything went down okay, BEAR_ERROR otherwise.
 *
 * Side effects:
 *   Cell instance is deleted from both the horizontal and vertical
 *   tile planes, and removed from the data base. 
 *
 * ----------------------------------------------------------------------------
 */

BearStatus
Tp_DeleteCell(cellInstPtr)
CellInst *cellInstPtr;
{
    CellMaster  *parentCellPtr, *cellMasterPtr;
    GenericCell gcell;
    PlaneData   *planeDataPtr;

    parentCellPtr = Mac_GetParentOfCell(cellInstPtr);
    planeDataPtr = Mac_GetCellPlaneOfCell(parentCellPtr);

    cellMasterPtr = Mac_GetMasterOfCell(cellInstPtr);

    gcell.unType = (CellClass) CELL_INST;
    gcell.unValue.cellInstPtr = cellInstPtr;

    Tp_UnpaintGCell(&gcell, planeDataPtr);
    if (Mac_DeleteCell(cellInstPtr) == BEAR_ERROR) {
        return (BEAR_ERROR);
    }
    if (cellMasterPtr->instList == NIL(CellInst)) {
        if (Mac_DeleteCellMaster(cellMasterPtr) == BEAR_ERROR) {
            return (BEAR_ERROR);
        }
    }

    return (BEAR_OK);
}



