
/* tpLineSeg.c --
 *
 *     Sangjin Hong
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/tileProp/tpLineSeg.c,v 1.1.1.1 2002/12/31 15:51:11 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "bear.h"
#include "tile.h"
#include "fpg.h"
#include "gtGraph.h"
#include "rectSlice.h"
#include "tileProp.h"
#include "tilePropInt.h"
#include "mac.h"

/*
 * ----------------------------------------------------------------------------
 *
 * TpDuplicateLineSeg() --
 *
 * Duplicate line segments of a cell instance.
 *
 * Results:
 *    BEAR_OK is returned if everything went down okay, BEAR_ERROR otherwise.
 *
 * Side effects:
 *    The duplicated line segments are attached to a duplicated cell.
 *
 * ----------------------------------------------------------------------------
 */

BearStatus
TpDuplicateLineSeg(origCellInstPtr, dupCellInstPtr)
CellInst        *origCellInstPtr;
CellInst        *dupCellInstPtr;
{
    LinkedLineSeg   *dupLineSegPtr;
    LinkedLineSeg   *curLinkedLineSeg;
    LineSeg         *lineSegPtr;

    dupLineSegPtr = NIL(LinkedLineSeg);
    for(curLinkedLineSeg = origCellInstPtr->boundary;
        curLinkedLineSeg != NIL(LinkedLineSeg);
        curLinkedLineSeg = curLinkedLineSeg->nextPtr)
    {
        lineSegPtr = Mac_MakeLineSeg();
        lineSegPtr->dir = curLinkedLineSeg->lineSeg->dir;
        lineSegPtr->segID = curLinkedLineSeg->lineSeg->segID;
        lineSegPtr->routCap = curLinkedLineSeg->lineSeg->routCap;
        lineSegPtr->line.point1.p_x = 
        curLinkedLineSeg->lineSeg->line.point1.p_x;
        lineSegPtr->line.point1.p_y = 
        curLinkedLineSeg->lineSeg->line.point1.p_y;
        lineSegPtr->line.point2.p_x = 
        curLinkedLineSeg->lineSeg->line.point2.p_x;
        lineSegPtr->line.point2.p_y = 
        curLinkedLineSeg->lineSeg->line.point2.p_y;

        if (Mac_AppendLineSeg(&dupLineSegPtr,lineSegPtr) == BEAR_ERROR)
        {
            Bear_PrintErr("TpDuplicateLineSeg() failed\n");
            return (BEAR_ERROR);
        }
    }
    dupCellInstPtr->boundary = dupLineSegPtr;
    return (BEAR_OK);
}

