
/* tpPinOfLineSeg.c --
 *
 *     Sangjin Hong
 *     (Advising Professor - E. S. Kuh)
 *
 */

#ifndef lint
static char rcsid[] = "$Header: /home/cvs/octtools/src/BearFP-1.1/src/tileProp/tpPinOfLineSeg.c,v 1.1.1.1 2002/12/31 15:51:11 saj Exp $";
#endif  not lint

#include "bearCopyRight.h"
#include <stdio.h>
#include "magic.h"
#include "malloc.h"
#include "geometry.h"
#include "bear.h"
#include "tile.h"
#include "fpg.h"
#include "gtGraph.h"
#include "rectSlice.h"
#include "tileProp.h"
#include "tilePropInt.h"
#include "mac.h"

/*
 * ----------------------------------------------------------------------------
 *
 * TpDuplicatePinOfLineSeg() --
 *
 * Duplicate pins of line segments of a cell instance.
 *
 * Results:
 *    BEAR_OK is returned if everything went down okay, BEAR_ERROR otherwise.
 *
 * Side effects:
 *    The duplicated pins are attached to a duplicated line segments of cell.
 *
 * ----------------------------------------------------------------------------
 */

BearStatus
TpDuplicatePinOfLineSeg(origCellInstPtr, dupCellInstPtr)
CellInst *origCellInstPtr;
CellInst *dupCellInstPtr;
{
    PortInst        *curPortInstPtr;
    PinInst         *curPinInstPtr;

    for (curPortInstPtr = dupCellInstPtr->portInstList;
        curPortInstPtr !=NIL(PortInst);
        curPortInstPtr = curPortInstPtr->nextCellPortPtr) {

        for (curPinInstPtr = curPortInstPtr->pinList;
            curPinInstPtr != NIL(PinInst);
            curPinInstPtr = curPinInstPtr->nextPtr) {
            if (Mac_InsertPinOfLineSeg(dupCellInstPtr->boundary,curPinInstPtr)
                == BEAR_ERROR)
            {
                Bear_PrintErr("TpDuplicatePinOfLineSeg() failed\n");
                return (BEAR_ERROR);
            }
        }
    }
    return (BEAR_OK);
}


