/*
Copyright (C) 1986 University of California (Berkeley). All rights reserved.

CDSPrint.c

Author(s):		Mitsuru Igusa
Revision history:	$Log: CDSPrint.c,v $
Revision history:	Revision 1.1.1.1  2002/12/31 15:50:52  saj
Revision history:	octtools 5.2 in a GNU format
Revision history:	
 * Revision 1.2  90/02/07  16:10:41  octtools
 * Checkin for 3.5 distribution
 * 
 * Revision 1.1  89/01/27  22:39:35  octtools
 * Initial revision
 * 
 * Revision 1.1  88/03/31  11:39:24  mitch
 * Initial revision
 * 
----------------------------------------------------------------------------*/
#include "copyright.h"
#include "port.h"
#include "MIInc.h"
#include "CDSInc.h"

/* Print picture of node graph
----------------------------------------------------------------------------*/
CDSPrintNGraph(sNode)

CDSGNodeDef	*sNode;
{
short		np, p;
short		ii, j, jn, k;
int		l, l2, lp;
CDSGNodeDef	*n, *n2;
CDSGEdgeDef	*e, *e1;
CDSGEdgeDef	**revHEdge;
short		numCol = 0;
char		nStr[5];

CDSGNodeDef	**tNode;
int		t, numTNode = 0;
short		stkRef;

#define	CDS_COLPERPAGE 5
#define CDS_NODETOSTR(str, dir) { \
    if (CDS_ID(n->bch[dir].node)>=0) \
    then (void) sprintf(str,"%3d%c", CDS_ID(n->bch[dir].node), n->bch[dir].type); \
    else (void) strcpy(str,"    "); \
}

MI_MOD_START("CDSPrintNGraph");

tNode = ALLOC_ARRAY(CDSHead.numGNode, CDSGNodeDef*);

stkRef = MIStackPtr;			/* Init tNode[] */
MI_STACK_PUSH(sNode);
tNode[numTNode++] = sNode;

while (stkRef!=MIStackPtr) {
    MI_STACK_POP(CDSGNodeDef*, n);
    for (k=0; k<4; k++) {
	n2 = n->bch[k].node;
	if (!n2) continue;
	for (t=0; t<numTNode; t++)
	    if (n2==tNode[t]) break;
	if (t<numTNode) continue;
	if (numTNode==CDSHead.numGNode) {
	    MIfprintf(MIERR,
		"ERROR in node table at starting at node %d (%d %d)\n",
		CDS_ID(sNode), sNode->loc[CDS_X], sNode->loc[CDS_Y]);
	    numTNode = 0;
	    for (n=CDSGNode; n; n=n->next)
		tNode[numTNode++] = n;
	    MIStackPtr = stkRef;
	    break;
	}
	MI_STACK_PUSH(n2);
	tNode[numTNode++] = n2;
    }
}

for (t=0; t<numTNode; t++) {		/* Print simple node table */
    n = tNode[t];
    MIprintf("Node %3d: (%d %d)", CDS_ID(n), n->loc[CDS_X], n->loc[CDS_Y]);
    for (k=0; k<4; k++) {
	if (n->bch[k].node)
	    MIprintf("  %s(%c%dn %do %dt)",
		CDS_CDIR_TOSTR(k), n->bch[k].type, CDS_ID(n->bch[k].node),
		n->bch[k].objNum, n->bch[k].treeId);
	else
	    MIprintf("  %s(xxxx)", CDS_CDIR_TOSTR(k));
    }
    MIprintf("\n");
}
MIprintf("\n");
					/* Init revHEdge[] */
revHEdge = ALLOC_ARRAY(CDSHead.numGEdge[CDS_H], CDSGEdgeDef*);
e = CDSGEdge[CDS_H];
for (j=0; j<CDSHead.numGEdge[CDS_H]; j++, e=e->next)
    revHEdge[j] = e;

lp = -(MAXINT);				/* Init numCol */
for (e=CDSGEdge[CDS_V]; e; e=e->next) {
    l = e->loc;
    if (l!=lp) numCol++;
    lp = l;
}
np = (numCol+CDS_COLPERPAGE-1)/CDS_COLPERPAGE;

e = CDSGEdge[CDS_V];			/* Print graphical node picture */
for (p=0; p<np; p++) {

    e1 = e;				/* Header */
    MIprintf("          +");
    for (ii=0; ii<CDS_COLPERPAGE && e1; ii++) {
	l = e1->loc;
	MIprintf("%2d/%6d+", ii+p*CDS_COLPERPAGE, l);
	for (e1=e1->next; e1; e1=e1->next)
	    if (e1->loc!=l) break;
    }
    MIprintf("\n");

    for (j=CDSHead.numGEdge[CDS_H]-1; j>=0; j=jn) {
	l2 = revHEdge[j]->loc;
	for (k=0; k<3; k++) {		/* Three rows */
	    if (k==1)
	    then MIprintf("%2d:%8d:", j, l2);
	    else MIprintf("           ");
	    e1 = e;
	    for (ii=0; ii<CDS_COLPERPAGE && e1; ii++) {
		l = e1->loc;
		for (t=0; t<numTNode; t++) {
		    n = tNode[t];
		    if (n->loc[CDS_X]==l &&
			n->loc[CDS_Y]==l2) break;
		}
		if (t==numTNode)
		    MIprintf("          ");
		else
		    switch (k) {
		    case  0:
			CDS_NODETOSTR(nStr, CDS_N);
			MIprintf("   %4s   ", nStr);
			break;
		    case  1:
			CDS_NODETOSTR(nStr, CDS_W);
			MIprintf(" %4s", nStr);
			CDS_NODETOSTR(nStr, CDS_E);
			MIprintf("%c%4s", (n ? n->type : '.'), nStr);
			break;
		    default:
			CDS_NODETOSTR(nStr, CDS_S);
			MIprintf("   %4s   ", nStr);
		    }
					/* Skip to next i */
		for (e1=e1->next; e1; e1=e1->next)
		    if (e1->loc!=l) break;
	    }
	    MIprintf("\n");
	}
	for (jn=j-1; jn>=0; jn--)	/* Skip to next j */
	    if (revHEdge[jn]->loc!=l2) break;
    }
    e = e1;
}

FREE_ARRAY(CDSHead.numGEdge[CDS_H], revHEdge, CDSGEdgeDef*);
FREE_ARRAY(CDSHead.numGNode, tNode, CDSGNodeDef*);

MI_MOD_END();
#undef CDS_COLPERPAGE
#undef CDS_NODETOSTR
} /* ............................. End of procedure CDSPrintNGraph */
/* Print channel definition tree.
----------------------------------------------------------------------------*/
CDSPrintTree()
{
short		stkRef;
CDSTreeDef	*t;
short		s;

MI_MOD_START("CDSPrintTree");

stkRef = MIStackPtr;
MI_STACK_PUSH(CDSTree);

while (MIStackPtr!=stkRef) {
    MI_STACK_POP(CDSTreeDef*, t);
    if (!t) continue;
    MIprintf("Tree %d: type=%d par=%d ord=%d ",
	CDS_ID(t), t->type, t->parentId, t->order);
    if (t->type!=CDS_TREE_ELEMENT &&
	t->type!=CDS_TREE_NOT_DONE) {
	MI_STACK_PUSH(t->child[CDS_LO]);
	MI_STACK_PUSH(t->child[CDS_HI]);
	MIprintf("loChild=%d hiChild=%d\n",
	    CDS_ID(t->child[CDS_LO]), CDS_ID(t->child[CDS_HI]));
	for (s=0; s<t->type; s++)
	    MIprintf("sliceLoc %2d: (%d %d)\n",
		s, t->slice[s][CDS_X], t->slice[s][CDS_Y]);
    }
    else
	MIprintf("objnum=%d\n", t->objNum);
}

MI_MOD_END();
} /* ............................. End of procedure CDSPrintTree */
