#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LL1Plus - 1+
 *
 *    (1+ number)
 *
 *    return the result
 */
LLobject *
LL1Plus(number)
LLobject *number;
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (1+ number)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
", number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_integerp(number) ?
		LLMakeInteger(number->value.a_integer + 1):
		LLMakeReal(number->value.a_real + 1.0));
}

/*
 *    LL1Minus - 1-
 *
 *    (1- number)
 *
 *    return the result
 */
LLobject *
LL1Minus(number)
LLobject *number;
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (1- number)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
", number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_integerp(number) ?
		LLMakeInteger(number->value.a_integer - 1):
		LLMakeReal(number->value.a_real - 1.0));
}
