#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLAcosh - acosh
 *
 *    (acosh number)
 *
 *    return the acosh
 */
LLobject *
LLAcosh(number)
LLobject *number;
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (acosh number)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
", number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number) ?
		(number->value.a_real < 0.0):
		(number->value.a_integer < 0)) {
	    LLErrorF("\
Function: (acosh number)\n\
\tnumber is negative\n\
\tnumber: ~S\n\
", number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number)) {
	    return (LLMakeReal(acosh(number->value.a_real)));
	} else {
	    return (LLMakeInteger((int) acosh((double) number->value.a_integer)));
	}

	/*NOTREACHED*/
}
