#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

static LLobject *func();

/*
 *    LLPlus - +
 *
 *    (+ &rest numbers)
 *
 *    return the result
 */
LLobject *
LLPlus(numbers)
LLobject *numbers;		/* &rest */
{
	return (func(numbers, "+", /* addP */ TRUE));
}

/*
 *    LLTimes - *
 *
 *    (* &rest numbers)
 *
 *    return the result
 */
LLobject *
LLTimes(numbers)
LLobject *numbers;		/* &rest */
{
	return (func(numbers, "*", /* addP */ FALSE));
}

static LLobject *
func(numbers, name, addP)
LLobject *numbers;	/* &rest */
String name;
Boolean addP;
{
	Boolean integerP;
	LLobject *n, *this;
	double rret;
	int iret;
	
	iret = addP ? 0: 1;
	integerP = TRUE;
	
	for (n=numbers; LL_consp(n); n=LL_cdr(n)) {
	    this = LL_car(n);

	    if ( ! LL_numberp(this) ) {
		LLErrorF("\
Function: (~A &rest numbers)\n\
\tnumber is not a number\n\
\toffender: ~S\n\
\tnumbers:  ~S\n\
", name, this, numbers);
		LLThrow(LL_lightlisp, LL_nil);
	    }

	    if (LL_realp(this) && integerP) {
		rret = iret;
		integerP = FALSE;
	    }

	    if (addP) {
		if (integerP) {
		    iret += this->value.a_integer;
		} else {
		    rret += LL_realp(this) ? this->value.a_real: this->value.a_integer;
		}
	    } else {
		if (integerP) {
		    iret *= this->value.a_integer;
		} else {
		    rret *= LL_realp(this) ? this->value.a_real: this->value.a_integer;
		}
	    }
	}

	return (integerP ? LLMakeInteger(iret): LLMakeReal(rret));
}
