#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLAnd - and
 *
 *    (and 
 *     forms ... )
 *
 *    return result
 */
LLobject *
LLAnd(arguments, environment)
LLobject *arguments;		/* value */
LLobject *environment;		/* value */
{
	if (LL_null(LLAnd_tr(&arguments, &environment)))
	    return (arguments);

	return (LLEvaluator(arguments, environment));
}

/*
 *    LLAnd_tr - and
 *
 *    (and 
 *     forms ... )
 *
 *    Every CommonLisp implementation has a right to implement
 *       a macro as a special form for speed
 *
 *    return {t, nil} on {tail-recursive, non-tail-recursive}
 */
LLobject *
LLAnd_tr(arguments, environment)
LLobject **arguments;		/* value/return */
LLobject **environment;		/* value/return */
{
	LLobject *sexps, *ret;

	sexps = *arguments;

	if (LL_null(sexps)) {
	    *arguments = LL_t;
	    return (LL_nil);
	}

	while ( ! LL_null(LL_cdr(sexps)) ) {
	    ret = LLEvaluator(LL_car(sexps), *environment);
	    if (LL_null(ret)) {
		*arguments = LL_nil;
		return (LL_nil);
	    }

	    sexps = LL_cdr(sexps);
	}

	*arguments = LL_car(sexps);
	return (LL_t);		/* tail-recur */
}
