#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLAppend - append two lists together
 *
 *    (append &rest lists)
 *
 *    return the new list
 */
LLobject *
LLAppend(lists)
LLobject *lists;	/* &rest */
{
	LLobject *list, *ret, *last, *tmp, *r, *subret, *sublast, *subr;

	if (LL_null(lists))
	    return (LL_nil);

	ret = LL_nil;
	last = LL_nil;

	for (r=lists; ! LL_null(LL_cdr(r)); r=LL_cdr(r)) {
	    list = LL_car(r);

	    if (LL_null(list))
		continue;

	    if ( ! LL_consp(list) ) {
		LLErrorF("\
Function: (append &rest lists)\n\
\tlist is not a list\n\
\tlist:  ~S\n\
\tlists: ~S\n\
", list, lists);
		LLThrow(LL_lightlisp, LL_nil);
	    }

	    /*
	     *    => (append '(a b) nil)
	     *    (a b)
	     *
	     *    => (append '(a . b) '(c . d))
	     *    (a c . d)
	     *
	     *    => (append '(a b) 'd)
	     *    (a b . d)
	     */
	    subret = LL_nil;
	    sublast = LL_nil;

	    for (subr=list; LL_consp(subr); subr=LL_cdr(subr)) {
		tmp = LLCons(LL_car(subr), LL_nil);

		if (LL_null(subret))
		    subret = tmp;
		else
		    LL_rplacd(sublast, tmp);
		sublast = tmp;
	    }

	    if (LL_null(ret)) {
		ret = subret;
		last = subret;
	    } else {
		LL_rplacd(last, subret);
	    }
	    while ( ! LL_null(LL_cdr(last)) )
		last = LL_cdr(last);
	}

	if (LL_null(ret))
	    ret = LL_car(r);
	else
	    LL_rplacd(last, LL_car(r));

	return (ret);
}
