#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

static LLobject *func();

/*
 *    LLAcos - acos
 *
 *    (acos number)
 *
 *    return the acos
 */
LLobject *
LLAcos(number)
LLobject *number;
{
	return (func(acos, "acos", number));
}

/*
 *    LLAsin - asin
 *
 *    (asin number)
 *
 *    return the asin
 */
LLobject *
LLAsin(number)
LLobject *number;
{
	return (func(asin, "asin", number));
}

/* the sequent and hp 4.3 (utah) don't define these */
#if ! (OPSYS_MFR == MD_SEQUENT || \
	(OPSYS_MFR == MD_HP && OPSYS_VERS == MD_BSD_4_3)) /* { */
/*
 *    LLAsinh - asinh
 *
 *    (asinh number)
 *
 *    return the asinh
 */
LLobject *
LLAsinh(number)
LLobject *number;
{
	return (func(asinh, "asinh", number));
}

/*
 *    LLAtanh - atanh
 *
 *    (atanh number)
 *
 *    return the atanh
 */
LLobject *
LLAtanh(number)
LLobject *number;
{
	return (func(atanh, "atanh", number));
}
#endif /* } */

/*
 *    double
 *    function(val)
 *    double val;
 */
static LLobject *
func(function, name, number)
double (*function)();
String name;
LLobject *number;
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (~A number)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
", name, number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number) ? (ABS(number->value.a_real) > 1.0): (ABS(number->value.a_integer > 1))) {
	    LLErrorF("\
Function: (~A number)\n\
\tmagnitude of number greater than 1\n\
\tnumber: ~S\n\
", name, number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number)) {
	    return (LLMakeReal((*function)(number->value.a_real)));
	} else {
	    return (LLMakeReal((*function)((double) number->value.a_integer)));
	}

	/*NOTREACHED*/
}
