#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLAtan - atan
 *
 *    (atan x &optional y)
 *
 *    return the atan
 */
LLobject *
LLAtan(y, x)
LLobject *y;
LLobject *x;	/* &optional */
{
	if ( ! LL_numberp(x) ) {
	    LLErrorF("\
Function: (atan x &optional y)\n\
\tx is not a number\n\
\tx: ~S\n\
", x);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_null(y)) {
	    return (LLMakeReal(atan(LL_realp(x) ? x->value.a_real: (double) x->value.a_integer)));
	} else {
	    if ( ! LL_numberp(y) ) {
		LLErrorF("\
Function: (atan x &optional y)\n\
\ty is not a number\n\
\tx: ~S\n\
\ty: ~S\n\
", x, y);
		LLThrow(LL_lightlisp, LL_nil);
	    }
	    if ((LL_realp(x) ? (x->value.a_real == 0.0): (y->value.a_real == 0)) &&
	        (LL_realp(y) ? (y->value.a_real == 0.0): (x->value.a_real == 0))) {
		LLErrorF("\
Function: (atan x &optional y)\n\
\ty and x cannot be both be zero\n\
\tx: ~S\n\
\ty: ~S\n\
", x, y);
		LLThrow(LL_lightlisp, LL_nil);
	    }

	    if (LL_realp(x) && LL_realp(y)) {
		return (LLMakeReal(atan2(x->value.a_real, y->value.a_real)));
	    } else if (LL_realp(x)) {
		return (LLMakeReal(atan2(x->value.a_real, (double) y->value.a_integer)));
	    } else if (LL_realp(y)) {
		return (LLMakeReal(atan2((double) x->value.a_integer, y->value.a_real)));
	    } else {
		return (LLMakeReal(atan2((double) x->value.a_integer, (double) x->value.a_integer)));
	    }
	}

	/*NOTREACHED*/
}

