#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLBoundp - boundp
 *
 *    (boundp symbol)
 *
 *    return {t, nil} on {bound, not}
 */
LLobject *
LLBoundp(symbol)
LLobject *symbol;
{
	if ( ! LL_symbolp(symbol) ) {
	    LLErrorF("\
Function: (boundp symbol)\n\
\tsymbol is not a symbol\n\
\tsymbol: ~S\n\
", symbol);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_unboundp(symbol, LL_valueSlot) ? LL_nil: LL_t);
}

/*
 *    LLFboundp - fboundp
 *
 *    (fboundp symbol)
 *
 *    return {t, nil} on {bound, not}
 */
LLobject *
LLFboundp(symbol)
LLobject *symbol;
{
	if ( ! LL_symbolp(symbol) ) {
	    LLErrorF("\
Function: (fboundp symbol)\n\
\tsymbol is not a symbol\n\
\tsymbol: ~S\n\
", symbol);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_unboundp(symbol, LL_functionSlot) ? LL_nil: LL_t);
}
