#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

#define subbody(exp, name, key, whole) \
/* LLobject **exp;	- value/return */ \
/* String name; */ \
/* char key; */ \
/* LLobject *whole; */ \
{ \
	if (key != ' ') { \
	    if ( ! LL_listp(*(exp)) ) { \
		LLErrorF("\
Function: (~A sexp)\n\
\tnot a cons\n\
\targument:  ~S\n\
\toffending: ~S\n\
", name, whole, *(exp)); \
		LLThrow(LL_lightlisp, LL_nil); \
	    } \
 \
	    switch (key) { \
	    case 'a': \
		*(exp) = LL_car(*(exp)); \
		break; \
	    case 'd': \
		*(exp) = LL_cdr(*(exp)); \
		break; \
	    } \
	} \
}

#define body(subexp, name, one, two, three, four) \
{ \
	LLobject *exp = (subexp); \
 \
	/* read from the inside out */ \
	subbody(&exp, name, four, /* whole */ subexp); \
	subbody(&exp, name, three, /* whole */ subexp); \
	subbody(&exp, name, two, /* whole */ subexp); \
	subbody(&exp, name, one, /* whole */ subexp); \
	return (exp); \
}

LLobject *
LLCaar(sexp)
LLobject *sexp;
{
	body(sexp, "caar", ' ', ' ', 'a', 'a');
}

LLobject *
LLCadr(sexp)
LLobject *sexp;
{
	body(sexp, "cadr", ' ', ' ', 'a', 'd');
}

LLobject *
LLCdar(sexp)
LLobject *sexp;
{
	body(sexp, "cdar", ' ', ' ', 'd', 'a');
}

LLobject *
LLCddr(sexp)
LLobject *sexp;
{
	body(sexp, "cddr", ' ', ' ', 'd', 'd');
}

LLobject *
LLCaaar(sexp)
LLobject *sexp;
{
	body(sexp, "caaar", ' ', 'a', 'a', 'a');
}

LLobject *
LLCaadr(sexp)
LLobject *sexp;
{
	body(sexp, "caadr", ' ', 'a', 'a', 'd');
}

LLobject *
LLCadar(sexp)
LLobject *sexp;
{
	body(sexp, "cadar", ' ', 'a', 'd', 'a');
}

LLobject *
LLCaddr(sexp)
LLobject *sexp;
{
	body(sexp, "caddr", ' ', 'a', 'd', 'd');
}

LLobject *
LLCdaar(sexp)
LLobject *sexp;
{
	body(sexp, "cdaar", ' ', 'd', 'a', 'a');
}

LLobject *
LLCdadr(sexp)
LLobject *sexp;
{
	body(sexp, "cdadr",  ' ', 'd', 'a', 'd');
}

LLobject *
LLCddar(sexp)
LLobject *sexp;
{
	body(sexp, "cddar", ' ', 'd', 'd', 'a');
}

LLobject *
LLCdddr(sexp)
LLobject *sexp;
{
	body(sexp, "cdddr", ' ', 'd', 'd', 'd');
}

LLobject *
LLCaaaar(sexp)
LLobject *sexp;
{
	body(sexp, "caaaar", 'a', 'a', 'a', 'a');
}

LLobject *
LLCaaadr(sexp)
LLobject *sexp;
{
	body(sexp, "caaadr", 'a', 'a', 'a', 'd');
}

LLobject *
LLCaadar(sexp)
LLobject *sexp;
{
	body(sexp, "caadar", 'a', 'a', 'd', 'a');
}

LLobject *
LLCaaddr(sexp)
LLobject *sexp;
{
	body(sexp, "caaddr", 'a', 'a', 'd', 'd');
}

LLobject *
LLCadaar(sexp)
LLobject *sexp;
{
	body(sexp, "cadaar", 'a', 'd', 'a', 'a');
}

LLobject *
LLCadadr(sexp)
LLobject *sexp;
{
	body(sexp, "cadadr", 'a', 'd', 'a', 'd');
}

LLobject *
LLCaddar(sexp)
LLobject *sexp;
{
	body(sexp, "caddar", 'a', 'd', 'd', 'a');
}

LLobject *
LLCadddr(sexp)
LLobject *sexp;
{
	body(sexp, "cadddr", 'a', 'd', 'd', 'd');
}

LLobject *
LLCdaaar(sexp)
LLobject *sexp;
{
	body(sexp, "cdaaar", 'd', 'a', 'a', 'a');
}

LLobject *
LLCdaadr(sexp)
LLobject *sexp;
{
	body(sexp, "cdaadr", 'd', 'a', 'a', 'd');
}

LLobject *
LLCdadar(sexp)
LLobject *sexp;
{
	body(sexp, "cdadar", 'd', 'a', 'd', 'a');
}

LLobject *
LLCdaddr(sexp)
LLobject *sexp;
{
	body(sexp, "cdaddr", 'd', 'a', 'd', 'd');
}

LLobject *
LLCddaar(sexp)
LLobject *sexp;
{
	body(sexp, "cddaar", 'd', 'd', 'a', 'a');
}

LLobject *
LLCddadr(sexp)
LLobject *sexp;
{
	body(sexp, "cddadr", 'd', 'd', 'a', 'd');
}

LLobject *
LLCdddar(sexp)
LLobject *sexp;
{
	body(sexp, "cdddar", 'd', 'd', 'd', 'a');
}

LLobject *
LLCddddr(sexp)
LLobject *sexp;
{
	body(sexp, "cddddr", 'd', 'd', 'd', 'd');
}
