#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLCdr - cdr
 *
 *    (cdr exp)
 *
 *    return the cdr
 */
LLobject *
LLCdr(exp)
LLobject *exp;
{
	if (LL_null(exp))
	    return (LL_nil);

	if ( ! LL_consp(exp) ) {
	    LLErrorF("\
Function: (cdr exp)\n\
\texp is not a cons\n\
\texp: ~S\n\
", exp);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_cdr(exp));
}
