#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLCoerce - coerce
 *
 *    (coerce item result-type)
 *
 *    return the concatenation
 */
LLobject *
LLCoerce(item, result_type)
LLobject *item;
LLobject *result_type;
{
	LLobjectType *type;
	LLsequence *sequence;
	String pname;

	if ( ! LL_symbolp(result_type) && ! LL_typep(result_type, LLTypeCell) ) {
	    LLErrorF("\
Function: (coerce item result-type)\n\
\tresult-type must be given by a type-name symbol\n\
\tresult-type: ~S\n\
", result_type);
	    LLThrow(LL_lightlisp, LL_nil);
	}
	if ((type = LLLookupType(result_type)) != NULL) {
	    pname = type->pname;
	    sequence = type->sequence;
	} else if ((sequence = LLLookupSequence(result_type)) != NULL) {
	    pname = sequence->sname;
	} else {
	    LLErrorF("\
Function: (coerce item result-type)\n\
\tinvalid type coersion key\n\
\tresult-type: ~S\n\
", result_type);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (sequence != NULL) {
	    /*
	     *    ? -> sequence
	     */
	    return ((*sequence->coerce)(item, type->object));
	}

	LLErrorF("\
Function: (coerce result-type &rest item)\n\
\tcannot coerce ~A to ~A\n\
\titem:        ~S\n\
\tresult-type: ~S\n\
", LL_type_of(item)->pname, pname, item, result_type);
	LLThrow(LL_lightlisp, LL_nil);
	/*NOTREACHED*/
}
