#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLConcatenate - concatenate
 *
 *    (concatenate result-type &rest sequences)
 *
 *    return the concatenation
 */
LLobject *
LLConcatenate(result_type, sequences)
LLobject *result_type;
LLobject *sequences;	/* &rest */
{
	LLobject *s, *sequence;
	LLsequence *seq;

	if ( ! LL_symbolp(result_type) && ! LL_typep(result_type, LLTypeCell)) {
	    LLErrorF("\
Function: (concatenate result-type &rest sequences)\n\
\tresult-type must be given by a type-name symbol\n\
\tresult-type: ~S\n\
", result_type);
	    LLThrow(LL_lightlisp, LL_nil);
	}
	if ((seq = LLLookupSequence(result_type)) == NULL) {
	    LLErrorF("\
Function: (concatenate result-type &rest sequences)\n\
\tresult-type is not a sequence\n\
\tform: ~S\n\
", result_type);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	/* concatenate checks its args to see if they are valid for LL_type_of(seq) */
	return ((*seq->concatenate)(seq->type->object, sequences));
}
