#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLCopylist - copy a list
 *
 *    (copy-list list)
 *
 *    return the newly copied list
 */
LLobject *
LLCopylist(list)
LLobject *list;
{
	LLobject *ret, *last, *tmp, *r;

	if (LL_null(list))
	    return (LL_nil);

	if ( ! LL_consp(list) ) {
	    LLErrorF("\
Function: (copy-list list)\n\
\tlist is not a cons\n\
\tlist: ~S\n\
", list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	/*
	 *    => (copy-list '(a b . c))
	 *    (a b . c)
	 */
	ret = LL_nil;
	last = LL_nil;

	for (r=list; LL_consp(r); r=LL_cdr(r)) {
	    tmp = LLCons(LL_car(r), LL_nil);

            if (LL_null(ret))
                ret = tmp;
            else
                LL_rplacd(last, tmp);
            last = tmp;
	}

	if ( ! LL_null(r) )		/* ! LL_null(last) */
	    LL_rplacd(last, r);

	return (ret);
}
