#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLCopyseq - copyseq
 *
 *    (copy-seq sequence)
 *
 *    return the sequence
 */
LLobject *
LLCopyseq(sequence)
LLobject *sequence;
{
	if (LL_null(sequence))
	    return (LL_nil);

	if ( ! LL_sequencep(sequence) ) {
	    LLErrorF("\
Function: (copy-seq sequence)\n\
\tsequence is not a sequence\n\
\tform: ~S\n\
", sequence);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return ((*LL_type_of(sequence)->sequence->copy_seq)(sequence));
}
