#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLCopytree - copy a tree of conses
 *
 *    (copy-tree object)
 *
 *    return the newly copied object
 */
LLobject *
LLCopytree(object)
LLobject *object;
{
	LLobject *ret, *last, *tmp, *r;

	if ( ! LL_consp(object) )
	    return (object);

	/*
	 *    => (copy-tree '(a . b))
	 *    (a . b)
	 */
	ret = LL_nil;
	last = LL_nil;

	for (r=object; LL_consp(r); r=LL_cdr(r)) {
	    tmp = LLCons(LLCopytree(LL_car(r)), LL_nil);

            if (LL_null(ret))
                ret = tmp;
            else
                LL_rplacd(last, tmp);
            last = tmp;
	}

	if ( ! LL_null(r) )		/* ! LL_null(last) */
	    LL_rplacd(last, LLCopytree(r));

	return (ret);
}
