#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLElt - elt
 *
 *    (elt sequence index)
 *
 *    return the elt member
 */
LLobject *
LLElt(sequence, index)
LLobject *sequence;
LLobject *index;
{
	if (LL_null(sequence)) {
	    LLErrorF("\
Function: (elt sequence index)\n\
\tindex is out of range for sequence\n\
\tsequence: ~S\n\
\tindex:    ~S\n\
", sequence, index);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if ( ! LL_sequencep(sequence) ) {
	    LLErrorF("\
Function: (elt sequence index)\n\
\tsequence is not a sequence\n\
\tform: ~S\n\
", sequence);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if ( ! LL_integerp(index) ) {
	    LLErrorF("\
Function: (elt sequence index)\n\
\tindex is not an integer\n\
\tindex: ~S\n\
", index);
	    LLThrow(LL_lightlisp, LL_nil);
	}
	if (index->value.a_integer < 0) {
	    LLErrorF("\
Function: (elt sequence index)\n\
\tindex must be non-negative\n\
\tindex: ~S\n\
", index);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return ((*LL_type_of(sequence)->sequence->elt)(sequence, index));
}
