#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLEqual - see if the two are equal
 *
 *    return the result
 */
LLobject *
LLEqual(first, second)
LLobject *first;
LLobject *second;
{
	LLobject *f, *s;

	if (LL_type_of(first) != LL_type_of(second))
	    return (LL_nil);

	if (LL_stringp(first)) {
	    return (first->value.a_string == second->value.a_string ? LL_t: LL_nil);
	} else if (LL_realp(first)) {
	    return (first->value.a_real == second->value.a_real ? LL_t: LL_nil);
	} else if (LL_consp(first)) {
	    for (f=first, s=second; LL_consp(f) && LL_consp(s); f=LL_cdr(f), s=LL_cdr(s)) {
		if ( ! LLEqual(LL_car(f), LL_car(s)) )
		    return (LL_nil);
	    }
	    return (LL_null(f) && LL_null(s) ? LL_t: LL_nil);
	} else if (LL_closurep(first)) {
	    if ( ! LL_eq(LL_code(first), LL_code(second)) )
		return (LL_nil);
	    if ( ! LL_eq(LL_env(first), LL_env(second)) )
		return (LL_nil);
	    return (LL_t);
	}
	
	return (LL_eq(first, second) ? LL_t: LL_nil);
}
