#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLEqualp - see if the two are equalp
 *
 *    return the result
 */
LLobject *
LLEqualp(first, second)
LLobject *first;
LLobject *second;
{
	double v1, v2;

	/* numbers are considered equal even if a different type */
	if ((LL_integerp(first) || LL_realp(second)) &&
	    (LL_integerp(first) || LL_realp(second))) {
	    v1 = LL_integerp(first) ? (double) first->value.a_integer: first->value.a_real;
	    v2 = LL_integerp(second) ? (double) second->value.a_integer: second->value.a_real;
	    return (v1 == v2 ? LL_t: LL_nil);
	} else if (LL_stringp(first) && LL_stringp(second)) {
	    return (nocase_strequal(first->value.a_string, second->value.a_string) ? LL_t: LL_nil);
	}

	return (LLEqual(first, second));
}
