#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

static LLobject *func();

/*
 *    LLExp - exp
 *
 *    (exp number)
 *
 *    return the exp
 */
LLobject *
LLExp(number)
LLobject *number;
{
	return (func(exp, "exp", number));
}

/*
 *    LLSin - sin
 *
 *    (sin number)
 *
 *    return the sin
 */
LLobject *
LLSin(number)
LLobject *number;
{
	return (func(sin, "sin", number));
}

/*
 *    LLCos - cos
 *
 *    (cos number)
 *
 *    return the cos
 */
LLobject *
LLCos(number)
LLobject *number;
{
	return (func(cos, "cos", number));
}

/*
 *    LLTan - tan
 *
 *    (tan number)
 *
 *    return the tan
 */
LLobject *
LLTan(number)
LLobject *number;
{
	return (func(tan, "tan", number));
}

/* the sequent and hp 4.3 (utah) don't define these */
#if ! (OPSYS_MFR == MD_SEQUENT || \
	(OPSYS_MFR == MD_HP && OPSYS_VERS == MD_BSD_4_3)) /* { */
/*
 *    LLSinh - sinh
 *
 *    (sinh number)
 *
 *    return the sinh
 */
LLobject *
LLSinh(number)
LLobject *number;
{
	return (func(sinh, "sinh", number));
}

/*
 *    LLCosh - cosh
 *
 *    (cosh number)
 *
 *    return the cosh
 */
LLobject *
LLCosh(number)
LLobject *number;
{
	return (func(cosh, "cosh", number));
}

/*
 *    LLTanh - tanh
 *
 *    (tanh number)
 *
 *    return the tanh
 */
LLobject *
LLTanh(number)
LLobject *number;
{
	return (func(tanh, "tanh", number));
}
#endif /* } */

/*
 *    double
 *    function(val)
 *    double val;
 */
static LLobject *
func(function, name, number)
double (*function)();
String name;
LLobject *number;
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (~A number)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
", name, number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number)) {
	    return (LLMakeReal((*function)(number->value.a_real)));
	} else {
	    return (LLMakeReal((*function)((double) number->value.a_integer)));
	}

	/*NOTREACHED*/
}
