#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLExpt - expt
 *
 *    (expt number)
 *
 *    return the expt
 */
LLobject *
LLExpt(base_number, power_number)
LLobject *base_number;
LLobject *power_number;
{
	if ( ! LL_numberp(base_number) ) {
	    LLErrorF("\
Function: (expt base-number power-number)\n\
\tbase-number is not a number\n\
\tbase-number: ~S\n\
\tpower-number: ~S\n\
", base_number, power_number);
	    LLThrow(LL_lightlisp, LL_nil);
	}
	if ( ! LL_numberp(power_number) ) {
	    LLErrorF("\
Function: (expt base-number power-number)\n\
\tpower-number is not a number\n\
\tbase-number: ~S\n\
\tpower-number: ~S\n\
", base_number, power_number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(base_number) && LL_realp(power_number)) {
	    return (LLMakeReal(pow(base_number->value.a_real, power_number->value.a_real)));
	} else if (LL_realp(base_number)) {
	    return (LLMakeReal(pow(base_number->value.a_real, (double) power_number->value.a_integer)));
	} else if (LL_realp(power_number)) {
	    return (LLMakeReal(pow((double) base_number->value.a_integer, power_number->value.a_real)));
	} else {
	    return (LLMakeReal(pow((double) base_number->value.a_integer, (double) power_number->value.a_integer)));
	}

	/*NOTREACHED*/
}
