#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

typedef enum func_op func_op;
enum func_op {
    finish,
    force,
    clear,
};
static LLobject *func();

/*
 *    LLFinishoutput - finish-output
 *
 *    (stream stream)
 *
 *    return nil
 */
LLobject *
LLFinishoutput(stream)
LLobject *stream;
{
	return (func(stream, "finish-output", finish));
}

/*
 *    LLForceoutput - force-output
 *
 *    (stream stream)
 *
 *    return nil
 */
LLobject *
LLForceoutput(stream)
LLobject *stream;
{
	return (func(stream, "force-output", force));
}

/*
 *    LLClearoutput - clear-output
 *
 *    (stream stream)
 *
 *    return nil
 */
LLobject *
LLClearoutput(stream)
LLobject *stream;
{
	return (func(stream, "clear-output", clear));
}

static LLobject *
func(stream, name, op)
LLobject *stream;
char *name;
func_op op;
{
	if (LL_null(stream))
	    stream = LLGetValue(LLMakeSymbol("*standard-output*"), LL_valueSlot, LL_environment);

	if ( ! LL_streamp(stream) ) {
	    LLErrorF("\
Function: (~A stream)\n\
\tstream is not a stream\n\
\tstream: ~S\n\
", name, stream);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	switch (op) {
	case clear:
	    STREAMClear(stream->value.a_stream, STREAM_output);
	    break;
	case finish:
	case force:
	    STREAMFlush(stream->value.a_stream, STREAM_output);
	    break;
	}

	return (LL_nil);
}
