#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

#define body(name, number) \
{ \
	int n; \
 \
	for (n=(number)-1; n > 0 ; n--) { \
	    if (LL_null(exp)) \
		return (LL_nil); \
 \
	    if ( ! LL_consp(exp) ) { \
		LLErrorF("\
Function: (~A exp)\n\
\texp is not a cons\n\
\texp: ~S\n\
", name, exp); \
		LLThrow(LL_lightlisp, LL_nil); \
	    } \
	    exp = LL_cdr(exp); \
	} \
 \
	return (LL_car(exp)); \
}

LLobject *
LLFirst(exp)
LLobject *exp;
{
	body("first", 1);
}

LLobject *
LLSecond(exp)
LLobject *exp;
{
	body("second", 2);
}

LLobject *
LLThird(exp)
LLobject *exp;
{
	body("third", 3);
}

LLobject *
LLFourth(exp)
LLobject *exp;
{
	body("fourth", 4);
}

LLobject *
LLFifth(exp)
LLobject *exp;
{
	body("fifth", 5);
}

LLobject *
LLSixth(exp)
LLobject *exp;
{
	body("sixth", 6);
}

LLobject *
LLSeventh(exp)
LLobject *exp;
{
	body("seventh", 7);
}

LLobject *
LLEighth(exp)
LLobject *exp;
{
	body("eighth", 8);
}

LLobject *
LLNinth(exp)
LLobject *exp;
{
	body("ninth", 9);
}

LLobject *
LLTenth(exp)
LLobject *exp;
{
	body("tenth", 10);
}
