#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLGensym - generate a new symbol
 *
 *    (gensym)
 *
 *    return the new symbol
 */
LLobject *
LLGensym(x)
LLobject *x;		/* &optional */
{
	LLstring pname;

	if (LL_stringp(x)) {
	    pname = LLGenerateSymbol(x->value.a_string, -1);
	} else if (LL_integerp(x)) {
	    if (x->value.a_integer < 0) {
		LLErrorF("\
Function: (gensym &optional x)\n\
\tinteger x must be positive\n\
\tx: ~S\n\
", x);
		LLThrow(LL_lightlisp, LL_nil);
	    }
	    pname = LLGenerateSymbol(NULL, x->value.a_integer);
	} else if (LL_null(x)) {
	    pname = LLGenerateSymbol(NULL, -1);
	} else {
	    LLErrorF("\
Function: (gensym &optional x)\n\
\tillegal argument type to gensym\n\
\tx: ~S\n\
", x);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LLMakeUninternedSymbol(pname));
}
