#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLIf - if
 *
 *    (if test then [ else ])
 *
 *    return the result
 */
LLobject *
LLIf(arguments, environment)
LLobject *arguments;		/* value */
LLobject *environment;		/* valuet */
{
	if (LL_null(LLIf_tr(&arguments, &environment)))
	    return (arguments);

	return (LLEvaluator(arguments, environment));
}

/*
 *    LLIf_tr - if
 *
 *    (if test then [ else ])
 *
 *    return {t, nil} on {tail-recursive, non-tail-recursive}
 */
LLobject *
LLIf_tr(arguments, environment)
LLobject **arguments;		/* value/return */
LLobject **environment;		/* value/return */
{
	int len;

	if ((len = LLGetLength(*arguments)) != 2 && len != 3) {
	    LLErrorF("\
Form: (if test then [ else ])\n\
\tinvalid number of arguments to if\n\
\tform: ~S\n\
", *arguments);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if ( ! LL_null(LLEvaluator(LL_first(*arguments), *environment)) ) {
	    *arguments = LL_second(*arguments);
	    return (LL_t);
	}

	*arguments = LL_third(*arguments);
	return (LL_null(*arguments) ? LL_nil: LL_t);
}
