#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLLast - get the last cons
 *
 *    (last list)
 *
 *    return the last cons
 */
LLobject *
LLLast(list)
LLobject *list;
{
	LLobject *l;

	if (LL_null(list))
	    return (LL_nil);

        if ( ! LL_consp(list) ) {
	    LLErrorF("\
Function: (last list)\n\
\tlist is not a cons\n\
\tlist: ~S\n\
", list);
            LLThrow(LL_lightlisp, LL_nil);
        }

	for (l = list; LL_consp(LL_cdr(l)); l=LL_cdr(l))
	    ;

	return (l);
}
