#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLList - list
 *
 *    (list &rest exps)
 *
 *    return the result
 */
LLobject *
LLList(exps)
LLobject *exps;		/* &rest */
{
	return (exps);
}

/*
 *    LLListstar - list*
 *
 *    (list* arg &rest others)
 *
 *    return the result
 */
LLobject *
LLListstar(arg, others)
LLobject *arg;
LLobject *others;		/* &rest */
{
	LLobject *e;

	others = LLCons(arg, others);

	if (LL_null(LL_cdr(others)))
	    return (others);

	for (e=others; LL_consp(LL_cdr(LL_cdr(e))); e=LL_cdr(e))
	    ;

	LL_rplacd(e, LL_car(LL_cdr(e)));
	return (others);
}
