#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLLog - log
 *
 *    (log number &optional base)
 *
 *    return the log
 */
LLobject *
LLLog(number, base)
LLobject *number;
LLobject *base;		/* &optional */
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (log number &optional base)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
\tbase:   ~S\n\
", number, base);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number) ? (number->value.a_real <= 0.0): (number->value.a_integer < 0)) {
	    LLErrorF("\
Function: (log number &optional base)\n\
\tnumber must be positive\n\
\tnumber: ~S\n\
\tbase:   ~S\n\
", number, base);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_null(base))
	    return (LLMakeReal(log(LL_realp(number) ? number->value.a_real: (double) number->value.a_integer)));

	if ( ! LL_numberp(base) ) {
	    LLErrorF("\
Function: (log number &optional base)\n\
\tbase is not a number\n\
\tnumber: ~S\n\
\tbase:   ~S\n\
", number, base);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	/*
	 *    base ^ x = e ^ y
	 *    ln (base ^ x) = y
	 *    x ln base = y
	 */
	return (LLMakeReal(log(LL_realp(number) ? number->value.a_real: (double) number->value.a_integer) *
		log(LL_realp(base) ? base->value.a_real: (double) base->value.a_integer)));
}
