#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLMakunbound - makunbound
 *
 *    (makunbound symbol)
 *
 *    return the symbol
 */
LLobject *
LLMakunbound(symbol)
LLobject *symbol;
{
	if ( ! LL_symbolp(symbol) ) {
	    LLErrorF("\
Function: (makunbound symbol)\n\
\tsymbol is not a symbol\n\
\tsymbol: ~S\n\
", symbol);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	LLSetValue(symbol, LL_valueSlot, LL_unbound, LL_nil);
	return (symbol);
}

/*
 *    LLFmakunbound - fmakunbound
 *
 *    (fmakunbound symbol)
 *
 *    return the symbol
 */
LLobject *
LLFmakunbound(symbol)
LLobject *symbol;
{
	if ( ! LL_symbolp(symbol) ) {
	    LLErrorF("\
Function: (fmakunbound symbol)\n\
\tsymbol is not a symbol\n\
\tsymbol: ~S\n\
", symbol);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	LLSetValue(symbol, LL_functionSlot, LL_unbound, LL_nil);
	return (symbol);
}
