#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLMember - membership list
 *
 *    (member item list)
 *
 *    return the matching item
 */
LLobject *
LLMember(item, list)
LLobject *item;
LLobject *list;
{
	LLobject *r, *a_item;

	if ( ! LL_listp(list) ) {
	    LLErrorF("\
Function: (member item list)\n\
\tlist is not a cons\n\
\titem: ~S\n\
\tlist: ~S\n\
", item, list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	for (r=list; LL_consp(r); r=LL_cdr(r)) {

	    a_item = LL_car(r);

	    if (LL_eq(a_item, item))
		return (r);
	}

	if ( ! LL_null(r) ) {
	    LLErrorF("\
Function: (member item list)\n\
\tbadly formed list - list is not a cons\n\
\titem: ~S\n\
\tlist: ~S\n\
", item, list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_nil);
}
