#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLNumnoteq - /=
 *
 *    (/= number &rest more-numbers)
 *
 *    return the result
 */
LLobject *
LLNumnoteq(number, more_numbers)
LLobject *number;
LLobject *more_numbers;		/* &rest */
{
	Boolean integerP, retP;
	LLobject *n, *n1, *this, *this1;
	double rret, rtest;
	int iret;
	
	integerP = LL_integerp(number);
	if (integerP) {
	    iret = number->value.a_integer;
	} else {
	    rret = number->value.a_real;
	}

	/*
	 *    Compare number against all in more-numbers
	 */
	retP = TRUE;
	for (n=more_numbers; LL_consp(n); n=LL_cdr(n)) {
	    this = LL_car(n);

	    if ( ! LL_numberp(this) ) {
		LLErrorF("\
Function: (/= number &rest more-numbers)\n\
\tnumber is not a number\n\
\toffender: ~S\n\
\tnumber:   ~S\n\
\tnumbers:  ~S\n\
", this, number, more_numbers);
		LLThrow(LL_lightlisp, LL_nil);
	    }

	    if (LL_realp(this) && integerP) {
		rret = iret;
		integerP = FALSE;
	    }

	    if (integerP) {
		if (iret == this->value.a_integer) {
		    retP = FALSE;
		    break;
		}
	    } else {
		rtest = LL_realp(this) ? this->value.a_real: this->value.a_integer;
		if (rret == rtest) {
		    retP = FALSE;
		    break;
		}
	    }
	}

	if ( ! retP )
	    return (LL_nil);

	/*
	 *    Now for-each for-each in more-numbers
	 *    check for equality.
	 */
	for (n=more_numbers; LL_consp(n); n=LL_cdr(n)) {
	    this = LL_car(n);

	    integerP = LL_integerp(this);
	    if (integerP) {
		iret = this->value.a_integer;
	    } else {
		rret = this->value.a_real;
	    }
	    for (n1=LL_cdr(n); LL_consp(n1); n1=LL_cdr(n1)) {
		this1 = LL_car(n1);

		if (LL_realp(this1) && integerP) {
		    rret = iret;
		    integerP = FALSE;
		}

		if (integerP) {
		    if (iret == this1->value.a_integer) {
			retP = FALSE;
			break;
		    }
		} else {
		    rtest = LL_realp(this1) ? this1->value.a_real: this1->value.a_integer;
		    if (rret == rtest) {
			retP = FALSE;
			break;
		    }
		}
	    }
	}

	return (retP ? LL_t: LL_nil);
}
