#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLPairlis - prepend to the a-list
 *
 *    (pairlis keys data &optional a-list)
 *
 *    return the cons cell
 */
LLobject *
LLPairlis(keys, data, a_list)
LLobject *keys;
LLobject *data;
LLobject *a_list;	/* &optional */
{
	LLobject *k, *d, *a;

	if ( ! LL_null(a_list) && ! LL_consp(a_list) ) {
	    LLErrorF("\
Function: (pairlis keys data &optional a-list)\n\
\ta-list is neither a cons nor nil\n\
\tkeys:   ~S\n\
\tdata:   ~S\n\
\ta-list: ~S\n\
", keys, data, a_list);
	}

	if ( ! LL_null(keys) && ! LL_consp(keys) ) {
	    LLErrorF("\
Function: (pairlis keys data &optional a-list)\n\
\tkeys is neither a cons nor nil\n\
\tkeys:   ~S\n\
\tdata:   ~S\n\
\ta-list: ~S\n\
", keys, data, a_list);
	}

	if ( ! LL_null(data) && ! LL_consp(data) ) {
	    LLErrorF("\
Function: (pairlis keys data &optional a-list)\n\
\tkeys is neither a cons nor nil\n\
\tkeys:   ~S\n\
\tdata:   ~S\n\
\ta-list: ~S\n\
", keys, data, a_list);
	}

	/*
	 *    If not specified, a_list is nil
	 */
	for (k=keys, d=data, a=a_list; LL_consp(k) && LL_consp(d); k=LL_cdr(k), d=LL_cdr(d)) {
	    a = LLCons(LLCons(LL_car(k), LL_car(d)), a);	/* acons */
	}

	if ( ! LL_null(k) || ! LL_null(d) ) {
	    LLErrorF("\
Function: (pairlis keys data &optional a-list)\n\
\tthe keys and data are not the same length\n\
\tkeys:   ~S\n\
\tdata:   ~S\n\
\ta-list: ~S\n\
", keys, data, a_list);
	}

	return (a);
}
