#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLRandom - random
 *
 *    (random number &optional state)
 *
 *    return the log
 */
LLobject *
LLRandom(number, state)
LLobject *number;
LLobject *state;		/* &optional */
{
	LLobject *ret;
	long rand;
	int ret_i;
	double ret_r;

	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (random number &optional state)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
\tstate:  ~S\n\
", number, state);
	    LLThrow(LL_lightlisp, LL_nil);
	}
	if (LL_realp(number) ? (number->value.a_real <= 0.0): (number->value.a_integer <= 0)) {
	    LLErrorF("\
Function: (random number &optional state)\n\
\tnumber is not positive\n\
\tnumber: ~S\n\
\tstate:  ~S\n\
", number, state);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if ( ! LL_null(state) ) {
	    if ( ! LL_integerp(state) ) {
		LLErrorF("\
Function: (random number &optional state)\n\
\tstate is not an integer\n\
\tnumber: ~S\n\
\tstate:  ~S\n\
", number, state);
		LLThrow(LL_lightlisp, LL_nil);
	    }

	    srandom(state->value.a_integer);
	}

	rand = random();
	if (LL_realp(number)) {
	    ret_r = (rand / (double) MAXINT) * number->value.a_real;
	    ret = LLMakeReal(ret_r);
	} else {
	    ret_i = rand % number->value.a_integer;
	    ret = LLMakeInteger(ret_i);
	}

	return (ret);
}
