#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "reader.h"
#include "internal.h"

/*
 *    LLRead - read
 *
 *    (read &optional input-stream eof-error-p eof-value recursive-p)
 *
 *    return {the result, eof-value} on {success, eof}
 */
LLobject *
LLRead(input_stream, eof_error_p, eof_value, recursive_p)
LLobject *input_stream;
LLobject *eof_error_p;
LLobject *eof_value;
LLobject *recursive_p;
{
	LLobject *sexp;
	STREAM *stream;

	if (LL_null(input_stream)) {
	    stream = LL_Re_InputStream;
	} else {
	    if ( ! LL_streamp(input_stream) ) {
		LLErrorF("\
Function: (read &optional input-stream eof-error-p eof-value recursive-p)\n\
\tinput-stream is not a stream\n\
\tinput-stream: ~S\n\
\teof-error-p:  ~S\n\
\teof-value:    ~S\n\
\trecursive-p:  ~S\n\
", input_stream, eof_error_p, eof_value, recursive_p);
		LLThrow(LL_lightlisp, LL_nil);
	    }
	    if (LL_null(LLInputstreamp(input_stream))) {
		LLErrorF("\
Function: (read &optional input-stream eof-error-p eof-value recursive-p)\n\
\tinput-stream is not an input-capable stream\n\
\tinput-stream: ~S\n\
\teof-error-p:  ~S\n\
\teof-value:    ~S\n\
\trecursive-p:  ~S\n\
", input_stream, eof_error_p, eof_value, recursive_p);
		LLThrow(LL_lightlisp, LL_nil);
	    }
	    stream = input_stream->value.a_stream;
	}

	sexp = LLReadValue(stream,
		LL_null(eof_error_p) ? FALSE: TRUE,
		eof_value,
		LL_null(recursive_p) ? FALSE: TRUE,
		LL_lightlisp);

	return (sexp);
}
