#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLSignum - signum
 *
 *    (signum number)
 *
 *    return the signum
 */
LLobject *
LLSignum(number)
LLobject *number;
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (signum number)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
", number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number)) {
	    if (number->value.a_real == 0.0) {
		return (LLMakeReal(0.0));
	    } else if (number->value.a_real < 0.0) {
		return (LLMakeReal(-1.0));
	    } else {
		return (LLMakeReal(1.0));
	    }
	} else {
	    if (number->value.a_integer == 0) {
		return (LLMakeInteger(0));
	    } else if (number->value.a_integer < 0) {
		return (LLMakeInteger(-1));
	    } else {
		return (LLMakeInteger(1));
	    }
	}

	/*NOTREACHED*/
}
