#include <sys/types.h>
#include <setjmp.h>
#include <math.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLSqrt - sqrt
 *
 *    (sqrt number)
 *
 *    return the square root
 */
LLobject *
LLSqrt(number)
LLobject *number;
{
	if ( ! LL_numberp(number) ) {
	    LLErrorF("\
Function: (sqrt number)\n\
\tnumber is not a number\n\
\tnumber: ~S\n\
", number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number) ?
		(number->value.a_real < 0.0):
		(number->value.a_integer < 0)) {
	    LLErrorF("\
Function: (sqrt number)\n\
\tnumber is negative\n\
\tnumber: ~S\n\
", number);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_realp(number)) {
	    return (LLMakeReal(sqrt(number->value.a_real)));
	} else {
	    return (LLMakeInteger((int) sqrt((double) number->value.a_integer)));
	}

	/*NOTREACHED*/
}

/*
 *    LLIsqrt - isqrt
 *
 *    (isqrt number)
 *
 *    return the truncated square root
 */
LLobject *
LLIsqrt(integer)
LLobject *integer;
{
	if ( ! LL_integerp(integer) ) {
	    LLErrorF("\
Function: (sqrt integer)\n\
\tinteger is not a integer\n\
\tinteger: ~S\n\
", integer);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (integer->value.a_real < 0.0) {
	    LLErrorF("\
Function: (sqrt integer)\n\
\tinteger is negative\n\
\tinteger: ~S\n\
", integer);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LLMakeInteger((int) sqrt((double) integer->value.a_integer)));
}
