#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLSubseq - subseq
 *
 *    (subseq sequence start [ end ])
 *
 *    return the subseq
 */
LLobject *
LLSubseq(sequence, start, end)
LLobject *sequence;
LLobject *start;
LLobject *end;		/* &optional */
{
	if (LL_null(sequence)) {
	    LLErrorF("\
Function: (subseq sequence start &optional end)\n\
\tindex is out of range for sequence\n\
\tsequence: ~S\n\
\tstart:    ~S\n\
\tend:      ~S\n\
", sequence, start, end);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if ( ! LL_sequencep(sequence) ) {
	    LLErrorF("\
Function: (subseq sequence start &optional end)\n\
\tsequence is not a sequence\n\
\tform: ~S\n\
", sequence);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if ( ! LL_integerp(start) ) {
	    LLErrorF("\
Function: (subseq sequence start &optional end)\n\
\tstart is not an integer\n\
\tstart: ~S\n\
", start);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if ( ! LL_null(end) && ! LL_integerp(end) ) {
	    LLErrorF("\
Function: (subseq sequence start &optional end)\n\
\tend is not an integer\n\
\tend: ~S\n\
", end);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return ((*LL_type_of(sequence)->sequence->subseq)(sequence, start, end));
}
