#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

typedef enum symbol_key symbol_key;
enum symbol_key {
    symbol_name,
    symbol_value,
    symbol_function,
};
static LLobject *symbol_thing();

/*
 *    LLSymbolname - symbol-name
 *
 *    (symbol-name symbol)
 *
 *    return the printname
 */
LLobject *
LLSymbolname(symbol)
LLobject *symbol;
{
	return (symbol_thing(symbol, symbol_name, "symbol-name"));
}

/*
 *    LLSymbolvalue - symbol-value
 *
 *    (symbol-value symbol)
 *
 *    return the value
 */
LLobject *
LLSymbolvalue(symbol)
LLobject *symbol;
{
	return (symbol_thing(symbol, symbol_value, "symbol-value"));
}

/*
 *    LLSymbolfunction - symbol-function
 *
 *    (symbol-function symbol)
 *
 *    return the function
 */
LLobject *
LLSymbolfunction(symbol)
LLobject *symbol;
{
	return (symbol_thing(symbol, symbol_function, "symbol-function"));
}

static LLobject *
symbol_thing(symbol, key, name)
LLobject *symbol;
symbol_key key;
String name;
{
	if ( ! LL_symbolp(symbol) ) {
	    LLErrorF("\
Function: (~A symbol)\n\
\tsymbol is not a symbol\n\
\tsymbol: ~S\n\
", name, symbol);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	switch (key) {
	case symbol_name:
	    return (LLMakeString(LL_pname(symbol)));
	case symbol_value:
	    return (LL_symbol_value(symbol));
	case symbol_function:
	    return (LL_symbol_function(symbol));
	}
	/*NOTREACHED*/
}
