#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLTerpri - terpri
 *
 *    (terpri &optional stream)
 *
 *    return nil
 */
LLobject *
LLTerpri(stream)
LLobject *stream;	/* &optional */
{
	if (LL_null(stream))
	    stream = LLGetValue(LLMakeSymbol("*standard-output*"), LL_valueSlot, LL_environment);

	if ( ! LL_streamp(stream) ) {
	    LLErrorF("\
Function: (terpri &optional stream)\n\
\tstream is not a stream\n\
\tstream: ~S\n\
", stream);
	    LLThrow(LL_lightlisp, LL_nil);
	}
	if ( ! LLOutputstreamp(stream) ) {
	    LLErrorF("\
Function: (terpri &optional stream)\n\
\tstream is not an output-capable stream\n\
\tstream: ~S\n\
", stream);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	STREAMPutc(stream->value.a_stream, '\n');
	return (LL_nil);
}

/*
 *    LLFreshline - fresh-line
 *
 *    (fresh-line &optional stream)
 *
 *    return {t, nil} on {printed, not-printed}
 */
LLobject *
LLFreshline(stream)
LLobject *stream;	/* &optional */
{
	if (LL_null(stream))
	    stream = LLGetValue(LLMakeSymbol("*standard-output*"), LL_valueSlot, LL_environment);

	if ( ! LL_streamp(stream) ) {
	    LLErrorF("\
Function: (fresh-line &optional stream)\n\
\tstream is not a stream\n\
\tstream: ~S\n\
", stream);
	    LLThrow(LL_lightlisp, LL_nil);
	}
	if ( ! LLOutputstreamp(stream) ) {
	    LLErrorF("\
Function: (fresh-line &optional stream)\n\
\tstream is not an output-capable stream\n\
\tstream: ~S\n\
", stream);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (STREAMGetColumnno(stream->value.a_stream, STREAM_output) == 0)
	    return (LL_nil);

	STREAMPutc(stream->value.a_stream, '\n');
	return (LL_t);
}
