#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "machine.h"
#include "internal.h"

/*
 *    LLTime - time
 *
 *    (time form)
 *
 *    return result
 */
LLobject *
LLTime(arguments, environment)
LLobject *arguments;		/* value */
LLobject *environment;		/* value */
{
	LLTime_tr(&arguments, &environment);
	return (arguments);
}

/*
 *    LLTime_tr - time
 *
 *    (time form)
 *
 *    return {t, nil} on {tail-recursive, non-tail-recursive}
 */
LLobject *
LLTime_tr(arguments, environment)
LLobject **arguments;		/* value/return */
LLobject **environment;		/* value/return */
{
	LLtime start, end, diff;
	LLobject *ret;

	if (LLGetLength(*arguments) != 1) {
	    LLErrorF("\
Form: (time form)\n\
\ttime requires exactly one argument\n\
\tform: ~S\n\
", *arguments);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	start = LLStopWatch();
	ret = LLEvaluator(LL_car(*arguments), *environment);
	end = LLStopWatch();

	diff = end - start;

	LLFormatC(LLErrorStream, "evaluation time ~D.~D~D~D sec\n",
		diff / 1000, (diff/100)%10, (diff/10)%10, (diff/1)%10);
	LLPrintStats(LLErrorStream);

	*arguments = ret;
	return (LL_nil);
}
