#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "reader.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLUninitialize - initialize LightLisp
 *
 *    return {LL_ok, LL_notok} on {success, fail}
 */
LLstatus
LLUninitialize()
{
	if ( ! LLInitializedP )
	    return (LL_ok);

	if (LL_Mach_Uninitialize() != LL_ok)
	    return (LL_notok);
	if (LL_Read_Uninitialize() != LL_ok)
	    return (LL_notok);
	if (LL_Print_Uninitialize() != LL_ok)
	    return (LL_notok);

	LLInitializedP = FALSE;

	return (LL_ok);
}
