#include "sumachine.h"

#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHAppendFromArchive - append the file from the other archive to the archive
 *
 *    return {ARCH_ok, ARCH_notok}
 */
ARCHstatus
ARCHAppendFromArchive(arch, from, from_index)
ARCHarchive *arch;
ARCHarchive *from;
int from_index;
{
	char buf[1024];
	ARCHfile file, *from_indexo;
	int cc, sofar, toread;

	if (from_index < 0 || DYNSizeOfEl(&from->files) <= from_index)
	    return (ARCHErrno = ARCH_EOUT_OF_RANGE, ARCH_notok);

	from_indexo = DYNpAt(&from->files, from_index, ARCHfile);

	file.name = ARCHCopyFilename(from_indexo->name);
	file.size = from_indexo->size;
	file.offset = lseek(arch->work_fd, 0, L_XTND);

	file.header = from_indexo->header;

	lseek(from->work_fd, from_indexo->offset, L_SET);
	sofar = 0;
	do {
	    toread = MIN(sizeof (buf), from_indexo->size - sofar);

	    if ((cc = read(from->work_fd, buf, toread)) < 0)
		return (ARCHErrno = ARCH_ESEE_ERRNO, ARCH_notok);
	    if (cc == 0)
		break;

	    if (write(arch->work_fd, buf, cc) < 0)
		return (ARCHErrno = ARCH_ESEE_ERRNO, ARCH_notok);

	    sofar += cc;
	    if (sofar == from_indexo->size)
		break;
	} while (1);

	if (sofar != from_indexo->size)
	    return (ARCHErrno = ARCH_ESEE_ERRNO, ARCH_notok);

	if (lseek(arch->work_fd, 0, L_XTND) & 01) {
	    if (write(arch->work_fd, "\n", 1) < 0)
		return (ARCHErrno = ARCH_ESEE_ERRNO, ARCH_notok);
	}

	DYNpAtEndPut(&arch->files, &file);

	return (arch->flushP = TRUE, ARCH_ok);
}
