#include "sumachine.h"

#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHExtractToFd - extract an archive member to a fd
 *
 *    return {ARCH_ok, ARCH_notok}
 */
ARCHstatus
ARCHExtractToFd(arch, index, fd)
ARCHarchive *arch;
int index;
int fd;
{
	char buf[1024];
	int sofar, cc, toread;
	ARCHfile *file;

	file = DYNpAt(&arch->files, index, ARCHfile);

	lseek(arch->work_fd, file->offset, L_SET);

	sofar = 0;
	do {
	    toread = MIN(sizeof (buf), file->size - sofar);

	    if ((cc = read(arch->work_fd, buf, toread)) != toread)
		return (ARCHErrno = ARCH_ESHORT_TMP, ARCH_notok);

	    if (cc == 0)
		break;

	    if (write(fd, buf, cc) != cc)
		return (ARCHErrno = ARCH_EBAD_WRITE, ARCH_notok);

	    sofar += cc;
	    if (sofar == file->size)
		break;
	} while (1);

	if (sofar != file->size)
	    return (ARCHErrno = ARCH_EBAD_WRITE, ARCH_notok);

	return (ARCH_ok);
}
