#include "sumachine.h"

#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHFree - free the archive, but won't write it
 *
 *    Do NOT flush
 *
 *    return {ARCH_ok, ARCH_notok} on {success, fail}
 */
ARCHstatus
ARCHFree(arch)
ARCHarchive *arch;
{
	int i;
	ARCHfile *o;

	for (i=0; i<DYNSizeOfEl(&arch->files); i++) {
	    o = DYNpAt(&arch->files, i, ARCHfile);
	    FREE_STRING(o->name);
	}

	close(arch->fd);
	if (arch->mode == ARCH_readwrite)
	    close(arch->work_fd);

	FREE_TYPE(arch, ARCHarchive);

	return (ARCH_ok);
}
