#include "sumachine.h"

#include <sys/param.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>
#include <ctype.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHUseForTmp - set the name to use for temporaries
 *
 *    return {ARCH_ok, ARCH_notok} on {success, fail}
 */
ARCHstatus
ARCHUseForTmp(tmp)
String tmp;
{
	static Boolean firstP = TRUE;
	struct stat statbuf;

	/*
	 *    Check for a writable directory
	 */
	if (stat(tmp, &statbuf) < 0)
	    return (ARCH_ESEE_ERRNO, ARCH_notok);
	if ((statbuf.st_mode & S_IFMT) != S_IFDIR)
	    return (ARCH_ENOT_A_DIRECTORY, ARCH_notok);
	if (access(tmp, W_OK) < 0)
	    return (ARCH_ESEE_ERRNO, ARCH_notok);

	if ( ! firstP )
	    FREE_STRING(ARCHTmp);

	firstP = FALSE;
	ARCHTmp = COPY_STRING(tmp);

	return (ARCH_ok);
}
