#include <sys/param.h>
#include <stdio.h>

#include "stuff.h"

#include "internal.h"

static void usage();

main(argc, argv)
int argc;
char **argv;
{
	Boolean appendP, symdefP, uniqueP, localP;
	String flag, metalibrary;
	int i;

	appendP = FALSE;
	symdefP = FALSE;
	uniqueP = TRUE;
	localP = FALSE;

	if (argc > 1 && argv[1][0] == '-') {
	    if (argc < 3)
		usage();

	    flag = argv[1];
	    argv++;
	    argc--;

	    while (*++flag != '\0') {
		switch (*flag) {
		case 'a':
		    appendP = TRUE;
		    break;
		case 'l':
		    localP = TRUE;
		    break;
		case 's':
		    symdefP = TRUE;
		    break;
		case 'u':
		    uniqueP = FALSE;
		    break;
		default:
		    usage();
		}
	    }
	} else if (argc < 2) {
	    usage();
	}

	metalibrary = argv[1];
	argv += 2;
	argc -= 2;

	/*
	 *    Perform the CNSLProcess function to manipulate the
	 *    archives.  CNSLProcess will either be an algorithm
	 *    to manipulate the archive (in the case of a real unix)
	 *    or in the case of an ersatz unix (e.g. apollo), then
	 *    it will be, effectively, a shell script. 
	 *
	 *    If Apollo EVER says ``we are unix compatibile''
	 *        then they are lying.
	 *
	 *    There is a different CNSLProcess for the apollo and for
	 *    the rest of the world.   see apollo.c and normal.c
	 */
	if (CNSLProcess(argc, argv, metalibrary, appendP, localP, symdefP, uniqueP) != CNSL_ok)
	    exit (1);	/* bitched about below */

#if OPSYS_MFR == MD_SUN && CPU_TYPE == MD_I386 || \
	OPSYS_SUBTYPE == MD_HPUX || \
	OPSYS_SUBTYPE == MD_AIX || \
	OPSYS_SUBTYPE == MD_SYS5 /* { */
	/*
	 *    This is how these guys do ranlib
	 *    And you in fact MUST do this before accessing
	 *    the library with the loader or such.
	 */
	{
		char buf[MAXPATHLEN+100];

		sprintf(buf, "ar ts %s > /dev/null", metalibrary);
		if (system(buf) != 0) {
		    fprintf(stderr, "conslibs: could not define symboltable information for %s\n", metalibrary);
		    exit (1);
		}
	}
#endif /* } */

	exit (0);
}

static void
usage()
{
	fprintf(stderr, "usage: conslibs [ -alsu ] metalibrary [ libraries ... ]\n");
	exit (1);
}
