#if ! defined(dynstk_h)
#define dynstk_h

#ifdef INCLUDE_HEADER
/*
 *    			RCS Control Information:
 *    $Author: saj $				
 *    $Date: 2002/12/31 15:50:57 $
 *
 *    $Revision: 1.1.1.1 $		
 *    $Source: /home/cvs/octtools/src/LightLisp/src/dynstk/dynstk.h,v $
 *    $State: Exp $
 */
#endif INCLUDE_HEADER

typedef DYNgeneralArray DYNStkgeneralStack;

/*
 *    Stack operation macros.
 */
#define DYNStkInit(stack, type)		DYNInit(stack, type)
#define DYNStkInitP(stack)			DYNInitP(stack)
#define DYNStkClear(stack) 			DYNClear(stack)
#define DYNStkInitClear(stack, type)	(			\
	DYNStkInitP(stack) ? DYNStkClear(stack): DYNStkInit(stack, type)	\
)

#define DYNStkEmptyP(stack)			(DYNSizeOfEl(stack) == 0)
#define DYNStkSp(stack)				DYNSizeOfEl(stack)

#define DYNStkpNth(stack, i, type)		DYNpAt(stack, i, type)
#define DYNStkNth(stack, i, type)		DYNAt(stack, i, type)

#define DYNStkpTop(stack, type)			DYNStkpNth(stack, DYNStkSp(stack)-1, type)
#define DYNStkTop(stack, type)			DYNStkNth(stack, DYNStkSp(stack)-1, type)

#define DYNStkPush(stack, object, type)		DYNAtEndPut(stack, object)
#define DYNStkpPush(stack, pobject, type)	DYNpAtEndPut(stack, pobject)

#define DYNStkpPop(stack, type)			((type *) DYNStkiPop(stack))
#define DYNStkPop(stack, type)			*((type *) DYNStkiPop(stack))

#define DYNStkCopy(stack)			DYNCopy(stack)
#define DYNStkCopyInto(to, from)		DYNCopyInto(to, from)

extern RefAny DYNStkiPop();
extern void DYNStkFree();

/*
 *    Stack member generators.
 */
/*
 *    Generate pointers to members forwards
 */
#define DYNStk_begin_ForwardpGen(stack, type, it)		\
	DYNStk_begin_Gen(stack, type, type *, it, 0, <, DYNStkSp(stack), ++, DYNStkpNth) {

#define DYNStk_end_ForwardpGen				\
	} DYNStk_end_Gen;

/*
 *    Generate the members forwards
 */
#define DYNStk_begin_ForwardGen(stack, type, it)		\
	DYNStk_begin_Gen(stack, type, type, it, 0, <, DYNStkSp(stack), ++, DYNStkNth) {

#define DYNStk_end_ForwardGen				\
	} DYNStk_end_Gen;

/*
 *    Generate pointers to members backwards
 */
#define DYNStk_begin_BackwardpGen(stack, type, it)		\
	DYNStk_begin_Gen(stack, type, type *, it, DYNStkSp(stack)-1, >=, 0, --, DYNStkpNth) {

#define DYNStk_end_BackwardpGen				\
	} DYNStk_end_Gen;

/*
 *    Generate the members backwards
 */
#define DYNStk_begin_BackwardGen(stack, type, it)		\
	DYNStk_begin_Gen(stack, type, type, it, DYNStkSp(stack)-1, >=, 0, --, DYNStkNth) {

#define DYNStk_end_BackwardGen				\
	} DYNStk_end_Gen;

/*
 *    Generator generator macros - these are not to be called directly.
 */
#define DYNStk_begin_Gen(stack, type, var_type, var, start, relop, end, incr, indirector)\
	{								\
	    var_type var;						\
	    int i99;							\
									\
	    for (i99= (start); i99 relop (end); i99 incr) {			\
		var = indirector(stack, i99, type);			\
		{

#define DYNStk_end_Gen							\
		}							\
	    }								\
	}

#endif /* dynstk_h */
