#if ! defined(dynstr_h)
#define dynstr_h

#ifdef INCLUDE_HEADER
/*
 *    			RCS Control Information:
 *    $Author: saj $				
 *    $Date: 2002/12/31 15:50:57 $
 *
 *    $Revision: 1.1.1.1 $		
 *    $Source: /home/cvs/octtools/src/LightLisp/src/dynstr/dynstr.h,v $
 *    $State: Exp $
 */
#endif INCLUDE_HEADER

/*
 *    This null termination stuff is due to Mary who convinced me that
 *    a string is a data structure unto itself, and should always be
 *    self consistent (atleast to the user's view).  
 *
 *    Fortune Cookie: Proper footnoting saves your life.
 */
typedef struct DYNStrgeneralString DYNStrgeneralString;
struct DYNStrgeneralString {
    Boolean null_terminatedP;
    DYNgeneralArray array;
};

#define DYNStrInit(sp)		(			\
	DYNInit(&(sp)->array, char),			\
	(sp)->null_terminatedP = FALSE			\
)

#define DYNStrInitP(sp)					\
	DYNInitP(&(sp)->array)

#define DYNStrClear(sp)		(			\
	DYNClear(&(sp)->array),				\
	(sp)->null_terminatedP = FALSE			\
)

#define DYNStrInitClear(sp)			(		\
	DYNStrInitP(sp) ? DYNStrClear(sp): DYNStrInit(sp)		\
)

#define DYNStrFree(sp)			DYNFree(&(sp)->array)

#define DYNStrLength(sp)		DYNSizeOfEl(&(sp)->array)

#define DYNStrInsureIncrement(sp, size)			\
	DYNStrInsureSize(sp, DYNSizeOfEl(&(sp)->array)+(size))

#define DYNStrInsureSize(sp, size)				\
	DYNInsureSize(&(sp)->array, size)

#define DYNStrAtPut(sp, at, c)	(					\
	DYNAtPut(&(sp)->array, at, c),					\
	(sp)->null_terminatedP = (c) == '\0' ? TRUE: FALSE		\
)

#define DYNStrAt(sp, at)							\
	DYNAt(&(sp)->array, at, char)

#define DYNStrSetTail(sp, token)	(					\
	DYNSetCurrent(&(sp)->array, token),				\
	(sp)->null_terminatedP = FALSE					\
)

#define DYNStrPointerToIndex(sp, pointer)					\
	DYNPointerToIndex(&(sp)->array, pointer)

extern void DYNStrAppendC();
extern void DYNStrReplaceEndC();
extern void DYNStrShrinkC();

extern int DYNStrIndexIn();
extern int DYNStrRIndexIn();

extern String DYNStrTheString();
extern String DYNStrConcatString();
extern String DYNStrConcatStringv();
extern String DYNStrConcatStringWithSpace();
extern String DYNStrConcatStringvWithSpace();

extern DYNStrgeneralString *DYNStrConcat();
extern DYNStrgeneralString *DYNStrConcatv();
extern DYNStrgeneralString *DYNStrCopy();

extern void DYNStrCopyInto();
extern void DYNStrAppendString();
extern void DYNStrAppendNChars();
extern void DYNStrPrependC();
extern void DYNStrPrependString();
extern void DYNStrPrependNChars();

extern DYNStrgeneralString DYNStrConcatBuf;

#endif /* dynstr_h */
