#ifdef SOURCE_HEADER
#endif SOURCE_HEADER
#include <sys/param.h>
#include <ctype.h>
#include <stdio.h>

#include <sys/file.h>
#include <sys/stat.h>

#include "stuff.h"
#include "bit.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"
#include "path.h"

#include "filename.h"
#include "internal.h"

extern String getenv();
extern Boolean accessP();

/*
 *    FNRegisterArgv0 - register argv0 for future processing.
 *
 *    Can be called more than once (though god knows why you would).
 *    Can be called with argv0 == NULL once this is registered.
 *
 *    return {0, -1} on {registered, could not register}
 */
int
FNRegisterArgv0(argv0)
String argv0;
{
	String path_env_variable, directory;
	PATHgen gen;

	DYNStrInitClear(&FNFullPathToBinaryBuf);

	if (argv0 == NULL) {
	    return (FNErrno = FN_ENULL_EXEC, -1);
	}

	/*
	 *    argv0 != NULL - then
	 */
	if (index(argv0, '/') != NULL) {
	    DYNStrAppendString(&FNFullPathToBinaryBuf, FNMassageToFullPath(argv0));
	    return (FNErrno = FN_ENO_EXEC, accessP(argv0) ? 0: -1);
	}

	/*
	 *    It was in the path_env_variable somewhere.
	 */
	if ((path_env_variable = getenv("PATH")) == NULL) {
	    return (FNErrno = FN_ENOPATH, -1);
	}

	gen = PATHStart(path_env_variable, ':');
	while (PATHNext(gen, &directory) != PATH_eof) {
	    String binary;

	    binary = DYNStrConcatStringWithSpace(&FNFullPathToBinaryBuf,
		    directory, "/", argv0, NULL);
	    if (accessP(binary))
		return (0);
	}
	PATHFinish(gen);

	/*
	 *   So DYNStrInitP == FALSE if fail.
	 */
	DYNStrFree(&FNFullPathToBinaryBuf);

	return (FNErrno = FN_ENO_EXEC, -1);
}

/*
 *    accessP - is it accessable, executable, and regular
 *
 *    return {TRUE, FALSE} on {is, is not}.
 */
static Boolean
accessP(from)
String from;
{
	struct stat stbuf;

	if (access(from, X_OK) == -1)
	    return (FALSE);

	stat(from, &stbuf);		/* stat "guaranteed" by access (2) */

	if ((stbuf.st_mode & S_IFMT) == S_IFREG)
	    return (TRUE);

	return (FALSE);
}
