#if ! defined(filesys_h)
#define filesys_h

typedef struct FIactions FIactions;
struct FIactions {
    int (*pre_root)();		/* returns void		*/
    int (*post_root)();		/* returns void		*/
    int (*pre_directory)();	/* returns void		*/
    int (*post_directory)();	/* returns void		*/
    int (*file)();		/* returns void		*/
    int (*onerror)();		/* returns void		*/
    int (*sort)();		/* returns int		*/
    Boolean (*selectP)();	/* returns Boolean	*/
};

/*
 *    Passed to the traverse functions.
 */
typedef enum FIfunctionType FIfunctionType;
enum FIfunctionType {
    FI_preroot,			/* before the root	*/
    FI_postroot,		/* after the root	*/
    FI_predirectory,		/* before the directory	*/
    FI_postdirectory,		/* after the directory	*/
    FI_file,			/* a file (not a dir)	*/
    FI_onerror,			/* an error		*/
};

#define FIDotOrDotDotP(path)	(					\
	(path)[0] == '.' && (path)[1] == '\0' ? TRUE:			\
	(path)[0] == '.' && (path)[1] == '.' && (path)[2] == '\0' ?	\
		TRUE: FALSE						\
)

extern int FITraverseFileSystem();	/* via stat() */
extern int FITraverseLinkFileSystem();	/* via lstat() */
extern int FIDefaultDirectorySort();


#endif /* filesys_h */
