;;;;
;;;;    The tail-recursion benchmark
;;;;
;;;;    Compute something in a tail-recursive fashion
;;;;    Ask for this something in a large enough quantity
;;;;       that a non-tail-recursive implementation would fail
;;;;

(defun stupid-ceiling (real &optional (closest-integer 0))
  "a real real stupid ceiling (for positive numbers)"
  (if (>= closest-integer real)
      closest-integer
      (stupid-ceiling real (1+ closest-integer))))

(defvar big 200000.1
  "a big enuf number to break non-tail-recursive
  this number turns out to be bigger than 42k (maxstacksize)
  worth of integers!")

(format t "Ceiling by stupid tail-recursion~%~%~
  This will take a very long time~%")

(let ((result (time (stupid-ceiling big))))
  (format t "stupid-ceiling of ~g is ~d~%" big result))
