;;;;
;;;;    The tokens-per-second benchmark
;;;;
;;;;    See how fast the raw-read speed is.
;;;;    Also, do the following:   '( /usr/dict/words )
;;;;       and do a load (load is written in C)
;;;;

(defconstant token-file "/usr/dict/words")

(defun read-up (file)
  "read up something"
  (do* ((stream (open file :direction :input))
	(token (read stream) (read stream))
	(count 0 (1+ count)))
       ((null token)
	(close stream)
	count)))	; count is the result

(format t "Tokens-per-second~%~
  should take about 20-25 seconds raw reading of ~s~%" token-file)
(format t "tokens read: ~D~%" (time (read-up token-file)))

(defun tokens-per-second (tokens seconds)
  "calculate the tokens-per-second"
  (/ tokens seconds))

(format t "Execute the following: (tokens-per-second <tokens> <seconds>)~%")
