;;;;
;;;;    Insure that a do loop fires up only a single
;;;;    lexical closure at this point.
;;;;

(setq funcs
  (do ((i 0 (1+ i))
       (j 10 (1- j))
       (k 100 (- k 10))
       (l 1000)
       (m -100 (+ m 10))
       (ret nil))
      ((= i 10) ret)
      (format t "i j k l m - ~d ~d ~d ~d ~d~%" i j k l m)
      (setq ret (cons #'(lambda () i) ret))))

(dolist (f funcs)
  (format t "expected 10 - got ~d~%" (funcall f)))

(format t "expected t - got ~s~%" (apply #'equal (map 'list #'funcall funcs)))

(setq funcs
  (do ((i -33)
       (j 10 (1- j))
       (ret nil))
      ((= j 0) ret)
      (format t "i j - ~d ~d~%" i j)
      (setq ret (cons #'(lambda () i) ret))))

(dolist (f funcs)
  (format t "expected -33 - got ~d~%" (funcall f)))

(format t "expected t - got ~s~%" (apply #'equal (map 'list #'funcall funcs)))
