;;;;
;;;;    Two-slot - insure that there are actually two slots
;;;;               for each symbol, a function slot and
;;;;               a value slot (no sick jokes here please)
;;;;

;;;
;;;    test to see if special variables have double slots
;;;
(setq plast '(a b c d e))
(defun plast (&optional (desc "executed"))
  (format t "plast - ~A~%" desc)
  (format t "plast is ~S~%" plast))

(plast)

;;;
;;;    test to see if lexically scoped variables have double slots
;;;

; first with let
(let ((re-plast '(f g h i j)))
  (defun re-plast (&optional (desc "executed"))
	 (format t "re-plast - ~A~%" desc)
	 (format t "re-plast is ~S~%" re-plast))
  (re-plast "locally"))

(re-plast)

(let ((be-plast '(f g h i j)))
  (flet ((be-plast (&optional (desc "executed"))
	 (format t "be-plast is ~S~%" be-plast)))
  (be-plast)))

; then with let*
(let* ((ye-plast '(f g h i j)))
  (defun ye-plast (&optional (desc "executed"))
	 (format t "ye-plast - ~A~%" desc)
	 (format t "ye-plast is ~S~%" ye-plast))
  (ye-plast "locally"))

(ye-plast)

(let* ((me-plast '(f g h i j)))
  (flet ((me-plast (&optional (desc "executed"))
  (format t "me-plast - ~A~%" desc)
	 (format t "me-plast is ~S~%" me-plast)))
  (me-plast)))

; then with flet
(let* ((pe-plast '(f g h i j)))
  (labels ((pe-plast (&optional foodle)
		     (format t "this should not be seen~%")
		     'error))
	  (flet ((pe-plast (&optional (desc "executed"))
			   (format t "pe-plast - ~A~%" desc)
			   (format t "pe-plast is ~S~%" pe-plast)))
		(pe-plast))))

; then with labels
(let* ((que-plast '(f g h i j)))
  (flet ((que-plast (&optional foodle)
		    (format t "this should not be seen~%")
		    'error))
	(labels ((que-plast (&optional (desc "executed"))
			    (format t "que-plast - ~A~%" desc)
			    (format t "que-plast is ~S~%" que-plast)))
		(que-plast))))

; then with macrolet
(let* ((we-plast '(f g h i j)))
  (flet ((we-plast (&optional foodle)
		   (format t "this should not be seen~%")
		   'error))
	(macrolet ((we-plast (&optional (desc "executed"))
			     `(progn
			       (format t "we-plast - ~A~%" ,desc)
			       (format t "we-plast is ~S~%" we-plast))))
		  (we-plast))))
