#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLAssoc - association list
 *
 *    (assoc item a-list)
 *
 *    return the matching item
 */
LLobject *
LLAssoc(key, a_list)
LLobject *key;
LLobject *a_list;
{
	LLobject *r, *a_key, *a_item;

	if ( ! LL_listp(a_list) ) {
	    LLErrorF("\
Function: (assoc key a-list)\n\
\ta-list is not a cons\n\
\tkey:    ~S\n\
\ta-list: ~S\n\
", key, a_list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	for (r=a_list; LL_consp(r) && LL_consp(LL_car(r)); r=LL_cdr(r)) {

	    a_item = LL_car(r);
	    if (LL_null(a_item))
		continue;	/* just ignore it */

	    a_key = LL_car(a_item);
	    if (LL_eq(a_key, key))
		return (a_item);
	}

	if ( ! LL_null(r) ) {
	    LLErrorF("\
Function: (assoc key a-list)\n\
\tbadly formed a-list - member is not a cons\n\
\tkey:    ~S\n\
\ta-list: ~S\n\
", key, a_list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_nil);
}
