#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLErefHandle - reference a handle
 *
 *    value of a handle is (value . environment)
 *
 *    return the value of the handle
 */
LLobject *
LLErefHandle(handle)
LLhandle handle;
{
	LLobject *handobj;
	
	if ( ! st_lookup(LLMachine.handles, handle, &handobj) ) {
	    LLErrorF("\
Function: LLErefHandle\n\
\tno such handle\n\
\thandle: ~D\n\
", handle);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_cdr(handobj));
}
