#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLEsetHandle - set the environment of a a handle
 *
 *    value of a handle is (value . environment)
 *
 *    return the old value of the handle is returned
 */
LLobject *
LLEsetHandle(handle, environment)
LLhandle handle;
LLobject *environment;
{
	LLobject *handobj, *old;
	
	if ( ! st_lookup(LLMachine.handles, handle, &handobj) ) {
	    LLErrorF("\
Function: LLEsetHandle\n\
\tno such handle\n\
\thandle: ~D\n\
", handle);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	old = LL_cdr(handobj);
	LL_rplacd(handobj, environment);

	return (old);
}
