#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLExtendEnvironment - define the value in the environment
 *
 *    return the new environment
 */
LLobject *
LLExtendEnvironment(symbol, slot, value, environment)
LLobject *symbol;
LLslot slot;
LLobject *value;
LLobject *environment;
{
	LLobject *tmp, *newenv;

	if ( ! LL_symbolp(symbol) ) {
	    LLErrorF("\
Symbol is not a symbol\n\
\tsymbol: ~S\n\
\tslot:   ~A\n\
\tvalue:  ~S\n\
", symbol, LL_slot_name(slot), value);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	if (LL_pname(symbol)[0] == ':') {
            LLErrorF("\
Symbol is a keyword\n\
\tcannot bind the value of a keyword\n\
\tsymbol: ~S\n\
", symbol);
            LLThrow(LL_lightlisp, LL_nil);
        }

	tmp = LLAcons(symbol, value, LL_slot(environment, slot));
	if (slot == LL_valueSlot)
	    newenv = LLCons(tmp, LL_function_slot(environment));
	else
	    newenv = LLCons(LL_value_slot(environment), tmp);

	return (newenv);
}
