#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

LLobject *
LL_GcScan_Nil(old)
LLobject *old;
{
	return (LL_nil);
}

LLobject *
LL_GcScan_Integer(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_integer = old->value.a_integer;
	new->type->count++;

	st_add_direct(LLMachine.integers, new->value.a_integer, new);

	return (new);
}

LLobject *
LL_GcScan_Real(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_real = old->value.a_real;
	new->type->count++;

	return (new);
}

LLobject *
LL_GcScan_String(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_string = old->value.a_string;
	new->type->count++;

	return (new);
}

LLobject *
LL_GcScan_Symbol(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_symbol = old->value.a_symbol;
	new->type->count++;

	return (new);
}

void
LL_GcReScan_Symbol(new, relocate)
LLobject *new;
LLobject *(*relocate)();
{
	new->value.a_symbol.value = (*relocate)(new->value.a_symbol.value);
}

LLobject *
LL_GcScan_Type(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_type = old->value.a_type;
	new->type->count++;

	return (new);
}

LLobject *
LL_GcScan_Closure(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_closure = old->value.a_closure;
	new->type->count++;

	return (new);
}

void
LL_GcReScan_Closure(new, relocate)
LLobject *new;
LLobject *(*relocate)();
{
	new->value.a_closure.code = (*relocate)(new->value.a_closure.code);
	new->value.a_closure.environment = (*relocate)(new->value.a_closure.environment);
}

LLobject *
LL_GcScan_Cons(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_cons = old->value.a_cons;
	new->type->count++;

	return (new);
}

void
LL_GcReScan_Cons(new, relocate)
LLobject *new;
LLobject *(*relocate)();
{
	new->value.a_cons.car = (*relocate)(new->value.a_cons.car);
	new->value.a_cons.cdr = (*relocate)(new->value.a_cons.cdr);
}

LLobject *
LL_GcScan_Function(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_function = old->value.a_function;
	new->type->count++;

	return (new);
}

LLobject *
LL_GcScan_Distinguished(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_distinguished = old->value.a_distinguished;
	new->type->count++;

	return (new);
}

LLobject *
LL_GcScan_Dead(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->type->count++;

	return (new);
}

LLobject *
LL_GcScan_Stream(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_stream = old->value.a_stream;
	new->type->count++;

	return (new);
}

LLobject *
LL_GcScan_Garbage(old)
LLobject *old;
{
	return (old->value.a_garbage.broken_heart);
}
