#include <sys/types.h>
#include <stdio.h>
#include <setjmp.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLGetFullStats - get full memory stats
 *
 *    return nothing, just do it.
 */
void
LLGetFullStats(fullStats)
LLfullStats *fullStats;			/* return */
{
	extern int etext;
	extern int edata;
	extern int end;
	LLblock b;	/* for sizeof */
	st_generator *g;
	LLobjectType *t;
	LLcellsByType c;
	LLstring s;

	fullStats->totalHeapBytes = LLHeap.nblocks * sizeof (b) * 2;
	fullStats->totalCells = LLHeap.nblocks * sizeof_el (b.subheap);
	fullStats->cellsUsed = LLHeap.halves[LLHeap.this].used;
	fullStats->cellsFree = fullStats->totalCells - fullStats->cellsUsed;;
	fullStats->maximumCellsAllowed = LLMaxBlocks * sizeof_el (b.subheap);

	DYNInit(&fullStats->cellsByType, LLcellsByType);
        g = st_init_gen(LLMachine.types);
        while (st_gen(g, &s, &t)) {
	    c.pname = t->pname;
	    c.count = t->count;
	    DYNpAtEndPut(&fullStats->cellsByType, &c);
	}
        st_free_gen(g);

	fullStats->cellBytes = fullStats->totalHeapBytes;
	fullStats->stringBytes = LLHeap.nstringb;
	fullStats->totalBytes = fullStats->cellBytes + fullStats->stringBytes;
	fullStats->totalCoreBytes = (int) sbrk(0) - (int) &end;

	fullStats->garbageCollections = LLHeap.gc;
	fullStats->garbageCollectTime = LLHeap.gctime;
	fullStats->totalTime = LLStopWatch() - LLHeap.starttime;
}
