#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLGetLength - length of the list
 *
 *    return the length of the list, -1 if circular
 */
int
LLGetLength(list)
LLobject *list;
{
	int32 count;
	LLobject *l, *l1;

	if ( ! LL_listp(list) ) {
	    LLErrorF("\
Function: (length list)\n\
\tlist is not a cons\n\
\tlist: ~S\n\
", list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	/* do the odd/even pointer trick for counting list lengths */
	for (l=list, l1=list, count=0; LL_consp(l); l=LL_cdr(l), l1=LL_cdr(LL_cdr(l1)), count++) {
	    if (count != 0 && LL_eq(l, l1))
		return (-1);	/* circular */
	}

	if ( ! LL_null(l) ) {
	    LLErrorF("\
Function: (length list)\n\
\tbadly formed list - tail member is not nil\n\
\tlist: ~S\n\
", list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (count);
}
