#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLGetNthcdr - get the nth cdr
 *
 *    return the nth cdr
 */
LLobject *
LLGetNthcdr(int_i, list)
int int_i;
LLobject *list;
{
	LLobject *l;

        if (int_i < 0) {
	    LLErrorF("\
Function: (nthcdr index list)\n\
\tindex is negative\n\\n\
\ti:    ~D\n\
\tlist: ~S\n\
", int_i, list);
            LLThrow(LL_lightlisp, LL_nil);
        }

	if (LL_null(list))
	    return (LL_nil);

        if ( ! LL_consp(list) ) {
	    LLErrorF("\
Function: (nthcdr index list)\n\
\tlist is not a cons\n\
\ti:    ~D\n\
\tlist: ~S\n\
", int_i, list);
            LLThrow(LL_lightlisp, LL_nil);
        }

	for (l = list; int_i > 0 && LL_consp(l); l=LL_cdr(l), int_i--)
	    ;

	if (LL_null(l))
	    return (LL_nil);

	if ( ! LL_consp(l) ) {
	    LLErrorF("\
Function: (nthcdr index list)\n\
\tbadly formed list - terminating cdr member was not nil\n\
\ti:    ~D\n\
\tlist: ~S\n\
", int_i, list);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (l);
}
