#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLGetValue - get the value lexically or at the top level
 *
 *    return the bound value
 */
LLobject *
LLGetValue(symbol, slot, environment)
LLobject *symbol;
LLslot slot;
LLobject *environment;
{
	LLobject *tmp;

	if ( ! LL_symbolp(symbol) ) {
            LLErrorF("\
Symbol is not a symbol\n\
\tsymbol: ~S\n\
", symbol);
            LLThrow(LL_lightlisp, LL_nil);
        }

	/*
	 *    The value of a keyword is a keyword
	 */
	if (LL_pname(symbol)[0] == ':')
	    return (symbol);

	tmp = LLAssoc(symbol, LL_slot(environment, slot));
	if ( ! LL_null(tmp) )
	    return (LL_cdr(tmp));

	/*
	 *    Else check the top-level environment
	 */
	if (LL_unboundp(symbol, slot)) {
            LLErrorF("\
symbol ~A slot is not bound\n\
\tsymbol: ~S\n\
", LL_slot_name(slot), symbol);
            LLThrow(LL_lightlisp, LL_nil);
	}

	return (LL_symbol_slot(symbol, slot));
}
