#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLInternedSymbolP - is this symbol interned?
 *
 *    return {TRUE, FALSE} on {is, is not}.
 */
Boolean
LLInternedSymbolP(symbol)
LLobject *symbol;
{
	LLobject *interned;

	if ( ! LL_symbolp(symbol) ) {
	    LLErrorF("\
Function: LLInternedSymbolP\n\
\tsymbol argument was not a symbol\n\
\tsymbol: ~S\n\
", symbol);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	return (st_lookup(LLMachine.oblist, LL_pname(symbol), &interned) && 
		    interned == symbol ? TRUE: FALSE);
}
