#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLLookupSequence - lookup the sequence
 *
 *    return {the sequence, NULL on {success, fail}
 */
LLsequence *
LLLookupSequence(key)
LLobject *key;
{
	LLsequence *sequence;
	LLobjectType *type;

	if (LL_typep(key, LLTypeCell)) {
	    return (key->value.a_type->sequence);	/* may be NULL */
	} else if (LL_symbolp(key)) {
	    if (st_lookup(LLMachine.sequences, LL_pname(key), &sequence))
		return (sequence);
	    if (st_lookup(LLMachine.types, LL_pname(key), &type))
		return (type->sequence);		/* may be NULL */
	    return (NULL);
	}

	LLErrorF("\
Function: LLLookupSeqeunce\n\
\tinvalid argument type\n\
\tkey: ~S\n\
", key);
	LLThrow(LL_lightlisp, LL_nil);
	/*NOTREACHED*/
}
