#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLLookupType - lookup the type
 *
 *    return {the type, NULL} on {success, fail}
 */
LLobjectType *
LLLookupType(key)
LLobject *key;
{
	LLobjectType *type;

	if (LL_typep(key, LLTypeCell)) {
	    return (key->value.a_type);
	} else if (LL_symbolp(key)) {
	    if (st_lookup(LLMachine.types, LL_pname(key), &type))
		return (type);
	    return (NULL);
	}

	LLErrorF("\
Function: LLLookupType\n\
\tinvalid argument type\n\
\tkey: ~S\n\
", key);
	LLThrow(LL_lightlisp, LL_nil);
	/*NOTREACHED*/
}
