#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLMakeASequence - make an objectType a sequence
 *
 *    return nothing, just do it.
 */
void
LLMakeASequence(objectType, template)
LLobjectType *objectType;
LLsequence template;
{
	LLsequence *new;

	template.sname = LLInternSymbol(template.sname);
	if (st_is_member(LLMachine.sequences, template.sname)) {
	    LLErrorF("\
Function: LLMakeASequence\n\
\tthe sequence name has already been defined\n\
\tsequence name: ~A\n\
", template.sname);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	new = ALLOC_TYPE(LLsequence);
	
	if (new == NULL) {
	    LLErrorF("\
LightLisp is out of memory - forcing garbage collection\n\
\ttrying to make the type ~S into a sequence\n\
", objectType->pname);
	    LLThrow(LL_uncatchable, LL_nil);
	}

	*new = template;
	new->type = objectType;
	objectType->sequence = new;
}
