#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLMakeMacro - create a macro
 *
 *    LLobject *
 *    expander(arguments, environment)
 *    LLobject *arguments;
 *    LLobject *environment;
 *
 *    see LightLispMachine.h for the distinction among function types
 *
 *    return the macro cell
 */
LLobject *
LLMakeMacro(prepname, function)
String prepname;
LLobject *(*function)();
{
	LLobject *new;
	LLstring pname;

	pname = LLInternSymbol(prepname);
	new = LLMakeObject();

	new->type = LLMacroCell;
	new->value.a_function.pname = pname;
	new->value.a_function.function = function;
	new->type->count++;

	return (new);
}
