#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLMakeSpecialForm - create an special form
 *
 *    LLobject *
 *    special_form(arguments, environment)
 *    LLobject **arguments;		- value/return
 *    LLobject **environment;		- value/return
 *
 *    returns {t, nil} on {tail-recursive, non-tail-recursive}
 *    if nil, then *arguments is the return value
 *    if t, then *arguments must be evaluated in *environment
 *
 *    see LightLispMachine.h for the distinction among function types
 *
 *    return the special-form cell
 */
LLobject *
LLMakeSpecialForm(prepname, function)
String prepname;
LLobject *(*function)();
{
	LLobject *new;
	LLstring pname;

	pname = LLInternSymbol(prepname);
	new = LLMakeObject();

	new->type = LLSpecialFormCell;
	new->value.a_function.pname = pname;
	new->value.a_function.function = function;
	new->type->count++;

	return (new);
}
