#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLMakeSymbol - create a new symbolCell
 *
 *    return the symbol cell
 */
LLobject *
LLMakeSymbol(prepname)
String prepname;
{
	LLobject *identifier, *new;
	LLstring pname;

	pname = LLInternSymbol(prepname);

	if (st_lookup(LLMachine.oblist, pname, &identifier))
	    return (identifier);

	new = LLMakeObject();

	new->type = LLSymbolCell;
	new->value.a_symbol.pname = pname;
	new->value.a_symbol.value = LLCons(LL_unbound, LL_unbound);
	new->type->count++;

	st_add_direct(LLMachine.oblist, pname, new);

	return (new);
}
