#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLMakeObject - make (e.g. get) an object
 *
 *    return the (LLobject *)
 */
LLobject *
LLMakeObject()
{
	LLobject *new;

	if (LLHeap.halves[LLHeap.this].pointer.index < sizeof_el (LLHeap.halves[LLHeap.this].pointer.block->subheap)) {
	    LLHeap.halves[LLHeap.this].used++;
	    new = &LLHeap.halves[LLHeap.this].pointer.block->subheap[LLHeap.halves[LLHeap.this].pointer.index++];
	    return (new);
	}

	if (LLHeap.halves[LLHeap.this].pointer.block->next != NULL) {
	    LLHeap.halves[LLHeap.this].pointer.block = LLHeap.halves[LLHeap.this].pointer.block->next;
	    LLHeap.halves[LLHeap.this].pointer.index = 0;

	    return (LLMakeObject());
	}

#ifdef SHIT
	/*
	 *    TODO - cannot do asynchronous garbage collection
	 *    because of the pointers on the C call stack.
	 *    This code should never be turned on.   It is here
	 *    to remind you not to turn it on.
	 */
	LLGarbageCollect();

	/* if garbage collecting worked, then return the new object */
	if (LLHeap.halves[LLHeap.this].pointer.index < sizeof_el (LLHeap.halves[LLHeap.this].pointer.block->subheap))
	    return (LLMakeObject());

	/* if still full, get another block */
#endif

	LLGetBlock();
	return (LLMakeObject());
}
