#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLMakeRegister - make an external register
 *
 *    Good for external package's hash tables and such
 *
 *    void
 *    scan(userData, relocate)
 *    RefAny userData;
 *    LLobject *(*relocate)();
 *
 *        LLobject *
 *        relocate(old)
 *        LLobject *old;
 *
 *    return nothing, just do it.
 */
void
LLMakeRegister(scan, userData)
void (*scan)();
RefAny userData;
{
	LLxregister x;

	x.scan = scan;
	x.userData = userData;

	DYNAtEndPut(&LLMachine.externals, x);
}
