#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLProbeValueP - see if the value is bound lexically or at the top level
 *
 *    return {TRUE, FALSE} on {is, is not}.
 */
Boolean
LLProbeValueP(symbol, slot, environment)
LLobject *symbol;
LLslot slot;
LLobject *environment;
{
	LLobject *tmp;

	if ( ! LL_symbolp(symbol) ) {
            LLErrorF("\
Symbol is not a symbol\n\
\tsymbol: ~S\n\
", symbol);
            LLThrow(LL_lightlisp, LL_nil);
        }

	/*
	 *    The value of a keyword is a keyword
	 */
	if (LL_pname(symbol)[0] == ':')
	    return (TRUE);

	tmp = LLAssoc(symbol, LL_slot(environment, slot));
	if ( ! LL_null(tmp) )
	    return (TRUE);

	return (LL_unboundp(symbol, slot) ? FALSE: TRUE);
}
