#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLQuote - quote
 *
 *    (quote sexp)
 *
 *    return the result
 */
LLobject *
LLQuote(arguments, environment)
LLobject *arguments;		/* value */
LLobject *environment;		/* value */
{
	LLQuote_tr(&arguments, &environment);
	return (arguments);
}

/*
 *    LLQuote_tr - quote
 *
 *    (quote sexp)
 *
 *    return {t, nil} on {tail-recursive, non-tail-recursive}
 */
LLobject *
LLQuote_tr(arguments, environment)
LLobject **arguments;		/* value/return */
LLobject **environment;		/* value/return */
{
	if (LLGetLength(*arguments) != 1) {
	    LLErrorF("\
Function: (quote sexp)\n\
\tinvalid number of arguments to quote\n\
\tform: ~S\n\
", *arguments);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	*arguments = LL_first(*arguments);
	return (LL_nil);
}
