#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLSetValue - set the value in the top-level
 *
 *    return the bound value
 */
LLobject *
LLSetValue(symbol, slot, value, environment)
LLobject *symbol;
LLslot slot;
LLobject *value;
LLobject *environment;
{
	LLobject *tmp;

	if ( ! LL_symbolp(symbol) ) {
            LLErrorF("\
symbol is not a symbol\n\
\tsymbol: ~S\n\
", symbol);
            LLThrow(LL_lightlisp, LL_nil);
        }

	if (LL_pname(symbol)[0] == ':') {
            LLErrorF("\
symbol is a keyword\n\
\tcannot set the value of a keyword\n\
\tsymbol: ~S\n\
", symbol);
            LLThrow(LL_lightlisp, LL_nil);
        }

	tmp = LLAssoc(symbol, LL_slot(environment, slot));
	if ( ! LL_null(tmp) ) {
	    LL_rplacd(tmp, value);
	    return (value);
	}

	LL_set_symbol_slot(symbol, slot, value);
	return (value);
}
