#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLThrow - throw the value to the given catcher
 *
 *    return nothing, just do it.
 */
LLobject *
LLThrow(tag, value)
LLobject *tag;
LLobject *value;
{
	LLcatcher old;

	/* 
	 *    Cons value into a cell so that you can
	 *    throw LL_nil with impunity through setjmp().  
	 */
	value = LLCons(value, LL_nil);

	while (DYNStkSp(&LLMachine.catchers) > 0) {
	    old = DYNStkPop(&LLMachine.catchers, LLcatcher);

	    /* if you want it in a lexical environment, put a closure over it */
	    LLEvaluator(old.cleanup, LL_environment);

	    if (LL_eq(LL_uncatchable, tag))
		continue;	/* the catcher from HELL */

	    if (LL_eq(LL_alwayscatchable, old.tag) || LL_eq(old.tag, tag))
		longjmp(old.state, value);
	}

	longjmp(LLMachine.top_level, value);
	/*NOTREACHED*/
}
