#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "machine.h"
#include "printer.h"
#include "internal.h"

/*
 *    LLUnmakeStream - make a streamCell dead
 *
 *    side effect the stream cell
 *
 *    return nothing, just do it.
 */
void
LLUnmakeStream(stream)
LLobject *stream;
{
	LLobject *orig_stream;
	STREAM *old;

	if ( ! LL_streamp(stream) ) {
	    LLErrorF("\
Function: LLUnmakeStream\n\
\targument is not a stream\n\
\targument: ~S\n\
", stream);
	    LLThrow(LL_lightlisp, LL_nil);
	}

	/*
	 *   It is possible to close a closed stream.
	 */
	if (stream->value.a_stream != NULL) {
	    old = stream->value.a_stream;
	    if ( ! st_delete(LLMachine.streams, &old, &orig_stream) ) {
		LLErrorF("\
Function: LLUnmakeStream\n\
\targument stream was not registered with the open streams\n\
\targument: ~S\n\
", stream);
		LLThrow(LL_lightlisp, LL_nil);
	    }

	    STREAMDestroy(orig_stream->value.a_stream);
	    orig_stream->value.a_stream = NULL;
	}
}
