#include <sys/types.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "path.h"
#include "internal.h"

/*
 *    PATHNext - set the gen to the next member in the path.
 *
 *    return {PATH_ok, PATH_eof} on {more members, done}
 */
PATHstatus
PATHNext(gen, iteration)
PATHgen gen;
String *iteration;
{
	PATHrealGen *realgen = (PATHrealGen *) gen;
	PATHstatus ret;
	char *begin;

	if (realgen->this == NULL)
	    return (PATH_eof);

	if (realgen->fillup != NULL)
	    *realgen->fillup = realgen->separator;

	*iteration = realgen->this;
	if (realgen->next != NULL) {
	    *realgen->next = '\0';
	    realgen->fillup = realgen->next;
	    realgen->this = &realgen->next[1];
	    if (PATHNextGivenSep(realgen->this, realgen->separator, &realgen->next) == PATH_eof)
		realgen->next = NULL;
	    ret = PATH_ok;
	} else if (realgen->this != NULL) {
	    /*
	     *    The last member in the path
	     */
	    realgen->fillup = NULL;
	    realgen->this = NULL;
	    ret = PATH_ok;
	} else {	/* realgen->this == NULL */
	    /*
	     *    You're done.
	     */
	    DYNFree(&realgen->buf);
	    ret = PATH_eof;
	}

	return (ret);
}
