#include <sys/types.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "path.h"
#include "internal.h"

/*
 *    PATHNextGivenSep - set the realgen to the next member in the path.
 *
 *    Note: :apple:banana:cherry::tree: generates
 *
 *    "" "apple" "banana" "cherry" "" "tree" ""
 *
 *    return {PATH_ok, PATH_eof} on {more members, done}
 */
PATHstatus
PATHNextGivenSep(subpath, sep, next)
String subpath;
char sep;
String *next;
{
	String presubpath;

	presubpath = subpath;

	do {
	    subpath = presubpath;		/* trivial the first time through */
	    if ((*next = index(subpath, sep)) == NULL)
		return (PATH_eof);;

	    presubpath = &(*next)[1];
	} while (*next > &subpath[2] && (*next)[-1] == '\\' && (*next)[-2] != '\\');

	return (PATH_ok);
}
