#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>
#include <ctype.h>
#include <varargs.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "internal.h"

/*
 *    LLPrintStats - get and print stats
 *
 *    return nothing, just do it.
 */
void
LLPrintStats(stream)
STREAM *stream;		/* may be NULL */
{
	LLstats mem;

	LLGetStats(&mem);

	if (stream == NULL)
	    stream = LLErrorStream;

	LLFormatC(stream, "heap is ~Dk bytes, ~D total cells, ~D used, ~D free",
		mem.totalHeapBytes/1024 + 1, mem.totalCells, mem.cellsUsed, mem.cellsFree);
	if (mem.maximumCellsAllowed != 0)
	    LLFormatC(stream, ", maximum cells allowed ~D", mem.maximumCellsAllowed);
	STREAMPutc(stream, '\n');
}
