/*
 *    Use global variables, not for elegance, but for speed.
 *    The parser is the inner loop of the readin phase (no kidding)
 *    so it must be as fast as possible.
 */
extern STREAM *LL_Re_STREAM;
extern Boolean LL_Re_CP;	
extern char LL_Re_C;
extern LLobject *LL_Re_CatcherTag;

extern DYNStrgeneralString LL_Re_StringToken;

/*
 *    So we don't have to call ungetc (which is more expensive than we need)
 */
#define LL_getc()		(LL_Re_CP ? \
					(LL_Re_CP = FALSE, LL_Re_C): \
					(STREAMGetc(LL_Re_STREAM, &LL_Re_C) == STREAM_eof ? EOF: LL_Re_C))
#define LL_ungetc(c)		(LL_Re_CP = TRUE, LL_Re_C = (c))
#define LL_peekc()		(LL_Re_CP ? \
					LL_Re_C: \
					(LL_Re_CP = TRUE, STREAMGetc(LL_Re_STREAM, &LL_Re_C) == STREAM_eof ? EOF: LL_Re_C))

#define LL_ridwhite()			\
	{ int c; while (c = LL_getc(), isspace(c)) ; LL_ungetc(c); }

#define LL_endtokenP(c)	(c == EOF || isspace(c) || (c) == '(' || (c) == ')' || \
			    (c) == ';' || ! LL_null(LLMachine.readtable[(int) c]))
#define LL_icase(c1, c2)	((isupper(c1) ? tolower(c1): c1) == (isupper(c2) ? tolower(c2): c2))
#define LL_Re_is_nil(b)		(LL_icase((b)[0], 'n') && LL_icase((b)[1], 'i') && LL_icase((b)[2], 'l') && (b)[3] == '\0')

extern LLobject *LL_Re_Number();
extern LLobject *LL_Re_String();
extern LLobject *LL_Re_Symbol();
