#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>
#include <ctype.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "reader.h"
#include "internal.h"

/*
 *    LL_Re_Number - parse an number
 *
 *    return the number
 */
LLobject *
LL_Re_Number(start)
char start;		/* may be '\0' */
{
	Boolean endP;
	int32 a_int;
	double a_real;
	char a_char;
	char buf[LL_MAXSTRINGLEN];		/* big enuf */
	char *b, *bend, *base;
	int c;

	c = start == '\0' ? LL_getc(): start;

	b = buf;
	bend = &buf[sizeof_el(buf)-2];	/* -1 for the '\0' */
	do {
	    *b++ = c;
	    c = LL_getc();

	    /* c == EOF implies endP */
	    endP = LL_endtokenP(c);
	} while ( ! endP && b < bend);

	*b = '\0';		/* yes there is room */

	if ( ! endP ) {
	    LLFormatC(LL_Re_STREAM, "\
~A, line ~D: symbol is just too long (length > ~D)\n\
", STREAMGetName(LL_Re_STREAM, STREAM_input),
    STREAMGetLineno(LL_Re_STREAM, STREAM_input),
    sizeof_el(buf));
	    LLThrow(LL_Re_CatcherTag, LL_nil);
	}
	LL_ungetc(c);	/* one too far */

	/*
	 *   Though slower, use the more specific tests first
	 */
	if (sscanf(buf, "0x%lx%c", &a_int, &a_char) == 1)
	    return (LLMakeInteger(a_int));
	if (sscanf(buf, "0%lo%c", &a_int, &a_char) == 1)
	    return (LLMakeInteger(a_int));
	if (sscanf(buf, "%ld%c", &a_int, &a_char) == 1)
	    return (LLMakeInteger(a_int));
	if (sscanf(buf, "%lf%c", &a_real, &a_char) == 1)
	    return (LLMakeReal(a_real));

	return (LLMakeSymbol(buf));
}
