#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>
#include <ctype.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "printer.h"
#include "reader.h"
#include "internal.h"

/*
 *    LL_Re_Symbol - parse a symbol
 *
 *    return the symbol
 */
LLobject *
LL_Re_Symbol(start)
char start;		/* may be '\0' */
{
	char buf[LL_MAXSTRINGLEN];
	char *b, *bend;
	Boolean endP;
	int c;

	c = start == '\0' ? LL_getc(): start;

	b = buf;
	bend = &buf[sizeof_el(buf)-2];	/* -1 for the '\0' */
	do {
	    *b++ = c;
	    c = LL_getc();

	    /* c == EOF implies endP */
	    endP = LL_endtokenP(c);
	} while ( ! endP && b < bend);

	*b = '\0';		/* yes there is room */

	if ( ! endP ) {
	    LLFormatC(LL_Re_STREAM, "\
~A, line ~D: symbol is just too long (length > ~D)\n\
", STREAMGetName(LL_Re_STREAM, STREAM_input),
    STREAMGetLineno(LL_Re_STREAM, STREAM_input),
    sizeof_el(buf));
	    LLThrow(LL_Re_CatcherTag, LL_nil);
	}
	LL_ungetc(c);	/* one too far */

	return (LL_Re_is_nil(buf) ? LL_nil: LLMakeSymbol(buf));
}
