#include "sumachine.h"

#include <sys/types.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"

#include "stream.h"

#include "internal.h"

static void clear();

/*
 *    STREAMClear - clear a stream
 *
 *    on input, ignore the rest of this line.
 *    on output, well, just flush it.
 *
 *    return nothing, just do it.
 */
void
STREAMClear(stream, sidename)
STREAM *stream;
STREAMsideName sidename;
{
	char c;

	if (sidename == STREAM_input) {
	    if (stream->input.counts.columnno != 0) {
		/*
		 *    If in the middle off a line, kill it
		 *    Don't start a new line b/c that causes another
		 *    read for linebuffered streams
		 */
		while (STREAMGetc(stream, &c) != STREAM_eof && c != '\n')
		    ;
	    }

	    clear(&stream->input, sidename);
	} else {
	    clear(&stream->output, sidename);
	}
}

static void
clear(side, sidename)
STREAMside *side;
STREAMsideName sidename;
{
	side->counts.parens = 0;
	side->counts.curls = 0;
	side->counts.squares = 0;
	side->counts.bracks = 0;

	switch (side->type) {
	case STREAM_void:
	    break;
	case STREAM_FILE:
	    /* won't clear pending output - but should clear pending input */
	    fflush(side->value.a_FILE.file);
	    break;
	case STREAM_string:
	    if (sidename == STREAM_input)
		DYNStrClear(&side->value.a_string.buf);
	    break;
	case STREAM_charback:
	    break;
	case STREAM_lineback:
	    if (sidename == STREAM_input)
		DYNStrClear(&side->value.a_string.buf);
	    break;
	case STREAM_xactback:
	    break;
	default:
	    break;
	}
}
