#include "sumachine.h"

#include <sys/types.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"

#include "stream.h"

#include "internal.h"

static void kill_side();

/*
 *    STREAMDestroy - create a stream
 *
 *    return nothing, just do it.
 */
void
STREAMDestroy(stream)
STREAM *stream;
{
	kill_side(&stream->input);

	DYNStrFree(&stream->unget);

	switch (stream->prompt.type) {
	case STREAM_noprompt:
	    /* do nothing - there is no prompt */
	    break;
	case STREAM_tty:
	case STREAM_raw:
	    if (stream->prompt.destructor != NULL)
		(*stream->prompt.destructor)(stream->prompt.userData);
	    break;;
	}

	switch (stream->newline.type) {
	case STREAM_nonewline:
	    /* do nothing - there is no newline */
	    break;
	case STREAM_beforenewline:
	case STREAM_afternewline:
	case STREAM_column0:
	    if (stream->newline.destructor != NULL)
		(*stream->newline.destructor)(stream->newline.userData);
	    break;
	}

	kill_side(&stream->output);

	FREE_TYPE(stream, STREAM);
}

static void
kill_side(side)
STREAMside *side;
{
	FREE_STRING(side->name);

	switch (side->type) {
	case STREAM_FILE:
	    if ( ! side->value.a_FILE.destroyP ) {
		fflush(side->value.a_FILE.file);
	    } else {
		if (side->value.a_FILE.file != NULL)
		    fclose(side->value.a_FILE.file);
		side->value.a_FILE.file = NULL;
	    }
	    break;
	case STREAM_string:
	    DYNStrFree(&side->value.a_string.buf);
	    break;
	case STREAM_lineback:
	case STREAM_xactback:
	    DYNStrFree(&side->value.a_callback.buf);
	    break;
	default:
	    /* all else do nothing */
	    break;
	}
}
