#include "sumachine.h"

#include <sys/types.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"

#include "stream.h"

#include "internal.h"

static void flush();

/*
 *    STREAMFlush - flush a stream
 *
 *    flush input kills pending input
 *    flush output writes out
 *
 *    return nothing, just do it.
 */
void
STREAMFlush(stream, sideName)
STREAM *stream;
STREAMsideName sideName;
{
	if (sideName == STREAM_input) {
	    DYNStrClear(&stream->unget);
	    flush(&stream->input, sideName);
	} else {
	    flush(&stream->output, sideName);
	}
}

static void
flush(side, sideName)
STREAMside *side;
STREAMsideName sideName;
{
	switch (side->type) {
	case STREAM_FILE:
	    fflush(side->value.a_FILE.file);
	    break;
	case STREAM_string:
	    if (sideName == STREAM_input)
		DYNStrClear(&side->value.a_string.buf);
	    break;
	case STREAM_lineback:
	    if (sideName == STREAM_input) {
		/* just clear (below) */
	    } else {
		side->last = '\n';	/* to insure a clear later */
		(*side->value.a_callback.function)(&side->value.a_string.buf);
	    }
	    DYNStrClear(&side->value.a_string.buf);
	    break;
	default:
	    /* all else do nothing */
	    break;
	}
}
