#include "sumachine.h"

#include <sys/types.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"

#include "stream.h"

#include "internal.h"

/*
 *    STREAMGetc - get a character
 *
 *    return {STREAM_ok, STREAM_eof} on {ok, eof}
 */
STREAMstatus
STREAMGetc(stream, c)
STREAM *stream;
char *c;		/* return */
{
	int len, ic;

	if (stream->input.last == '\n' || stream->firstReadP) {
	    switch (stream->prompt.type) {
	    case STREAM_noprompt:
		/* nothing */
		break;
	    case STREAM_tty:
	    case STREAM_raw:
		if (stream->debits == 0)
		    (*stream->prompt.callback)(stream, stream->prompt.userData);
		break;
	    }
	}

	stream->firstReadP = FALSE;

	if ((len = DYNStrLength(&stream->unget)) > 0) {
	    ic = DYNStrAt(&stream->unget, len-1);
	    DYNStrSetTail(&stream->unget, len-1);
	} else {
	    switch (stream->input.type) {
	    case STREAM_void:
		ic = EOF;		/* doesn't have any chars unless they were ungotten */
		break;
	    case STREAM_FILE:
		ic = getc(stream->input.value.a_FILE.file);
		break;
	    case STREAM_string:
		if (stream->input.value.a_string.index <  DYNStrLength(&stream->input.value.a_string.buf)) {
		    ic = DYNStrAt(&stream->input.value.a_string.buf, stream->input.value.a_string.index);
		    stream->input.value.a_string.index++;
		} else  {
		    ic = EOF;
		}
		break;
	    case STREAM_charback:
		if ((*stream->input.value.a_callback.function)(&ic) == STREAM_eof)
		    ic = EOF;
		/* else ic was filled in */
		break;
	    case STREAM_lineback:
	    case STREAM_xactback:
		if (stream->input.value.a_string.index < DYNStrLength(&stream->input.value.a_string.buf)) {
		    ic = DYNStrAt(&stream->input.value.a_string.buf, stream->input.value.a_string.index);
		    stream->input.value.a_string.index++;
		} else {
		    if ((*stream->input.value.a_callback.function)(&stream->input.value.a_callback.buf) == STREAM_eof) {
			ic = EOF;
		    } else {
			stream->input.value.a_string.index = 0;
			if (stream->input.value.a_string.index < DYNStrLength(&stream->input.value.a_string.buf)) {
			    ic = DYNStrAt(&stream->input.value.a_string.buf, stream->input.value.a_string.index);
			    stream->input.value.a_string.index++;
			} else {
			    ic = EOF;
			}
		    }
		}
		break;
	    default:
		ic = EOF;
		break;
	    }
	}

	stream->input.last = ic;

	if (ic == EOF)
	    return (STREAM_eof);

	STREAMCount(&stream->input, (char) ic);

	stream->debits = MIN(0, stream->debits+1);
	if (stream->prompt.type == STREAM_raw) {
	    if (stream->debits == 0)
		(*stream->prompt.callback)(stream, stream->prompt.userData);
	}

	*c = (char) ic;
	return (STREAM_ok);
}
