#include "sumachine.h"

#include <sys/types.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"

#include "stream.h"

#include "internal.h"

/*
 *    STREAMPutc - put a character
 *
 *    return {STREAM_ok, STREAM_notok} on {ok, notok}
 */
STREAMstatus
STREAMPutc(stream, c)
STREAM *stream;
char c;
{
	STREAMstatus status;

	switch (stream->newline.type) {
	case STREAM_nonewline:
	case STREAM_afternewline:
	    /* nothing */
	    break;
	case STREAM_beforenewline:
	    if (c == '\n')
		STREAMCallNewlineDemon(stream);
	    break;
	case STREAM_column0:
	    if (stream->output.counts.columnno == 0)
		STREAMCallNewlineDemon(stream);
	    break;
	}

	STREAMCount(&stream->output, c);

	switch (stream->output.type) {
	case STREAM_void:
	    status = STREAM_ok;
	    break;
	case STREAM_FILE:
	    putc(c, stream->output.value.a_FILE.file);
	    status = STREAM_ok;
	    break;
	case STREAM_string:
	    DYNStrAppendC(&stream->output.value.a_string.buf, c);
	    status = STREAM_ok;
	    break;
	case STREAM_charback:
	    status = (*stream->output.value.a_callback.function)(c);
	    /* DON'T do anything here so its not a problem if the function longjmps */
	    break;
	case STREAM_lineback:
	    if (stream->output.last == '\n')
		DYNStrClear(&stream->output.value.a_string.buf);
	    stream->output.last = c;

	    DYNStrAppendC(&stream->output.value.a_string.buf, c);

	    if (c != '\n') {
		status = STREAM_ok;
	    } else {
		status = (*stream->output.value.a_callback.function)(&stream->output.value.a_string.buf);
		/* DON'T do anything here so its not a problem if the function longjmps */
	    }
	    break;
	case STREAM_xactback:
	    DYNStrClear(&stream->output.value.a_string.buf);
	    DYNStrAppendC(&stream->output.value.a_string.buf, c);
	    status = (*stream->output.value.a_callback.function)(&stream->output.value.a_string.buf);
	    DYNStrClear(&stream->output.value.a_string.buf);
	default:
	    status = STREAM_notok;
	    break;
	}

	switch (stream->newline.type) {
	case STREAM_nonewline:
	case STREAM_beforenewline:
	case STREAM_column0:
	    /* nothing */
	    break;
	case STREAM_afternewline:
	    if (c == '\n')
		STREAMCallNewlineDemon(stream);
	    break;
	}

	return (status);
}
