#if ! defined(alloc_h)
#define alloc_h

#ifdef INCLUDE_HEADER
/*
 *    			RCS Control Information:
 *    $Author: saj $				
 *    $Date: 2002/12/31 15:50:57 $
 *
 *    $Revision: 1.1.1.1 $		
 *    $Source: /home/cvs/octtools/src/LightLisp/src/stuff/alloc.h,v $
 *    $State: Exp $
 */
#endif INCLUDE_HEADER

/* 
 *    Actually these definitions are done in sumachine.h
 *    because they are a bit tricky b/c not all systems allow
 *    the declarations seen here (goddamnit).
 *
 *    extern RefAny sbrk();
 *    extern RefAny brk();
 *    extern RefAny malloc();
 *    extern RefAny realloc();
 *    extern void free();
 */

/*
 *    Memory allocation macros (MUST match sda).
 */
#define ALLOC_TYPE(type)		(type *) malloc(sizeof (type))
#define ALLOC_ARRAY(sizeof_el, type)	(type *) malloc(sizeof (type) * (sizeof_el))

#define CLEAR_TYPE(p, type)		bzero(p, sizeof (type))
#define CLEAR_ARRAY(p, sizeof_el, type)	bzero(p, sizeof (type) * (sizeof_el))

#define COPY_TYPE(p1, p2, type)			bcopy(p1, p2, sizeof (type))
#define COPY_ARRAY(p1, p2, sizeof_el, type)	bcopy(p1, p2, sizeof (type) * (sizeof_el))

#define FREE_TYPE(p, type)		free((type *) p)
#define FREE_ARRAY(p, sizeof_el, type)	free((type *) p)
#define FREE(p)				free((char *) p)	/* free anything */

#if OPSYS_MFR == MD_SUN || \
	OPSYS_SUBTYPE == MD_HPUX || \
	OPSYS_SUBTYPE == MD_AIX || \
	OPSYS_SUBTYPE == MD_SYS5 || \
	OPSYS_SUBTYPE == MD_VMS /* { */
#define REALLOC_ARRAY(p, new_sizeof_el, type)	(			\
	(p) = (p) == NULL ? ALLOC_ARRAY(new_sizeof_el, type):		\
	    (type *) realloc(p, (new_sizeof_el) * sizeof (type))	\
)
#else /* } else { */	/* the rest of the western world */
#define REALLOC_ARRAY(p, new_sizeof_el, type)	(			\
	(p) = (type *) realloc(p, (new_sizeof_el) * sizeof (type))	\
)
#endif /* } */

/*
 *    To make COPY_STRING on literal strings work ok.
 *    Be sure that these can and will return NULL if malloc fails
 */
int Stuff_tmplen;
String Stuff_tmp;
String Stuff_tmp1;
#define ALLOC_STRING(length)		(		\
	Stuff_tmp = ALLOC_ARRAY((length)+1, char),	\
	Stuff_tmp != NULL ? (				\
		Stuff_tmp[length] = '\0',		\
		Stuff_tmp): NULL			\
)

#define COPY_STRING(s)		(					\
	Stuff_tmp = s,							\
	Stuff_tmplen = strlen(Stuff_tmp)+1,				\
	Stuff_tmp1 = ALLOC_ARRAY(Stuff_tmplen, char),			\
	Stuff_tmp1 != NULL ? strcpy(Stuff_tmp1, Stuff_tmp): NULL	\
)

#define FREE_STRING(s)		FREE(s)		/* FREE_ARRAY(s, strlen(s)+1, char) */

#endif /* alloc_h */
