#include "sumachine.h"

#include <sys/types.h>

#include "stuff.h"
#include "alloc.h"

#include "tostring.h"

/*
 *    PrintableString - return a copy of the string which is totally printable
 *
 *    return the new copy
 */
String
PrintableString(unprintable)
String unprintable;
{
	String u, p, printable;
	int len;
	register int c;

	for (u=unprintable, len=0; *u != '\0'; u++) {
	    c = (u_char) *u;

	    if (c > 0177) {
		len += 2;		/* M- (at least) */
		c &= 0177;
	    }

	    if (c < ' ' || c == 0177)
		len += 2;		/* ^%c */
	    else
		len++;			/* %c */
	}

	printable = ALLOC_ARRAY(len+1, char);	/* '\0' */

	for (u=unprintable, p=printable; *u != '\0'; u++) {
	    c = (u_char) *u;

	    if (c > 0177) {
		*p++ = 'M';
		*p++ = '-';
		c &= 0177;
	    }

	    if (c < ' ') {
		*p++ = '^';
		*p++ = c+'@';
	    } else if (c == 0177) {
		*p++ = '^';
		*p++ = '?';
	    } else {
		*p++ = c;
	    }
	}
	*p = '\0';

	return (printable);
}
