#include "sumachine.h"

#include <sys/types.h>
#include <stdio.h>

#include "stuff.h"

/*
 *    ExpandSet - expand a set.
 *
 *    a-z 		includes a to z inclusive
 *    			- must be first if it is to be included.
 *    z-a		is considered an error
 *
 *    Currently '\0' cannot be put into a set.
 *    '-' must be first if it is to be in the set.
 *
 *    return {0, -1} on {success, set range error}.
 */
int
ExpandSet(insetP, set)
Boolean insetP[256];
u_char *set;		/* not a String, but ... */
{
	int top;
	register u_char *s;	/* not a String, but ... */
	register int c;

	bzero(insetP, 256 * sizeof (Boolean));

	if (set == NULL)
	    return (0);

	for (s=set; *s != '\0'; s++) {
	    if (s[1] != '-') {				/* a	*/
		c = *s;
		insetP[c] = TRUE;
	    } else if (s[0] > s[2]) {			/* z-a	*/
		return (-1);
	    } else {					/* a-z	*/
		top = s[2];	/* so that you can compare say c <= 255 */
		for (c=s[0]; c <= top; c++) {
		    insetP[c] = TRUE;
		}
		s += 2;	/* s++ above carries through */
	    }
	}
	return (0);
}
