#if ! defined(stuff_h)
#define stuff_h

#if ! defined(sumachine_h) /* { */
/*
 *    In case they haven't included it just yet...
 *    #include "sumachine.h" should be the first thing included in any .c file
 */
#include "sumachine.h"
#endif /* } */

/*
 *    			RCS Control Information:
 *    $Author: saj $				
 *    $Date: 2002/12/31 15:50:57 $
 *
 *    $Revision: 1.1.1.1 $		
 *    $Source: /home/cvs/octtools/src/LightLisp/src/stuff/stuff.h,v $
 *    $State: Exp $
 */

#ifndef TRUE		/* curses.h for one		*/
#define FALSE	0
#define TRUE	1
#endif TRUE

typedef int Boolean;

typedef char Byte;
typedef unsigned char u_Byte;

typedef long FitAny;		/* can fit any integral type */

typedef char *RefAny;		/* can't be a byte b/c of pointer comparison */
typedef Byte *RefByte;		/* same as RefAny I guess ... for closure */
typedef u_Byte *Refu_Byte;

typedef char *String;
typedef char **Stringv;

#define strequal(s1, s2)		( ! strcmp(s1, s2) )
#define strnequal(s1, s2, n)		( ! strncmp(s1, s2, n) )

extern int nocase_strcmp();
extern Boolean nocase_strequal();
extern Boolean nocase_strnequal();

extern Boolean lead_strequal();
extern Boolean nocase_lead_strequal();

extern int strhash();
extern int nocase_strhash();

/*
 *    Some useful macros.
 */
#ifndef NULL		/* stdio.h for one		*/
#define NULL	0
#endif NULL
#ifndef NIL		/* lotsa people define this	*/
#define NIL(thing)	((thing *) 0)
#endif NIL

#ifndef EOF		/* stdio.h for one		*/
#define EOF	(-1)
#endif EOF

#define sizeof_el(thing)		(sizeof (thing)/sizeof (thing[0]))

#ifndef ABS	/* because now that utility.h now wants to define it too */
#define ABS(a)		((a) > 0 ? (a): -(a))
#endif ABS

#ifndef MIN		/* sys/param.h for one		*/
#define MIN(a, b)	(((a) < (b)) ? (a): (b))
#define MAX(a, b)	(((a) > (b)) ? (a): (b))
#endif MIN
#ifndef MAX3		/* just in case somebody defines this himself ... */
#define MAX3(a, b, c)	(((a) > (b)) ? MAX(a, c): MAX(b, c))
#endif MAX3
#ifndef MIN3		/* just in case somebody defines this himself ... */
#define MIN3(a, b, c)	(((a) < (b)) ? MIN(a, c): MIN(b, c))
#endif MIN3

#if OPSYS_SUBTYPE != MD_AIX || ! defined(MAXSHORT) /* { */
/* math.h includes values.h which defines these under AIX */
#define MAXINT		(int) 2147483647	/* 2 ^ 31 - 1 */
#define MAXSHORT	(short) 32767		/* 2 ^ 15 - 1 */
#endif /* } */

#define MININT 		(int) -2147483647	/* - (2 ^ 31 - 1) */
#define MINSHORT 	(short) -32767		/* - (2 ^ 15 - 1) */

#define MAXUINT		(u_int) 4294967295	/* 2 ^ 32 - 1 */
#define MAXUSHORT	(u_short) 65535		/* 2 ^ 16 - 1 */

#endif /* stuff_h */
