#include "sumachine.h"

#include <sys/types.h>
#include <time.h>		/* not sys/time.h */
#include <stdio.h>

#include "untime.h"

extern int UnTimeFindMonth();

/*
 * Offsets into the ctime string to various parts.
 */

#define	E_MONTH		4
#define	E_DAY		8
#define	E_HOUR		11
#define	E_MINUTE	14
#define	E_SECOND	17
#define	E_YEAR		20

/*
 * Convert a ctime(3) format string into a system format date.
 * Return the date thus calculated.
 *
 * Return -1 if the string is not in ctime format.
 */

time_t 
UnCtime(str)
char *str;
{
	struct tm then;
	int len, month;
	char dbuf[30];

	if ((len = strlen(str)) != 24 && len != 25) 
	    return (-1);
	strcpy(dbuf, str);

	dbuf[E_YEAR+4] = '\0';
	dbuf[E_MONTH+3] = '\0';
	dbuf[E_DAY+2] = '\0';
	dbuf[E_HOUR+2] = '\0';
	dbuf[E_MINUTE+2] = '\0';
	dbuf[E_SECOND+2] = '\0';

	if (UnTimeFindMonth(&dbuf[E_MONTH], &month) < 0)
	    return(-1);

	then.tm_year = atoi(&dbuf[E_YEAR]) - 1900;
	then.tm_mon = month;
	then.tm_mday = atoi(&dbuf[E_DAY]);
	then.tm_hour = atoi(&dbuf[E_HOUR]);
	then.tm_min = atoi(&dbuf[E_MINUTE]);
	then.tm_sec = atoi(&dbuf[E_SECOND]);

	return (UnLocalTime(&then));
}
