#include "internal.h"	/* before sumachine.h */
#include "sumachine.h"

static char RCS[] = "sumachine ($Revision: 1.1.1.1 $)";	/* to prevent a complete #ifdef */

#if OPSYS_TYPE == MD_UNIX /* { */
#include <sys/param.h>

#include <sys/stat.h>
#include <sys/file.h>

#if OPSYS_MFR == MD_MASSCOMP || \
    OPSYS_SUBTYPE == MD_HPUX /* { */
#include <ndir.h>
#else /* } else { */
#include <sys/dir.h>
#endif /* } */

#if (OPSYS_SUBTYPE == MD_AIX && OPSYS_VERS <= MD_AIX_2_2) /* { */
DIR *
opendir(name)
char *name;
{
	DIR *dir;
	struct stat statbuf;

	if (stat(name, &statbuf) < 0)
	    return (NULL);

	if ((statbuf.st_mode & S_IFMT) != S_IFDIR)
	    return (NULL);

	if ((dir = (DIR *) malloc(sizeof (DIR))) == NULL)
	    return (NULL);

	if ((dir->fd = open(name, 0)) < 0) {
	    free(dir);
	    return (NULL);
	}

	return (dir);
}

struct direct *
readdir(dir)
DIR *dir;
{
	if (read(dir->fd, &dir->buf, sizeof (dir->buf)) != sizeof (dir->buf))
	    return (NULL);
	
	return (&dir->buf);
}

long
telldir(dir)
DIR *dir;
{
	return (lseek(dir->fd, /* offset */ 0, L_INCR));
}

void
seekdir(dir, place)
DIR *dir;
long place;	/* as returned by telldir */
{
	lseek(dir->fd, place, L_SET);
}

void
closedir(dir)
DIR *dir;
{
	close(dir->fd);
	free(dir);
}
#endif /* } */
#endif /* } */
