#!/bin/sh

#
#    display.sh
#
usage="display.sh";

if [ $# != 0 ] ; then
    echo "usage: $usage" 1>&2 ;
    exit 1
fi ;

#
#    IBM AIX (AIX 2.2.1 at least) has a fancy C compiler which parameterizes
#    the predefined symbols in /lib/cpp via the file /etc/cc.cfg  This file
#    is examined by cc before it invokes /lib/cpp.  This means that just
#    running /lib/cpp is not sufficient to get the predefined symbols.  You
#    must run cc -E to get /lib/cpp run with the correct symbols defined.
#
#    cc -E must be run with a file - it will not read from stdin.
#    cc -E file.c must be run
#

#
#    Both of these options can be run as
#
#    $cpp file.c | sed ... etc ...
#
#cpp=/lib/cpp 
cpp='cc -E' ;

#
#    Must use a .c suffix file here b/c otherwise the C compiler
#    will think that this is a binary file and will try to /bin/ld it!
#
tmp=/tmp/su$$.c	# a temporary file with a .c suffix

cat sumachine.h - << done | sed -e '
/^ \*.*\$Revision: / {
	s/.*\(Revision: .*\)  *\$.*/#define SUMACHINE_VERSION \1/
	H
	d
}
/^ \*.*\$Date: / {
	s/.*\(Date: .*\)  *\$.*/#define SUMACHINE_DATE \1/
	H
	d
}
/^SUMACHINE-DUMPOUT/ {
    x
    p
}
/^#define MD_/ d
/^#define CPU_/ {
    /^#define CPU_MODEL/ !{
	/^#define CPU_TYPE/ !{
	    /^#define SUMACHINE/ !d
	}
    }
}
' > $tmp ;
SUMACHINE-DUMPOUT
RECOVER-AFTER-HERE
    The \`\`sumachine'' Portability Package
implements a \`\`Standard Unix Machine'' environment

Sumachine Package
    Version:            SUMACHINE_VERSION
    Last Modified:      SUMACHINE_DATE

Operating System
    Type
        OPSYS_/**/TYPE =    OPSYS_TYPE
    Subtype
        OPSYS_/**/SUBTYPE = OPSYS_SUBTYPE
    Manufacturer
        OPSYS_/**/MFR =     OPSYS_MFR
    Version
        OPSYS_/**/VERS =    OPSYS_VERS

Processor
    Architecture
        CPU_/**/TYPE =      CPU_TYPE
    Model
        CPU_/**/MODEL =     CPU_MODEL
                (this need not be entirely accurate)
done

#
#    Recover the stuff in the tmpfile
#
#    -Ddisplay_sh - tell sumachine.h no to fully activate all defines
#        this allows the sed script to report symbolic values back instead
#        of the numbers that the C compiler sees - much nicer for humans
#
$cpp -Ddisplay_sh $tmp | sed -e '
1,/RECOVER-AFTER-HERE/ d
'

rm $tmp
