#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLBoxof - box-of
 *
 *    (box-of object)
 *
 *    return the box
 */
LLobject *
OLBoxof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_BOX_MASK, "box-of", "OCT-BOX", "box", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (box-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_BOX) {
	    LLErrorF("\
Function: (box-of object)\n\
\tobject must be an OCT-BOX\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (OLMakeBox(o.contents.box));
}
