#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLBox - box
 *
 *    (box lowerLeft upperRight)
 *
 *    return the box
 */
LLobject *
OLBox(lowerLeft, upperRight)
LLobject *lowerLeft;
LLobject *upperRight;
{
	struct octBox box;

	if ( ! OL_pointp(lowerLeft) || ! OL_pointp(upperRight) ) {
	    LLErrorF("\
Function: (box lowerLeft upperRight)\n\
\tthe lowerLeft and upperRight must both be points\n\
\tlowerLeft:  ~S\n\
\tupperRight: ~S\n\
", lowerLeft, upperRight);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractPoint(lowerLeft, &box.lowerLeft);
	OLExtractPoint(upperRight, &box.upperRight);

	return (OLMakeBox(box));
}
