#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

void
OLExtractBox(obj, box)
LLobject *obj;
struct octBox *box;	/* return */
{
	LLobject *car, *cdr;

	/*
	 *    A cons-like formation of two points.
	 *
	 *    (box point point)
         *
	 *    car->value.a_userDefined.value[0] = lowerLeft.x
	 *    car->value.a_userDefined.value[1] = lowerLeft.y
	 *    cdr->value.a_userDefined.value[0] = upperRight.x
	 *    cdr->value.a_userDefined.value[1] = upperRight.y
	 *
	 *    obj->value.a_userDefined.value[1] == car;
	 *    obj->value.a_userDefined.value[1] == cdr;
	 */
	car = (LLobject *) obj->value.a_userDefined.value[0];
	cdr = (LLobject *) obj->value.a_userDefined.value[1];

	box->lowerLeft.x = car->value.a_userDefined.value[0];
	box->lowerLeft.y = car->value.a_userDefined.value[1];
	box->upperRight.x = cdr->value.a_userDefined.value[0];
	box->upperRight.y = cdr->value.a_userDefined.value[1];
}

LLobject *
OLMakeBox(box)
struct octBox box;
{
	LLobject *new;

	new = LLMakeObject();
	new->type = OLBoxCell;
	new->type->count++;

	/* in case of throw below */
	new->value.a_userDefined.value[0] = (FitAny) LL_nil;
	new->value.a_userDefined.value[1] = (FitAny) LL_nil;

	new->value.a_userDefined.value[0] = (FitAny) OLMakePoint(box.lowerLeft);
	new->value.a_userDefined.value[1] = (FitAny) OLMakePoint(box.upperRight);

	return (new);
}

void
OL_Pr_Box(obj, stream)
LLobject *obj;
STREAM *stream;
{
	LLFormatC(stream, "{ ~S, ~S }",
		(LLobject *) obj->value.a_userDefined.value[0],
		(LLobject *) obj->value.a_userDefined.value[1]);
}

void
OL_Pr_Box1(obj, stream)
LLobject *obj;
STREAM *stream;
{
	LLFormatC(stream, "(box ~S ~S)",
		(LLobject *) obj->value.a_userDefined.value[0],
		(LLobject *) obj->value.a_userDefined.value[1]);
}

LLobject *
OL_GcScan_Box(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}

void
OL_GcReScan_Box(new, relocate)
LLobject *new;
LLobject *(*relocate)();
{
	new->value.a_userDefined.value[0] = (FitAny) (*relocate)(new->value.a_userDefined.value[0]);
	new->value.a_userDefined.value[1] = (FitAny) (*relocate)(new->value.a_userDefined.value[1]);
}
