#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLCellof - cell-of
 *
 *    (cell-of object)
 *
 *    return the cell
 */
LLobject *
OLCellof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_FACET_MASK, "cell-of", "OCT-FACET", "cell", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (cell-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_FACET) {
	    LLErrorF("\
Function: (cell-of object)\n\
\tobject must be an OCT-FACET\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (LLMakeString(o.contents.facet.cell));
}
