#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLCopyfacet - copyfacet
 *
 *    (copy-facet new-form old-form)
 *
 *    return {t, nil} on {success, fail}
 */
LLobject *
OLCopyfacet(new_form, old_form)
LLobject *new_form;
LLobject *old_form;
{
	struct octPoint *unused;
	int nunused;
	octObject n, o;

	if (( ! OL_objectp(new_form) && ! OL_object_formp(new_form) ) ||
	    ( ! OL_objectp(old_form) && ! OL_object_formp(old_form) )) {
	    LLErrorF("\
Function: (copy-facet new-form old-form)\n\
\tnew-form and old-form must both be either an object-form or an object\n\
\tnew-form: ~S\n\
\told-form: ~S\n\
", new_form, old_form);
	    LLThrow(OL_octlisp, LL_nil);
	}
	OLObjectForm(new_form, &n, &nunused, &unused);
	OLObjectForm(old_form, &o, &nunused, &unused);

	OLGlobalOctStatus = octCopyFacet(&n, &o);
	return (OLGlobalOctStatus < OCT_OK ? LL_nil: new_form);
}
