#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLEndingangleof - endingAngle-of
 *
 *    (endingAngle-of object)
 *
 *    return the endingAngle
 */
LLobject *
OLEndingangleof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_CIRCLE_MASK, "endingAngle-of", "OCT-CIRCLE", "endingAngle", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (endingAngle-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_CIRCLE) {
	    LLErrorF("\
Function: (endingAngle-of object)\n\
\tobject must be an OCT-CIRCLE\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (LLMakeInteger(o.contents.circle.endingAngle));
}

/*
 *    OLStartingangleof - startingAngle-of
 *
 *    (startingAngle-of object)
 *
 *    return the startingAngle
 */
LLobject *
OLStartingangleof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_CIRCLE_MASK, "startingAngle-of", "OCT-CIRCLE", "startingAngle", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (startingAngle-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_CIRCLE) {
	    LLErrorF("\
Function: (startingAngle-of object)\n\
\tobject must be an OCT-CIRCLE\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (LLMakeInteger(o.contents.circle.startingAngle));
}
