#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLFacetof - facet-of
 *
 *    (facet-of object)
 *
 *    return the facet
 */
LLobject *
OLFacetof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_FACET_MASK, "facet-of", "OCT-FACET", "facet", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (facet-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	switch (o.type) {
	case OCT_FACET:
	    return (LLMakeString(o.contents.facet.facet));
	default:
	    LLErrorF("\
Function: (facet-of object)\n\
\tobject must be an OCT-FACET\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}
	/*NOTREACHED*/
}
