#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLFreegenerator - free-generator
 *
 *    (free-generator generator)
 *
 *    return {t, nil}
 */
LLobject *
OLFreegenerator(generator)
LLobject *generator;
{
	octGenerator g;

	if ( ! OL_generatorp(generator) ) {
	    LLErrorF("\
Function: (free-generator generator)\n\
\tgenerator is not a generator\n\
\tgenerator: ~S\n\
", generator);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractGenerator(generator, &g);

	OLGlobalOctStatus = octFreeGenerator(&g);
	generator->type->count--;
	generator->type = LLDeadCell;
	generator->type->count++;

	return (OLGlobalOctStatus < OCT_OK ? LL_nil: LL_t);
}
