#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

typedef enum func_op func_op;
enum func_op {
    gen_first_container,
    gen_first_content,
};

static LLobject *func();

/*
 *    OLGenfirstcontainer - gen-first-container
 *
 *    (gen-first-container content mask)
 *
 *    return the {object, nil} on {success, fail}
 */
LLobject *
OLGenfirstcontainer(content, mask)
LLobject *content;
LLobject *mask;
{
	return (func(content, mask, "gen-first-container", "content", gen_first_container));
}

/*
 *    OLGenfirstcontent - gen-first-contant
 *
 *    (init-gen-contents container mask)
 *
 *    return the {object, nil} on {success, fail}
 */
LLobject *
OLGenfirstcontent(container, mask)
LLobject *container;
LLobject *mask;
{
	return (func(container, mask, "gen-first-content", "containner", gen_first_content));
}

static LLobject *
func(container, mask, name, container_name, op)
LLobject *container;
LLobject *mask;
String name;
String container_name;
func_op op;
{
	octObject c, f;
	octObjectMask m;

	if ( ! OL_objectp(container) ) {
	    LLErrorF("\
Function: (~A ~A mask)\n\
\t~A is not an object\n\
\t~A: ~S\n\
\tmask:      ~S\n\
", name, container_name, container_name, container_name, container, mask);
	    LLThrow(OL_octlisp, LL_nil);
	}
	if ( ! OL_object_maskp(mask) ) {
	    LLErrorF("\
Function: (~A ~A mask)\n\
\tmask is not an object-mask\n\
\t~A: ~S\n\
\tmask:      ~S\n\
", name, container_name, container_name, container, mask);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(container, &c);
	OLExtractObjectMask(mask, &m);

	if (op == gen_first_container) {
	    OLGlobalOctStatus = octGenFirstContainer(&c, m, &f);
	} else {
	    OLGlobalOctStatus = octGenFirstContent(&c, m, &f);
	}

	return (OLGlobalOctStatus != OCT_OK ? LL_nil: OLMakeObject(f));
}
