#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLGenerate - generate
 *
 *    (generate generator)
 *
 *    return {t, nil}
 */
LLobject *
OLGenerate(generator)
LLobject *generator;
{
	octGenerator g;
	octObject o;

	if ( ! OL_generatorp(generator) ) {
	    LLErrorF("\
Function: (generate generator)\n\
\tgenerator is not a generator\n\
\tgenerator: ~S\n\
", generator);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractGenerator(generator, &g);

	OLGlobalOctStatus = octGenerate(&g, &o);

	return (OLGlobalOctStatus < OCT_OK || OLGlobalOctStatus == OCT_GEN_DONE ? LL_nil: OLMakeObject(o));
}
