#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

void
OLExtractGenerator(obj, generator)
LLobject *obj;
octGenerator *generator;	/* return */
{
	LLobject *one, *two;

	/*
	 *    A string of two userDefined.
	 *
	 *    one->value.a_userDefined.value[0] = generator_func
	 *    two->value.a_userDefined.value[0] = state
	 *    two->value.a_userDefined.value[1] = free_func
	 *
	 *    one->value.a_userDefined.value[1] === two;
	 */
	one = obj;
	two = (LLobject *) one->value.a_userDefined.value[1];

	/* WATCHOUT - this must match the structure of the octGenerator */
	generator->generator_func = (octStatus (*)()) one->value.a_userDefined.value[0];
	generator->state = (char *) two->value.a_userDefined.value[0];
	generator->free_func = (octStatus (*)()) two->value.a_userDefined.value[1];
}

LLobject *
OLMakeGenerator(generator)
octGenerator generator;
{
	LLobject *new, *new2;

	new = LLMakeObject();
	new->type = OLGeneratorCell;
	new->type->count++;

	/* in case of throw below */
	new->value.a_userDefined.value[0] = (FitAny) LL_nil;
	new->value.a_userDefined.value[1] = (FitAny) LL_nil;

	new2 = LLMakeObject();
	new2->type = OLGenerator2Cell;
	new2->type->count++;

	/* in case of throw below */
	new2->value.a_userDefined.value[0] = (FitAny) LL_nil;
	new2->value.a_userDefined.value[1] = (FitAny) LL_nil;

	new->value.a_userDefined.value[0] = (FitAny) generator.generator_func;
	new->value.a_userDefined.value[1] = (FitAny) new2;
	new2->value.a_userDefined.value[0] = (FitAny) generator.state;
	new2->value.a_userDefined.value[1] = (FitAny) generator.free_func;

	return (new);
}

void
OL_Pr_Generator(obj, stream)
LLobject *obj;
STREAM *stream;
{
	octGenerator g;

	OLExtractGenerator(obj, &g);
	LLFormatC(stream, "<generator ~X>", (int) g.state);
}

LLobject *
OL_GcScan_Generator(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}

void
OL_GcReScan_Generator(new, relocate)
LLobject *new;
LLobject *(*relocate)();
{
	new->value.a_userDefined.value[1] = (FitAny) (*relocate)(new->value.a_userDefined.value[1]);
}

LLobject *
OL_GcScan_Generator2(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}
