#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLGetfacet - get-facet
 *
 *    (get-facet object)
 *
 *    return {facet, nil} on {success, fail}
 */
LLobject *
OLGetfacet(object)
LLobject *object;
{
	octObject o, f;

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (get-facet object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);
	octGetFacet(&o, &f);

	return (OLMakeObject(f));
}
