
#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLGetname - get-name
 *
 *    (get-name object)
 *
 *    return {string, nil} on {success, fail}
 */
LLobject *
OLGetname(object)
LLobject *object;
{
	octObject o;
	String s;

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (get-name object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);
	s = octhGetName(&o);

	return (s == NULL ? LL_nil: LLMakeString(s));
}
