#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLInnerradiusof - innerRadius-of
 *
 *    (innerRadius-of object)
 *
 *    return the innerRadius
 */
LLobject *
OLInnerradiusof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_CIRCLE_MASK, "innerRadius-of", "OCT-CIRCLE", "innerRadius", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (innerRadius-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_CIRCLE) {
	    LLErrorF("\
Function: (innerRadius-of object)\n\
\tobject must be an OCT-CIRCLE\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (LLMakeInteger(o.contents.circle.innerRadius));
}

/*
 *    OLOuterradiusof - outerRadius-of
 *
 *    (outerRadius-of object)
 *
 *    return the outerRadius
 */
LLobject *
OLOuterradiusof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_CIRCLE_MASK, "outerRadius-of", "OCT-CIRCLE", "outerRadius", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (outerRadius-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_CIRCLE) {
	    LLErrorF("\
Function: (outerRadius-of object)\n\
\tobject must be an OCT-CIRCLE\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (LLMakeInteger(o.contents.circle.outerRadius));
}
