#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLInstanceof - instance-of
 *
 *    (instance-of object)
 *
 *    return the instance
 */
LLobject *
OLInstanceof(object)
LLobject *object;
{
	octObject o, i;
	LLobject *ret;

	if (OLOfForm(object, OCT_TERM_MASK, "instance-of", "OCT-TERM", "instance", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (instance-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_TERM) {
	    LLErrorF("\
Function: (instance-of object)\n\
\tobject must be an OCT-TERM\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	i.objectId = o.contents.term.instanceId;
	if (o.contents.term.instanceId == oct_null_id || octGetById(&i) < OCT_OK)
	    return (LLGetValue(LLMakeSymbol("oct-null-id"), LL_valueSlot, LL_environment));

	return (OLMakeObject(i));
}
