#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLLabelof - label-of
 *
 *    (label-of object)
 *
 *    return the label
 */
LLobject *
OLLabelof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_LABEL_MASK, "label-of", "OCT-LABEL", "label", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (label-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_LABEL) {
	    LLErrorF("\
Function: (label-of object)\n\
\tobject must be an OCT-LABEL\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (LLMakeString(o.contents.label.label));
}

#if ! defined(OCT_JUST_RIGHT) /* { */
/* oct 1.0 */
/*
 *    OLPositionof - position-of
 *
 *    (position-of object)
 *
 *    return the position
 */
LLobject *
OLPositionof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_LABEL_MASK, "position-of", "OCT-LABEL", "position", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (position-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_LABEL) {
	    LLErrorF("\
Function: (position-of object)\n\
\tobject must be an OCT-LABEL\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	return (OLMakePoint(o.contents.label.position));
}
#endif /* } */
