#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

typedef enum func_op func_op;
enum func_op {
    lowerLeft_of,
    upperRight_of,
};

static LLobject *func();

/*
 *    OLLowerleftof - lowerLeft-of
 *
 *    (lowerLeft-of box)
 *
 *    return the point
 */
LLobject *
OLLowerleftof(box)
LLobject *box;
{
	return (func(box, "lowerLeft-of", lowerLeft_of));
}

/*
 *    OLUpperrightof - upperRight-of
 *
 *    (upperRight-of box)
 *
 *    return the point
 */
LLobject *
OLUpperrightof(box)
LLobject *box;
{
	return (func(box, "upperRight-of", upperRight_of));
}

static LLobject *
func(box, name, op)
LLobject *box;
String name;
func_op op;
{
	struct octBox b;

	if ( ! OL_boxp(box) ) {
	    LLErrorF("\
Function: (~A box)\n\
\tbox must be a box\n\
\tbox: ~S\n\
", name, box);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractBox(box, &b);
	return (OLMakePoint(op == lowerLeft_of ? b.lowerLeft: b.upperRight));
}
