#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLMaskmember - mask-member
 *
 *    (mask-member mask-or-type mask)
 *
 *    return t or nil
 */
LLobject *
OLMaskmember(mask_or_type, mask)
LLobject *mask_or_type;
LLobject *mask;
{
	octObjectMask om, tom;
	int /* octType */ tot;
	int /* octTransformMask */ tm, ttm;
	octTransformType ttt;

	if (OL_object_maskp(mask)) {
	    OLExtractObjectMask(mask, &om);
	    if (OL_object_maskp(mask_or_type)) {
		OLExtractObjectMask(mask_or_type, &tom);

		return (OLMakeObjectMask(om & tom));
	    } else if (OL_object_typep(mask_or_type)) {
		OLExtractObjectType(mask_or_type, &tot);

		return (OLMakeObjectMask(om & (1<<(int) tot)));
	    }

	    LLErrorF("\
Function: (mask-member mask-or-type mask)\n\
\tmask-or-type is not an object-mask or a object-mask\n\
\tmask-or-type: ~S\n\
\tmask:         ~S\n\
", mask_or_type, mask);
	    LLThrow(OL_octlisp, LL_nil);
	} else if (OL_transform_maskp(mask)) {
	    OLExtractTransformMask(mask, &tm);

	    if (OL_transform_maskp(mask_or_type)) {
		OLExtractTransformMask(mask_or_type, &ttm);

		return (OLMakeTransformMask(tm & ttm));
	    } else if (OL_transform_typep(mask_or_type)) {
		OLExtractTransformType(mask_or_type, &ttt);

		return (OLMakeObjectMask(om & (1<<(int) ttt)));
	    }

	    LLErrorF("\
Function: (mask-member mask-or-type mask)\n\
\tmask-or-type is not an transform-mask or a transform-mask\n\
\tmask-or-type: ~S\n\
\tmask:         ~S\n\
", mask_or_type, mask);
	    LLThrow(OL_octlisp, LL_nil);
	}

	LLErrorF("\
Function: (mask-member mask-or-type mask)\n\
\tmask is not an object-mask or a transform-mask\n\
\tmask-or-type: ~S\n\
\tmask:         ~S\n\
", mask_or_type, mask);
	LLThrow(OL_octlisp, LL_nil);

	/*NOTREACHED*/
}
