#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLModeof - mode-of
 *
 *    (mode-of object)
 *
 *    return the mode
 */
LLobject *
OLModeof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_FACET_MASK|OCT_INSTANCE_MASK, "mode-of", "OCT-FACET or OCT-INSTANCE", "mode", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (mode-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_FACET) {
	    LLErrorF("\
Function: (mode-of object)\n\
\tobject must be an OCT-FACET\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	if (strequal(o.contents.facet.mode, "r")) {
	    return (LLMakeSymbol(OLReadonly));
	} else if (strequal(o.contents.facet.mode, "w")) {
	    return (LLMakeSymbol(OLReadwrite));
	} else if (strequal(o.contents.facet.mode, "a")) {
	    return (LLMakeSymbol(OLReadwriteappend));
	} else {
	    LLErrorF("\
Function: (mode-of object)\n\
\tbadly formed facet - invalid mode field - ~A\n\
\tobject: ~S\n\
", o.contents.facet.mode, object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	/*NOTREACHED*/
}
