#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLNameof - name-of
 *
 *    (name-of object)
 *
 *    return the name
 */
LLobject *
OLNameof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;
#define NAME_MASKS	OCT_BAG_MASK|OCT_INSTANCE_MASK|OCT_LAYER_MASK|OCT_NET_MASK|OCT_PROP_MASK|OCT_TERM_MASK
#define NAME_MASKS_string	"OCT-BAG, OCT-INSTANCE, OCT-LAYER, OCT-NET, OCT-PROP, or OCT-TERM"

	if (OLOfForm(object, NAME_MASKS, "name-of", NAME_MASKS_string, "name", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (name-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	switch (o.type) {
	case OCT_BAG:
	    return (LLMakeString(o.contents.bag.name));
	case OCT_INSTANCE:
	    return (LLMakeString(o.contents.instance.name));
	case OCT_LAYER:
	    return (LLMakeString(o.contents.layer.name));
	case OCT_NET:
	    return (LLMakeString(o.contents.net.name));
	case OCT_PROP:
	    return (LLMakeString(o.contents.prop.name));
	case OCT_TERM:
	    return (LLMakeString(o.contents.term.name));
	default:
	    LLErrorF("\
Function: (name-of object)\n\
\tobject must be an OCT-BAG, OCT-INSTANCE, OCT-LAYER, OCT-NET, OCT-PROP, or OCT-TERM\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}
	/*NOTREACHED*/
}
