#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

void
OLExtractObjectType(obj, type)
LLobject *obj;
int /* octType */ *type;	/* return */
{
	/*
	 *    A userDefined.
	 *
	 *    obj->value.a_userDefined.value[0] = octType
	 */

	*type = (int) /* octType */ obj->value.a_userDefined.value[0];
}

LLobject *
OLMakeObjectType(type)
int /* octType */ type;
{
	LLobject *new;

	if ( ! LL_null(OLMachine.object_types[(int) type - OL_OTYPE_LOW]) )
	    return (OLMachine.object_types[(int) type - OL_OTYPE_LOW]);

	new = LLMakeObject();
	new->type = OLObjectTypeCell;
	new->type->count++;

	/* in case of throw below */
	new->value.a_userDefined.value[0] = (FitAny) type;

	OLMachine.object_types[(int) type - OL_OTYPE_LOW] = new;

	return (new);
}

static String map[] = {
    "OCT-FACET",
    "OCT-TERM",
    "OCT-NET",
    "OCT-INSTANCE",
    "OCT-POLYGON",
    "OCT-BOX",
    "OCT-CIRCLE",
    "OCT-PATH",
    "OCT-LABEL",
    "OCT-PROP",
    "OCT-BAG",
    "OCT-LAYER",
    "OCT-POINT",
    "OCT-EDGE",
};

void
OL_Pr_ObjectType(obj, stream)
LLobject *obj;
STREAM *stream;
{
	int /* octType */ t;

	OLExtractObjectType(obj, &t);

	LLFormatC(stream, "~A", map[(int) t - OL_OTYPE_LOW]);
}

LLobject *
OL_GcScan_ObjectType(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}
