#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

void
OLExtractOctStatus(obj, status)
LLobject *obj;
octStatus *status;	/* return */
{
	/*
	 *    A userDefined.
	 *
	 *    obj->value.a_userDefined.value[0] = status
	 */

	*status = (octStatus) obj->value.a_userDefined.value[0];
}

LLobject *
OLMakeOctStatus(status)
octStatus status;
{
	LLobject *new;

	if ( ! LL_null(OLMachine.stati[(int) status - OL_STATUS_LOW]) )
	    return (OLMachine.stati[(int) status - OL_STATUS_LOW]);

	new = LLMakeObject();
	new->type = OLOctStatusCell;
	new->type->count++;

	/* in case of throw below */
	new->value.a_userDefined.value[0] = (FitAny) status;

	OLMachine.stati[(int) status - OL_STATUS_LOW] = new;

	return (new);
}

static String map[] = {
    "OCT-NO-BB",
    "OCT-ILL-OP",
    "OCT-TOO-SMALL",
    "OCT-NOT-FOUND",
    "OCT-CORRUPTED-OBJECT",
    "OCT-NO-PERM",
    "OCT-NO-EXIST",
    "OCT-ERROR",
    "no-code",	/* this error code (zero) does not exist */
    "OCT-OK",
    "OCT-NEW-FACET",
    "OCT-OLD-FACET",
    "OCT-GEN-DONE",
    "OCT-ALREADY-OPEN",
    "OCT-NOT-ATTACHED",
    "OCT-ALREADY-ATTACHED",
};

void
OL_Pr_OctStatus(obj, stream)
LLobject *obj;
STREAM *stream;
{
	octStatus s;

	OLExtractOctStatus(obj, &s);

	LLFormatC(stream, "~A", map[(int) s - OL_STATUS_LOW]);
}

LLobject *
OL_GcScan_OctStatus(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}
