#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLOfForm - is this an object-form of the appropriate type?
 *
 *    return {OL_ok, OL_notok} on {is-object-form (and correct type), not object-form}
 */
OLstatus
OLOfForm(object_form, mask, name, mask_name, key_name, ret)
LLobject *object_form;
octObjectMask mask;
String name;		/* "box-of" */
String mask_name;	/* "OCT-BOX, OCT-POLYGON, or OCT-CIRCLE" */
String key_name;	/* "box" */
LLobject **ret;	/* return */
{
	int /* octType */ type;
	LLobject *key_value;

	if ( ! OL_object_formp(object_form) )
	    return (OL_notok);

	OLExtractObjectType(LL_second(object_form), &type);

	if (((1<<type) & mask) == 0x0) {
	    LLErrorF("\
Function: (~A object)\n\
\tobject-form must be of an ~A\n\
\tobject-form: ~S\n\
", name, mask_name, object_form);
	    LLThrow(OL_octlisp, LL_nil);
	}

	key_value = LLAssoc(LLMakeSymbol(key_name), LLThird(object_form));
	if (LL_null(key_value)) {
	    LLErrorF("\
Function: (~A object)\n\
\tobject-form must contain the key ~A\n\
\tobject-form: ~S\n\
", name, key_name, object_form);
	    LLThrow(OL_octlisp, LL_nil);
	}

	*ret = LL_cdr(key_value);
	return (OL_ok);
}
