#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLOpenfacet - open-facet
 *
 *    (open-facet facet-form mode)
 *
 *    return {facet, nil} on {success, fail}
 */
LLobject *
OLOpenfacet(facet_form, mode)
LLobject *facet_form;
LLobject *mode;
{
	struct octPoint *unused;
	int nunused;
	octObject f;

	if ( ! OL_objectp(facet_form) && ! OL_object_formp(facet_form) ) {
	    LLErrorF("\
Function: (open-facet facet-form mode)\n\
\tfacet-form must be an object or object-form\n\
\tfacet-form: ~S\n\
\tmode:       ~S\n\
", facet_form, mode);
	    LLThrow(OL_octlisp, LL_nil);
	}
	if ( ! LL_symbolp(mode) ||
		(LL_pname(mode) != OLReadonly &&
		 LL_pname(mode) != OLReadwrite &&
		 LL_pname(mode) != OLReadwriteappend) ) {
	    LLErrorF("\
Function: (open-facet facet-form mode)\n\
\tmode must be a symbol :readonly :readwrite or :readwrite-append\n\
\tfacet-form: ~S\n\
\tmode:       ~S\n\
", facet_form, mode);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLObjectForm(facet_form, &f, &nunused, &unused);

	if (LL_pname(mode) == OLReadonly)
	    f.contents.facet.mode = "r";
	else if (LL_pname(mode) == OLReadwrite)
	    f.contents.facet.mode = "w";
	else if (LL_pname(mode) == OLReadwriteappend)
	    f.contents.facet.mode = "a";

	OLGlobalOctStatus = octOpenFacet(&f);
	return (OLGlobalOctStatus < OCT_OK ? LL_nil: OLMakeObject(f));
}
