#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLPoint - point
 *
 *    (point lowerLeft upperRight)
 *
 *    return the point
 */
LLobject *
OLPoint(x, y)
LLobject *x;
LLobject *y;
{
	struct octPoint point;

	if ( ! LL_integerp(x) || ! LL_integerp(y) ) {
	    LLErrorF("\
Function: (point x y)\n\
\tthe x and y must both be integers\n\
\tx: ~S\n\
\ty: ~S\n\
", x, y);
	    LLThrow(OL_octlisp, LL_nil);
	}

	point.x = x->value.a_integer;
	point.y = y->value.a_integer;
	return (OLMakePoint(point));
}
