#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

void
OLExtractPoint(obj, point)
LLobject *obj;
struct octPoint *point;	/* return */
{
	/*
	 *    A userDefined.
	 *
	 *    obj->value.a_userDefined.value[0] = x
	 *    obj->value.a_userDefined.value[1] = y
	 */
	point->x = obj->value.a_userDefined.value[0];
	point->y = obj->value.a_userDefined.value[1];
}

LLobject *
OLMakePoint(point)
struct octPoint point;
{
	LLobject *new;

	new = LLMakeObject();
	new->type = OLPointCell;
	new->type->count++;

	/* in case of throw below */
	new->value.a_userDefined.value[0] = (FitAny) point.x;
	new->value.a_userDefined.value[1] = (FitAny) point.y;

	return (new);
}

void
OL_Pr_Point(obj, stream)
LLobject *obj;
STREAM *stream;
{
	struct octPoint p;

	OLExtractPoint(obj, &p);
	LLFormatC(stream, "(~D, ~D)", p.x, p.y);
}

void
OL_Pr_Point1(obj, stream)
LLobject *obj;
STREAM *stream;
{
	struct octPoint p;

	OLExtractPoint(obj, &p);
	LLFormatC(stream, "(point ~D ~D)", p.x, p.y);
}

LLobject *
OL_GcScan_Point(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}
