#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLPointsof - points-of
 *
 *    (points-of object)
 *
 *    return the id
 */
LLobject *
OLPointsof(object)
LLobject *object;
{
	struct octPoint *p;
	int np;
	octObject o;
	int i;
	LLobject *ret, *list, *last, *tmp;

	if (OLOfForm(object, OCT_PATH_MASK|OCT_POLYGON_MASK, "points-of", "OCT-PATH or OCT-POLYGON", "points", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (points-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	if (o.type != OCT_PATH || o.type != OCT_POLYGON) {
	    LLErrorF("\
Function: (points-of object)\n\
\tobject must be an OCT-PATH or OCT-POLYGON\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	if (OLGetPoints(&o, &np, &p) < OCT_OK) {
	    LLErrorF("\
Function: (points-of object)\n\
\t~S\n\
\tobject: ~S\n\
", octErrorString(), object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	list = LL_nil;
	for (i=0; i<np; i++) {
	    tmp = LLCons(OLMakePoint(p[i]), LL_nil);
	    if (LL_null(list))
		list = tmp;
	    else
		LL_rplacd(last, tmp);
	    last = tmp;
	}

	return (list);
}
