#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLBoxp - boxp
 *
 *    (boxp object)
 *
 *    return {t, nil} on {box, not}
 */
LLobject *
OLBoxp(object)
LLobject *object;
{
	return (OL_boxp(object) ? LL_t: LL_nil);
}

/*
 *    OLGeneratorp - generatorp
 *
 *    (generatorp object)
 *
 *    return {t, nil} on {generator, not}
 */
LLobject *
OLGeneratorp(object)
LLobject *object;
{
	return (OL_generatorp(object) ? LL_t: LL_nil);
}

/*
 *    OLObjectformp - object-formp
 *
 *    (object-form-p object)
 *
 *    return {t, nil} on {object-form, not}
 */
LLobject *
OLObjectformp(object)
LLobject *object;
{
	return (OL_object_formp(object) ? LL_t: LL_nil);
}

/*
 *    OLObjectp - objectp
 *
 *    (objectp object)
 *
 *    return {t, nil} on {object, not}
 */
LLobject *
OLObjectp(object)
LLobject *object;
{
	return (OL_objectp(object) ? LL_t: LL_nil);
}

/*
 *    OLObjectmaskp - object-mask-p
 *
 *    (object-mask-p object)
 *
 *    return {t, nil} on {object-mask, not}
 */
LLobject *
OLObjectmaskp(object)
LLobject *object;
{
	return (OL_object_maskp(object) ? LL_t: LL_nil);
}

/*
 *    OLObjecttypep - object-type-p
 *
 *    (object-type-p object)
 *
 *    return {t, nil} on {object-type, not}
 */
LLobject *
OLObjecttypep(object)
LLobject *object;
{
	return (OL_object_typep(object) ? LL_t: LL_nil);
}

/*
 *    OLOctstatusp - oct-status--p
 *
 *    (oct-status--p object)
 *
 *    return {t, nil} on {oct-status, not}
 */
LLobject *
OLOctstatusp(object)
LLobject *object;
{
	return (OL_oct_statusp(object) ? LL_t: LL_nil);
}

/*
 *    OLPointp - pointp
 *
 *    (pointp object)
 *
 *    return {t, nil} on {point, not}
 */
LLobject *
OLPointp(object)
LLobject *object;
{
	return (OL_pointp(object) ? LL_t: LL_nil);
}

/*
 *    OLPropertytypep - property-type-p
 *
 *    (property-type-p object)
 *
 *    return {t, nil} on {property-type, not}
 */
LLobject *
OLPropertytypep(object)
LLobject *object;
{
	return (OL_property_typep(object) ? LL_t: LL_nil);
}

/*
 *    OLTransformp - transformp
 *
 *    (transformp object)
 *
 *    return {t, nil} on {transform, not}
 */
LLobject *
OLTransformp(object)
LLobject *object;
{
	return (OL_transformp(object) ? LL_t: LL_nil);
}

/*
 *    OLTransformmaskp - transform-mask-p
 *
 *    (transform-mask-p object)
 *
 *    return {t, nil} on {transform-mask, not}
 */
LLobject *
OLTransformmaskp(object)
LLobject *object;
{
	return (OL_transform_maskp(object) ? LL_t: LL_nil);
}

/*
 *    OLTransformtypep - transform-type-p
 *
 *    (transform-type-p object)
 *
 *    return {t, nil} on {transform-type, not}
 */
LLobject *
OLTransformtypep(object)
LLobject *object;
{
	return (OL_transform_typep(object) ? LL_t: LL_nil);
}
