#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

void
OLExtractPropertyType(obj, type)
LLobject *obj;
octPropType *type;	/* return */
{
	/*
	 *    A userDefined.
	 *
	 *    obj->value.a_userDefined.value[0] = octPropType
	 */

	*type = (octPropType) obj->value.a_userDefined.value[0];
}

LLobject *
OLMakePropertyType(type)
octPropType type;
{
	LLobject *new;

	if ( ! LL_null(OLMachine.property_types[(int) type - OL_PTYPE_LOW]) )
	    return (OLMachine.property_types[(int) type - OL_PTYPE_LOW]);

	new = LLMakeObject();
	new->type = OLPropertyTypeCell;
	new->type->count++;

	/* in case of throw below */
	new->value.a_userDefined.value[0] = (FitAny) type;

	OLMachine.property_types[(int) type - OL_PTYPE_LOW] = new;

	return (new);
}

static String map[] = {
    "OCT-NULL",
    "OCT-INTEGER",
    "OCT-REAL",
    "OCT-STRING",
    "OCT-ID",
    "OCT-STRANGER",
    "OCT-REAL-ARRAY",
    "OCT-INTEGER-ARRAY",
};

void
OL_Pr_PropertyType(obj, stream)
LLobject *obj;
STREAM *stream;
{
	octPropType t;

	OLExtractPropertyType(obj, &t);

	LLFormatC(stream, "~A", map[(int) t]);
}

LLobject *
OL_GcScan_PropertyType(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}
