#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

void
OLExtractTransformType(obj, transformType)
LLobject *obj;
octTransformType *transformType;	/* return */
{
	/*
	 *    A userDefined.
	 *
	 *    obj->value.a_userDefined.value[0] = objectId
	 */

	*transformType = (octTransformType) obj->value.a_userDefined.value[0];
}

LLobject *
OLMakeTransformType(transformType)
octTransformType transformType;
{
	LLobject *new;

	if ( ! LL_null(OLMachine.transform_types[(int) transformType - OL_TTYPE_LOW]) )
	    return (OLMachine.transform_types[(int) transformType - OL_TTYPE_LOW]);

	new = LLMakeObject();
	new->type = OLTransformTypeCell;
	new->type->count++;

	/* in case of throw below */
	new->value.a_userDefined.value[0] = (FitAny) transformType;

	OLMachine.transform_types[(int) transformType - OL_TTYPE_LOW] = new;

	return (new);
}


static String map[] = {
    "OCT-NO-TRANSFORM",
    "OCT-MIRROR-X",
    "OCT-MIRROR-Y",
    "OCT-ROT90",
    "OCT-ROT180",
    "OCT-ROT270",
    "OCT-MX-ROT90",
    "OCT-MY-ROT90",
    "OCT-FULL-TRANSFORM",
};

void
OL_Pr_TransformType(obj, stream)
LLobject *obj;
STREAM *stream;
{
	octTransformType t;

	OLExtractTransformType(obj, &t);

	LLFormatC(stream, "~A", map[(int) t - OL_TTYPE_LOW]);
}

LLobject *
OL_GcScan_TransformType(old)
LLobject *old;
{
	LLobject *new;

	new = LLMakeObject();

	new->type = old->type;
	new->value.a_userDefined = old->value.a_userDefined;
	new->type->count++;

	return (new);
}
