#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "oct_helperlib.h"
#include "internal.h"

/*
 *    OLUninitialize - uninitialize OctLisp
 *
 *    return {OL_ok, OL_notok} on {success, fail}
 */
OLstatus
OLUninitialize()
{
	if ( ! OLInitializedP )
	    return (OL_ok);

	if (OL_Octh_Uninitialize() != OL_ok)
	    return (OL_notok);
	if (OL_Help_Uninitialize() != OL_ok)
	    return (OL_notok);

	st_free_table(OLMachine.objects);

	if (LLUninitialize() != LL_ok)
	    return (OL_notok);

	OLInitializedP = FALSE;

	return (OL_ok);
}
