#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLVersionof - version-of
 *
 *    (version-of object)
 *
 *    return the version
 */
LLobject *
OLVersionof(object)
LLobject *object;
{
	octObject o;
	LLobject *ret;

	if (OLOfForm(object, OCT_FACET_MASK|OCT_INSTANCE_MASK, "version-of", "OCT-FACET or OCT-INSTANCE", "version", &ret) == OL_ok)
	    return (ret);

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (version-of object)\n\
\tobject must be an object\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, &o);

	switch (o.type) {
	case OCT_FACET:
	    return (LLMakeString(o.contents.facet.version));
	case OCT_INSTANCE:
	    return (LLMakeString(o.contents.instance.version));
	default:
	    LLErrorF("\
Function: (version-of object)\n\
\tobject must be an OCT-FACET or OCT-INSTANCE\n\
\tobject: ~S\n\
", object);
	    LLThrow(OL_octlisp, LL_nil);
	}
	/*NOTREACHED*/
}
