#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

typedef enum func_op func_op;
enum func_op {
    x_of,
    y_of,
};

static LLobject *func();

/*
 *    OLXof - x-of
 *
 *    (x-of point)
 *
 *    return the coordinate
 */
LLobject *
OLXof(point)
LLobject *point;
{
	return (func(point, "x-of", x_of));
}

/*
 *    OLYof - y-of
 *
 *    (y-of point)
 *
 *    return the coordinate
 */
LLobject *
OLYof(point)
LLobject *point;
{
	return (func(point, "y-of", y_of));
}

static LLobject *
func(point, name, op)
LLobject *point;
String name;
func_op op;
{
	struct octPoint p;

	if ( ! OL_pointp(point) ) {
	    LLErrorF("\
Function: (~A point)\n\
\tpoint must be a point\n\
\tpoint: ~S\n\
", name, point);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractPoint(point, &p);
	return (LLMakeInteger(op == x_of ? p.x: p.y));
}
