#include "sumachine.h"

#include <sys/param.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHCopyFilename - copy a filename up to 16(?) chars
 *
 *    return the string
 */
String
ARCHCopyFilename(string)
String string;
{
	char buf[MAXPATHLEN];
	struct ar_hdr ar;
	String new, after, sub_buf;
	int len, max_length;

	strcpy(buf, string);

#if OPSYS_MFR == MD_SUN && CPU_TYPE == MD_I386 || \
	OPSYS_MFR == MD_APOLLO || \
	OPSYS_SUBTYPE == MD_AIX || \
        OPSYS_SUBTYPE == MD_HPUX || \
        OPSYS_SUBTYPE == MD_SYS5 /* { */
	/*
	 *    If terminated by a slash,
	 *    kill the terminating slash.
	 */
	len = strlen(buf);	/* len >= 0 */
	if (len > 0 && buf[len-1] == '/')
	    buf[len-1] = '\0';
#endif /* } */

	/*
	 *    Take after the directory path
	 *    to get only the filename part.
	 */
	if ((after = rindex(buf, '/')) != NULL) {
	    sub_buf = &after[1];
	} else {
	    sub_buf = buf;
	}
#if OPSYS_MFR == MD_SUN && CPU_TYPE == MD_I386 || \
	OPSYS_MFR == MD_APOLLO || \
	OPSYS_SUBTYPE == MD_AIX || \
        OPSYS_SUBTYPE == MD_HPUX || \
        OPSYS_SUBTYPE == MD_SYS5 /* { */
        /*
         *    Copy one less in order to insure that there is a padding
         *    character at the end of the filename.  This is MANDATORY
         *    for the ar format on these machines
         */
        max_length = sizeof (ar.ar_name)-1;
#else /* } else { */
        /*
         *    Can copy the full size on these machines b/c the ar format
         *    does not require a terminating character.
         */
        max_length = sizeof (ar.ar_name);
#endif /* } */

	/*
	 *    Must be shorter by one for the 
	 *    padding character (a slash or a space)
	 */
	len = strlen(sub_buf);	/* len >= 0 */
	if (len >= max_length);
	    sub_buf[max_length-1] = '\0';

	new = COPY_STRING(sub_buf);
	return (new);
}
