#include "sumachine.h"

#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHExtractTo - extract an archive member to a filename
 *
 *    return {ARCH_ok, ARCH_notok}
 */
ARCHstatus
ARCHExtractTo(arch, index, extract, filename)
ARCHarchive *arch;
int index;
ARCHextract extract;
String filename;
{
	char buf[1024];
	time_t timep[2];
	int fd, sofar, cc, toread;
	ARCHfile *file;

	file = DYNpAt(&arch->files, index, ARCHfile);

	if ((fd = open(filename, O_CREAT|O_TRUNC|O_WRONLY, file->mode & 0777)) < 0)
	    return (ARCHErrno = ARCH_ESEE_ERRNO, ARCH_notok);

	lseek(arch->work_fd, file->offset, L_SET);

	sofar = 0;
	do {
	    toread = MIN(sizeof (buf), file->size - sofar);

	    if ((cc = read(arch->work_fd, buf, toread)) != toread) {
		close(fd);
		return (ARCHErrno = ARCH_ESHORT_TMP, ARCH_notok);
	    }
	    if (cc == 0)
		break;

	    if (write(fd, buf, cc) != cc) {
		close(fd);
		return (ARCHErrno = ARCH_EBAD_WRITE, ARCH_notok);
	    }

	    sofar += cc;
	    if (sofar == file->size)
		break;
	} while (1);

	close(fd);

	if (sofar != file->size)
	    return (ARCHErrno = ARCH_EBAD_WRITE, ARCH_notok);

	timep[0] = file->date;
	timep[1] = file->date;
	if (extract == ARCH_then && utime(filename, timep) < 0)
	    return (ARCHErrno = ARCH_ESEE_ERRNO, ARCH_notok);

	return (arch->flushP = TRUE, ARCH_ok);
}
