#include "sumachine.h"

#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHMoveTo - move an archive member
 *
 *    return {ARCH_ok, ARCH_notok}
 */
ARCHstatus
ARCHMoveTo(arch, index, where, to)
ARCHarchive *arch;
int index;
ARCHwhere where;
int to;
{
	ARCHfile move, shift;
	int i;
	
	if (index < 0 || DYNSizeOfEl(&arch->files) <= index)
	    return (ARCHErrno = ARCH_EOUT_OF_RANGE, ARCH_notok);

	switch (where) {
	case ARCH_begin:
	    to = 0;
	    break;
	case ARCH_end:
	    to = DYNSizeOfEl(&arch->files)-1;
	    break;
	case ARCH_here:
	    if (to < 0 || DYNSizeOfEl(&arch->files) <= to)
		return (ARCHErrno = ARCH_EOUT_OF_RANGE, ARCH_notok);
	    break;
	case ARCH_before:
	    if (to < 0 || DYNSizeOfEl(&arch->files) <= to)
		return (ARCHErrno = ARCH_EOUT_OF_RANGE, ARCH_notok);
	    to -= index < to;
	    break;
	case ARCH_after:
	    if (to < 0 || DYNSizeOfEl(&arch->files) <= to)
		return (ARCHErrno = ARCH_EOUT_OF_RANGE, ARCH_notok);
	    to += index > to;
	    break;
	default:
	    return (ARCHErrno = ARCH_EUNKNOWN_PLACE, ARCH_notok);
	}

	if (index == to)		/* pointless */
	    return (ARCH_ok);		/* don't need to flush */

	move = DYNAt(&arch->files, index, ARCHfile);

	/*
	 *    Place the old <index> at <to>, shifting as necessary
	 */
	if (index < to) {
	    for (i=index+1; i<=to; i++) {
		shift = DYNAt(&arch->files, i, ARCHfile);
		DYNpAtPut(&arch->files, i-1, &shift);
	    }
	} else { /* to < index */
	    for (i=index-1; i>to; i--) {
		shift = DYNAt(&arch->files, i, ARCHfile);
		DYNpAtPut(&arch->files, i+1, &shift);
	    }
	}
	DYNpAtPut(&arch->files, to, &move);

	return (arch->flushP = TRUE, ARCH_ok);
}
