#include "sumachine.h"

#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <ar.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"

#include "archive.h"
#include "internal.h"

/*
 *    ARCHRenameFile - rename a file in the archive
 *
 *    return {ARCH_ok, ARCH_notok}
 */
ARCHstatus
ARCHRenameFile(arch, index, newname)
ARCHarchive *arch;
int index;
String newname;
{
	ARCHfile *file;

	if (index < 0 || DYNSizeOfEl(&arch->files) <= index)
	    return (ARCHErrno = ARCH_EOUT_OF_RANGE, ARCH_notok);

	file = DYNpAt(&arch->files, index, ARCHfile);
	FREE_STRING(file->name);
	file->name = ARCHCopyFilename(newname);

#if OPSYS_MFR == MD_SUN && CPU_TYPE == MD_I386 || \
	OPSYS_MFR == MD_APOLLO || \
	OPSYS_SUBTYPE == MD_AIX || \
	OPSYS_SUBTYPE == MD_HPUX || \
	OPSYS_SUBTYPE == MD_SYS5 /* { */
	/*
	 *    Copy one less in order to insure that there is a padding
	 *    character at the end of the filename.  This is MANDATORY
	 *    for the ar format on these machines
	 */
	strncpy(file->header.ar_name, newname, sizeof (file->header.ar_name)-1);
#else /* } else { */
	/*
	 *    Can copy the full size on these machines b/c the ar format
	 *    does not require a terminating character.
	 */
	strncpy(file->header.ar_name, newname, sizeof (file->header.ar_name));
#endif /* } */
	ARCHBlankSlashPad(file->header.ar_name, sizeof (file->header.ar_name));
	
	return (arch->flushP = TRUE, ARCH_ok);
}
