#include <sys/param.h>
#include <stdio.h>

#include "stuff.h"

#include "internal.h"

#if TEST_APOLLO_HACK || OPSYS_MFR == MD_APOLLO /* { */
/*
 *    CNSLProcess - process a library on an apollo
 *
 *    A normal unix is any unix that is not an apollo
 *    If Apollo EVER says ``we are completely unix compatibile''
 *        then they are lying.  Its always the little things;
 *    Apollo is compatible only at a program interface level,
 *        rarely is it compatible at a lower level.
 *
 *    This is effectively a shell script because the
 *    only way you can deal with an archive on an apollo
 *    is to use the ar (1) program.  GRRRR!!!!
 *
 *    return {CNSL_ok, CNSL_notok} on {success, fail}
 */
CNSLstatus
CNSLProcess(argc, argv, metalibrary, appendP, localP, symdefP, uniqueP)
int argc;
Stringv argv;
String metalibrary;
Boolean appendP;
Boolean localP;
Boolean symdefP;
Boolean uniqueP;
{
	static char tmp_arch[] = { "/tmp/conslibsXXXXXX" };
	static char tmp_place[] = { "/tmp/placeXXXXXX" };
	static char local_arch[] = { "conslibsXXXXXX" };
	static char local_place[] = { "placeXXXXXX" };
	static char script[] = { "/tmp/scriptXXXXXX" };
	char temporary_script[MAXPATHLEN];
	char temporary_arch[MAXPATHLEN];
	char temporary_place[MAXPATHLEN];
	char cute[MAXPATHLEN];		/* actually only MAXFILENAMELEN is required */
	char buf[MAXPATHLEN+100];	/* good enuf for a system */
	long pid;
	int library_number;
	String suffix, filename, minus_xv;
	FILE *sh;
	int i;

#ifdef POPEN /* { */
	if ((sh = popen("/bin/sh", "w")) == NULL) {
	    fprintf(stderr, "conslibs: could not popen a /bin/sh to manipulate the archive because %s\n", sys_errlist[errno]);
	    return (CNSL_notok);
	}

#if defined(TEST_APOLLO_HACK) /* { */
	fprintf(stderr, "conslibs: testing the apollo hack with popen\n");
#endif /* } */
#else /* } else { */
	strcpy(temporary_script, script);
	mktemp(temporary_script);
	if ((sh = fopen(temporary_script, "w")) == NULL) {
	    fprintf(stderr, "conslibs: could not open %s to manipulate the archive because %s\n", temporary_script, sys_errlist[errno]);
	    return (CNSL_notok);
	}

#if defined(TEST_APOLLO_HACK) /* { */
	fprintf(stderr, "conslibs: testing the apollo hack with fopen\n");
#endif /* } */
#endif /* } */

#if defined(TEST_APOLLO_HACK) /* { */
	minus_xv = "-xv" ;
#else /* } else { */
	minus_xv = "" ;
#endif /* } */

	fprintf(sh, "set -e %s\nPATH=/usr/bin:/bin ; export PATH\n", minus_xv);
	library_number = 0;


	if (localP) {
	    strcpy(temporary_arch, local_arch);
	    strcpy(temporary_place, local_place);
	} else  {
	    strcpy(temporary_arch, tmp_arch);
	    strcpy(temporary_place, tmp_place);
	}

	mktemp(temporary_arch);
	mktemp(temporary_place);

	/*
	 *    Must take care of the metalibrary if appending
	 *    No need to remove if not appending b/c it will get
	 *    overwritten later.
	 */
	if (appendP) {
	    fprintf(sh, "cp %s %s\n", metalibrary, temporary_arch);
	}

	for (i=0; i<argc; i++) {
	    suffix = rindex(argv[i], '.');

	    if (suffix == NULL || ! strequal(suffix, ".a")) {
		/*
		 *    A non-archive file
		 */
		fprintf(sh, "ar qc %s %s\n", temporary_arch, argv[i]);
	    } else {
		/*
		 *    An archive file (as shown by the .a suffix)
		 */
		if ((filename = rindex(argv[i], '/')) != NULL) {
		    filename = &filename[1];	/* just after the slash */
		} else {
		    filename = argv[i];
		}

#ifdef never /* used to make cute names for the libraries (results in too-long names) */
		strcpy(cute, filename);
		*(rindex(cute, '.')) = '\0';	/* this is guaranteed to work */
#endif

		fprintf(sh, "mkdir %s\n", temporary_place);
		fprintf(sh, "cp %s %s/%s\n", argv[i], temporary_place, filename);
		fprintf(sh, "\
( cd %s ;\n\
  ar x %s ;\n\
  rm -f %s ;\n\
", temporary_place, filename, filename);
#ifdef dangerous /* { */
		/*
		 *    WATCHOUT - if the library has alot of names, then this
		 *    WATCHOUT - will bomb because dirname/* expands to too
		 *    WATCHOUT - many names.
		 */
		fprintf(sh, "\
  for i in *; do\n\
      mv $i %d-$i;\n\
  done ; )\n
", library_number);
#else /* } else { */
		fprintf(sh, "\
  # WATCHOUT - Archives with hyper-large numbers of members breaks * expansion\n\
  # The following is a script from hell designed to run mv on all the files\n\
  ls | awk '\n\
{\n\
	printf(\"mv '%%s' '%d-%%s'\\n\", $0, $0);\n\
}\n\
' | sh %s ) ;\n\
", library_number, minus_xv);
#endif /* } */

#ifdef dangerous /* { */
		/*
		 *    WATCHOUT - if the library has alot of names, then this
		 *    WATCHOUT - will bomb because dirname/* expands to too
		 *    WATCHOUT - many names.
		 */
		fprintf(sh, "ar qc %s %s/*\n", temporary_arch, temporary_place);
#else /* } else { */
#ifdef slow /* { */
		/*
		 *    This is just too slow to be useful...
		 */
		fprintf(sh, "for i in %s/* ; do\n    ar qc %s $i ;\ndone;\n",
			temporary_place, temporary_arch);
#else /* } else { */
		/*
		 *    WATCHOUT - the following printf statements MUST be broken
		 *    WATCHOUT - up in the following manner or else the cc
		 *    WATCHOUT - on the Apollo coredumps!
		 */
		fprintf(sh, "\
# WATCHOUT - Archives with hyper-large numbers of members breaks * expansion\n\
# The following is a script from hell designed to run ar qc in large batches\n\
ls %s | awk '\n\
BEGIN {\n\
\tout = \"\";\n\
}\n\
", temporary_place);
		fprintf(sh, "\
{\n\
	out = out \" %s/\" $0 ;\n\
	if (length(out) > 500) {\n\
	    print \"ar qc %s\" out;\n\
	    out = \"\"; \n\
	}\n\
}\n\
", temporary_place, temporary_arch);
		fprintf(sh, "\
END {\n\
	if (length(out) > 0) {\n\
	    print \"ar qc %s\" out;\n\
	}\n\
}\n\
' | sh %s ;\n\
", temporary_arch, minus_xv);
#endif /* } */
#endif /* } */
		fprintf(sh, "rm -rf %s\n", temporary_place);
		library_number++;
	    }
	}

	fprintf(sh, "cp %s %s\n", temporary_arch, metalibrary);
	fprintf(sh, "rm -f %s\n", temporary_arch);

#if OPSYS_VERS >= MD_APOLLO_10_0_1 /* { */
	fprintf(sh, "ar ts %s > /dev/null\n", metalibrary);
#endif /* } */

	fclose(sh);

#ifdef POPEN /* { */
	/*
	 *    Wait around till the shell we were talking to dies.
	 */
	wait(0);
#else /* } else { */
	sprintf(buf, "/bin/sh %s", temporary_script);
	if (system(buf) != 0) {
	    fprintf(stderr, "conslibs: execution of %s to manipulate the archive failed\n", temporary_script);
	    return (CNSL_notok);
	}
#if ! defined(TEST_APOLLO_HACK) /* { */ /* only if for real on an apollo */
	unlink(temporary_script);	/* if this fails, ignore it */
#endif /* } */
#endif /* } */
	return (CNSL_ok);
}
#endif /* } */
