#if ! defined(filename_h)
#define filename_h

/*
 *    FNErrno values
 */
#define FN_ENOERROR		0	/* no error */
#define FN_ESEE_ERRNO		1	/* see errno */
#define FN_EBAD_TILDE		2	/* bad tilde expansion name */
#define FN_EBAD_PASSWD		3	/* couldn't get your passwd entry */
#define FN_ENULL_EXEC		4	/* NULL executable name */
#define FN_ENO_EXEC		5	/* executable not found in path */
#define FN_ENOPATH		6	/* no PATH environment variable */
#define FN_ERESOLVE		7	/* cannot resolve name in path */
#define FN_EMISSING_LCURL	8	/* missing } */
#define FN_EMISSING_LBRA	9	/* missing ] */
#define FN_EBADSET		10	/* bad set notation */
#define FN_EONE			11	/* globbed to more than one filename */

extern int FNErrno;
extern String FNErrList[];
extern int FNNErrs;

extern int FNRegisterArgv0();

extern FILE *FNGlobOpen();
extern FILE *FNTildeOpen();

extern String FNFromTilde();
extern String FNFullPathToBinary();
extern String FNFullPathToHierarchy();
extern String FNMassageToFullPath();

extern String FNResolveAgainstPath();
extern String FNResolveAgainstPathV();

extern String FNTildeExpand();
extern Stringv FNGlobFilename();
extern String FNGlobToSingleFilename();

#endif /* filename_h */
