#ifdef SOURCE_HEADER
#endif SOURCE_HEADER
#include <sys/param.h>
#include <stdio.h>
#include <pwd.h>

extern struct passwd *getpwuid();
extern struct passwd *getpwnam();

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"

#include "filename.h"
#include "internal.h"

static DYNStrgeneralString home_directory;
static int home_directory_len;

/* 
 *    FNFromTilde - return the path from ~
 *
 *    ~/<name> is returned
 *    NULL, or "" may be passed and ~ will be returned.
 *
 *    return {the path, NULL} on {success, can't get your passwd entry}.
 */
String
FNFromTilde(tail)
String tail;
{
	if ( ! DYNStrInitP(&home_directory) ) {
	    struct passwd *pw;

	    if ((pw = getpwuid(geteuid())) == NULL) 
		return (FNErrno = FN_EBAD_PASSWD, (String) NULL);

	    DYNStrInit(&home_directory);
	    DYNStrAppendString(&home_directory, pw->pw_dir);
	    home_directory_len = DYNStrLength(&home_directory);
	}

	DYNStrSetTail(&home_directory, home_directory_len);
	if (tail != NULL && tail[0] != '\0') {
	    DYNStrAppendC(&home_directory, '/');
	    DYNStrAppendString(&home_directory, tail);
	}

	return (DYNStrTheString(&home_directory));
}
