#include <sys/param.h>
#include <stdio.h>

#include <sys/stat.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"
#include "path.h"

#include "filename.h"
#include "internal.h"

/*
 *    FNMassageToFullPath - return the shortest full path possible.
 *
 *    Return a {massaged_path, NULL} on {success, fail}
 */
String
FNMassageToFullPath(path)
String path;
{
        static DYNStrgeneralString final, concat;
	char current_directory[MAXPATHLEN];
	Boolean slashP;
	String sub;
	PATHgen gen;

	DYNStrInitClear(&concat);
	if (path[0] != '/') {
	    if (getwd(current_directory) == NULL) 
		return (FNErrno = FN_ESEE_ERRNO, (String) NULL);
	    DYNStrAppendString(&concat, current_directory);
	    DYNStrAppendC(&concat, '/');
	}
	DYNStrAppendString(&concat, path);
	
	DYNStrInitClear(&final);
	gen = PATHStart(DYNStrTheString(&concat), '/');
	while (PATHNext(gen, &sub) != PATH_eof) {
	    /*
	     *    Ignore /pre_path// and such
	     */
	    if (sub[0] == '\0')
		continue;
	    /*
	     *    Ignore /pre_path/./
	     */
	    if (sub[0] == '.' && sub[1] == '\0')
		continue;
	    /*
	     *    Back up over /pre_path/../ if /pre_path
	     *    is not a symbolic link.   If you can't stat it
	     *    then to your mind its not a symlink.
	     */
	    if (sub[0] == '.' && sub[1] == '.' && sub[2] == '\0') {
		int slash_token,
		    length_before;
		struct stat statbuf;

		length_before = DYNStrLength(&final);

		if (strequal(DYNStrTheString(&final), "/")) {
		    /*
		     *    Do exactly nothing.  "/.." == "/"
		     */
		    /* nothing */;
#ifdef S_IFLNK
		} else if (lstat(DYNStrTheString(&final), &statbuf) == 0 &&
			(statbuf.st_mode & S_IFMT) == S_IFLNK) {
		    /*
		     *    If it is a symlink, then continue processing.
		     *    You must save it.
		     */
		    DYNStrSetTail(&final, length_before);
#endif S_IFLNK
		} else {
		    /*
		     *    Do this if not a symlink (or if symlinks aren't defined)
		     */
		    slash_token = DYNStrRIndexIn(&final, '/');
		    slashP = slash_token > 0 ? TRUE: FALSE;
		    DYNStrSetTail(&final, slash_token);
		    continue;
#ifdef S_IFLNK
		}
#endif S_IFLNK
	    }
	    slashP = TRUE;
	    DYNStrAppendC(&final, '/');
	    DYNStrAppendString(&final, sub);
	}
	PATHFinish(gen);
	if ( ! slashP )
	    DYNStrAppendC(&final, '/');

	return (DYNStrTheString(&final));
}
