#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>
#include <struct.h>		/* structure offsets */

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OLGetPoints - octGetPoints
 *
 *    but does it into the private buffer
 *
 *    return {OL_ok, OL_notok} on {success, fail};
 */
OLstatus
OLGetPoints(object, nparray, parray)
octObject *object;		/* value (like octGetPoints()) */
int *nparray;			/* return */
struct octPoint **parray;	/* return */
{
	*nparray = 0;
	if ((OLGlobalOctStatus = octGetPoints(object, nparray, NULL)) < OCT_OK)
	    return (OL_notok);
	    
	DYNMakeArray(&OLPointArray, *nparray);
	*parray = DYNTheArray(&OLPointArray, struct octPoint);

	if (*parray == NULL)
	    return (OL_notok);

	if ((OLGlobalOctStatus = octGetPoints(object, nparray, *parray)) < OCT_OK)
	    return (OL_notok);

	return (OL_ok);
}
