#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

/*
 *    OL_Help_Initialize - initialize the help library
 *
 *    return {OL_ok, OL_notok} on {success, fail}
 */
OLstatus
OL_Help_Initialize()
{
	int i, j;

        OLReadonly = LLInternSymbol(OLReadonly);
        OLReadwrite = LLInternSymbol(OLReadwrite);
        OLReadwriteappend = LLInternSymbol(OLReadwriteappend);

	/*
	 *    Turn all of the names into symbols
	 */
	for (i=0; i<OLNAttributeTable; i++) {
	    for (j=0; j<OLAttributeTable[i].nattributes; j++)
		OLAttributeTable[i].attributes[j].name = LLInternSymbol(OLAttributeTable[i].attributes[j].name);
	}

	/*
	 *    Turn all of the names into symbols
	 */
	for (i=0; i<OLNTypeNameTable; i++)
	    OLTypeNameTable[i].name = LLInternSymbol(OLTypeNameTable[i].name);

	DYNInit(&OLPointArray, struct octPoint);
	DYNInit(&OLRealArray, double);
	DYNInit(&OLIntegerArray, int32);
	DYNInit(&OLCharArray, char);

	return (OL_ok);
}
