
typedef enum OLattributeType OLattributeType;
enum OLattributeType {
    OL_octBoolean,
    OL_octInteger,
    OL_octReal,
    OL_octString,
    OL_octNullString,
    OL_octCoord,
    OL_octId,
    OL_octTransform,
    OL_octPoint,
    OL_octStranger,
    OL_octModeSymbol,
    OL_octBox,
    OL_array,		/* of integer, real, or point */
};

/*
 *    Describe the oct system in terms of various tables
 */
typedef struct OLattribute OLattribute;
struct OLattribute {
    LLstring name;			/* the single legal name for this attribute */
    Boolean requiredP;			/* must be in the a-list of (object object-type a-list) */
    OLattributeType type;		/* type of attribute here */
    int offset;				/* offset to the data */
    OLattributeType subtype;		/* (type == OL_array), type of the array  */
    int number_offset;			/* offset to the nelements count */
};

typedef struct OLattributeTable OLattributeTable;
struct OLattributeTable {
    /* octType */ int type;	/* octType this table refers to */
    octPropType subtype;	/* type == OCT_PROP, then the type of the prop.type, else OCT_NULL */
    int nattributes;		/* attributes of this type */
    OLattribute *attributes;
};

typedef struct OLtypeName OLtypeName;
struct OLtypeName {
    LLstring name;		/* the name of the type */
    OLattributeType type;	/* type represented by the keyword */
};

extern OLattributeTable OLAttributeTable[];
extern int OLNAttributeTable;

extern OLtypeName OLTypeNameTable[];
extern int OLNTypeNameTable;

extern DYNgeneralArray OLPointArray;	/* of struct octPoint */
extern DYNgeneralArray OLRealArray;	/* of double */
extern DYNgeneralArray OLIntegerArray;	/* of int32 */
extern DYNgeneralArray OLCharArray;	/* of char */

extern OLstatus OLGetPoints();
