#include <sys/types.h>

#include "stuff.h"
#include "alloc.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhAddToPairSet - add an object to a set
 *
 *    return {octh_isa_member, octh_added} on {already in the set, added}
 */
octhSetStatus
octhAddToPairSet(set, objectId, userData)
octhObjectPairSet set;
octId objectId;
FitAny userData;
{
	lsList list;
	lsGen gen;
	Boolean foundP;
	octhObjectPair *search, *new;

	/*
	 *    I'll be damned if I'll tell them how its implemented
	 */
	list = (lsList) set;

	foundP = FALSE;

	gen = lsStart(list);
	while (lsNext(gen, &search, NULL) == LS_OK) {
	    if (objectId == search->objectId) {
		foundP = TRUE;
		break;
	    }
	}
	lsFinish(gen);

	if ( ! foundP ) {
	    new = ALLOC_TYPE(octhObjectPair);
	    new->objectId = objectId;
	    new->userData = userData;

	    lsNewEnd(list, new, NULL);
	    return (octh_added);
	}

	search->userData = userData;

	return (octh_isa_member);
}
