#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhCloseMaster - close the master of this instance
 *
 *    Not because this is so algorithmiclly hard, but b/c its done so often.
 *    Should only be called if its already open
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhCloseMaster(instance)
octObject *instance;
{
	octObject master;

	master.type = OCT_FACET;
	master.contents.facet.cell = instance->contents.instance.master;
	master.contents.facet.view = instance->contents.instance.view;
	master.contents.facet.facet = "contents";
	master.contents.facet.version = instance->contents.instance.version;
	master.contents.facet.mode = "r";	/* sure, why not */

	if (octOpenFacet(&master) < OCT_OK)
	    return (OCTH_NOTOK);
	if (octCloseFacet(&master) < OCT_OK)
	    return (OCTH_NOTOK);

	if (octCloseFacet(&master) < OCT_OK)	/* close twice */
	    return (OCTH_NOTOK);

	return (OCTH_OK);
}
