#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhIsContainerOfP - check to see if one contains the other
 *
 *    return {TRUE, FALSE} on {is, is not}.
 */
Boolean
octhIsContainerOfP(container, contents)
octObject *container;
octObject *contents;
{
	Boolean isP;
	octGenerator test_gen;
	octStatus test_gen_status;
	octObject test;

	if (octInitGenContents(container, (octObjectMask) (1<<contents->type), &test_gen) < OCT_OK)
	    return (FALSE);
	
	isP = FALSE;
	while ((test_gen_status = octGenerate(&test_gen, &test)) == OCT_OK) {
	    if (test.objectId == contents->objectId) {
		isP = TRUE;
		break;
	    }
	}

	octFreeGenerator(&test_gen);

	return (isP);
}
