#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhCountContainers - count the containers (of the mask types)
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhCountContainers(contents, mask, count)
octObject *contents;
octObjectMask mask;
int *count;
{
	octGenerator gen;
	octStatus gen_status;
	octObject object;

	*count = 0;

	if (octInitGenContainers(contents, mask, &gen) < OCT_OK)
	    return (OCTH_NOTOK);

	while ((gen_status = octGenerate(&gen, &object)) == OCT_OK)
	    *count++;

	return (gen_status == OCT_GEN_DONE ? OCTH_OK: OCTH_NOTOK);
}
