#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhCreateRequiredContentsStuff - create the required contents facet stuff
 *
 *    Try to make some intelligent decisions about what to set them to.
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhCreateRequiredContentsStuff(contents)
octObject *contents;
{
	char FACET_VIEW[1024];
	octObject TECHNOLOGY, EDITSTYLE, VIEWTYPE;
	int stati_i, i;
	octStatus stati[1024];

	if (contents->type != OCT_FACET)
	    return (OCTH_NOTOK);

	strcpy(FACET_VIEW, contents->contents.facet.view);
	ToUpper(FACET_VIEW);

	TECHNOLOGY.type = OCT_PROP;
	TECHNOLOGY.contents.prop.name = "TECHNOLOGY";
	TECHNOLOGY.contents.prop.type = OCT_STRING;
	TECHNOLOGY.contents.prop.value.string = DEFAULT_TECHNOLOGY_PROPERTY_VALUE;

	EDITSTYLE.type = OCT_PROP;
	EDITSTYLE.contents.prop.name = "EDITSTYLE";
	EDITSTYLE.contents.prop.type = OCT_STRING;
	EDITSTYLE.contents.prop.value.string = FACET_VIEW;

	VIEWTYPE.type = OCT_PROP;
	VIEWTYPE.contents.prop.name = "VIEWTYPE";
	VIEWTYPE.contents.prop.type = OCT_STRING;
	VIEWTYPE.contents.prop.value.string = FACET_VIEW;

	stati_i = 0;
	stati[stati_i++] = octCreate(contents, &TECHNOLOGY);
	stati[stati_i++] = octCreate(contents, &EDITSTYLE);
	stati[stati_i++] = octCreate(contents, &VIEWTYPE);

	for (i=0; i<stati_i; i++) {
	    if (stati[i] < OCT_OK)
		return (OCTH_NOTOK);
	}

	return (OCTH_OK);
}
