#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhCreateRequiredInterfaceStuff - create the required interface facet stuff
 *
 *    Try to make some intelligent decisions about what to set them to.
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success , fail}
 */
octhStatus
octhCreateRequiredInterfaceStuff(interface)
octObject *interface;
{
	char FACET_VIEW[1024];
	octObject TECHNOLOGY, EDITSTYLE, VIEWTYPE, CELLCLASS;
	int stati_i, i;
	octStatus stati[1024];

	if (interface->type != OCT_FACET)
	    return (OCTH_NOTOK);

	strcpy(FACET_VIEW, interface->contents.facet.view);
	ToUpper(FACET_VIEW);

	TECHNOLOGY.type = OCT_PROP;
	TECHNOLOGY.contents.prop.name = "TECHNOLOGY";
	TECHNOLOGY.contents.prop.type = OCT_STRING;
	TECHNOLOGY.contents.prop.value.string = DEFAULT_TECHNOLOGY_PROPERTY_VALUE;

	EDITSTYLE.type = OCT_PROP;
	EDITSTYLE.contents.prop.name = "EDITSTYLE";
	EDITSTYLE.contents.prop.type = OCT_STRING;
	EDITSTYLE.contents.prop.value.string = FACET_VIEW;

	VIEWTYPE.type = OCT_PROP;
	VIEWTYPE.contents.prop.name = "VIEWTYPE";
	VIEWTYPE.contents.prop.type = OCT_STRING;
	VIEWTYPE.contents.prop.value.string = FACET_VIEW;

	CELLCLASS.type = OCT_PROP;
	CELLCLASS.contents.prop.name = "CELLCLASS";
	CELLCLASS.contents.prop.type = OCT_STRING;
	CELLCLASS.contents.prop.value.string = "LEAF";		/* for lack of a better idea */

	stati_i = 0;
	stati[stati_i++] = octCreate(interface, &TECHNOLOGY);
	stati[stati_i++] = octCreate(interface, &EDITSTYLE);
	stati[stati_i++] = octCreate(interface, &VIEWTYPE);
	stati[stati_i++] = octCreate(interface, &CELLCLASS);

	for (i=0; i<stati_i; i++) {
	    if (stati[i] < OCT_OK)
		return (OCTH_NOTOK);
	}

	return (OCTH_OK);
}
