#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhForeachContainer - another interface to gencontainer
 *
 *    void
 *    anyObject(object, state)
 *    octObject *object;
 *    FitAny state;
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhForeachContainer(contents, mask, anyObject, state)
octObject *contents;
octObjectMask mask;
void (*anyObject)();
FitAny state;
{
	octGenerator gen;
	octStatus gen_status;
	octObject object;

	if (octInitGenContainers(contents, mask, &gen) < OCT_OK)
	    return (OCTH_NOTOK);

	while ((gen_status = octGenerate(&gen, &object)) == OCT_OK)
	    (*anyObject)(&object, state);

	return (gen_status == OCT_GEN_DONE ? OCTH_OK: OCTH_NOTOK);
}
