#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhForeachCellInstance - foreach cellInstance
 *
 *    void
 *    cellInstance(instance, state)
 *    octObject *instance;
 *    FitAny state;
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhForeachCellInstance(facet, cellInstance, state)
octObject *facet;
void (*cellInstance)();
FitAny state;
{
	octGenerator instance_gen;
	octStatus instance_gen_status;
	octObject INSTANCES, instance;

	if (facet->type != OCT_FACET)
	    return (OCTH_NOTOK);

	INSTANCES.type = OCT_BAG;
	INSTANCES.contents.bag.name = "INSTANCES";

	if (octGetByName(facet, &INSTANCES) < OCT_OK)
	    return (OCTH_OK);		/* if not there, then okay (no instances) */

	if (octInitGenContents(&INSTANCES, OCT_INSTANCE_MASK, &instance_gen) < OCT_OK)
	    return (OCTH_NOTOK);

	while ((instance_gen_status = octGenerate(&instance_gen, &instance)) == OCT_OK)
	    (*cellInstance)(&instance, state);

	return (instance_gen_status == OCT_GEN_DONE ? OCTH_OK: OCTH_NOTOK);
}
