#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhForeachConnectorInstance - foreach connectorInstance
 *
 *    void
 *    connectorInstance(instance, state)
 *    octObject *instance;
 *    FitAny state;
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhForeachConnectorInstance(facet, connectorInstance, state)
octObject *facet;
void (*connectorInstance)();
FitAny state;
{
	octGenerator instance_gen;
	octStatus instance_gen_status;
	octObject CONNECTORS, instance;

	if (facet->type != OCT_FACET)
	    return (OCTH_NOTOK);

	CONNECTORS.type = OCT_BAG;
	CONNECTORS.contents.bag.name = "CONNECTORS";

	if (octGetByName(facet, &CONNECTORS) < OCT_OK)
	    return (OCTH_OK);		/* if not there, then okay (no connectors) */

	if (octInitGenContents(&CONNECTORS, OCT_INSTANCE_MASK, &instance_gen) < OCT_OK)
	    return (OCTH_NOTOK);

	while ((instance_gen_status = octGenerate(&instance_gen, &instance)) == OCT_OK)
	    (*connectorInstance)(&instance, state);

	return (instance_gen_status == OCT_GEN_DONE ? OCTH_OK: OCTH_NOTOK);
}
