#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhForeachFormalTerminal - foreach formalTerminal
 *
 *    void
 *    anyFormalTerminal(formalTerminal, state)
 *    octObject *formalTerminal;
 *    FitAny state;
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhForeachFormalTerminal(facet, anyFormalTerminal, state)
octObject *facet;
void (*anyFormalTerminal)();
FitAny state;
{
	octGenerator formalTerminal_gen;
	octStatus formalTerminal_gen_status;
	octObject formalTerminal;

	if (facet->type != OCT_FACET)
	    return (OCTH_NOTOK);

	if (octInitGenContents(facet, OCT_TERM_MASK, &formalTerminal_gen) < OCT_OK)
	    return (OCTH_NOTOK);

	while ((formalTerminal_gen_status = octGenerate(&formalTerminal_gen, &formalTerminal)) == OCT_OK)
	    (*anyFormalTerminal)(&formalTerminal, state);

	return (formalTerminal_gen_status == OCT_GEN_DONE ? OCTH_OK: OCTH_NOTOK);
}
