#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhForeachInstance - foreach instance
 *
 *    void
 *    anyInstance(instance, state)
 *    octObject *instance;
 *    FitAny state;
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhForeachInstance(facet, anyInstance, state)
octObject *facet;
void (*anyInstance)();
FitAny state;
{
	octGenerator instance_gen;
	octStatus instance_gen_status;
	octObject instance;

	if (facet->type != OCT_FACET)
	    return (OCTH_NOTOK);

	if (octInitGenContents(facet, OCT_INSTANCE_MASK, &instance_gen) < OCT_OK)
	    return (OCTH_NOTOK);

	while ((instance_gen_status = octGenerate(&instance_gen, &instance)) == OCT_OK)
	    (*anyInstance)(&instance, state);

	return (instance_gen_status == OCT_GEN_DONE ? OCTH_OK: OCTH_NOTOK);
}
