#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhGetFacetByName - get a facet by a name
 *
 *    cell:view:optionalfacet:optionalversion
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhGetFacetByName(cell_view_optionalfacet_optionalversion, mode, facet)
String cell_view_optionalfacet_optionalversion;		/* modified */
String mode;
octObject *facet;
{
	String cellname, viewname, facetname, versionname;
	octStatus oct_status;

	cellname = cell_view_optionalfacet_optionalversion;
	if ((versionname = rindex(cell_view_optionalfacet_optionalversion, ':')) == NULL) {
	    /*
	     *    a name without any colons in it.
	     */

	    /* fill it in so that its okay to printf ... */
	    facet->type = OCT_FACET;
	    facet->contents.facet.cell = cell_view_optionalfacet_optionalversion;
	    facet->contents.facet.view = "";
	    facet->contents.facet.facet = "";
	    facet->contents.facet.version = "";
	    facet->contents.facet.mode = mode;

	    return (OCTH_NOTOK);
	} else {
	    /*
	     *    cell:view
	     *    cell:view:facet
	     *    cell:view:facet:version
	     */
	    *versionname++ = '\0';

	    if ((facetname = rindex(cell_view_optionalfacet_optionalversion, ':')) == NULL) {
		/*
		 *    cell:view
		 */
		viewname = versionname;
		facetname = "contents";
		versionname = OCT_CURRENT_VERSION;
	    } else {
		*facetname++ = '\0';

		if ((viewname = rindex(cell_view_optionalfacet_optionalversion, ':')) == NULL) {
		    /*
		     *    cell:view:facet
		     */
		    viewname = facetname;
		    facetname = versionname;
		    versionname = OCT_CURRENT_VERSION;
		} else {
		    /*
		     *    cell:view:facet:version
		     */
		    *viewname++ = '\0';
		}
	    }
	}

	facet->type = OCT_FACET;
	facet->contents.facet.cell = cellname;
	facet->contents.facet.view = viewname;
	facet->contents.facet.facet = facetname;
	facet->contents.facet.version = versionname;
	facet->contents.facet.mode = mode;

	return (OCTH_OK);
}
