#include <sys/types.h>

#include "stuff.h"
#include "list.h"
#include "alloc.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhGetName - get the name for this object (if possible)
 *
 *    From the octGetByName man page...
 *
 *    return {the String, NULL} on {success, fail}
 */
String
octhGetName(object)
octObject *object;
{
	String ret;

        /*
         *    From octGetName man page
         */
        switch (object->type) {
        case OCT_TERM:
            ret = object->contents.term.name;
            break;
        case OCT_NET:
            ret = object->contents.net.name;
            break;
        case OCT_INSTANCE:
            ret = object->contents.instance.name;
            break;
        case OCT_PROP:
            ret = object->contents.prop.name;
            break;
        case OCT_LAYER:
            ret = object->contents.layer.name;
            break;
        case OCT_BAG:
            ret = object->contents.bag.name;
            break;
        case OCT_LABEL:
            ret = object->contents.label.label;
            break;
        default:
	    /* the object has no name - get out */
	    return (NULL);
        }

	ret = ret == NULL ? "<NO-NAME>": ret[0] == '\0' ? "\"\"": ret;
}
