#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhGetNetFromTerminal - given a net, get its terminal
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, error}
 */
octhStatus
octhGetNetFromTerminal(actualTerminal, net, foundP)
octObject *actualTerminal;
octObject *net;
Boolean *foundP;		/* return - TRUE, FALSE if net, no net */
{
	octStatus status;
	octObject segment_obj;

        if (octhIsInstanceTerminalP(actualTerminal)) {
            status = octGenFirstContainer(actualTerminal, OCT_NET_MASK, net);
        } else {        /* octhIsConnectorTerminalP(actualTerminal) */
            status = octGenFirstContainer(actualTerminal, OCT_PATH_MASK, &segment_obj);
	    if (status < OCT_OK)
		return (OCTH_NOTOK);
            if (status == OCT_GEN_DONE)
		return (*foundP = FALSE, OCTH_OK);

	    status = octGenFirstContainer(&segment_obj, OCT_NET_MASK, net);
        }

	if (status < OCT_OK)
	    return (OCTH_NOTOK);
	if (status == OCT_GEN_DONE)
	    return (*foundP = FALSE, OCTH_OK);
	return (*foundP = TRUE, OCTH_OK);
}
