#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhGetSegmentActualTerminals - the 2 actualTerminals on a segment
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhGetSegmentActualTerminals(segment, actualTerminals)
octObject *segment;
octObject actualTerminals[2];
{
	octGenerator term2_gen; 
	octObject bogusTerminal_obj;
	octStatus status0, status1, status2;

	if (octInitGenContents(segment, OCT_TERM_MASK, &term2_gen) < OCT_OK)
	    return (OCTH_NOTOK);

	status0 = octGenerate(&term2_gen, &actualTerminals[0]);
	status1 = octGenerate(&term2_gen, &actualTerminals[1]);
	status2 = octGenerate(&term2_gen, &bogusTerminal_obj);

	octFreeGenerator(&term2_gen);

	if (status0 < OCT_OK || status1 < OCT_OK || status2 < OCT_OK)
	    return (OCTH_NOTOK);
	if (status0 == OCT_GEN_DONE || status1 == OCT_GEN_DONE)
	    return (OCTH_NOTOK);
	if (status2 != OCT_GEN_DONE)
	    return (OCTH_NOTOK);

	return (OCTH_OK);
}
