#include <sys/types.h>

#include "stuff.h"
#include "list.h"

#include "oct.h"

#include "oct_helper.h"
#include "internal.h"

/* 
 *    octhGetUniqueContainer - get the unique object of type containing
 *
 *    return {OCTH_OK, OCTH_NOTOK} on {success, fail}
 */
octhStatus
octhGetUniqueContainer(content, mask, unique)
octObject *content;
octObjectMask mask;
octObject *unique;
{
	octGenerator gen;
	octStatus gen_status;
	int count;

	if (octInitGenContainers(content, mask, &gen) < OCT_OK)
	    return (OCTH_NOTOK);

	count = 0;
	while ((gen_status = octGenerate(&gen, unique)) == OCT_OK)
	    count++;

	return (gen_status == OCT_GEN_DONE && count == 1 ? OCTH_OK: OCTH_NOTOK);
}
