#if ! defined(oct_helper_h)
#define oct_helper_h

typedef enum octhStatus octhStatus;
enum octhStatus {
    OCTH_NOTOK = -1,	/* consistent with "oct notok" < "oct ok" */
    OCTH_OK = 0,	/* consistent with "oct notok" < "oct ok" */
};

typedef enum octhSetStatus octhSetStatus;
enum octhSetStatus {
    octh_isa_member,		/* is already a member */
    octh_nota_member,		/* is not a member */
    octh_added,			/* member added */
    octh_deleted,		/* member deleted */
};

typedef RefAny octhObjectSet;		/* a set of objectId's */
typedef RefAny octhObjectPairSet;	/* a set of { objectId, FitAny } pairs */

typedef RefAny octhObjectSetGen;	/* generate the set of objectId's */
typedef RefAny octhObjectPairSetGen;	/* generate the set of { objectId, FitAny } pairs */

extern String octhOctTypeNames[];
extern String octhOctTransformTypeNames[];

extern void octhCenterOfBB();
extern void octhNormalizeBB();

extern octhObjectSet octhCreateSet();
extern octhSetStatus octhAddToSet();
extern octhSetStatus octhRemoveFromSet();
extern Boolean octhIsMemberOfSetP();
/* no sense in extern octhSetStatus octhLookupMemberOfSet(); */
extern void octhDestroySet();

extern octhObjectSetGen octhStartSet();
extern void octhFinishSet();
extern Boolean octhNextSet();

extern octhObjectPairSet octhCreatePairSet();
extern octhSetStatus octhAddToPairSet();
extern octhSetStatus octhRemoveFromPairSet();
extern Boolean octhIsMemberOfPairSetP();
extern octhSetStatus octhLookupMemberOfPairSet();
extern void octhDestroyPairSet();

extern octhObjectPairSetGen octhStartPairSet();
extern void octhFinishPairSet();
extern Boolean octhNextPairSet();

/*
 *    The VIEWTYPE predicates
 */
extern Boolean octhPhysicalP();
extern Boolean octhSymbolicP();
extern Boolean octhSchematicP();
extern Boolean octhSlideP();

/*
 *    void
 *    anyObject(object, state)
 *    octObject *object;
 *    FitAny state;
 */
extern octhStatus octhDepthFirstTraversal();

/*
 *    void
 *    anyObject(object, state)
 *    octObject *object;
 *    FitAny state;
 */
extern octhStatus octhBreadthFirstTraversal();

/*
 *    void
 *    anyObject(object, state)
 *    octObject *object;
 *    FitAny state;
 */
extern octhStatus octhForeachContent();
extern octhStatus octhForeachContainer();

/*
 *    void
 *    cellInstance(instance, state)
 *    octObject *instance;
 *    FitAny state;
 */
extern octhStatus octhForeachCellInstance();

/*
 *    void
 *    connnectorInstance(instance, state)
 *    octObject *instance;
 *    FitAny state;
 */
extern octhStatus octhForeachConnectorInstance();

/*
 *    void
 *    anyInstance(instance, state)
 *    octObject *instance;
 *    FitAny state;
 */
extern octhStatus octhForeachInstance();

/*
 *    void
 *    connectivity(net, nterms, terms, state)
 *    octObject *net;
 *    int nterms;
 *    octObject *terms;
 *    FitAny state;
 */
extern octhStatus octhNetList();

extern octhStatus octhGetFacetByName();
extern octhStatus octhOpenFacetByName();

extern octhStatus octhGetNetFromTerminal();
extern octhStatus octhGetSegmentActualTerminals();

extern octhStatus octhOpenMaster();
extern octhStatus octhCloseMaster();
extern octhStatus octhReInstantiate();

extern octhStatus octhGetTerminalImplementationBB();

extern octhStatus octhGetUniqueContent();
extern octhStatus octhGetUniqueContainer();

extern octhStatus octhCountContents();
extern octhStatus octhCountContainers();

extern octhStatus octhGetPoints();
extern void octhUnGetPoints();

extern String octhGetName();
extern String octhStringifyObject();

extern Boolean octhIsContainerOfP();

extern Boolean octhIsCellInstanceP();
extern Boolean octhIsConnectorInstanceP();

extern Boolean octhIsFormalTerminalP();
extern Boolean octhIsConnectorTerminalP();
extern Boolean octhIsInstanceTerminalP();

extern void octhSetTECHNOLOGY();
extern octhStatus octhCreateRequiredInterfaceStuff();
extern octhStatus octhCreateRequiredContentsStuff();

#endif /* oct_helper_h */
