#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "machine.h"
#include "help.h"
#include "internal.h"

static void funcall();

/*
 *    OLDepthfirsttraversal - depth first traversal starting at the object
 *
 *    return {t, nil} on {success, fail}
 */
LLobject*
OLDepthfirsttraversal(object, function)
LLobject *object;
LLobject *function;
{
	octObject o;

	if ( ! OL_objectp(object) ) {
	    LLErrorF("\
Function: (depth-first-traversal object function)\n\
\tobject is not an object\n\
\tobject:   ~S\n\
\tfunction: ~S\n\
", object, function);
	    LLThrow(OL_octlisp, LL_nil);
	}
	if ( ! LL_functionp(function) || ! LL_function_closurep(function) ) {
	    LLErrorF("\
Function: (depth-first-traversal object function)\n\
\tfunction is not a function\n\
\tobject:   ~S\n\
\tfunction: ~S\n\
", object, function);
	    LLThrow(OL_octlisp, LL_nil);
	}

	OLExtractObject(object, o);

	if (octhDepthFirstTraversal(&o, funcall, function) != OCTH_OK) {
	    OLGlobalOctStatus = OCT_ERROR;
	    return (LL_nil);
	}

	return (LL_t);
}

static void
funcall(object, function)
octObject *object;
LLobject *function;
{
	LLobject *swing;

        /*
         *    TODO if this throws, the data structures
	 *    of DepthFirstTraversal are lost
         */
	swing = OLMakeObject(*object);
	LLApply(function, swing, LL_nil);
}
