#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

#include "help.h"
#include "machine.h"
#include "oct_helperlib.h"
#include "internal.h"

/*
 *    LLobject *
 *    function(args ... )
 *    LLobject *args;
 */
static struct {
    String pname;
    LLobject *(*function)();
    int nrequired;
    int noptional;
    Boolean restP;
} functions[] = {
    { "breadth-first-traversal",	OLBreadthfirsttraversal,	2,	0,	FALSE	},
    { "depth-first-traversal",		OLDepthfirsttraversal,		2,	0,	FALSE	},
};

/*
 *    OL_Octh_Initialize - initialize oct_helper stuff
 *
 *    return {OL_ok, OL_notok} on {success, fail}
 */
OLstatus
OL_Octh_Initialize()
{
	int i;

	for (i=0; i<sizeof_el (functions); i++) {
	    LLSetValue(LLMakeSymbol(functions[i].pname),
		    LL_functionSlot,
		    LLMakeFunction(functions[i].pname, functions[i].function,
			    functions[i].nrequired,
			    functions[i].noptional,
			    functions[i].restP),
		    LL_nil);
	}

	return (OL_ok);
}
