;;;;
;;;;    An assert macro for those who believe in these things.
;;;;

;;;
;;;   Example:
;;;    (oct-assert (open-facet-by-name "this" "that" "contents" "" :readwrite))
;;;

(defmacro oct-assert (test &optional description)
  "if it failed, debug it, and throw it."
  (let ((ret (gensym)))		; get a variable that nobody else can name
       `(let ((,ret ,test))
	     (when (null ,ret)
		   (format *error-output*
			   "An Oct Error has occurred: ~A~
			   ~%    because ~A~
			   ~%    form:   ~S~%"
			   ,(if (null description) "" 'description)
			   (oct-error-string) ',test)
		   (subshell "oct-assert")
		   (throw 'octlisp nil))
	     ,ret)))
