;;;;
;;;;    some useful generation macros
;;;;

;;
;;    (do-contents (o (facet OCT-PROP-MASK))
;;                 (print o))
;;
;;    (do-contents (o (facet (merge-masks OCT-PROP-MASK OCT-BAG-MASK)))
;;                 (print o))
;;
(defmacro do-contents ((iterate (container mask) &optional retval) &body body)
  "generate all contents of type mask"
  (let ((genvar (gensym)))
       `(do* ((,genvar (init-gen-contents ,container ,mask))
	      (,iterate (generate ,genvar) (generate ,genvar)))
	     ((null ,iterate)
	      (setq ,iterate nil)	; like dolist
	      ,retval)			; retval is the return value
	     ,@body)))

;;
;;    (do-containers (o (facet OCT-PROP-MASK))
;;                 (print o))
;;
;;    (do-containers (o (facet (merge-masks OCT-PROP-MASK OCT-BAG-MASK)))
;;                 (print o))
;;
(defmacro do-containers ((iterate (content mask) &optional retval) &body body)
  "generate all containers of type mask"
  (let ((genvar (gensym)))
       `(do* ((,genvar (init-gen-containers ,content ,mask))
	      (,iterate (generate ,genvar) (generate ,genvar)))
	     ((null ,iterate)
	      (setq ,iterate nil)	; like dolist
	      ,retval)			; retval is the return value
	     ,@body)))

;;
;;    (map-contents container mask)
;;
(defun map-contents (container mask)
  "return a list of all the contents matching mask"
  (let ((ret nil))
       (do-contents (o (container mask) ret)
		    (setq ret (cons o ret)))))

;;
;;    (map-containers content mask)
;;
(defun map-containers (content mask)
  "return a list of all the containers matching mask"
  (let ((ret nil))
       (do-containers (o (content mask) ret)
		      (setq ret (cons o ret)))))
