;;;;
;;;;    with-open-facet just like with-open-file
;;;;

;;;
;;;    (with-open-facet (variable facet-form mode)
;;;                     body ... )
;;;
(defmacro with-open-facet ((variable facet-form mode)
			   &body body)
  "the same as with-open-file but different"
  `(let ((,variable (open-facet ,facet-form ,mode)))
	(unless (objectp ,variable)
		(format t "with-open-facet could not ~s because ~a~%"
			'(open-facet ,facet-form ,mode)
			(oct-error-string))
		(throw 'octlisp (oct-error-status)))
	(unwind-protect (progn ,@body)
			(close-facet ,variable))))

;;;
;;;    (with-open-facet-by-name (variable cell view facet version mode)
;;;                             body ... )
;;;
(defmacro with-open-facet-by-name ((variable cell view facet version mode)
				   &body body)
  "the same as with-open-file but different"
  `(let ((,variable (open-facet-by-name ,cell ,view ,facet ,version ,mode)))
	(unless (objectp ,variable)
		(format t "with-open-facet-by-name could not ~s because ~a~%"
			'(open-facet-by-name ,cell ,view ,facet ,version ,mode)
			(oct-error-string))
		(throw 'octlisp (oct-error-status)))
	(unwind-protect (progn ,@body)
			(close-facet ,variable))))

;;;
;;;    (with-open-facet-by-packed-name (variable packed mode)
;;;                                    body ... )
;;;
(defmacro with-open-facet-by-packed-name ((variable packed mode)
					  &body body)
  "the same as with-open-file but different
  WARNING - requires facetname.ll to be loaded"
  `(let ((,variable (open-facet-by-packed-name ,packed ,mode)))
	(unless (objectp ,variable)
		(format t "with-open-facet-by-packed-name could not ~s because ~a~%"
			'(open-facet-by-packed-name ,packed ,mode)
			(oct-error-string))
		(throw 'octlisp (oct-error-status)))
	(unwind-protect (progn ,@body)
			(close-facet ,variable))))
