;;;;
;;;;    Get a list of all formalTerminals on a facet
;;;;

(defun formalTerminals-of (facet)
  "get all the formalTerminals on a facet"
  (do* ((gen (init-gen-contents facet OCT-TERM-MASK))
	(term (generate gen) (generate gen))
	(list nil))
       ;; (null term) is the end-condition, list is the return value
       ((null term) list)

       ;; cons up the list
       (setq list (cons term list))))

(defun demo ()
  "a demo function"
  (setq demo
	(let ((facet (open-facet-by-name "/tmp/whipping" "symbolic" "contents"
					 OCT-CURRENT-VERSION :readwrite-append)))
	     (when (null facet)
		   ;; print out an ultra-informative error message
		   ;; and throw up (urp)
		   (format t "Could not open the demo facet because ~a~%"
			   (oct-error-string))
		   (throw 'octlisp nil))
	     
	     ;; create some terminals on the facet
	     (dolist (term-name '("eany" "meany" "miney" "moe"
					 "this" "little" "piggy" "had" "roast-beef"))
		     (create facet `(object ,OCT-TERM ((name . ,term-name)
						       (instance . ,oct-null-id)))))
	     ;; return the facet as the value to setq
	     facet))
  (formalTerminals-of demo))

(format t "Generate Formal Terminals Demo~%    use (demo) to get a demo~%")
