;;;;
;;;;    octprop - a rewrite of octprop (1)_
;;;;

(load "~cad/lib/OctLisp/generate.ll")
(load "~cad/lib/OctLisp/with-open.ll")
(load "~cad/lib/OctLisp/facetname.ll")

(defun octprop (object &rest action-forms)
  "octprop is a rewrite of octprop (1) that is
  more suitable for the lisp world"
  (dolist (action action-forms)
  (print action)
	  (case (car action)
		((b bag)
		 ;;
		 ;;    (bag name)
		 ;;
		 (let ((name (second action))
		       (path-mask (first (third action)))
		       (path-name (second (third action)))
		       (subchain (nthcdr 3 action)))
		      (setq path-mask (if path-mask path-mask OCT-ALL-MASK))
		      (if (nthcdr 2 action)
			  (do-contents (o (object path-mask))
					 (when (or (null path-name)
						   (equal (name-of o) path-name))
					       (octprop o `(bag ,name 
								,@subchain))))
			  (get-or-create object `(object ,OCT-BAG
							 ((name . ,name)))))))
		((p prop property)
		 ;;
		 ;;    (property name value)
		 ;;    (property name value
		 ;;                   (OCT-TERM-MASK "BASE"))
		 ;;    (property name value
		 ;;                   (OCT-BAG-MASK "BJTMODEL")
		 ;;                   (OCT-BAG-MASK "SPICE"))
		 ;;
		 (let ((name (second action))
		       (value (third action))
		       (path-mask (first (fourth action)))
		       (path-name (second (fourth action)))
		       (subchain (nthcdr 4 action)))
		      (setq path-mask (if path-mask path-mask OCT-ALL-MASK))
		      (if (nthcdr 3 action)
			  (do-contents (o (object path-mask))
					 (when (or (null path-name)
						   (equal (name-of o) path-name))
					       (octprop o `(property ,name ,value
								     ,@subchain))))
			  (create-or-modify object
					    `(object ,OCT-PROP
						     ((name . ,name)
						      (value . ,value)))))))
		(t
		 ;;
		 ;;    wierd
		 ;;
		 (format *error-output "octprop: ~A - unknown form ~S - ignoring~%"
			 (pack-facet-name facet) action)))))

(defun demo ()
  "the example that is in the octprop (1) man page"
  (with-open-facet-by-packed-name (facet "/tmp/npn:schematic:contents" :readwrite)
				  (dolist (tname '("BASE" "EMITTER" "COLLECTOR"))
					  (create facet `(object ,OCT-TERM
								 ((name . ,tname)
								  (instance . ,oct-null-id)))))
				  ;; openning copies over the terminals 
				  (let ((ifacet (open-facet-by-packed-name "/tmp/npn:schematic:interface" :readwrite)))
				       (pprint facet)
				       (pprint ifacet)
				       ;;
				       ;;    the demo
				       ;;
				       (octprop ifacet
						`(property "TECHNOLOGY" "scmos")
						`(property "VIEWTYPE" "SCHEMATIC")
						`(property "EDITSTYLE" "PHYSICAL")
						`(property "CELLTYPE" "BJT")
						`(property "BJTTYPE" "NPN")
						`(property "BJTAREA" 1e-11)
						`(bag "BJTMODEL")
						`(bag "SPICE"
						      (,OCT-BAG-MASK "BJTMODEL"))
						`(property "Is" 1e-15
							   (,OCT-BAG-MASK "BJTMODEL")
							   (,OCT-BAG-MASK "SPICE"))
						`(property "DIRECTION" "INPUT"
							   (,OCT-TERM-MASK "BASE"))
						`(property "DIRECTION" "INOUT"
							   (,OCT-TERM-MASK "EMITTER"))
						`(property "DIRECTION" "OUTPUT"
							   (,OCT-TERM-MASK "COLLECTOR")))
				       (close-facet ifacet))))

(format t "octprop~%    ~
  use (demo) to demo~%")

