(validation attach-once
  (with-genfacet (facet :readwrite)
		 (error-recovery
		  (attach-once nil facet))
		 (error-recovery
		  (attach-once facet 1))
		 (error-recovery
		  (attach-once 1 1)))
  (with-genfacet (facet :readwrite)
		 (let (ret
		       (TECHNOLOGY
			(create-not-attached facet
					     `(object ,OCT-PROP
						      ((name . "TECHNOLOGY")
						       (value . "scmos")))))
		       (VIEWTYPE
			(create-not-attached facet
					     `(object ,OCT-PROP
						      ((name . "VIEWTYPE")
						       (value . "SCHEMATIC")))))
		       (EDITSTYLE 
			(create-not-attached facet
					     `(object ,OCT-PROP
						      ((name . "EDITSTSYLE")
						       (value . "PHYSICAL")))))
		       (CONNECTORS
			(create-not-attached facet
					     `(object ,OCT-BAG
						      ((name . "CONNECTORS")))))
		       (INSTANCES
			(create-not-attached facet
					     `(object ,OCT-BAG
						      ((name . "INSTANCES")))))
		       (WIRING
			(create-not-attached facet
					     `(object ,OCT-LAYER
						      ((name . "WIRING")))))
		       (multi-edge
			(create-not-attached facet
					     `(object ,OCT-EDGE
						      ((start . ,(point 4 0))
						       (end . ,(point 9 33)))))))
		      (dolist (ob (list TECHNOLOGY VIEWTYPE EDITSTYLE
					CONNECTORS INSTANCES WIRING
					multi-edge multi-edge multi-edge multi-edge))
			      (setq ret (attach-once facet ob))
			      (format t "attach-once ~S -> ~S returns ~S~%" facet ob ret))
		      (format t "Containers of ~S~%" facet)
		      (do-containers (thing facet)
				     (princ thing) (terpri))
		      (format t "Average number of edges per container: ~F~%"
			      (average-number-of-attachments object #'init-gen-containers))
		      (format t "Contents of ~S~%" facet)
		      (do-contents (thing facet)
				     (princ thing) (terpri))
		      (format t "Average number of edges per content: ~F~%"
			      (average-number-of-attachments object #'init-gen-contents)))))
