(validation create
  (with-genfacet (facet :readwrite)
		 (error-recovery
		  (create facet nil))
		 (error-recovery
		  (create nil `(object ,OCT-BOX
				       ((box . ,(box (point 2 2) (point 2 2))))))))
  (flet ((create-genfacet (object-form)
			  "create the object in a newly-generated facet (don't close the facet)"
			  (let ((facet (genfacet :readwrite)))
			       (create-not-attached facet object-form))))
	(let* ((bag (create-genfacet
		     `(object ,OCT-BAG
			      ((name . ,(genname))))))
	       (box (create-genfacet
		     `(object ,OCT-BOX
			      ((box . ,(box (point 900 234)
					    (point 934 999)))))))
	       (circle (create-genfacet
			`(object ,OCT-CIRCLE
				 ((center . ,(point 9 2))
				  (innerRadius . 0)
				  (outerRadius . 100)
				  (startingAngle . 0)
				  (endingAngle . 3600)))))
	       (edge (create-genfacet
		      `(object ,OCT-EDGE
			       ((start . ,(point 3 14))
				(end . ,(point 0 -8))))))
	       (instance (with-genfacet (master :readwrite)
					(create-genfacet
					 `(object ,OCT-INSTANCE
						  ((transform . ,(transform (point 0 0) OCT-NO-TRANSFORM))
						   (name . ,(genname))
						   (master . ,(cell-of master))
						   (view . ,(view-of master))
						   (version . ,(version-of master)))))))
	       (label (create-genfacet
		       `(object ,OCT-LABEL
				((label . ,(genname))
				 (position . ,(point 33 1002))))))
	       (layer (create-genfacet
		       `(object ,OCT-LAYER
				((name . ,(genname))))))
	       (net (create-genfacet
		     `(object ,OCT-NET
			      ((name . ,(genname))))))
	       (path (create-genfacet
		      `(object ,OCT-PATH
			       ((width . 100)
				(points . ,(list (point 0 0)
						 (point 2 3)
						 (point 4 9)
						 (point 16 81)
						 (point 256 6561)))))))
	       (polygon (create-genfacet
			 `(object ,OCT-POLYGON
				  ((points . ,(list (point 0 0)
						    (point 0 1)
						    (point 1 2)
						    (point 2 4)
						    (point 4 8)
						    (point 8 4)
						    (point 4 2)
						    (point 2 1)))))))
	       (point (create-genfacet
		       `(object ,OCT-POINT
				((point . ,(point 33 -1934))))))
	       (id (create-genfacet
		    `(object ,OCT-PROP
			     ((name . ,(genname))
			      (value . ,facet)))))
	       (integer (create-genfacet
			 `(object ,OCT-PROP
				  ((name . ,(genname))
				   (value . 100)))))
	       (real (create-genfacet
		      `(object ,OCT-PROP
			       ((name . ,(genname))
				(value . .100)))))
	       (string (create-genfacet
			`(object ,OCT-PROP
				 ((name . ,(genname))
				  (value . ,(genname))))))
	       (integer-array (create-genfacet
			       `(object ,OCT-PROP
					((name . ,(genname))
					 (value . (1 2 3 4 5 6 7 8 9))))))
	       (real-array (create-genfacet
			    `(object ,OCT-PROP
				     ((name . ,(genname))
				      (value . (1 2 3.0 4 5 6 7 8 9))))))
	       (stranger (create-genfacet
			  `(object ,OCT-PROP
				   ((name . ,(genname))
				    (value . ,(cons "" (map 'list #'(lambda (x) (+ 97 x))
							    '(1 2 3 4 5 6 7 8 9))))))))
	       (term (create-genfacet
		      `(object ,OCT-TERM
			       ((name . ,(genname))
				(instance . ,oct-null-id))))))
	      (dolist (ob (list bag box circle edge facet instance label layer net path polygon point
				id integer real string integer-array real-array stranger term))
		      (format t "facet of ~S is ~S because ~S is the same object~%"
			      ob
			      (get-facet ob)
			      (gen-first-content (get-facet ob) OCT-ALL-MASK))))))
