(validation open-facet-by-name
  (error-recovery
   (open-facet-by-name (point 0 0) "yes" "contents" "" :readwrite))
  (error-recovery
   (open-facet-by-name (gencellname) (box (point 1 2) (point 3 4)) "contents" "" :readwrite))
  (error-recovery
   (open-facet-by-name (gencellname) "no" 1.2 "" :readwrite))
  (error-recovery
   (open-facet-by-name (gencellname) "no" "contents" #'car :readwrite))
  (error-recovery
   (open-facet-by-name (gencellname) "no" "contents" OCT-CURRENT-VERSION 100))
  (error-recovery
   (open-facet-by-name (gencellname) "no" "contents" OCT-CURRENT-VERSION 'symbol-name))
  (flet ((test-mode (mode)
		    (let* ((cell (gencellname))
			   (view (genname))
			   (facet (open-facet-by-name cell view "contents" OCT-CURRENT-VERSION mode)))
			  (when (not facet)
				(format t "Could not open ~A:~A:contents as ~S because ~A~%"
					cell view mode (oct-error-string))
				(throw 'octlisp nil))
			  (format t "facet ~a:~a:contents mode is ~S~%"
				  (cell-of facet)
				  (view-of facet)
				  (mode-of facet))
			  (if (not (close-facet facet))
			      (format t "Could not close ~A:~A:contents as ~S because ~A~%"
				      cell view mode (oct-error-string))))))
	
	(test-mode :readonly)
	(test-mode :readwrite)
	(test-mode :readwrite-append)))
