(validation open-facet-pair
  (error-recovery
   (open-facet-pair (point 0 0) "contents" :readwrite))
  (with-open-facet (contents (gencellname) (genname) "contents" OCT-CURRENT-VERSION :readwrite)
		   (error-recovery
		    (let ((interface (open-facet-pair contents 45 :readwrite)))
			 (format t "This should never be seen~%")))
		   (error-recovery
		    (let ((interface (open-facet-pair contents "interface1" .8)))
			 (format t "This should never be seen~%")))
		   (error-recovery
		    (let ((interface (open-facet-pair contents "interface1" 'car)))
			 (format t "This should never be seen~%"))))
  (flet ((terms (facet)
		(format t "Facet ~S~%" facet)
		(do-contents (term facet OCT-TERM-MASK)
			     (format t "    Terminal ~S~%" term))
		(format t "----~%"))
	 (test-mode (contents mode)
		    (let* ((facet (open-facet contents "interface" mode)))
			  (when (not facet)
				(format t "Could not open ~A:~A:interface as ~S because ~A~%"
					(cell-of contents) (view-of contents) mode (oct-error-string))
				(throw 'octlisp nil))
			  (terms contents)
			  (terms interface)
			  (format t "----------~%")
			  (close-facet interface))))
	(with-genfacet (facet :readwrite)
		       (dotimes (i 10)
				(create facet `(object ,OCT-TERM
						       ((name . ,(genname))
							(instance . ,oct-null-id)))))
		       (test-mode facet :readonly)
		       (test-mode facet :readwrite)
		       (test-mode facet :readwrite-append))))
