(validation open-facet
  (error-recovery
   (open-facet (point 0 0) :readwrite))
  (error-recovery
   (open-facet `(object ,OCT-FACET
			((cell . ,(gencellname))
			 (view . ,(genname))
			 (facet . "contents")
			 (version . "")
			 (mode . :readonly)))
	       'symbol-name))
  (flet ((test-mode (mode)
		    (let* ((cell (gencellname))
			   (view (genname))
			   (facet (open-facet `(object ,OCT-FACET
						       ((cell . ,cell)
							(view . ,view)
							(facet . "contents")
							(version . ,OCT-CURRENT-VERSION)
							(mode . ,mode)))
					      mode)))
			  (when (not facet)
				(format t "Could not open ~A:~A:contents as ~S because ~A~%"
					cell view mode (oct-error-string))
				(throw 'octlisp nil))
                          (format t "facet ~a:~a:contents mode is ~S~%"
                                  (cell-of facet)
                                  (view-of facet)
                                  (mode-of facet))
			  (if (not (close-facet facet))
			      (format t "Could not close ~A:~A:contents as ~S because ~A~%"
				      cell view mode (oct-error-string))))))
	
	(test-mode :readonly)
	(test-mode :readwrite)
	(test-mode :readwrite-append)))
