(validation open-master
  (error-recovery
   (open-master (point 0 0) "contents" :readwrite))
  (with-genfacet (facet :readwrite)
		 (with-genfacet (master :readwrite)
				(let ((instance (create facet
							`(object ,OCT-INSTANCE
								 ((transform . ,(transform (point 0 0)
											   OCT-NO-TRANSFORM))
								  (name . ,(genname))
								  (cell . ,(cell-of master))
								  (view . ,(view-of master))
								  (version . ,OCT-CURRENT-VERSION))))))
				     (error-recovery
				      (open-master instance (box (point 1 2) (point 3 4)) :readwrite))
				     (error-recovery
				      (open-master instance "contents" '*)))))
  (flet ((test-mode (master mode)
		    (let* ((cell (gencellname))
			   (view (genname))
			   (facet (open-facet cell view "contents" OCT-CURRENT-VERSION :readwrite))
			   instance
			   master-facet)
			  (when (not facet)
				(format t "Could not open ~A:~A:contents as ~S because ~A~%"
					cell view mode (oct-error-string))
				(throw 'octlisp nil))
			  (setq instance (create facet `(object ,OCT-INSTANCE
								((transform . ,(transform (point 0 0)
											  OCT-NO-TRANSFORM))
								 (name . ,(genname))
								 (cell . ,(cell-of master))
								 (view . ,(viewof master))
								 (version . ,OCT-CURRENT-VERSION)))))
			  (when (not instance)
				(format t "Could not instantiate ~A:~A because ~A~%"
					(cell-of master) (view-of) (oct-error-string))
				(throw 'octlisp nil))
			  (setq master-facet (open-master instance "contents" mode))
			  (when (not master-facet)
				(format t "Could not open master of ~S because ~A~%"
					instance (oct-error-string))
				(throw 'octlisp nil)))))
	(with-genfacet (facet :readwrite)
		       (dotimes (i 10)
				(create facet `(object ,OCT-EDGE ((start . ,(point (random 1000)
										   (random 1000)))
								  (end . ,(point (random 1000)
										 (random 1000)))))))
		       (test-mode facet :readonly)
		       (test-mode facet :readwrite)
		       (test-mode facet :readwrite-append))))
