;;;;(
;;;;    show that generation works
;;;;

; this is made for loading from the octlisp directory
(load "OctLisp/generate.ll")
(load "OctLisp/assert.ll")

(let ((facet (open-facet-by-name "/tmp/diddly" "symbolic" "contents" "" :readwrite)))
  (dotimes (i 5)
	   (let* ((random (random 1000))
		  (bag (create facet
			       `(object ,OCT-BAG
					((name . ,(format nil
							  "sack-~d" i))))))
		  (minor-down (create
			       (create-not-attached
				facet
				`(object ,OCT-BAG ((name . "turdbag"))))
			       `(object ,OCT-PROP
					((name . "DOWN")
					 (value . ,(format nil
							   "downer-~d" random))))))
		  (minor-up (create
			     (create-not-attached
			      facet
			      `(object ,OCT-BAG ((name . "turdbag"))))
			     `(object ,OCT-PROP
				      ((name . "UP")
				       (value . ,(format nil
							 "uppity-~d" random)))))))
		 (oct-assert (attach bag minor-down))
		 (oct-assert (attach minor-up bag))))
  
  (format t "~%The Basic Generation tests~%")
  (flet ((updown (init)
		 "generate all of the containers or
		 contents of the bags on the facet"
		 
		 (do* ((gen (oct-assert (init-gen-contents facet oct-bag-mask)))
		       (b (generate gen) (generate gen)))
		      ((null b))
		      
		      (pprint b)
		      
		      ;; generate all of the containers or contents
		      (do* ((gen (oct-assert (funcall init b oct-prop-mask)))
			    (p (gen-first-content (generate gen) OCT-PROP-MASK)
			       (gen-first-content (generate gen) OCT-PROP-MASK)))
			   ((null p))
			   (princ "    ")
			   (pprint p)
			   (terpri)))))
	
	(updown #'init-gen-contents)
	(updown #'init-gen-containers))
  
  (format t "~%The Do-Containers/Do-Contents tests~%")
  (do-containers (b (facet OCT-BAG-MASK))
		 (let (up (up-ret nil) down (down-test nil))
		      (pprint b)
		      (terpri)
		      (setq up (do-containers (p (b OCT-ALL-MASK) up-ret)
					      (setq p (gen-first-content p OCT-PROP-MASK))
					      (princ "   ")
					      (pprint p)
					      (terpri)
					      (setq up-ret (cons p up-ret))))
		      (format t "    map-containers is ~a~%"
			      (if (equalp up (map-containers b OCT-PROP-MASK))
				  "equal"
				  "not equal"))
		      (setq down (do-contents (p (b OCT-ALL-MASK) down-ret)
					      (setq p (gen-first-content p OCT-PROP-MASK))
					      (princ "   ")
					      (pprint p)
					      (terpri)
					      (setq down-ret (cons p down-ret))))
		      (format t "    map-contents is ~a~%"
			      (if (equalp down (map-contents b OCT-PROP-MASK))
				  "equal"
				  "not equal")))))

;)
