;(
;;;;
;;;;    Try to create all possible object types
;;;;

(defvar master `(object ,OCT-FACET
			((cell . "/tmp/frog")
			 (view . "symbolic")
			 (facet . "contents")
			 (version . "")
			 (mode . :readwrite))))
(defvar facet `(object ,OCT-FACET
		       ((cell . "/tmp/fig")
			(view . "symbolic")
			(facet . "contents")
			(version . "")
			(mode . :readwrite))))
(defvar term `(object ,OCT-TERM
		      ((name . "T")
		       (instance . ,oct-null-id))))
(defvar net `(object ,OCT-NET
		     ((name . nil))))
(defvar instance `(object ,OCT-INSTANCE
			  ((name . nil)
			   (master . "/tmp/frog")
			   (view . "symbolic")
			   (version . "")
			   (transform . ,(transform (point 0 0)
						    OCT-NO-TRANSFORM)))))
(defvar polygon `(object ,OCT-POLYGON
			 ((points . ,(list (point 0 0)
					   (point 1 2)
					   (point 3 4)
					   (point 5 6)
					   (point 7 8))))))
(defvar box `(object ,OCT-BOX
			 ((box . ,(box (point 0 2)
				       (point 3 9))))))
(defvar circle `(object ,OCT-CIRCLE
			 ((center . ,(point 0 2))
			  (innerRadius . 4)
			  (outerRadius . 30)
			  (startingAngle . 90)
			  (endingAngle . 3555))))
(defvar path `(object ,OCT-PATH
		      ((width . 3)
		       (points . ,(list (point 0 0)
					(point 1 2)
					(point 3 4)
					(point 5 6)
					(point 7 8))))))
(defvar label `(object ,OCT-LABEL
		       ((label . "l")
			(position . ,(point 0 2)))))
(defvar prop `(object ,OCT-PROP
		      ((name . "p")
		       (value . "2"))))
(defvar bag `(object ,OCT-BAG
		      ((name . "b"))))
(defvar layer `(object ,OCT-LAYER
		       ((name . "l"))))
(defvar point `(object ,OCT-POINT
		       ((point . ,(point 2 9090)))))
(defvar edge `(object ,OCT-EDGE
		      ((start . ,(point 2 -7))
		       (end . ,(point -34 3)))))

(defmacro testq (symbol exp)
  `(catch 'octlisp
	  (unless (setq ,symbol ,exp)
		  (format t "~S - ~A~%" ',symbol (oct-error-string)))))

(testq facet-obj (open-facet facet :readwrite))
(testq master-obj (open-facet master :readwrite))

(testq term-obj (create facet-obj term))
(testq net-obj (create facet-obj net))
(testq instance-obj (create facet-obj instance))
(testq polygon-obj (create facet-obj polygon))
(testq box-obj (create facet-obj box))
(testq circle-obj (create facet-obj circle))
(testq path-obj (create facet-obj path))
(testq label-obj (create facet-obj label))
(testq prop-obj (create facet-obj prop))
(testq bag-obj (create facet-obj bag))
(testq layer-obj (create facet-obj layer))
(testq point-obj (create facet-obj point))
(testq edge-obj (create facet-obj edge))

;)
