;;;;(
;;;;    show that with-open works
;;;;

; this is made for loading from the octlisp directory
(load "OctLisp/facetname.ll")
(load "OctLisp/assert.ll")

(defun shove (facet)
  "shove some stuff in the facet"
  (macrolet ((p (name func)
		`(create facet
			 '(object ,OCT-PROP ((name . ,name)
					     (value . ,(funcall func facet)))))))
	    (p "cell" #'cell-of)
	    (p "view" #'view-of)
	    (p "facet" #'facet-of)
	    (p "version" #'version-of))
  (dotimes (i 5)
	   (let* ((random (random 1000))
		  (bag (create facet
			       `(object ,OCT-BAG
					((name . ,(format nil
							  "sack-~d" i))))))
		  (minor-down (create
			       (create-not-attached
				facet
				`(object ,OCT-BAG ((name . "turdbag"))))
			       `(object ,OCT-PROP
					((name . "DOWN")
					 (value . ,(format nil
							   "downer-~d" random))))))
		  (minor-up (create
			     (create-not-attached
			      facet
			      `(object ,OCT-BAG ((name . "turdbag"))))
			     `(object ,OCT-PROP
				      ((name . "UP")
				       (value . ,(format nil
							 "uppity-~d" random)))))))
		 (oct-assert (attach bag minor-down))
		 (oct-assert (attach minor-up bag)))))

(defun pull (facet)
  "pull the stuff out of the facet"
  (flet ((updown (init)
		 "generate all of the containers or contents of the bags on the facet"
		 
		 (do* ((gen (oct-assert (init-gen-contents facet oct-bag-mask)))
		       (b (generate gen) (generate gen)))
		      ((null b))
		      
		      (pprint b)
		      
		      ;; generate all of the containers or contents
		      (do* ((gen (oct-assert (funcall init b oct-prop-mask)))
			    (p (gen-first-content (generate gen) OCT-PROP-MASK)
			       (gen-first-content (generate gen) OCT-PROP-MASK)))
			   ((null p))
			   (princ "    ")
			   (pprint p)
			   (terpri)))))
	
	(updown #'init-gen-contents)
	(updown #'init-gen-containers)))
  
;;;
;;;    Begin testing the with-open macros
;;;

(with-open-facet (fig `(object ,OCT-FACET
			       ((cell . "/tmp/dingaling")
				(view . "symbolic")
				(facet . "contents")
				(version . "")
				(mode . :readonly)))
		      :readwrite)
  (shove fig)
  (pull fig))

(with-open-facet-by-name (fog "/tmp/dingalong" "symbolic" "contents" "" :readwrite)
  (shove fog)
  (pull fog))

(with-open-facet-by-packed-name (fag "/tmp/hopalong:symbolic:contents" :readwrite)
  (shove fag)	; hey! you can't say that on TV!
  (pull fag))
  
