#include <sys/types.h>
#include <setjmp.h>
#include <stdio.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstk.h"
#include "dynstr.h"
#include "st.h"
#include "stream.h"

#include "LightLisp.h"
#include "LightLispMachine.h"

#include "oct.h"
#include "oct_helper.h"

#include "OctLisp.h"
#include "OctLispMachine.h"

static OLstatus (*user_subinitialize)();
static LLstatus octlisp_initialize();

static void usage();

/*
 *    OLMain - a main for terminal based OctLisp programs
 *
 *    OLstatus
 *    user_initialize()
 *
 *    return stuff for exit() from main()
 */
int
OLMain(argc, argv, binary, package, libdir, user_initialize)
int argc;
char **argv;
String binary;			/* e.g. argv[0] but may be NULL */
String package;			/* e.g. "OctLisp" but may be NULL */
String libdir;			/* e.g. "~cad/lib/OctLisp" but may be NULL */
OLstatus (*user_initialize)();	/* may be NULL */
{
	extern char *getenv();	/* damnit I wish they'd do this for us */
	char *b;
	int i;

	if (binary == NULL) {
	    binary = "octlisp";
	}
	if (package == NULL) {
	    package = "OctLisp";
	}
	if (libdir == NULL) {
	    if ((libdir = getenv(package)) == NULL)
		libdir = OctLisp_LIBDIR;
	}

	user_subinitialize = user_initialize;
	return (LLMain(argc, argv, binary, package, libdir, octlisp_initialize));
}

static LLstatus
octlisp_initialize()
{
	if (OLInitialize() != OL_ok)
	    return (LL_notok);

	if (user_subinitialize != NULL && (*user_subinitialize)() != OL_ok)
	    return (LL_notok);

	return (LL_ok);
}
