#include "sumachine.h"

#include <sys/types.h>
#include <stdio.h>
#include <varargs.h>

#include "stuff.h"
#include "alloc.h"
#include "dyna.h"
#include "dynstr.h"

#include "stream.h"

#include "internal.h"

/*
 *    STREAMPrintf - printf but on streams
 *
 *    STREAMPrintf(stream, format, args ... )
 *
 *    return {STREAM_ok, STREAM_notok} on {ok, notok}
 */
STREAMstatus
STREAMPrintf(va_alist)
va_dcl
{
	STREAM *stream;
	String format;
	char *f, *sf, *sf_end;
	char sub_format_buf[15], fixed_buf[4096];
	STREAMstatus status;
	va_list ap;

	va_start(ap);

	stream = va_arg(ap, STREAM *);
	format = va_arg(ap, String);

	for (f=format; *f != '\0'; f++) {
	    if (*f != '%') {
		STREAMPutc(stream, *f);
	    } else {
		sf = sub_format_buf;
		sf_end = &sub_format_buf[sizeof_el (sub_format_buf)-2];	/* -1 for '\0' */

		do {
		    *sf++ = *f++;
		} while (*f != '\0' && index("%cdoxDOUXefgEFGsS", *f) == NULL && sf < sf_end);

		if (*f == '\0') {
		    *sf = '\0';
		    f--;	/* f++ above */
		} else if (sf >= sf_end) {
		    *sf = '\0';	/* f++ above */
		} else {
		    *sf++ = *f;	/* f++ above */
		    *sf = '\0';
		}

		/*
		 *    All of the hard stuff is done for us by vsprintf
		 */
		vsprintf(fixed_buf, sub_format_buf, ap);

		/*
		 *    Advance ap (b/c ap was passed by value to vsprintf
		 *    so it clearly wasn't advanced for us).
		 */
		switch (*f) {
		case '%':
		case '\0':
		    break;
		case 'c':
		    va_arg(ap, int);	/* should be a char! */
		    break;
		case 'd':
		case 'D':
		case 'o':
		case 'O':
		case 'u':
		case 'U':
		case 'x':
		case 'X':
		    va_arg(ap, long);
		    break;
		case 'e':
		case 'E':
		case 'f':
		case 'F':
		case 'g':
		case 'G':
		    va_arg(ap, double);
		    break;
		case 's':
		    va_arg(ap, char *);
		    break;
		}

		STREAMPuts(stream, fixed_buf);
	    }
	}

	va_end(ap)

	return (status);
}
