#include "sumachine.h"

#include <sys/types.h>

#include "stuff.h"
#include "alloc.h"

#include "tostring.h"

#define TABSTOPS	8

/*
 *    ExpandTabsString - return a copy of the string which is totally expanded
 *
 *    return the new copy
 */
String
ExpandTabsString(unexpanded)
String unexpanded;
{
	String u, e, expanded;
	int i, len, column, incr;

	for (u=unexpanded, len=0; *u != '\0'; u++) {
	    if (*u != '\t') {
		len++;
	    } else {
		len += TABSTOPS - len % TABSTOPS;
	    }
	}

	expanded = ALLOC_ARRAY(len+1, char);	/* '\0' */

	for (u=unexpanded, e=expanded, column=0; *u != '\0'; u++, e++) {
	    if (*u != '\t') {
		*e = *u;
		column++;
	    } else {
		incr = TABSTOPS - column % TABSTOPS;
		column += incr;
		for (i=0; i<incr; i++)
		    *e++ = ' ';
		--e;		/* ++ above */
	    }
	}
	*e = '\0';

	return (expanded);
}
