#include "sumachine.h"

#include <sys/types.h>
#include <time.h>		/* not sys/time.h */
#include <ctype.h>

#include "stuff.h"
#include "untime.h"

extern int UnTimeFindMonth();

/*
 * Convert a date(3) (output) format string into a system format date.
 * Return the date thus calculated.
 *
 * Return -1 if the string is not in date (output) format.
 */

time_t 
UnDate(str)
char *str;
{
	struct tm then;
	char weekday[4], amonth[4], offset[4];
	int month, day, hours, minutes, seconds, year;

	if (sscanf(str, " %3s %3s %2d %2d:%2d:%2d %3s %4d ",
		weekday, amonth, &day,
		&hours, &minutes, &seconds,
		offset, &year) != 8) {
	    return (-1);
	}

	if (UnTimeFindMonth(amonth, &month) < 0)
	    return  (-1);

	if (year > 1900)
	    year -= 1900;

	then.tm_year = year;
	then.tm_mon = month;
	then.tm_mday = day;
	then.tm_hour = hours;
	then.tm_min = minutes;
	then.tm_sec = seconds;

	if (then.tm_mon > 11 || then.tm_mday > 31 || then.tm_hour > 23 || then.tm_min > 59 || then.tm_sec > 59)
	    return (-1);

	return(UnLocalTime(&then));
}
