#include "sumachine.h"

#include <sys/types.h>
#include <time.h>		/* not sys/time.h */
#include <ctype.h>

#include "stuff.h"
#include "untime.h"

#define atoi2(ar)       (((ar)[0] - '0') * 10 + ((ar)[1] - '0'))

static Boolean alldigitsP();

/*
 * Convert a date(3) (input) format string into a system format date.
 * Return the date thus calculated.
 *
 * Return -1 if the string is not in (input) date format.
 */

time_t 
UnSetDate(str)
char *str;
{
	struct tm then, *gmnow;
	time_t now;
	int len;
	char dbuf[sizeof ("yyyymmddhhmm.ss")];
	char *period;

	len = strlen(str);

	if (len > sizeof_el (dbuf)-1)
	    return (-1);

	strcpy(dbuf, str);
	if ((period = rindex(dbuf, '.')) == NULL) {
	    then.tm_sec = 0;
	} else {
	    if (period[1] == '\0' || period[2] == '\0' || period[3] != '\0')
		return (-1);
	    if ( ! alldigitsP(&period[1]) )
		return (-1);
	    then.tm_sec = atoi2(&period[1]);
	    *period = '\0';
	    len -= 3;
	}

	if ( ! alldigitsP(dbuf) )
	    return (-1);

	time(&now);
	gmnow = localtime(&now);

	switch (len) {
	case 12:		/* 19yymmddhhmm */
	    if (dbuf[0] != '1' || dbuf[1] != '9')
		return (-1);
	    then.tm_year = atoi2(&dbuf[2]);
	    then.tm_mon = atoi2(&dbuf[4])-1;
	    then.tm_mday = atoi2(&dbuf[6]);
	    then.tm_hour = atoi2(&dbuf[8]);
	    then.tm_min = atoi2(&dbuf[10]);
	    break;
	case 10:		/* yymmddhhmm */
	    then.tm_year = atoi2(&dbuf[0]);
	    then.tm_mon = atoi2(&dbuf[2])-1;
	    then.tm_mday = atoi2(&dbuf[4]);
	    then.tm_hour = atoi2(&dbuf[6]);
	    then.tm_min = atoi2(&dbuf[8]);
	    break;
	case 8:			/* mmddhhmm */
	    then.tm_year = gmnow->tm_year;
	    then.tm_mon = atoi2(&dbuf[0])-1;
	    then.tm_mday = atoi2(&dbuf[2]);
	    then.tm_hour = atoi2(&dbuf[4]);
	    then.tm_min = atoi2(&dbuf[6]);
	    break;
	case 6:			/* ddhhmm */
	    then.tm_year = gmnow->tm_year;
	    then.tm_mon = gmnow->tm_mon;
	    then.tm_mday = atoi2(&dbuf[0]);
	    then.tm_hour = atoi2(&dbuf[2]);
	    then.tm_min = atoi2(&dbuf[4]);
	    break;
	case 4:			/* hhmm */
	    then.tm_year = gmnow->tm_year;
	    then.tm_mon = gmnow->tm_mon;
	    then.tm_mday = gmnow->tm_mday;
	    then.tm_hour = atoi2(&dbuf[0]);
	    then.tm_min = atoi2(&dbuf[2]);
	    break;
	}

	if (then.tm_mon > 11 || then.tm_mday > 31 || then.tm_hour > 23 || then.tm_min > 59 || then.tm_sec > 59)
	    return (-1);

	return(UnLocalTime(&then));
}

static Boolean 
alldigitsP(str)
String str;
{
	char *s;

	for (s=str; *s != '\0'; s++) {
	    if ( ! isdigit(*s) )
		return (FALSE);
	}

	return (TRUE);
}
