#include "internal.h"	/* before sumachine.h */
#include "sumachine.h"

static char RCS[] = "sumachine ($Revision: 1.1.1.1 $)";	/* to prevent a complete #ifdef */

#if (OPSYS_MFR == MD_UCB && OPSYS_VERS >= MD_BSD_4_2) || \
	(OPSYS_MFR == MD_IBM && OPSYS_SUBTYPE == MD_AICS) || \
	OPSYS_SUBTYPE == MD_DYNIX || \
	(OPSYS_MFR == MD_HP && OPSYS_SUBTYPE != MD_HPUX) || \
	OPSYS_MFR == MD_SONY /* { */
	/* sun provides this as of os 3.5 */

#if OPSYS_TYPE == MD_UNIX /* { */
#include <sys/types.h>
#endif /* } */
#if OPSYS_TYPE == MD_VMS /* { */
#include <types.h>
#endif /* } */

/*
 * Get next token from string s ((char *) 0 on 2nd, 3rd, etc. calls),
 * where tokens are nonempty strings separated by runs of
 * chars from delim.  Writes NULs into s to end tokens.  delim need not
 * remain constant from call to call.
 */

static char *scanpoint = (char *) 0;

char *				/* (char *) 0 if no token left */
strtok(s, delim)
char *s;
register char *delim;
{
	register char *scan;
	char *tok;
	register char *dscan;

	if (s == (char *) 0 && scanpoint == (char *) 0)
		return (char *) 0;
	if (s != (char *) 0)
		scan = s;
	else
		scan = scanpoint;

	/*
	 * Scan leading delimiters.
	 */
	for (; *scan != '\0'; scan++) {
		for (dscan = delim; *dscan != '\0'; dscan++)
			if (*scan == *dscan)
				break;
		if (*dscan == '\0')
			break;
	}
	if (*scan == '\0') {
		scanpoint = (char *) 0;
		return (char *) 0;
	}

	tok = scan;

	/*
	 * Scan token.
	 */
	for (; *scan != '\0'; scan++) {
		for (dscan = delim; *dscan != '\0';)	/* ++ moved down. */
			if (*scan == *dscan++) {
				scanpoint = scan+1;
				*scan = '\0';
				return tok;
			}
	}

	/*
	 * Reached end of string.
	 */
	scanpoint = (char *) 0;
	return tok;
}
#endif /* } */
