#include "internal.h"	/* before sumachine.h */
#include "sumachine.h"

#if OPSYS_TYPE == MD_UNIX /* { */
#include <sys/types.h>
#endif /* } */
#if OPSYS_TYPE == MD_VMS /* { */
#include <types.h>
#endif /* } */

static char RCS[] = "sumachine ($Revision: 1.1.1.1 $)";	/* to prevent a complete #ifdef */

static void fill_opsys_type();
static void fill_opsys_mfr();
static void fill_opsys_vers();
static void fill_cpu_model();
static void fill_cpu_type();

/*
 *    TODO - make this table-driven
 *
 *    TODO - this basically doesn't work
 */

/*
 *    GetSumachine - fill the sumachine structure.
 *
 *    return nothing, just do it.
 */
void
GetSumachine(su)
Sumachine *su;
{
	fill_opsys_type(&su->opsys_type);
	fill_opsys_mfr(&su->opsys_mfr);
	fill_opsys_vers(&su->opsys_vers);
	fill_cpu_type(&su->cpu_type);
	fill_cpu_model(&su->cpu_model);
}

/* TODO - find a better way to do this */

static void
fill_opsys_type(ps)
char **ps;		/* return */
{
	static char n[20];

#if OPSYS_TYPE == MD_UNIX
	*ps = "unix";
#define opsys_setP
#endif
#if OPSYS_TYPE == MD_VMS	
	*ps = "vms";
#define opsys_setP
#endif
#if OPSYS_TYPE == MD_IBM370
	*ps = "ibm 370";
#define opsys_setP
#endif
#if OPSYS_TYPE == MD_IBM_PC_AT_OS
	*ps = "ibm pc at";
#define opsys_setP
#endif
#if OPSYS_TYPE == MD_CRAY_OS
	*ps = "cray";
#define opsys_setP
#endif
#ifndef opsys_setP
	sprintf(n, "%d", OPSYS_TYPE);
	*ps = n;
#endif
}

static void
fill_opsys_mfr(ps)
char **ps;		/* return */
{
	static char n[20];

#if OPSYS_MFR == MD_UCB
	*ps = "ucb";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_ATT
	*ps = "att";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_MASSCOMP
	*ps = "masscomp";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_DEC
	*ps = "dec";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_SUN
	*ps = "sun";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_WOLLONGONG
	*ps = "wollongong";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_CRAY
	*ps = "cray";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_IBM
	*ps = "ibm";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_HP
	*ps = "hp";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_APOLLO
	*ps = "apollo";
#define mfr_setP
#endif
#if OPSYS_MFR == MD_SONY
	*ps = "sony";
#define mfr_setP
#endif
#if OPSYS_SUBTYPE == MD_DYNIX
	*ps = "sequent";
#define mfr_setP
#endif
#ifndef mfr_setP
	sprintf(n, "%d", OPSYS_MFR);
	*ps = n;
#endif
}

static void
fill_opsys_vers(ps)
char **ps;		/* return */
{
	static char n[20];

#if OPSYS_VERS == MD_BSD_4_1
	*ps = "4.1 bsd";
#define vers_setP
#endif
#if OPSYS_VERS == MD_BSD_4_2
	*ps = "4.2 bsd";
#define vers_setP
#endif
#if OPSYS_VERS == MD_BSD_4_3
	*ps = "4.3 bsd";
#define vers_setP
#endif
#if OPSYS_VERS == MD_BSD_4_4
	*ps = "4.4 bsd";
#define vers_setP
#endif
#if OPSYS_VERS == MD_SUN_1_4
	*ps = "sun 1.4";
#define vers_setP
#endif
#if OPSYS_VERS == MD_SUN_3_0
	*ps = "sun 3.0";
#define vers_setP
#endif
#if OPSYS_VERS == MD_SUN_3_1
	*ps = "sun 3.1";
#define vers_setP
#endif
#if OPSYS_VERS == MD_SUN_4_0
	*ps = "sun 4.0";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ULTRIX32_1_1
	*ps = "ultrix 32 V1.1";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ULTRIX32_1_2
	*ps = "ultrix 32 V1.2";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ULTRIX32_2_0
	*ps = "ultrix 32 V2.0";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ULTRIX32_2_1
	*ps = "ultrix 32 V2.1";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ULTRIX32_2_2
	*ps = "ultrix 32 V2.2";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ATT_SYS_3
	*ps = "att sys III";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ATT_SYS_5
	*ps = "att sys V";
#define vers_setP
#endif
#if OPSYS_VERS == MD_ATT_SYS_7
	*ps = "att sys VII";
#define vers_setP
#endif
#if OPSYS_VERS == MD_MC_2_1
	*ps = "masscomp 2.1";
#define vers_setP
#endif
#if OPSYS_VERS == MD_MC_2_2
	*ps = "masscomp 2.2";
#define vers_setP
#endif
#if OPSYS_VERS == MD_MC_3_0
	*ps = "masscomp 3.0";
#define vers_setP
#endif
#if OPSYS_VERS == MD_CRAY_1_OS
	*ps = "cray 1";
#define vers_setP
#endif
#if OPSYS_VERS == MD_CRAY_2_OS
	*ps = "cray 2";
#define vers_setP
#endif
#if OPSYS_VERS == MD_IBM_PC_AT
	*ps = "ibm pc at";
#define vers_setP
#endif
#if OPSYS_VERS == MD_HPUX_5_02
	*ps = "hpux 5.02";
#define vers_setP
#endif
#if OPSYS_VERS == MD_HPUX_5_02
	*ps = "hpux 5.02";
#define vers_setP
#endif
#if OPSYS_VERS == MD_HPUX_5_5
	*ps = "hpux 5.5";
#define vers_setP
#endif
#if OPSYS_VERS == MD_HPUX_5_6
	*ps = "hpux 5.6";
#define vers_setP
#endif
#if OPSYS_VERS == MD_APOLLO_5_9
	*ps = "apollo 5.9";
#define vers_setP
#endif
#if OPSYS_VERS == MD_APOLLO_6_0
	*ps = "apollo 5.9";
#define vers_setP
#endif
#if OPSYS_VERS == MD_DYNIX_3_0
	*ps = "dynix 3.0";
#define vers_setP
#endif
#ifndef vers_setP
	sprintf(n, "%d", OPSYS_VERS);
	*ps = n;
#endif
}

static void
fill_cpu_type(ps)
char **ps;		/* return */
{
	static char n[20];

#if CPU_TYPE == MD_VAX
	*ps = "vax";
#define type_setP
#endif
#if CPU_TYPE == MD_MC68K
	*ps = "mc 680?0";
#define type_setP
#endif
#if CPU_TYPE == MD_NSC32
	*ps = "nsc 320??";
#define type_setP
#endif
#if CPU_TYPE == MD_CRAY_CPU
	*ps = "cray";
#define type_setP
#endif
#if CPU_TYPE == MD_SPARC
	*ps = "sparc";
#define type_setP
#endif
#ifndef type_setP
	sprintf(n, "%d", CPU_TYPE);
	*ps = n;
#endif
}

static void
fill_cpu_model(ps)
char **ps;		/* return */
{
	static char n[20];

#if CPU_MODEL == MD_VAX730
	*ps = "vax 730";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX750
	*ps = "vax 750";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX780
	*ps = "vax 780";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX785
	*ps = "vax 785";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX8600
	*ps = "vax 8600";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX8650
	*ps = "vax 8650";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX8650
	*ps = "vax 8650";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX8800
	*ps = "vax 8800";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX8850
	*ps = "vax 8850";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX8900
	*ps = "vax 8900";
#define model_setP
#endif
#if CPU_MODEL == MD_VAX8950
	*ps = "vax 8950";
#define model_setP
#endif
#if CPU_MODEL == MD_UVAX_1
	*ps = "uvax 1";
#define model_setP
#endif
#if CPU_MODEL == MD_UVAX_2
	*ps = "uvax 2";
#define model_setP
#endif
#if CPU_MODEL == MD_UVAX_3
	*ps = "uvax 3";
#define model_setP
#endif
#if CPU_MODEL == MD_VAXSTAR
	*ps = "vaxstar";
#define model_setP
#endif
#if CPU_MODEL == MD_MC68000
	*ps = "mc 68000";
#define model_setP
#endif
#if CPU_MODEL == MD_MC68010
	*ps = "mc 68010";
#define model_setP
#endif
#if CPU_MODEL == MD_MC68020
	*ps = "mc 68020";
#define model_setP
#endif
#if CPU_MODEL == MD_NSC16032
	*ps = "nsc 16032";
#define model_setP
#endif
#if CPU_MODEL == MD_NSC32032
	*ps = "nsc 32032";
#define model_setP
#endif
#if CPU_MODEL == MD_CRAY_1
	*ps = "cray 1";
#define model_setP
#endif
#if CPU_MODEL == MD_CRAY_2
	*ps = "cray 2";
#define model_setP
#endif
#if CPU_MODEL == MD_SPARC_SUN
	*ps = "sun's sparc";
#define model_setP
#endif
#ifndef model_setP
	sprintf(n, "%d", CPU_MODEL);
	*ps = n;
#endif
}
