#include "internal.h"	/* before sumachine.h */
#include "sumachine.h"

static char RCS[] = "sumachine ($Revision: 1.1.1.1 $)";	/* to prevent a complete #ifdef */

#if (OPSYS_SUBTYPE == MD_ULTRIX && OPSYS_VERS >= MD_ULTRIX32_3_0) /* { */

#include <sys/types.h>
#include <ctype.h>

/*
 *    If you are on ultrix 3.0 or beyond, fake load-time
 *    compatibility by creating this array.  This is not a
 *    problem if ALL objects are compiled under ultrix 3.0
 *    but typically some are left over from ultrix 2.4 etc.
 *
 *    Because this only solves a load-time compatibility problem
 *    there is no need to fake up the ctype.h macros in sumachine.h
 */
char _ctype_[] = {
    /* M-^? */ 0x0,
    /* ^@ */ _C,
    /* ^A */ _C,
    /* ^B */ _C,
    /* ^C */ _C,
    /* ^D */ _C,
    /* ^E */ _C,
    /* ^F */ _C,
    /* ^G */ _C,
    /* ^H */ _C,
    /* ^I */ _S|_C,
    /* ^J */ _S|_C,
    /* ^K */ _S|_C,
    /* ^L */ _S|_C,
    /* ^M */ _S|_C,
    /* ^N */ _C,
    /* ^O */ _C,
    /* ^P */ _C,
    /* ^Q */ _C,
    /* ^R */ _C,
    /* ^S */ _C,
    /* ^T */ _C,
    /* ^U */ _C,
    /* ^V */ _C,
    /* ^W */ _C,
    /* ^X */ _C,
    /* ^Y */ _C,
    /* ^Z */ _C,
    /* ^[ */ _C,
    /* ^\ */ _C,
    /* ^] */ _C,
    /* ^^ */ _C,
    /* ^_ */ _C,
    /*   */ _S,
    /* ! */ _P,
    /* " */ _P,
    /* # */ _P,
    /* $ */ _P,
    /* % */ _P,
    /* & */ _P,
    /* ' */ _P,
    /* ( */ _P,
    /* ) */ _P,
    /* * */ _P,
    /* + */ _P,
    /* , */ _P,
    /* - */ _P,
    /* . */ _P,
    /* / */ _P,
    /* 0 */ _N,
    /* 1 */ _N,
    /* 2 */ _N,
    /* 3 */ _N,
    /* 4 */ _N,
    /* 5 */ _N,
    /* 6 */ _N,
    /* 7 */ _N,
    /* 8 */ _N,
    /* 9 */ _N,
    /* : */ _P,
    /* ; */ _P,
    /* < */ _P,
    /* = */ _P,
    /* > */ _P,
    /* ? */ _P,
    /* @ */ _P,
    /* A */ _U|_X,
    /* B */ _U|_X,
    /* C */ _U|_X,
    /* D */ _U|_X,
    /* E */ _U|_X,
    /* F */ _U|_X,
    /* G */ _U,
    /* H */ _U,
    /* I */ _U,
    /* J */ _U,
    /* K */ _U,
    /* L */ _U,
    /* M */ _U,
    /* N */ _U,
    /* O */ _U,
    /* P */ _U,
    /* Q */ _U,
    /* R */ _U,
    /* S */ _U,
    /* T */ _U,
    /* U */ _U,
    /* V */ _U,
    /* W */ _U,
    /* X */ _U,
    /* Y */ _U,
    /* Z */ _U,
    /* [ */ _P,
    /* \ */ _P,
    /* ] */ _P,
    /* ^ */ _P,
    /* _ */ _P,
    /* ` */ _P,
    /* a */ _L|_X,
    /* b */ _L|_X,
    /* c */ _L|_X,
    /* d */ _L|_X,
    /* e */ _L|_X,
    /* f */ _L|_X,
    /* g */ _L,
    /* h */ _L,
    /* i */ _L,
    /* j */ _L,
    /* k */ _L,
    /* l */ _L,
    /* m */ _L,
    /* n */ _L,
    /* o */ _L,
    /* p */ _L,
    /* q */ _L,
    /* r */ _L,
    /* s */ _L,
    /* t */ _L,
    /* u */ _L,
    /* v */ _L,
    /* w */ _L,
    /* x */ _L,
    /* y */ _L,
    /* z */ _L,
    /* { */ _P,
    /* | */ _P,
    /* } */ _P,
    /* ~ */ _P,
    /* ^? */ _C,
    /* M-^@ */ 0x0,
    /* M-^A */ 0x0,
    /* M-^B */ 0x0,
    /* M-^C */ _X,
    /* M-^D */ _S|_C,
    /* M-^E */ _U|_L|_C,
    /* M-^F */ _U|_S|_C,
    /* M-^G */ _U|_L|_C|_X,
    /* M-^H */ _N|_P|_C|_X,
    /* M-^I */ _U|_S|_P|_C|_X,
    /* M-^J */ _P|_C|_X,
    /* M-^K */ _U|_N|_C|_X,
    /* M-^L */ _U|_L|_N|_S|_P|_X,
    /* M-^M */ _L|_N|_S|_C,
    /* M-^N */ _U|_L|_C|_X,
    /* M-^O */ _U|_S,
    /* M-^P */ _U|_L|_P|_C,
    /* M-^Q */ _L|_N|_S|_C,
    /* M-^R */ _U|_P|_C,
    /* M-^S */ _U|_S,
    /* M-^T */ _S|_C,
    /* M-^U */ _U|_N|_P|_X,
    /* M-^V */ _N|_S|_X,
    /* M-^W */ _N|_P|_X,
    /* M-^X */ _L|_P|_X,
    /* M-^Y */ _U|_S|_X,
    /* M-^Z */ _S|_P|_X,
    /* M-^[ */ _U|_S|_C,
    /* M-^\ */ _U|_S,
    /* M-^] */ _U|_L|_P|_C,
    /* M-^^ */ _U|_L|_N|_S|_C,
    /* M-^_ */ _U|_N|_P|_C,
    /* M-  */ _U|_L|_N|_S|_C,
    /* M-! */ _S|_P|_C,
    /* M-" */ _U|_L|_N|_P|_C,
    /* M-# */ 0x0,
    /* M-$ */ 0x0,
    /* M-% */ 0x0,
    /* M-& */ 0x0,
    /* M-' */ _N|_S,
    /* M-( */ _U|_N|_P,
    /* M-) */ 0x0,
    /* M-* */ 0x0,
    /* M-+ */ _X,
    /* M-, */ _S|_C,
    /* M-- */ _U|_L|_C,
    /* M-. */ _U|_S|_C,
    /* M-/ */ _L|_N|_C|_X,
    /* M-0 */ _N|_S|_C|_X,
    /* M-1 */ _U|_L|_P|_C|_X,
    /* M-2 */ _L|_C|_X,
    /* M-3 */ _U|_N|_P|_C|_X,
    /* M-4 */ _L|_N|_C|_X,
    /* M-5 */ _L|_N|_S|_C,
    /* M-6 */ _U|_L|_C|_X,
    /* M-7 */ _U|_S,
    /* M-8 */ _U|_L|_P|_C,
    /* M-9 */ _L|_N|_S|_C,
    /* M-: */ _U|_P|_C,
    /* M-; */ _U|_S,
    /* M-< */ _S|_C,
    /* M-= */ _U|_N|_P|_X,
    /* M-> */ _N|_S|_X,
    /* M-? */ _N|_P|_X,
    /* M-@ */ _L|_P|_X,
    /* M-A */ _U|_S|_X,
    /* M-B */ _S|_P|_X,
    /* M-C */ _U|_S|_C,
    /* M-D */ _U|_S,
    /* M-E */ _U|_L|_P|_C,
    /* M-F */ _U|_L|_N|_S|_C,
    /* M-G */ _U|_N|_P|_C,
    /* M-H */ _U|_L|_N|_S|_C,
    /* M-I */ _S|_P|_C,
    /* M-J */ _U|_L|_N|_P|_C,
    /* M-K */ 0x0,
    /* M-L */ 0x0,
    /* M-M */ 0x0,
    /* M-N */ 0x0,
    /* M-O */ _N|_P|_C|_X,
    /* M-P */ _U|_N|_P,
    /* M-Q */ 0x0,
    /* M-R */ 0x0,
    /* M-S */ 0x0,
    /* M-T */ 0x0,
    /* M-U */ 0x0,
    /* M-V */ 0x0,
    /* M-W */ 0x0,
    /* M-X */ 0x0,
    /* M-Y */ 0x0,
    /* M-Z */ 0x0,
    /* M-[ */ 0x0,
    /* M-\ */ 0x0,
    /* M-] */ 0x0,
    /* M-^ */ 0x0,
    /* M-_ */ 0x0,
    /* M-` */ 0x0,
    /* M-a */ 0x0,
    /* M-b */ 0x0,
    /* M-c */ _U,
    /* M-d */ 0x0,
    /* M-e */ 0x0,
    /* M-f */ 0x0,
    /* M-g */ _L|_N|_S,
    /* M-h */ _U|_N|_S,
    /* M-i */ 0x0,
    /* M-j */ 0x0,
    /* M-k */ _N|_S|_P|_X,
    /* M-l */ _L|_S|_C,
    /* M-m */ 0x0,
    /* M-n */ 0x0,
    /* M-o */ _N,
    /* M-p */ _S|_P,
    /* M-q */ 0x0,
    /* M-r */ 0x0,
    /* M-s */ 0x0,
    /* M-t */ _C,
    /* M-u */ 0x0,
    /* M-v */ 0x0,
    /* M-w */ _L|_S,
    /* M-x */ 0x0,
    /* M-y */ _U,
    /* M-z */ 0x0,
    /* M-{ */ 0x0,
    /* M-| */ 0x0,
    /* M-} */ 0x0,
    /* M-~ */ 0x0,
    /* M-^? */ 0x0,
};
#endif /* } */
#ifdef origin /* { */
/*
 *    Go to a pre-ultrix 3.0 system, and compile and
 *    run this program.  It will produce the this data
 *
 *    cc -o thing thing.c -lstuff
 */
#include <ctype.h>

struct thing {
    int mask;
    char *name;
} things[] = {
    { _U,	"_U"	},
    { _L,	"_L"	},
    { _N,	"_N"	},
    { _S,	"_S"	},
    { _P,	"_P"	},
    { _C,	"_C"	},
    { _X,	"_X"	},
};

main()
{
	int c, i, yetP;

	printf("char _ctype_[] = {\n");

	for (c=0; c<257; c++) {
	    printf("    /* %s */ ", PrintableChar(c-1));

	    if ((_ctype_[c] & (_U|_L|_N|_S|_P|_C|_X)) == 0x0) {
		printf("0x0,\n");
	    } else {
		yetP = 0;
		for (i=0; i<sizeof (things)/sizeof (things[0]); i++) {
		    if (_ctype_[c] & things[i].mask) {
			if (yetP)
			    printf("|");
			yetP = 1;
			printf("%s", things[i].name);
		    }
		}
		printf(",\n");
	    }
	}

	printf("};\n");
}
#endif /* } */
