#include "internal.h"	/* before sumachine.h */
#include "sumachine.h"

static char RCS[] = "sumachine ($Revision: 1.1.1.1 $)";	/* to prevent a complete #ifdef */

#if (OPSYS_SUBTYPE == MD_ULTRIX && OPSYS_VERS < MD_ULTRIX32_3_0) /* { */

#include <sys/types.h>
#include <ctype.h>

/*
 *    If you not are on ultrix 3.0 or beyond, fake load-time
 *    compatibility with ultrix 3.0 and beyond by creating this array.
 *    This is not a problem if ALL objects are compiled pre-ultrix 3.0
 *    but typically some are from the new ultrix 3.0 also
 *
 *    Because this only solves a load-time compatibility problem
 *    there is no need to fake up the ctype.h macros in sumachine.h
 */
unsigned short _ctype__[] = {
    /* M-^? */ 0x0,
    /* ^@ */ _C,
    /* ^A */ _C,
    /* ^B */ _C,
    /* ^C */ _C,
    /* ^D */ _C,
    /* ^E */ _C,
    /* ^F */ _C,
    /* ^G */ _C,
    /* ^H */ _C,
    /* ^I */ _S|_C,
    /* ^J */ _S|_C,
    /* ^K */ _S|_C,
    /* ^L */ _S|_C,
    /* ^M */ _S|_C,
    /* ^N */ _C,
    /* ^O */ _C,
    /* ^P */ _C,
    /* ^Q */ _C,
    /* ^R */ _C,
    /* ^S */ _C,
    /* ^T */ _C,
    /* ^U */ _C,
    /* ^V */ _C,
    /* ^W */ _C,
    /* ^X */ _C,
    /* ^Y */ _C,
    /* ^Z */ _C,
    /* ^[ */ _C,
    /* ^\ */ _C,
    /* ^] */ _C,
    /* ^^ */ _C,
    /* ^_ */ _C,
    /*   */ _S|_B,
    /* ! */ _P,
    /* " */ _P,
    /* # */ _P,
    /* $ */ _P,
    /* % */ _P,
    /* & */ _P,
    /* ' */ _P,
    /* ( */ _P,
    /* ) */ _P,
    /* * */ _P,
    /* + */ _P,
    /* , */ _P,
    /* - */ _P,
    /* . */ _P,
    /* / */ _P,
    /* 0 */ _N,
    /* 1 */ _N,
    /* 2 */ _N,
    /* 3 */ _N,
    /* 4 */ _N,
    /* 5 */ _N,
    /* 6 */ _N,
    /* 7 */ _N,
    /* 8 */ _N,
    /* 9 */ _N,
    /* : */ _P,
    /* ; */ _P,
    /* < */ _P,
    /* = */ _P,
    /* > */ _P,
    /* ? */ _P,
    /* @ */ _P,
    /* A */ _U|_X,
    /* B */ _U|_X,
    /* C */ _U|_X,
    /* D */ _U|_X,
    /* E */ _U|_X,
    /* F */ _U|_X,
    /* G */ _U,
    /* H */ _U,
    /* I */ _U,
    /* J */ _U,
    /* K */ _U,
    /* L */ _U,
    /* M */ _U,
    /* N */ _U,
    /* O */ _U,
    /* P */ _U,
    /* Q */ _U,
    /* R */ _U,
    /* S */ _U,
    /* T */ _U,
    /* U */ _U,
    /* V */ _U,
    /* W */ _U,
    /* X */ _U,
    /* Y */ _U,
    /* Z */ _U,
    /* [ */ _P,
    /* \ */ _P,
    /* ] */ _P,
    /* ^ */ _P,
    /* _ */ _P,
    /* ` */ _P,
    /* a */ _L|_X,
    /* b */ _L|_X,
    /* c */ _L|_X,
    /* d */ _L|_X,
    /* e */ _L|_X,
    /* f */ _L|_X,
    /* g */ _L,
    /* h */ _L,
    /* i */ _L,
    /* j */ _L,
    /* k */ _L,
    /* l */ _L,
    /* m */ _L,
    /* n */ _L,
    /* o */ _L,
    /* p */ _L,
    /* q */ _L,
    /* r */ _L,
    /* s */ _L,
    /* t */ _L,
    /* u */ _L,
    /* v */ _L,
    /* w */ _L,
    /* x */ _L,
    /* y */ _L,
    /* z */ _L,
    /* { */ _P,
    /* | */ _P,
    /* } */ _P,
    /* ~ */ _P,
    /* ^? */ _C,
    /* M-^@ */ 0x0,
    /* M-^A */ 0x0,
    /* M-^B */ 0x0,
    /* M-^C */ 0x0,
    /* M-^D */ 0x0,
    /* M-^E */ 0x0,
    /* M-^F */ 0x0,
    /* M-^G */ 0x0,
    /* M-^H */ 0x0,
    /* M-^I */ 0x0,
    /* M-^J */ 0x0,
    /* M-^K */ 0x0,
    /* M-^L */ 0x0,
    /* M-^M */ 0x0,
    /* M-^N */ 0x0,
    /* M-^O */ 0x0,
    /* M-^P */ 0x0,
    /* M-^Q */ 0x0,
    /* M-^R */ 0x0,
    /* M-^S */ 0x0,
    /* M-^T */ 0x0,
    /* M-^U */ 0x0,
    /* M-^V */ 0x0,
    /* M-^W */ 0x0,
    /* M-^X */ 0x0,
    /* M-^Y */ 0x0,
    /* M-^Z */ 0x0,
    /* M-^[ */ 0x0,
    /* M-^\ */ 0x0,
    /* M-^] */ 0x0,
    /* M-^^ */ 0x0,
    /* M-^_ */ 0x0,
    /* M-  */ 0x0,
    /* M-! */ 0x0,
    /* M-" */ 0x0,
    /* M-# */ 0x0,
    /* M-$ */ 0x0,
    /* M-% */ 0x0,
    /* M-& */ 0x0,
    /* M-' */ 0x0,
    /* M-( */ 0x0,
    /* M-) */ 0x0,
    /* M-* */ 0x0,
    /* M-+ */ 0x0,
    /* M-, */ 0x0,
    /* M-- */ 0x0,
    /* M-. */ 0x0,
    /* M-/ */ 0x0,
    /* M-0 */ 0x0,
    /* M-1 */ 0x0,
    /* M-2 */ 0x0,
    /* M-3 */ 0x0,
    /* M-4 */ 0x0,
    /* M-5 */ 0x0,
    /* M-6 */ 0x0,
    /* M-7 */ 0x0,
    /* M-8 */ 0x0,
    /* M-9 */ 0x0,
    /* M-: */ 0x0,
    /* M-; */ 0x0,
    /* M-< */ 0x0,
    /* M-= */ 0x0,
    /* M-> */ 0x0,
    /* M-? */ 0x0,
    /* M-@ */ 0x0,
    /* M-A */ 0x0,
    /* M-B */ 0x0,
    /* M-C */ 0x0,
    /* M-D */ 0x0,
    /* M-E */ 0x0,
    /* M-F */ 0x0,
    /* M-G */ 0x0,
    /* M-H */ 0x0,
    /* M-I */ 0x0,
    /* M-J */ 0x0,
    /* M-K */ 0x0,
    /* M-L */ 0x0,
    /* M-M */ 0x0,
    /* M-N */ 0x0,
    /* M-O */ 0x0,
    /* M-P */ 0x0,
    /* M-Q */ 0x0,
    /* M-R */ 0x0,
    /* M-S */ 0x0,
    /* M-T */ 0x0,
    /* M-U */ 0x0,
    /* M-V */ 0x0,
    /* M-W */ 0x0,
    /* M-X */ 0x0,
    /* M-Y */ 0x0,
    /* M-Z */ 0x0,
    /* M-[ */ 0x0,
    /* M-\ */ 0x0,
    /* M-] */ 0x0,
    /* M-^ */ 0x0,
    /* M-_ */ 0x0,
    /* M-` */ 0x0,
    /* M-a */ 0x0,
    /* M-b */ 0x0,
    /* M-c */ 0x0,
    /* M-d */ 0x0,
    /* M-e */ 0x0,
    /* M-f */ 0x0,
    /* M-g */ 0x0,
    /* M-h */ 0x0,
    /* M-i */ 0x0,
    /* M-j */ 0x0,
    /* M-k */ 0x0,
    /* M-l */ 0x0,
    /* M-m */ 0x0,
    /* M-n */ 0x0,
    /* M-o */ 0x0,
    /* M-p */ 0x0,
    /* M-q */ 0x0,
    /* M-r */ 0x0,
    /* M-s */ 0x0,
    /* M-t */ 0x0,
    /* M-u */ 0x0,
    /* M-v */ 0x0,
    /* M-w */ 0x0,
    /* M-x */ 0x0,
    /* M-y */ 0x0,
    /* M-z */ 0x0,
    /* M-{ */ 0x0,
    /* M-| */ 0x0,
    /* M-} */ 0x0,
    /* M-~ */ 0x0,
    /* M-^? */ 0x0,
};
unsigned short *_pctype = _ctype__;
#endif /* } */
#ifdef origin /* { */
/*
 *    Go to a post-ultrix 3.0 system, and compile and
 *    run this program.  It will produce the this data
 *
 *    cc -o thing thing.c -lstuff
 */
#include <ctype.h>

struct thing {
    int mask;
    char *name;
} things[] = {
    { _U,	"_U"	},
    { _L,	"_L"	},
    { _N,	"_N"	},
    { _S,	"_S"	},
    { _P,	"_P"	},
    { _C,	"_C"	},
    { _X,	"_X"	},
    { _B,	"_B"	},
};

main()
{
	int c, i, yetP;

	printf("unsigned short _ctype__[] = {\n");

	for (c=0; c<257; c++) {
	    printf("    /* %s */ ", PrintableChar(c-1));

	    if ((_ctype__[c] & (_U|_L|_N|_S|_P|_C|_X|_B)) == 0x0) {
		printf("0x0,\n");
	    } else {
		yetP = 0;
		for (i=0; i<sizeof (things)/sizeof (things[0]); i++) {
		    if (_ctype__[c] & things[i].mask) {
			if (yetP)
			    printf("|");
			yetP = 1;
			printf("%s", things[i].name);
		    }
		}
		printf(",\n");
	    }
	}

	printf("};\n");
	printf("unsigned short *_pctype = _ctype__;\n");
}
#endif origin /* } */
