#include "boss_int.h"

BossBox::BossBox( BossFacet& facet,
		 int height,
		 int width,
		 char* layer_name)
{
    this->type = OCT_BOX;
    (getBB()).lowerLeft.x = 0;
    (getBB()).lowerLeft.y = 0;
    (getBB()).upperRight.x = width;
    (getBB()).upperRight.y = height;
    
    bossMessage("Creating Box");
    if(octCreate(&facet, this) != OCT_OK)
      errRaise( BOSS_PKG_NAME, 16, "Problems creating instance");
    
    BossLayer layer( facet, layer_name);
    if(octAttach(&layer, this) < OCT_OK)
      errRaise( BOSS_PKG_NAME, 18, form("Problem in attaching box to the layer %s", layer_name));
}
