#include "boss_int.h"

extern "C"
{
#include "symlib.h"
}

BossNet::BossNet(BossFacet& facet, char *name)
{
  static int auto_net_num = 0;

  if(name == 0)
    name = bossStrsav(form("auto.%d",auto_net_num++));
  bossMessage( form("creating net %s",name));
  symCreateNet(&facet, this);
  net_name() = name;
  OH_ASSERT(octModify(this));
}

void BossNet::add_term(BossTerm& term)
{
symAddTermToNet(&term, this);
}

void bossConnectAll( char *term_name, BossNet& net, enum BossNetConnType type)
{
octGenerator gen;
octObject inst;
octObject facet;

octGetFacet(&net, &facet);
OH_ASSERT(octInitGenContents(&facet, OCT_INSTANCE_MASK, &gen));
while(octGenerate(&gen, &inst) == OCT_OK)
  {
    octObject term;
    if(ohGetByTermName(&inst, &term, term_name) == OCT_OK)
      {
	if(type == BOSS_UNCONNECTED)
	  {
	    octObject test_net;
	    octStatus stat = octGenFirstContainer(&term , OCT_NET_MASK, &test_net);
	    if(stat == OCT_OK)
	      continue;
	    if(stat == OCT_ERROR)
	      errRaise( BOSS_PKG_NAME, 13, "Problem in connecting terminal\n");
	  }
	symAddTermToNet(&term, &net);	
      }
  }
}


/*
int BossNet::is_connected( BossInstance inst )
{
octGenerator gen;
octObject term;

OH_ASSERT( octInitGenContents(this, BOSSTERM_MASK, &gen) );
while(octGenerate(&gen, &term) == OCT_OK)
  {
    if(term.contents.term.instanceId == inst.objectId)
      return 1;
  }
return 0;
}
*/
