#include "boss_int.h"

extern "C"
{
#include "region.h"
#include "tr.h"
}

// returns 1 if a geometry on the specified layer can be found within the given
// box, 0 otherwise.

int bossSearchRegion( octObject& facet, octBox& box, char* layer_name )
{
regGenerator gen;
octObject layer;
octObject obj;
octObject new_facet;
octObject transformed_box;
octTransform trans;

// bossMessage(form("Searching %s : %s",facet.contents.facet.cell,facet.contents.facet.view));

OH_ASSERT(ohGetOrCreateLayer( &facet, &layer, layer_name));
regInit(&layer, &box, OCT_GEO_MASK, &gen);
if( regNext( &gen, &obj, 0, 0, 0 ) == REG_NOMORE )
  {
    transformed_box.type = OCT_BOX;
    regInit(&facet, &box, OCT_INSTANCE_MASK, &gen);
    while(regNext(&gen, &obj, 0, 0, 0) != REG_NOMORE)
      {
	transformed_box.contents.box.lowerLeft.x = box.lowerLeft.x;
	transformed_box.contents.box.lowerLeft.y = box.lowerLeft.y;
	transformed_box.contents.box.upperRight.x = box.upperRight.x;
	transformed_box.contents.box.upperRight.y = box.upperRight.y;

	if(ohOpenMaster(&new_facet, &obj, "contents", "r") < OCT_OK)
	  errRaise( BOSS_PKG_NAME, 45, "ERROR in opening master");

	tr_get_inverse_transform(&(obj.contents.instance.transform), &trans);
	octTransformGeo(&transformed_box, &trans);
	if(bossSearchRegion( new_facet, transformed_box.contents.box, layer_name) == 1)
	  return 1;
      }
    return 0;
  }
return 1;
}



