#include "boss_int.h"

extern "C"
{
#include "region.h"
#include "tap.h"
}


BossTerm::BossTerm(BossInstance& inst, char *name)
{
  (void)get(inst, name);
}

BossTerm::BossTerm(octObject& term)
{
  this->objectId = term.objectId;
  octStatus s = octGetById( this );  
  if( s < OCT_OK)
    errRaise( BOSS_PKG_NAME, 1, "Problems getting terminal of instance");
}

octStatus BossTerm::get(BossInstance& inst, char *name)
{
  octStatus s = ohGetByTermName(&inst, this, name); 
  if( s < OCT_OK)
    errRaise( BOSS_PKG_NAME, 2, "Problems getting terminal of instance");
  return s;
}

int BossTerm::num_layers()
{
int count;
octBox box;
char **layers;

if(regFindLyrImpl(this, &box, &count, &layers) != REG_OK)
  errRaise( BOSS_PKG_NAME, 7, "Problems in finding terminal layer");
return count;
}

char * BossTerm::layer(int i)
{
int count;
octBox box;
char **layers;

if(regFindLyrImpl(this, &box, &count, &layers) != REG_OK)
  errRaise( BOSS_PKG_NAME, 8, "Problems in finding terminal layer");
if(i >= count)
  errRaise( BOSS_PKG_NAME, 9, "Indexing nonexistent layer");
return layers[i];
}

