/*
 * giant.h
 * 
 * This is the header for the program giant, a simulated annealing based
 * partitioner.
 */

#include "port.h"
#include "utility.h"
#include "oct.h"
#include "oh.h"

/* general stuff */
#define TRUE 1
#define FALSE 0
#ifndef NULL
#define NULL 0
#endif
#define INFINITY 2000000000

/* defined types of cell weighting					*/
#define WEIGHT_TERMS (unsigned)1<<0

/* data types								*/

typedef struct bin {
    int count;
    int marked;
} s_bin;

typedef struct net {
    octId objectId;
    struct net *next;
    int numCells;
    struct cell **cell;
} s_net;

typedef struct cell {
    octId objectId;
    int row;
    int col;
    int numNets;
    int weight;
    struct net **net;
} s_cell;
