#include "copyright.h"
#include "jumbo.h"

extern int NumRows; 
extern int NumCols;
extern int NumCells;
extern int NewRow; 
extern int NewCol;
extern s_bin **Bin;
extern s_cell **Cells;
/*
 * genMove
 *
 * randomly generate a move to a cell
 */
genMove( cell, limiter )
s_cell *cell;
double limiter;
{
    int rowBound, colBound;
    int lowerBound, upperBound;

    rowBound = (int)(NumRows * limiter );
    if( rowBound < 1 )rowBound = 1;
    colBound = (int)(NumCols * limiter );
    if( colBound < 1 )colBound = 1;

    /* interate until a new state is found				*/
    while( 1 ){
	lowerBound = cell->row - rowBound;
	if( lowerBound < 0 )lowerBound = 0;
	upperBound = cell->row + rowBound;
	if( upperBound > NumRows - 1 )upperBound = NumRows - 1;
	NewRow = randomInt( lowerBound, upperBound );

	lowerBound = cell->col - colBound;
	if( lowerBound < 0 )lowerBound = 0;
	upperBound = cell->col + colBound;
	if( upperBound > NumCols - 1 )upperBound = NumCols - 1;
	NewCol = randomInt( lowerBound, upperBound );

	if(( cell->row != NewRow )||( cell->col != NewCol ))return;
    }
}
accMove( cell )
s_cell *cell;
{
    Bin[ cell->row ][ cell->col ].count -= cell->weight;
    Bin[ NewRow ][ NewCol ].count += cell->weight;
    cell->row = NewRow;
    cell->col = NewCol;
}
initialPlacement()
{
    int index;
    s_cell *cell;

    for( index = 0; index < NumCells; index++ ){
	cell = Cells[ index ];
	cell->row = randomInt( 0, NumRows - 1);
	cell->col = randomInt( 0, NumCols - 1);
	Bin[ cell->row ][ cell->col ].count += cell->weight;
    }
}

