#include "copyright.h"
#include "jumbo.h"
#include "nle.h"

extern octObject oFacet;
/*
 * undoPrevRun
 *
 * flatten the instances from a previous run, truncate the instances masters
 */
undoPrevRun()
{
    octObject oPartBag;
    octObject *oPart;
    octObject oInst;
    octGenerator gInst;
    octStatus sInst;
    int count = 0;

    oPartBag.type = OCT_BAG;
    oPartBag.contents.bag.name = "PARTITIONS";
    if( octGetByName( &oFacet, &oPartBag ) < OCT_OK ){
	fprintf( stderr, "Could not open %s bag in %s:%s:%s: %s: %s\n",
		 oPartBag.contents.bag.name,
		 oFacet.contents.facet.cell,
		 oFacet.contents.facet.view,
		 oFacet.contents.facet.version,
		 octErrorString(),
		 "cannot undo the partition" );
	exit( -1 );
    }
    OH_ASSERT( octInitGenContents( &oPartBag, OCT_INSTANCE_MASK, &gInst ));
    while(( sInst = octGenerate( &gInst, &oInst )) == OCT_OK ){
	count++;
    }
    oPart = ALLOC( octObject, count );
    OH_ASSERT( sInst );
    count = 0;
    OH_ASSERT( octInitGenContents( &oPartBag, OCT_INSTANCE_MASK, &gInst ));
    while(( sInst = octGenerate( &gInst, &oInst )) == OCT_OK ){
	oPart[ count ].type = OCT_FACET;
	oPart[ count ].contents.facet.cell = 
	    util_strsav( oInst.contents.instance.master );
	oPart[ count ].contents.facet.view = 
	    util_strsav( oInst.contents.instance.view );
	oPart[ count ].contents.facet.version = 
	    util_strsav( oInst.contents.instance.version );
	oPart[ count ].contents.facet.facet = "contents";
	oPart[ count ].contents.facet.mode = "a";
	if( nleFlatInstance( &oInst, NIL( octObject ), NLE_SOFT ) < NLE_OK ){
	    fprintf( stderr, "Problem flattening instance %s: %s: %s\n",
			     oInst.contents.instance.name,
			     nleErrorString(),
			     "cannot undo the partition" );
	    exit( -1 );
	}
	count++;
    }
    OH_ASSERT( sInst );
    /* 
    while( --count >= 0 ){
	oPart[ count ].contents.facet.mode = "a";
	if( octOpenFacet( &oPart[ count ] ) >= OCT_OK ){
	    while( octFreeFacet( &oPart[ count ] ) >= OCT_OK );
	}
	oPart[ count ].contents.facet.mode = "w";
	if( octOpenFacet( &oPart[ count ] ) < OCT_OK ){
	    fprintf( stderr, "Couldn't open master %s:%s:%s: %s: %s\n",
		     oPart[ count ].contents.facet.cell,
		     oPart[ count ].contents.facet.view,
		     oPart[ count ].contents.facet.version,
		     octErrorString(),
		     "cannot undo the partition" );
	    exit( -1 );
	}
	OH_ASSERT( octCloseFacet( &oPart[ count ] ));
    }
    */
    OH_ASSERT( octCloseFacet( &oFacet ));
}
