#! /bin/csh -f
#
# slide-send printer slide-list-file
#

if ($#argv != 2) then
    echo "usage: slide-send (film|trans|paper|lps40|lwcad) filename"
    exit 1
endif

set PRINTER = $1
set LIMIT = 3

if ($PRINTER == "film") then
    set LIMIT = 6
endif

if (($PRINTER == "film") || ($PRINTER == "trans") || ($PRINTER == "paper")) then
    if (! -e 7550-$PRINTER.map) then
        echo "The mapping file (7550-$PRINTER.map) does not exist in the current directory"
        exit 1
    endif
    set COMMAND = "hpgl -n -P$PRINTER -c 7550-$PRINTER.map"
    unset LPR
else if (($PRINTER == "lps40") || ($PRINTER == "lwcad")) then
    set COMMAND = "oct2ps"
    set LPR = "lpr -P$PRINTER"
else
    echo "Only the output devices 'film', 'trans', 'paper', 'lps40', and 'lwcad' are understood"
    exit 1
endif

foreach i (`cat $2`)
    if (-d $i/slide) then
	set x = `lpq -P$PRINTER | grep $USER | wc -l`
	while ($x > $LIMIT)
	    sleep 10
	    set x = `lpq -P$PRINTER | grep $USER | wc -l`  
	end
	echo printing $i\:slide on $PRINTER
	if ($?LPR) then
	    $COMMAND $i\:slide | $LPR
	else
	    $COMMAND $i\:slide
	endif
    else 
	echo Error: cannot find $i\:slide
    endif
end

exit 0

