/*
 * Slide-Maker
 *
 * Oct Tools Distribution 5.1
 *
 * Copyright (c) 1988, 1989, 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Use and copying of this software and preparation of derivative works
 * based upon this software are permitted.  However, any distribution of
 * this software or derivative works must include the above copyright
 * notice.
 *
 * This software is made available AS IS, and neither the Electronics
 * Research Laboratory or the University of California make any
 * warranty about the software, its performance or its conformity to
 * any specification.
 *
 * Suggestions, comments, or improvements are welcome and should be
 * addressed to:
 *
 *   octtools@eros.berkeley.edu
 *   ..!ucbvax!eros!octtools
 */

#define OFFSET 1000
#define PAGEHEIGHT 11.0
#define PAGEWIDTH 8.5
#define UNITSPERINCH 500

#define ARROWANGLE 60.0
#define DEGREESTORADIANS (3.1415926 / 180.0)
#define ARROWSCALE 1.0
#define WIDTH 0
#define SCALE 10
#define LETTERDIR "lib/slide-maker/letters"
#define FONTFILE "lib/slide-maker/hershey-fonts/hershey.oc"
#define FONTDIRECTORY "lib/slide-maker/hershey-fonts"
#define MAXINTEGER 0x7fffffff

#define WNQREGION(facet, bb) \
{\
   struct octBox bx; \
   bx.lowerLeft = (bb)->lowerLeft; \
   bx.upperRight = (bb)->upperRight; \
   bx.lowerLeft.x -= 30;\
   bx.lowerLeft.y -= 30; \
   bx.upperRight.x += 30; \
   bx.upperRight.y += 30; \
   (void) vemWnQRegion(facet, &bx); \
}

#define SIZEOFLETTER(name, font, size) \
{ \
    int dummy, glyph; \
    glyph = findGlyph(name, font); \
    if (glyph == -1) { \
        size = 0; \
    } else { \
        sizeletter(findGlyph(name, font), &size, &dummy); \
    } \
}

#define HEIGHTOFLETTER(name, font, size) \
{ \
  int dummy; \
  sizeletter(findGlyph(name, font), &dummy, &size); \
}

#define STREQ(a,b)  (strcmp((a),(b)) == 0)
  
#define SMMIN(a,b)    ((a) < (b) ? (a) : (b))
#define SMMAX(a,b)    ((a) > (b) ? (a) : (b))
  
#define OCTASSERT(function, msg) \
  if (function < OCT_OK) { \
      (void) octError(msg); \
      vemPrompt(); \
      return(RPC_OK); \
  }

#define MAJORVERSION 5

#define BULLET (char) 255
#define BULLETSCALE 0.47
  
extern char *FontFile;
extern char *FontDirectory;

extern int GenLetters;

int horizBox();
int vertBox();
int newString();
int newBox();
int newArrow();
int newCircle();
int newLine();
int chlayer();
int chscale();
int chjust();
int changeString();
int lineUpX();
int lineUpY();
int centerY();
int spaceY();
int group();
int ungroup();

int setSequenceFile();
int initScreen();
int nextSlide();
int previousSlide();
int loadUp();
int continuous();

int placeInstance();

int listfonts();
int help();
int exitApp();
    
char *strsave();
char *celltail();
void stripNewLines();
void tilde_expand();
void deleteCell();

void sm_create_dir();
