/*LINTLIBRARY*/
#include "copyright.h"
#include "port.h"
#include "smfont.h"
#include "oct.h"
#include "oh.h"

extern font *fontptr[MAXGLYPH];

int
sizeletter(num,x,y)
int num, *x,*y;
{
    *x = (fontptr[num]->right - fontptr[num]->left);
    *y = (fontptr[num]->top - fontptr[num]->bottom);
    return;
}

struct octPoint coords[1000];

int
genletter(num,name,view,scale,layer,width)
int num;
char *name;
char *view;
int scale; /* double */
char *layer;
int width; /* double */
{
    octObject obj;
    octObject path;
    octObject lyr;
    octObject prop;
    octStatus status;
    int i;
    int j;
    int x = 0, y = 0;

    if(fontptr[num]) {

	status = ohOpenFacet( &obj, name, view, "contents", "a" );
	OH_ASSERT( status );

	ohCreatePropStr( &obj, &prop, "EDITSTYLE", "PHYSICAL" );
	ohCreatePropStr( &obj, &prop, "TECHNOLOGY", "slide" );
	ohCreatePropStr( &obj, &prop, "VIEWTYPE", "slide" );
	ohCreateLayer( &obj,&lyr,layer);
	

	i = 1;
	j = 0;
	while(i < fontptr[num]->numstroke) {
	    if(fontptr[num]->vlist[i].flags & 0x1) {
		coords[j].x = scale * (x = x + fontptr[num]->vlist[i].x);
		coords[j].y = scale * (y = y - fontptr[num]->vlist[i].y);
	    } else {
		coords[j].x = scale * (x = fontptr[num]->vlist[i].x);
		coords[j].y = scale * (y = -fontptr[num]->vlist[i].y);
	    }
	    if(fontptr[num]->vlist[i].flags & 0x2) {
		/* interesting case - new stroke */
		i++;
		if(j > 0) {
		    path.type = OCT_PATH;
		    path.contents.path.width = width;
		    if (octCreate(&lyr,&path) < OCT_OK) {
			octError("can not create the path");
			return(-1);
		    }
		    if (octPutPoints(&path,j,coords) < OCT_OK) {
			octError("can not put the points");
			return(-1);
		    }
		}
		coords[0].x = scale * x;
		coords[0].y = scale * y;
		j = 1;
	    } else {
		/* uninteresting case */
		i++;
		j++;
	    }
	}
	if(j > 0) {
	    path.type = OCT_PATH;
	    path.contents.path.width = width;
	    if (octCreate(&lyr,&path) < OCT_OK) {
		octError("can not create the path");
		return(-1);
	    }
	    
	    if (octPutPoints(&path,j,coords) < OCT_OK) {
		octError("can not put the points");
		return(-1);
	    }
	    
	}
	if ( status == OCT_NEW_FACET ) {
	    OH_ASSERT(octCloseFacet(&obj) );
	}
    }
    return 0;
}
