#include "port.h"
#include "cp.h"

#define CP_PKG_NAME "cp"

typedef enum {CP_FALSE = 0, CP_TRUE} boolean;

typedef int type_type;

#define BLANK 1
#define UPPER_CHAR 2
#define DIGIT 4
#define SPECIAL 8
#define SEP (BLANK | UPPER_CHAR)

#define MAX_INT 077777777

#define IS(type,char) ( (type) & char_type[(int) (char)] )

extern type_type char_type[];

extern char current_char;
extern int current_int;
extern FILE *infile;

#define CP_GET_CHAR ( ((current_int = getc(infile)) == EOF) ?\
			error("Unexpected end of file"),(char) 0 :\
			((current_char = (char) current_int) == '\n' ?\
			cp_line_number++, current_char : current_char))

#define CP_UNGET_CHAR(c, file) {\
    if (c == '\n') cp_line_number--;\
    (void) ungetc(c, file);\
}

extern void error();
extern void flush(type_type);

extern int cp_get_integer(int *);
extern int cp_get_path(int *,cp_path **);
extern int cp_get_point(cp_point *);
extern int cp_get_shortname(char **);
extern int cp_get_transform();
extern int cp_get_sinteger(int *);

