static char rcs_id[] = "$Id: layer.c,v 1.1.1.1 2002/12/31 15:51:04 saj Exp $";
/*
 * Implementations of the the oct functions for layers.
 */

#include "copyright.h"
#include "port.h"
#include "internal.h"
#include "io.h"

extern struct object_desc oct_default_desc;
static struct object_desc *super = &oct_default_desc;

static int layer_modify_func();
static int layer_copy_fields();
static int layer_free_fields();
static int layer_write_fields();
static int layer_read_fields();
static int layer_modify();

oct_layer_desc_set(object_desc)
struct object_desc *object_desc;
{
    *object_desc = *super;
    
    object_desc->internal_size = sizeof(struct layer);
    object_desc->external_size = sizeof(struct octLayer);
    object_desc->flags |= HAS_NAME;
    object_desc->contain_mask =
      (octObjectMask) OCT_BAG_MASK|OCT_GEO_MASK|OCT_PROP_MASK;
    object_desc->user_offset = FIELD_OFFSET(struct layer, user_layer);
    object_desc->name_offset = FIELD_OFFSET(struct octLayer, name),
    object_desc->copy_fields_func = layer_copy_fields;
    object_desc->modify_func = layer_modify;
    object_desc->free_fields_func = layer_free_fields;
    object_desc->write_fields_func = layer_write_fields;
    object_desc->read_fields_func = layer_read_fields;
}

/*ARGSUSED*/
static int
layer_copy_fields(o_p, c_p, size)
char *o_p, *c_p;
int size;
{
    struct octLayer *orig = (struct octLayer *) o_p;
    struct octLayer *copy = (struct octLayer *) c_p;

    *copy = *orig;

    if (copy->name != NIL(char)) {
	copy->name = oct_str_intern(copy->name);
    }
}

static int
layer_free_fields(ptr)
generic *ptr;
{
    struct layer *layer = (struct layer *) ptr;

    if (layer->user_layer.name != NIL(char)) {
	oct_str_free(layer->user_layer.name);
    }
}
    
static octStatus
layer_modify(ptr, obj)
generic *ptr;
struct octObject *obj;
{
    struct layer *layer = (struct layer *) ptr;
    char *new_name = obj->contents.layer.name;

    MODIFY_NAME(layer->user_layer.name, new_name);
    layer->user_layer.name = new_name;
    
    return OCT_OK;
}

static octStatus
layer_read_fields(ptr)
generic *ptr;
{
    struct layer *layer = (struct layer *) ptr;
    
    return (*super->read_fields_func)(ptr) &&
      oct_get_string(&layer->user_layer.name);
}

static octStatus
layer_write_fields(ptr)
generic *ptr;
{
    struct layer *layer = (struct layer *) ptr;
    
    return (*super->write_fields_func)(ptr) &&
      oct_put_string(layer->user_layer.name);
}
