static char rcs_id[] = "$Id: point.c,v 1.1.1.1 2002/12/31 15:51:04 saj Exp $";
/*
 * Implementations of the the oct functions for boxes.
 */

#include "copyright.h"
#include "port.h"
#include "internal.h"
#include "geo.h"
#include "io.h"


static octStatus point_read_fields(), point_write_fields(), point_bb();

extern struct object_desc oct_geo_desc;
static struct object_desc *super = &oct_geo_desc;

oct_point_desc_set(object_desc)
struct object_desc *object_desc;
{
    *object_desc = *super;
    
    object_desc->internal_size = sizeof(struct point);
    object_desc->external_size = sizeof(struct octPoint);
    object_desc->flags |= HAS_BB_FUNC;
    object_desc->contain_mask = (octObjectMask) OCT_PROP_MASK|OCT_BAG_MASK;
    object_desc->user_offset = FIELD_OFFSET(struct point, user_point);
    object_desc->write_fields_func = point_write_fields;
    object_desc->read_fields_func = point_read_fields;
    object_desc->bb_func = point_bb;
}
  
static octStatus
point_bb(lptr, bbox)
generic *lptr;
struct octBox *bbox;
{
    struct point *point = (struct point *) lptr;

    if (bbox == NIL(struct octBox)) {
	return OCT_OK;
    }
    
    bbox->lowerLeft = point->user_point;
    bbox->upperRight = point->user_point;
    return OCT_OK;
}

static octStatus point_read_fields(ptr)
generic *ptr;
{
    struct point *point = (struct point *) ptr;
    
    return (*super->read_fields_func)(ptr) &&
      oct_get_point(&point->user_point);
}

static octStatus
point_write_fields(ptr)
generic *ptr;
{
    struct point *point = (struct point *) ptr;
    
    return (*super->write_fields_func)(ptr) &&
      oct_put_point(point->user_point);
}
