static char rcs_id[] = "$Id: temp.c,v 1.1.1.1 2002/12/31 15:51:04 saj Exp $";
#include "copyright.h"
#include "port.h"
#include "internal.h"

void 
octMarkTemporary(object)
octObject *object;
{
    generic *ptr = oct_id_to_ptr(object->objectId);

    if (ptr == NIL(generic)) {
	oct_error("octMarkTemporary: The argument's octId has been corrupted");
	errRaise(OCT_PKG_NAME, OCT_CORRUPTED_OBJECT, octErrorString());
    }

    if (!ptr->flags.is_temporary) {
	ptr->flags.is_temporary = 1;
	ptr->facet->temp_count++;
    }
    return;
}

void 
octUnmarkTemporary(object)
octObject *object;
{
    generic *ptr = oct_id_to_ptr(object->objectId);

    if (ptr == NIL(generic)) {
	oct_error("octUnmarkTemporary: The argument's octId has been corrupted");
	errRaise(OCT_PKG_NAME, OCT_CORRUPTED_OBJECT, octErrorString());
    }

    if (ptr->flags.is_temporary) {
	ptr->flags.is_temporary = 0;
	ptr->facet->temp_count--;
    }
    return;
}

int
octIsTemporary(object)
octObject *object;
{
    generic *ptr = oct_id_to_ptr(object->objectId);

    if (ptr == NIL(generic)) {
	oct_error("octIsTemporary: The argument's octId has been corrupted");
	errRaise(OCT_PKG_NAME, OCT_ERROR, octErrorString());
    }

    return ptr->flags.is_temporary;
}
