/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     MINUS = 258,
     PLUS = 259,
     XOR = 260,
     TIMES = 261,
     NAME = 262,
     NUMBER = 263,
     REAL = 264,
     LPAREN = 265,
     RPAREN = 266,
     SEMI = 267,
     INVALID = 268,
     EQUAL = 269,
     COMMA = 270,
     SLASH = 271,
     GROW = 272,
     SQUARES = 273,
     DELETE = 274,
     FRAME = 275,
     SCALE = 276,
     PROPERTY = 277,
     OPTIONS = 278,
     LABELS = 279,
     BOUNDBOX = 280,
     GROWX = 281,
     GROWY = 282,
     FRAMEX = 283,
     FRAMEY = 284,
     FLATTEN = 285,
     SUBCELL = 286
   };
#endif
#define MINUS 258
#define PLUS 259
#define XOR 260
#define TIMES 261
#define NAME 262
#define NUMBER 263
#define REAL 264
#define LPAREN 265
#define RPAREN 266
#define SEMI 267
#define INVALID 268
#define EQUAL 269
#define COMMA 270
#define SLASH 271
#define GROW 272
#define SQUARES 273
#define DELETE 274
#define FRAME 275
#define SCALE 276
#define PROPERTY 277
#define OPTIONS 278
#define LABELS 279
#define BOUNDBOX 280
#define GROWX 281
#define GROWY 282
#define FRAMEX 283
#define FRAMEY 284
#define FLATTEN 285
#define SUBCELL 286




/* Copy the first part of user declarations.  */
#line 1 "yacc.y"

#include "copyright.h"
#include "port.h"
#include "st.h"
#include "oct.h"
#include "utility.h"
#include "fang.h"
#include "harpoon.h"
#include "oh.h"
#include "tap.h"
#include "octmm.h"
#include "vov.h"

typedef struct layer_struct {
    char *name;
    fa_geometry *geos;
} layer_t;

typedef struct {
    fa_geometry *geos;
    int free_on_use;
} geo_t;
    
extern FILE *yyin;
extern char yytext[];

static st_table *layer_table;
static octObject *facet;
static struct octBox facet_bb;
static char *filename;
static char *progname;
static int har_type = HAR_UNFILLED_BOX;

static double prescale;		/* Scale before running harpoon and fang. */
static double postscale;	/* Scale after running harpoon and fang. */
static double scale;		/* Cumulative scale factor. */
static int do_prescale;		/* Non-zero if a prescale factor was given. */
#define	PRE_SCALE \
	if (do_prescale) { \
		do_prescale = 0; \
		scale = prescale * postscale; \
		if (scale != 1.0) \
			OH_ASSERT(myScaleFacet(facet, scale)); \
	}

static enum st_retval fang_to_oct();
static void fetch_and_delete_objects();
static void delete_layer();
static layer_t *find_layer();
static void copy_labels();

extern octStatus flatten_contacts();
extern hackTerm();
extern void map_terminals_to_labels();
extern void flattenCell(), flattenSubcellLayer();
extern void squares();


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 59 "yacc.y"
typedef union YYSTYPE {
    int intval;
    double dblval;
    char *strval;
    geo_t layer;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 203 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 215 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   201

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  32
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  11
/* YYNRULES -- Number of rules. */
#define YYNRULES  43
/* YYNRULES -- Number of states. */
#define YYNSTATES  133

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    15,    19,    23,    29,
      35,    41,    47,    51,    55,    59,    63,    70,    77,    84,
      95,   102,   109,   116,   123,   127,   138,   142,   147,   152,
     157,   159,   160,   163,   164,   167,   169,   173,   177,   183,
     189,   191,   193,   195
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      33,     0,    -1,    34,    -1,    33,    34,    -1,    12,    -1,
      39,    14,    35,    12,    -1,    23,    37,    12,    -1,    19,
      36,    12,    -1,    24,    39,    14,    39,    12,    -1,    22,
      40,    14,    40,    12,    -1,    22,    40,    14,    42,    12,
      -1,    22,    40,    14,    41,    12,    -1,    35,     4,    35,
      -1,    35,     6,    35,    -1,    35,     3,    35,    -1,    35,
       5,    35,    -1,    17,    10,    35,    15,    42,    11,    -1,
      26,    10,    35,    15,    42,    11,    -1,    27,    10,    35,
      15,    42,    11,    -1,    18,    10,    35,    15,    42,    15,
      42,    15,    42,    11,    -1,    20,    10,    35,    15,    42,
      11,    -1,    28,    10,    35,    15,    42,    11,    -1,    29,
      10,    35,    15,    42,    11,    -1,    21,    10,    35,    15,
      41,    11,    -1,    10,    35,    11,    -1,    25,    10,    42,
      15,    42,    15,    42,    15,    42,    11,    -1,    25,    10,
      11,    -1,    25,    10,    35,    11,    -1,    31,    10,    35,
      11,    -1,    30,    10,    35,    11,    -1,    39,    -1,    -1,
      36,    39,    -1,    -1,    37,    38,    -1,    40,    -1,    40,
      14,    41,    -1,    21,    14,    41,    -1,    40,    14,    42,
      16,    42,    -1,    21,    14,    42,    16,    42,    -1,     7,
      -1,     7,    -1,     9,    -1,     8,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    80,    80,    81,    84,    87,   105,   108,   111,   116,
     124,   131,   140,   149,   158,   167,   181,   190,   199,   208,
     220,   229,   238,   247,   255,   260,   270,   280,   292,   302,
     312,   325,   326,   333,   334,   337,   353,   365,   370,   383,
     390,   401,   405,   409
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "MINUS", "PLUS", "XOR", "TIMES", "NAME",
  "NUMBER", "REAL", "LPAREN", "RPAREN", "SEMI", "INVALID", "EQUAL",
  "COMMA", "SLASH", "GROW", "SQUARES", "DELETE", "FRAME", "SCALE",
  "PROPERTY", "OPTIONS", "LABELS", "BOUNDBOX", "GROWX", "GROWY", "FRAMEX",
  "FRAMEY", "FLATTEN", "SUBCELL", "$accept", "program", "statement",
  "expression", "delete_list", "options_list", "option", "layer_name",
  "name", "real", "integer", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    32,    33,    33,    34,    34,    34,    34,    34,    34,
      34,    34,    35,    35,    35,    35,    35,    35,    35,    35,
      35,    35,    35,    35,    35,    35,    35,    35,    35,    35,
      35,    36,    36,    37,    37,    38,    38,    38,    38,    38,
      39,    40,    41,    42
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     4,     3,     3,     5,     5,
       5,     5,     3,     3,     3,     3,     6,     6,     6,    10,
       6,     6,     6,     6,     3,    10,     3,     4,     4,     4,
       1,     0,     2,     0,     2,     1,     3,     3,     5,     5,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    40,     4,    31,     0,    33,     0,     0,     2,     0,
       0,    41,     0,     0,     0,     1,     3,     0,     7,    32,
       0,     6,     0,    34,    35,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    30,
      43,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     9,    11,    10,    37,     0,
      36,     0,     8,    24,     0,     0,     0,     0,    26,     0,
       0,     0,     0,     0,     0,     0,     0,    14,    12,    15,
      13,     0,     0,     0,     0,     0,     0,    27,     0,     0,
       0,     0,     0,    29,    28,    39,    38,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,     0,    20,    23,
       0,    17,    18,    21,    22,     0,     0,     0,     0,     0,
       0,    19,    25
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     7,     8,    38,    10,    13,    23,    39,    12,    43,
      44
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -46
static const short int yypact[] =
{
      -1,   -46,   -46,   -46,     0,   -46,    33,    67,   -46,    27,
      58,   -46,    49,    57,    59,   -46,   -46,   102,   -46,   -46,
      -4,   -46,    62,   -46,    66,    33,   102,    56,    61,    71,
      82,    83,    86,    89,    90,    91,   100,   101,    39,   -46,
     -46,   -46,   105,   106,   109,     8,     8,   112,   173,   102,
     102,   102,   102,    77,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   -46,   -46,   -46,   -46,   -46,   132,
     -46,   133,   -46,   -46,     9,   110,   131,   135,   -46,   177,
     111,   139,   152,   156,   160,   186,   190,    14,    14,   -46,
     -46,   143,   143,   143,   143,   143,   138,   -46,   143,   143,
     143,   143,   143,   -46,   -46,   -46,   -46,   141,   153,   142,
     158,   155,   161,   162,   163,   174,   -46,   143,   -46,   -46,
     143,   -46,   -46,   -46,   -46,   171,   172,   143,   143,   187,
     188,   -46,   -46
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
     -46,   -46,   193,   -24,   -46,   -46,   -46,    52,    48,   -36,
     -45
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      69,    71,    48,    11,    40,    41,     1,    11,    80,    68,
      70,     2,    60,    61,    62,    63,    40,    41,     3,    62,
      63,     4,     5,     6,    93,    74,    75,    76,    77,    79,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       1,    17,    60,    61,    62,    63,   105,   106,   107,   108,
     109,    64,     9,   111,   112,   113,   114,   115,    14,     9,
     110,    24,    19,    20,    11,     1,    49,    15,    42,    21,
      18,    50,   125,    25,     1,   126,    45,    47,    22,     2,
      46,    51,   129,   130,     1,    40,     3,    26,    78,     4,
       5,     6,    52,    53,    27,    28,    54,    29,    30,    55,
      56,    57,    31,    32,    33,    34,    35,    36,    37,     1,
      58,    59,    26,    60,    61,    62,    63,    65,    66,    27,
      28,    67,    29,    30,    72,    94,    98,    31,    32,    33,
      34,    35,    36,    37,    60,    61,    62,    63,    60,    61,
      62,    63,    60,    61,    62,    63,    95,    41,    91,    92,
      96,    40,   116,   118,    99,    60,    61,    62,    63,    60,
      61,    62,    63,    60,    61,    62,    63,   100,   117,   119,
     120,   101,   121,   122,   123,   102,    60,    61,    62,    63,
      60,    61,    62,    63,    73,   124,   127,   128,    97,    60,
      61,    62,    63,    60,    61,    62,    63,   103,   131,   132,
      16,   104
};

static const unsigned char yycheck[] =
{
      45,    46,    26,     7,     8,     9,     7,     7,    53,    45,
      46,    12,     3,     4,     5,     6,     8,     9,    19,     5,
       6,    22,    23,    24,    15,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
       7,    14,     3,     4,     5,     6,    91,    92,    93,    94,
      95,    12,     0,    98,    99,   100,   101,   102,     6,     7,
      96,    13,    10,    14,     7,     7,    10,     0,    20,    12,
      12,    10,   117,    14,     7,   120,    14,    25,    21,    12,
      14,    10,   127,   128,     7,     8,    19,    10,    11,    22,
      23,    24,    10,    10,    17,    18,    10,    20,    21,    10,
      10,    10,    25,    26,    27,    28,    29,    30,    31,     7,
      10,    10,    10,     3,     4,     5,     6,    12,    12,    17,
      18,    12,    20,    21,    12,    15,    15,    25,    26,    27,
      28,    29,    30,    31,     3,     4,     5,     6,     3,     4,
       5,     6,     3,     4,     5,     6,    15,     9,    16,    16,
      15,     8,    11,    11,    15,     3,     4,     5,     6,     3,
       4,     5,     6,     3,     4,     5,     6,    15,    15,    11,
      15,    15,    11,    11,    11,    15,     3,     4,     5,     6,
       3,     4,     5,     6,    11,    11,    15,    15,    11,     3,
       4,     5,     6,     3,     4,     5,     6,    11,    11,    11,
       7,    11
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     7,    12,    19,    22,    23,    24,    33,    34,    39,
      36,     7,    40,    37,    39,     0,    34,    14,    12,    39,
      14,    12,    21,    38,    40,    14,    10,    17,    18,    20,
      21,    25,    26,    27,    28,    29,    30,    31,    35,    39,
       8,     9,    40,    41,    42,    14,    14,    39,    35,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
       3,     4,     5,     6,    12,    12,    12,    12,    41,    42,
      41,    42,    12,    11,    35,    35,    35,    35,    11,    35,
      42,    35,    35,    35,    35,    35,    35,    35,    35,    35,
      35,    16,    16,    15,    15,    15,    15,    11,    15,    15,
      15,    15,    15,    11,    11,    42,    42,    42,    42,    42,
      41,    42,    42,    42,    42,    42,    11,    15,    11,    11,
      15,    11,    11,    11,    11,    42,    42,    15,    15,    42,
      42,    11,    11
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 85 "yacc.y"
    {}
    break;

  case 5:
#line 88 "yacc.y"
    {
			layer_t *dest = find_layer(yyvsp[-3].strval);
			if (yyvsp[-1].layer.free_on_use) {
			    /* don't free $3, just re-assign it */
			    fa_free_geo(dest->geos);	/* discard lhs */
			    FREE(dest->geos);
			    dest->geos = yyvsp[-1].layer.geos;
			} else {
			    /* need to copy geos -- watch for LAYER = LAYER; */
			    if (yyvsp[-1].layer.geos != dest->geos) {
				fa_free_geo(dest->geos);      /* discard lhs */
				fa_copy(yyvsp[-1].layer.geos, dest->geos);
			    }
			}
			FREE(yyvsp[-3].strval);
		    }
    break;

  case 6:
#line 106 "yacc.y"
    {}
    break;

  case 7:
#line 109 "yacc.y"
    {}
    break;

  case 8:
#line 112 "yacc.y"
    {
			copy_labels(yyvsp[-1].strval, yyvsp[-3].strval);
		    }
    break;

  case 9:
#line 117 "yacc.y"
    {
			octObject prop;
			OH_ASSERT(ohCreateOrModifySprop(facet, &prop, yyvsp[-3].strval, yyvsp[-1].strval));
			FREE(yyvsp[-3].strval);
			FREE(yyvsp[-1].strval);
		    }
    break;

  case 10:
#line 125 "yacc.y"
    {
			octObject prop;
			OH_ASSERT(ohCreateOrModifyIprop(facet, &prop, yyvsp[-3].strval, yyvsp[-1].intval));
			FREE(yyvsp[-3].strval);
		    }
    break;

  case 11:
#line 132 "yacc.y"
    {
			octObject prop;
			OH_ASSERT(ohCreateOrModifyRprop(facet, &prop, yyvsp[-3].strval, yyvsp[-1].dblval));
			FREE(yyvsp[-3].strval);
		    }
    break;

  case 12:
#line 141 "yacc.y"
    {
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_or(yyvsp[-2].layer.geos, yyvsp[0].layer.geos, yyval.layer.geos);
			if (yyvsp[-2].layer.free_on_use){fa_free_geo(yyvsp[-2].layer.geos);FREE(yyvsp[-2].layer.geos);}
			if (yyvsp[0].layer.free_on_use){fa_free_geo(yyvsp[0].layer.geos);FREE(yyvsp[0].layer.geos);}
		    }
    break;

  case 13:
#line 150 "yacc.y"
    {
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_and(yyvsp[-2].layer.geos, yyvsp[0].layer.geos, yyval.layer.geos);
			if (yyvsp[-2].layer.free_on_use){fa_free_geo(yyvsp[-2].layer.geos);FREE(yyvsp[-2].layer.geos);}
			if (yyvsp[0].layer.free_on_use){fa_free_geo(yyvsp[0].layer.geos);FREE(yyvsp[0].layer.geos);}
		    }
    break;

  case 14:
#line 159 "yacc.y"
    {
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_andnot(yyvsp[-2].layer.geos, yyvsp[0].layer.geos, yyval.layer.geos);
			if (yyvsp[-2].layer.free_on_use){fa_free_geo(yyvsp[-2].layer.geos);FREE(yyvsp[-2].layer.geos);}
			if (yyvsp[0].layer.free_on_use){fa_free_geo(yyvsp[0].layer.geos);FREE(yyvsp[0].layer.geos);}
		    }
    break;

  case 15:
#line 168 "yacc.y"
    {
			fa_geometry t1, t2;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_andnot(yyvsp[-2].layer.geos, yyvsp[0].layer.geos, &t1);
			fa_andnot(yyvsp[0].layer.geos, yyvsp[-2].layer.geos, &t2);
			fa_or(&t1, &t2, yyval.layer.geos);
			if (yyvsp[-2].layer.free_on_use){fa_free_geo(yyvsp[-2].layer.geos);FREE(yyvsp[-2].layer.geos);}
			if (yyvsp[0].layer.free_on_use){fa_free_geo(yyvsp[0].layer.geos);FREE(yyvsp[0].layer.geos);}
			fa_free_geo(&t1);
			fa_free_geo(&t2);
		    }
    break;

  case 16:
#line 182 "yacc.y"
    {
			int i = yyvsp[-1].intval * postscale;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_grow(yyvsp[-3].layer.geos, i, yyval.layer.geos);
			if (yyvsp[-3].layer.free_on_use){fa_free_geo(yyvsp[-3].layer.geos);FREE(yyvsp[-3].layer.geos);}
		    }
    break;

  case 17:
#line 191 "yacc.y"
    {
			int i = yyvsp[-1].intval * postscale;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_grow_xy(yyvsp[-3].layer.geos, i, FA_HORIZONTAL, yyval.layer.geos);
			if (yyvsp[-3].layer.free_on_use){fa_free_geo(yyvsp[-3].layer.geos);FREE(yyvsp[-3].layer.geos);}
		    }
    break;

  case 18:
#line 200 "yacc.y"
    {
			int i = yyvsp[-1].intval * postscale;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_grow_xy(yyvsp[-3].layer.geos, i, FA_VERTICAL, yyval.layer.geos);
			if (yyvsp[-3].layer.free_on_use){fa_free_geo(yyvsp[-3].layer.geos);FREE(yyvsp[-3].layer.geos);}
		    }
    break;

  case 19:
#line 210 "yacc.y"
    {
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			squares(yyvsp[-7].layer.geos, yyvsp[-5].intval, yyvsp[-3].intval, yyvsp[-1].intval, yyval.layer.geos);
			if (yyvsp[-7].layer.free_on_use) {
			    fa_free_geo(yyvsp[-7].layer.geos);
			    FREE(yyvsp[-7].layer.geos);
			}
		    }
    break;

  case 20:
#line 221 "yacc.y"
    {
			int i = yyvsp[-1].intval * postscale;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_frame(yyvsp[-3].layer.geos, i, i, yyval.layer.geos);
			if (yyvsp[-3].layer.free_on_use){fa_free_geo(yyvsp[-3].layer.geos);FREE(yyvsp[-3].layer.geos);}
		    }
    break;

  case 21:
#line 230 "yacc.y"
    {
			int i = yyvsp[-1].intval * postscale;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_frame_xy(yyvsp[-3].layer.geos, i, i, FA_HORIZONTAL, yyval.layer.geos);
			if (yyvsp[-3].layer.free_on_use){fa_free_geo(yyvsp[-3].layer.geos);FREE(yyvsp[-3].layer.geos);}
		    }
    break;

  case 22:
#line 239 "yacc.y"
    {
			int i = yyvsp[-1].intval * postscale;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_frame_xy(yyvsp[-3].layer.geos, i, i, FA_VERTICAL, yyval.layer.geos);
			if (yyvsp[-3].layer.free_on_use){fa_free_geo(yyvsp[-3].layer.geos);FREE(yyvsp[-3].layer.geos);}
		    }
    break;

  case 23:
#line 248 "yacc.y"
    {
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			yyval.layer.free_on_use = 1;
			fa_scale(yyvsp[-3].layer.geos, yyvsp[-1].dblval, yyval.layer.geos);
			if (yyvsp[-3].layer.free_on_use){fa_free_geo(yyvsp[-3].layer.geos);FREE(yyvsp[-3].layer.geos);}
		    }
    break;

  case 24:
#line 256 "yacc.y"
    {
			yyval.layer = yyvsp[-1].layer;
		    }
    break;

  case 25:
#line 262 "yacc.y"
    {
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			fa_init(yyval.layer.geos);
			yyval.layer.free_on_use = 1;
			fa_add_box(yyval.layer.geos, yyvsp[-7].intval, yyvsp[-5].intval, yyvsp[-3].intval, yyvsp[-1].intval);
		    }
    break;

  case 26:
#line 271 "yacc.y"
    {
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			fa_init(yyval.layer.geos);
			yyval.layer.free_on_use = 1;
			fa_add_box(yyval.layer.geos, 
			    facet_bb.lowerLeft.x, facet_bb.lowerLeft.y, 
			    facet_bb.upperRight.x, facet_bb.upperRight.y);
		    }
    break;

  case 27:
#line 281 "yacc.y"
    {
			fa_box bb;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			fa_init(yyval.layer.geos);
			yyval.layer.free_on_use = 1;
			fa_bb(yyvsp[-1].layer.geos, &bb);
			fa_add_box(yyval.layer.geos, bb.left, bb.bottom, 
						bb.right, bb.top);
			if (yyvsp[-1].layer.free_on_use){fa_free_geo(yyvsp[-1].layer.geos);FREE(yyvsp[-1].layer.geos);}
		    }
    break;

  case 28:
#line 293 "yacc.y"
    {
			fa_geometry t1;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			flattenSubcellLayer(facet, yyvsp[-1].layer.geos, &t1, yyval.layer.geos);
			yyval.layer.free_on_use = 1;
			if (yyvsp[-1].layer.free_on_use){fa_free_geo(yyvsp[-1].layer.geos);FREE(yyvsp[-1].layer.geos);}
			fa_free_geo(&t1);
		    }
    break;

  case 29:
#line 303 "yacc.y"
    {
			fa_geometry t1;
			yyval.layer.geos = ALLOC(fa_geometry, 1);
			flattenSubcellLayer(facet, yyvsp[-1].layer.geos, yyval.layer.geos, &t1);
			yyval.layer.free_on_use = 1;
			if (yyvsp[-1].layer.free_on_use){fa_free_geo(yyvsp[-1].layer.geos);FREE(yyvsp[-1].layer.geos);}
			fa_free_geo(&t1);
		    }
    break;

  case 30:
#line 313 "yacc.y"
    {
			layer_t *layer;

			PRE_SCALE
			layer = find_layer(yyvsp[0].strval);
			yyval.layer.geos = layer->geos;
			yyval.layer.free_on_use = 0;
			FREE(yyvsp[0].strval);
		    }
    break;

  case 32:
#line 327 "yacc.y"
    {
			delete_layer(yyvsp[0].strval);
			FREE(yyvsp[0].strval);
		    }
    break;

  case 35:
#line 338 "yacc.y"
    {
			if (strcmp(yyvsp[0].strval, "flatten_connectors") == 0) {
			    (void) flatten_contacts(facet);
			} else if (strcmp(yyvsp[0].strval, "infer_terminals") == 0) {
			    (void) hackTerm(facet, 1);
			} else if (strcmp(yyvsp[0].strval, "map_terminals_to_labels") == 0) {
			    map_terminals_to_labels(progname, facet, scale);
			} else if (strcmp(yyvsp[0].strval, "unfilled_polygons") == 0) {
			    har_type = HAR_UNFILLED_POLYGON;
			} else {
			    yyerror("unrecognized option");
			}
			FREE(yyvsp[0].strval);
		    }
    break;

  case 36:
#line 354 "yacc.y"
    {
			if (strcmp(yyvsp[-2].strval, "prescale") == 0) {
			    prescale = prescale * yyvsp[0].dblval;
			} else if (strcmp(yyvsp[-2].strval, "postscale") == 0) {
			    postscale = postscale * yyvsp[0].dblval;
			} else {
			    yyerror("unrecognized option");
			}
			FREE(yyvsp[-2].strval);
		    }
    break;

  case 37:
#line 366 "yacc.y"
    {
			prescale = prescale * yyvsp[0].dblval;
		    }
    break;

  case 38:
#line 371 "yacc.y"
    {
			double scl = (double) yyvsp[-2].intval / (double) yyvsp[0].intval;
			if (strcmp(yyvsp[-4].strval, "prescale") == 0) {
			    prescale = prescale * scl;
			} else if (strcmp(yyvsp[-4].strval, "postscale") == 0) {
			    postscale = postscale * scl;
			} else {
			    yyerror("unrecognized option");
			}
			FREE(yyvsp[-4].strval);
		    }
    break;

  case 39:
#line 384 "yacc.y"
    {
			double scl = (double) yyvsp[-2].intval / (double) yyvsp[0].intval;
			prescale = prescale * scl;
		    }
    break;

  case 40:
#line 391 "yacc.y"
    { yyval.strval = util_strsav(yytext); }
    break;

  case 41:
#line 402 "yacc.y"
    { yyval.strval = util_strsav(yytext); }
    break;

  case 42:
#line 406 "yacc.y"
    { yyval.dblval = atof(yytext); }
    break;

  case 43:
#line 410 "yacc.y"
    { yyval.intval = atoi(yytext); }
    break;


    }

/* Line 1010 of yacc.c.  */
#line 1589 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 412 "yacc.y"


/* utility routines - part of my not included in oh */

octStatus
myScaleContents(container, mask, scale)
octObject *container;
octObjectMask mask;
double scale;
{
    octObject geo;
    octGenerator gen;
    octStatus status;
    octObject inst;

    status = octInitGenContents(container, mask, &gen);
    if (status != OCT_OK) return status;

    while ((status = octGenerate(&gen, &geo)) == OCT_OK) {
	if (geo.type == OCT_INSTANCE) {
	    /* Do not scale the rotation matrix. (BCR) */
	    inst = geo;
	    octScaleGeo(&inst, scale);
	    geo.contents.instance.transform.translation =
			inst.contents.instance.transform.translation;
	    status = octModify(&geo);
	} else {
	    status = octScaleAndModifyGeo(&geo, scale);
	}
	if (status != OCT_OK) return status;
    }
    if (status != OCT_GEN_DONE) return status;
    return OCT_OK;
}


octStatus
myScaleFacet(facet, scale)
octObject *facet;
double scale;
{
    octObject layer;
    octGenerator gen;
    octStatus status;

    status = octInitGenContents(facet, OCT_LAYER_MASK, &gen);
    if (status != OCT_OK) return status;

    while ((status = octGenerate(&gen, &layer)) == OCT_OK) {
	status = myScaleContents(&layer, OCT_GEO_MASK, scale);
	if (status != OCT_OK) return status;
    }
    if (status != OCT_GEN_DONE) return status;

    status = myScaleContents(facet, OCT_INSTANCE_MASK, scale);
    if (status != OCT_GEN_DONE) return status;
    return OCT_OK;
}


/* start of octmm routines */

void
oct_mask_mod(the_progname, the_filename, the_facet, the_scale)
char *the_progname;
char *the_filename;
octObject *the_facet;
char *the_scale;
{
    octStatus status;
    char temp1[1024];
    double a, b;
    char *the_post;

    /* Initialize layer identifiers for flattening. */
    flattenCell();

    /* Set the (ack!) global variables */
    layer_table = st_init_table(strcmp, st_strhash);
    facet = the_facet;
    progname = (the_progname == NIL(char)) ? "" : the_progname;
    scale = 1.0;
    prescale = 1.0;
    postscale = 1.0;
    do_prescale = 1;

    /* Determine the command-line pre-scale */
    if (the_scale != NIL(char)) {
	if ((the_post = strchr(the_scale, 'x')) != NIL(char)) {
	    *the_post++ = '\000';
	    if (*the_post != '\000') {
		if (strchr(the_post, '/') == NIL(char)) {
		    postscale = atof(the_post);
		} else  {
		    (void) sscanf(the_post, "%lf/%lf", &a, &b);
		    postscale = a / b;
		}
	    }
	}
	if (*the_scale != '\000') {
	    if (strchr(the_scale, '/') == NIL(char)) {
		prescale = atof(the_scale);
	    } else {
		(void) sscanf(the_scale, "%lf/%lf", &a, &b);
		prescale = a / b;
	    }
	}
	if (the_post) *--the_post = 'x';
    }

    /* Open the program file */
    filename = the_filename;
    if (filename == NIL(char) || strcmp(filename, "") == 0) {
	/* There is no OCTMM program, so only scale the facet. */
	PRE_SCALE
	return;
    }

    if ((yyin = VOVfopen(the_filename, "r")) == NULL) {
	(void) sprintf(temp1, "%s/%s",
		       util_file_expand(tapGetDefaultRoot()),
		       the_filename);
	filename = temp1;
	if ((yyin = VOVfopen(filename, "r")) == NULL) {
	    perror(filename);
	    exit(1);
	}
    }

    /* Find BBOX of the facet */
    status = octBB(facet, &facet_bb);
    if (status == OCT_NO_BB) {
	facet_bb.lowerLeft.x = 0;
	facet_bb.lowerLeft.y = 0;
	facet_bb.upperRight.x = 0;
	facet_bb.upperRight.y = 0;
    } else {
	OH_ASSERT(status);
    }

    /* Use our friend yacc to parse things */
    if (yyparse() != 0) {
	(void) fprintf(stderr, "%s: error in parse\n", progname);
	exit(1);
    }

    /* Place all remaining layers back into the facet */
    (void) st_foreach(layer_table, fang_to_oct, NIL(char));
    st_free_table(layer_table);
    (void) fclose(yyin);
}


/* ARGSUSED */
static enum st_retval
fang_to_oct(key, value, arg)
char *key;
char *value;
char *arg;
{
    layer_t *layer = (layer_t *) value;
    octObject oct_layer;

    OH_ASSERT(ohGetOrCreateLayer(facet, &oct_layer, layer->name));
    harFangToContents(layer->geos, &oct_layer, har_type);
    fa_free_geo(layer->geos);
    FREE(layer->geos);
    FREE(layer->name);
    FREE(layer); 
    return ST_CONTINUE;
}


static layer_t *
find_layer(name)
char *name;
{
    octObject oct_layer;
    octStatus status;
    layer_t *layer;
    char *layer_p;

    if (st_lookup(layer_table, name, &layer_p) == 0) {
        status = ohGetByLayerName(facet, &oct_layer, name);
	if (status == OCT_OK || status == OCT_NOT_FOUND) {
	    layer = ALLOC(layer_t, 1);
	    layer->name = util_strsav(name);
	    layer->geos = ALLOC(fa_geometry, 1);
	    fa_init(layer->geos);
	    (void) st_insert(layer_table, layer->name, (char *) layer);
	    if (status == OCT_OK) {
		fetch_and_delete_objects(&oct_layer, layer->geos);
	    }
	} else {
	    OH_ASSERT(status);
	}
    } else {
	layer = (layer_t *) layer_p;
    }
    return layer;
}


/*
 *  Move objects from octObject 'layer' to a fa_geometry 'geos', and then
 *  delete the objects from Oct.  Do NOT delete labels or terminal
 *  implementations.
 */
static void
fetch_and_delete_objects(layer, geos)
octObject *layer;
fa_geometry *geos;
{
    octObject fterm, obj;
    octGenerator gen;
    octStatus status;

    OH_ASSERT(octInitGenContents(layer, OCT_GEO_MASK &~ OCT_LABEL_MASK, &gen));
    while ((status = octGenerate(&gen, &obj)) == OCT_OK) {
	harAddObjectToFang(&obj, geos, HAR_NO_TRANSFORM);

	/* Is this a terminal implementation ?? */
	status = octGenFirstContainer(&obj, OCT_TERM_MASK, &fterm);
	if (status == OCT_GEN_DONE) {
	    OH_ASSERT(octDelete(&obj));	/* not a terminal frame */
	} else {
	    OH_ASSERT(status);			/* make sure status was okay */
	}
    }
    OH_ASSERT(status == OCT_GEN_DONE ? OCT_OK : status);
}


static void
delete_layer( name)
char *name;
{
    char *layer_p, *dummy;
    layer_t *layer;
    octObject oct_layer, obj;
    octGenerator gen;
    octStatus status;

    if (st_lookup(layer_table, name, &layer_p) != 0) {
	/* Throw away the existing geo */
	layer = (layer_t *) layer_p;
	dummy = name;
	(void) st_delete(layer_table, &dummy, NIL(char *));
	fa_free_geo(layer->geos);
	FREE(layer->geos);
	FREE(layer->name);
	FREE(layer);
    }

    /* Delete the oct objects on the layer, and the layer */
    if (ohGetByLayerName(facet, &oct_layer, name) == OCT_OK) {
	OH_ASSERT(octInitGenContents(&oct_layer, OCT_ALL_MASK, &gen));
	while ((status = octGenerate(&gen, &obj)) == OCT_OK) {
	    OH_ASSERT(octDelete(&obj));
	}
	OH_ASSERT(status == OCT_GEN_DONE ? OCT_OK : status);
	OH_ASSERT(octDelete(&oct_layer));
    }
}


static void
copy_labels(src_layer, dst_layer)
char *src_layer, *dst_layer;
{
    octObject lyr, slayer, dlayer, label, fterm, geo;
    octGenerator gen, gen1;
    octStatus status;

    /* Get the source and destination layers */
    OH_ASSERT(ohGetOrCreateLayer(facet, &slayer, src_layer));
    OH_ASSERT(ohGetOrCreateLayer(facet, &dlayer, dst_layer));

    /* Move labels from one layer to the other */
    OH_ASSERT(octInitGenContents(&slayer, OCT_LABEL_MASK, &gen));
    while ((status = octGenerate(&gen, &label)) == OCT_OK) {
	OH_ASSERT(octDetach(&slayer, &label));
	OH_ASSERT(octAttach(&dlayer, &label));
    }
    OH_ASSERT(status == OCT_GEN_DONE ? OCT_OK : status);

    /* Copy terminal implementation attachments (needed by ciftooct) */
    OH_ASSERT(octInitGenContents(facet, OCT_TERM_MASK, &gen));
    while ((status = octGenerate(&gen, &fterm)) == OCT_OK) {
	if (!octIdIsNull(fterm.contents.term.instanceId)) continue;

	/* Find all geos attached to this terminal */
	OH_ASSERT(octInitGenContents(&fterm, OCT_GEO_MASK, &gen1));
	while ((status = octGenerate(&gen1, &geo)) == OCT_OK) {

	    /* find what layer this geo is on */
	    status = octGenFirstContainer(&geo, OCT_LAYER_MASK, &lyr);
	    if (status == OCT_OK) {
		if (octIdsEqual(lyr.objectId, slayer.objectId)) {
		    OH_ASSERT(octCreate(&dlayer, &geo));
		    OH_ASSERT(octAttach(&fterm, &geo));
		}
	    } else if (status != OCT_GEN_DONE) {
		OH_ASSERT(status);
	    }
	}
	OH_ASSERT(status == OCT_GEN_DONE ? OCT_OK : status);
    }
    OH_ASSERT(status == OCT_GEN_DONE ? OCT_OK : status);
}


int
yyerror(s)
char *s;
{
    (void) fprintf(stderr, "%s: %s in file %s\n", 
	progname, s, filename);
    exit(1);
}


int
yywrap()
{
    return 1;
}


