#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[] = "$Id: yybdsyn.c,v 1.1.1.1 2002/12/31 15:50:53 saj Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "yybdsyn.y"
#include "copyright.h"
#include "port.h"
#include "utility.h"
#include "symtab.h"
#include "node.h"
#include "yylex.h"

/*
 *  Deviations allowed from BDS syntax:
 *	1) BEHAVIOR / ENDBEHAVIOR keywords are optional;
 *	2) name following ENDMODEL is optional;
 *	3) name following ENDROUTINE is optional;
 *	4) Declaring a variable with no size (disallowed by BDS) defines
 *	   its size as a single bit
 *	5) Syntax rule for ZXT/OXT/SXT is "SXT {width=expr} expr"
 *	6) Constant-valued expressions are allowed wherever constants are
 *	     (e.g., declaring variable sizes, and defining other constants)
 *
 *  We use operator priorities to resolve ambiguities in many cases; as in any
 *  good grammar, there is a single shift/reduce conflict (IF...THEN...ELSE).
 */


#define MAKE_ASSIGNMENT(ret, var, e1) \
    ret = node_create(T_EQ, yyfile, *yyline); ret->un.assign.lexpr = var;\
    ret->un.assign.rexpr = e1;\

#define MAKE_TERNARY(ret, op, e1, e2, e3) \
    ret = node_create(op, yyfile, *yyline); ret->un.ternary.lexpr = e1;\
    ret->un.ternary.mexpr = e2; ret->un.ternary.rexpr = e3;\

#define MAKE_BINARY(ret, e1, op, e2)\
    ret = node_create(op, yyfile, *yyline); ret->un.binary.lexpr = e1;\
    ret->un.binary.rexpr = e2;

#define MAKE_UNARY(ret, op, e1)\
    ret = node_create(op, yyfile, *yyline); ret->un.unary.expr = e1;

#define MAKE_IF(ret, e1, stmt1, stmt2)\
    ret = node_create(T_IF, yyfile, *yyline); ret->un.bdif.expr = e1; \
    ret->un.bdif.thenb = stmt1; ret->un.bdif.elseb = stmt2;

#define MAKE_SELECT(ret, op, e1, stmts)\
    ret = node_create(op, yyfile, *yyline); ret->un.select.expr = e1;\
    ret->un.select.bdcase = node_reverse(stmts);

#define MAKE_FOR(ret, op, v, from_e, to_e, by_e, st) \
    ret = node_create(op, yyfile, *yyline); ret->un.bdfor.var = v; \
    ret->un.bdfor.from = from_e; ret->un.bdfor.to = to_e; \
    ret->un.bdfor.by = by_e; ret->un.bdfor.stmt = st;

#define MAKE_CONST(ret, number, base) \
    ret = node_create(T_IS_CONSTANT, yyfile, *yyline);\
    read_constant(number, base, &dummy, &(ret->un.constant.hbit));\
    ret->un.constant.num = (int) dummy; \
    ret->un.constant.hbit -= 1;

#define MAKE_VAR(ret, op, varname, nobit, highbit, lowbit)\
    ret = node_create(op, yyfile, *yyline);\
    ret->un.bdvar.name = yacc_lookup(varname);\
    ret->un.bdvar.nbit = nobit; ret->un.bdvar.lbit = lowbit;\
	ret->un.bdvar.hbit = highbit;

#define MAKE_LEAVE(ret, label_name)\
    ret = node_create(T_LEAVE, yyfile, *yyline);\
    ret->un.leave.name = yacc_lookup(label_name);

#define MAKE_LABEL(ret, label_name, body)\
    ret = node_create(T_LABEL, yyfile, *yyline);\
    ret->un.label.name = yacc_lookup(label_name);\
    yacc_check_defined(ret->un.label.name);\
    ret->un.label.name->type = T_LABEL;\
    ret->un.label.stmt = body;\
    ret->un.label.name->u.label.def = ret;

#define SAVE_YYTEXT		strcpy(ALLOC(char, yylength + 1), yytext)

extern int select_unique;
extern int got_a_model;

node *input_ports, *output_ports;
char *model_name;

static char *routine_name;
#line 89 "yybdsyn.y"
typedef union {
    int intval;
    char *strval;
    node *expr;
} YYSTYPE;
#line 104 "y.tab.c"
#define T_AND 257
#define T_BASE 258
#define T_BEGIN 259
#define T_BEHAVIOR 260
#define T_BUF 261
#define T_BY 262
#define T_CLOSE_ANGLE 263
#define T_CLOSE_BRACKET 264
#define T_CLOSE_CURLY 265
#define T_CLOSE_PAREN 266
#define T_COLON 267
#define T_COMMA 268
#define T_CONCAT 269
#define T_CONSTANT 270
#define T_DIV 271
#define T_DO 272
#define T_DOWNTO 273
#define T_ELSE 274
#define T_END 275
#define T_ENDBEHAVIOR 276
#define T_ENDMACRO 277
#define T_ENDMODEL 278
#define T_ENDMODULE 279
#define T_ENDROUTINE 280
#define T_ENDSELECT 281
#define T_ENDSELECTALL 282
#define T_ENDSELECTONE 283
#define T_ENTRY 284
#define T_EQ 285
#define T_EQL 286
#define T_EQV 287
#define T_EXIT 288
#define T_EXTERNAL 289
#define T_FOR 290
#define T_FORWARD 291
#define T_FOURSTATE 292
#define T_FROM 293
#define T_GEQ 294
#define T_GTR 295
#define T_HALT 296
#define T_IF 297
#define T_INFORM 298
#define T_INPUT 299
#define T_INVALID 300
#define T_LEAVE 301
#define T_LEQ 302
#define T_LSS 303
#define T_MACRO 304
#define T_MINUS 305
#define T_MOD 306
#define T_MODEL 307
#define T_MODULE 308
#define T_NAME 309
#define T_NAND 310
#define T_NEQ 311
#define T_NEXT 312
#define T_NOENTRY 313
#define T_NOR 314
#define T_NOT 315
#define T_NUMBER 316
#define T_OPEN_ANGLE 317
#define T_OPEN_BRACKET 318
#define T_OPEN_CURLY 319
#define T_OPEN_PAREN 320
#define T_OR 321
#define T_OTHERWISE 322
#define T_OUTPUT 323
#define T_OXT 324
#define T_PLUS 325
#define T_PORT 326
#define T_PRINT 327
#define T_REPEAT 328
#define T_RETURN 329
#define T_REVISION 330
#define T_ROUTINE 331
#define T_SELECT 332
#define T_SELECTALL 333
#define T_SELECTONE 334
#define T_SL0 335
#define T_SL1 336
#define T_SLR 337
#define T_SR0 338
#define T_SR1 339
#define T_SRR 340
#define T_STATE 341
#define T_STATIC 342
#define T_STRING 343
#define T_SXT 344
#define T_SYNONYM 345
#define T_THEN 346
#define T_TIMES 347
#define T_TO 348
#define T_TWOSTATE 349
#define T_UNTIL 350
#define T_VAR 351
#define T_WHILE 352
#define T_WIDTH 353
#define T_XOR 354
#define T_ZXT 355
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   40,   42,   44,   43,   45,   45,   46,   46,
   41,   41,   47,   47,   48,   48,   48,   48,   48,    4,
   14,    8,    9,   10,   10,   11,   11,   12,   12,   12,
   12,    1,    1,    2,    2,    2,   39,   39,    3,    3,
    3,   49,   53,   53,   54,   54,   50,   56,   56,   57,
   57,   52,   58,   58,   59,   51,   60,   60,   61,    5,
    5,    5,    5,   17,   17,   18,   18,   18,   18,   18,
   18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
   18,   18,   19,   19,   22,   22,   22,   22,   20,   20,
   21,   21,   21,   29,   28,   28,   32,   32,   33,   33,
   34,   34,   35,   35,   35,   23,   24,   25,   26,   27,
   30,   62,   62,   63,   63,   63,   31,   31,   31,   31,
   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
   31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
   31,   31,   31,   13,   13,    6,    6,    7,    7,   16,
   16,   16,   15,   15,   15,   38,   37,   36,   55,   55,
   64,   64,   64,   64,   64,   64,
};
short yylen[] = {                                         2,
    1,    1,    3,    6,    3,    3,    0,    3,    0,    3,
    0,    2,    2,    2,    4,    1,    2,    1,    1,    2,
    5,    2,    2,    0,    3,    0,    1,    1,    2,    3,
    4,    0,    2,    2,    2,    2,    0,    1,    1,    1,
    1,    2,    1,    3,    1,    2,    2,    1,    3,    1,
    2,    2,    1,    3,    3,    2,    1,    3,    3,    1,
    3,    4,    6,    1,    3,    3,    1,    3,    6,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    2,    3,    8,   10,    8,   10,    4,    6,
    5,    5,    5,    2,    1,    2,    1,    2,    6,    5,
    1,    3,    1,    3,    1,    4,    4,    4,    4,    2,
    4,    1,    3,    0,    1,    1,    1,    1,    3,    4,
    1,    2,    2,    2,    2,    2,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    7,    7,
    7,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    4,    1,    3,    1,    2,    2,
    3,    5,    1,    3,    3,    1,    1,    1,    1,    2,
    1,    1,    4,    1,    1,    1,
};
short yydefred[] = {                                      0,
    0,    0,    1,    0,    0,  166,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   19,    0,    0,    0,   18,
   12,    0,   16,   39,   40,   41,    0,    0,   11,    0,
   28,    0,    0,    0,    0,    0,   57,    0,  168,   20,
    0,    0,   43,   17,   23,    0,    0,   48,    0,    0,
   53,   14,   32,    0,   22,   13,   38,    0,    0,    3,
    0,   29,    0,    0,    0,    0,    0,    0,    0,  176,
  171,  174,  172,  175,    0,  169,    0,    0,    0,    0,
    0,    0,    0,    8,    0,    0,    6,    0,    0,   30,
    0,   61,    0,    0,  167,    0,    0,    0,    0,    0,
    0,  117,  121,  118,    0,    0,    0,   59,    0,   58,
   15,    0,  170,   44,   49,   55,   54,    0,    0,    0,
    0,    0,   81,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   33,    0,    0,    0,    0,   64,   70,
   71,   72,   76,   77,   78,   79,   80,   74,   73,   75,
    0,    0,   25,    5,    0,    4,   31,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   62,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  159,    0,   82,    0,
    0,    0,   21,    0,    0,    0,   94,    0,  110,    0,
    0,    0,    0,    0,    0,   34,   35,    0,   36,    0,
   10,    0,    0,    0,    0,    0,    0,  142,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  164,  165,  160,    0,  154,    0,    0,  173,   83,   66,
    0,    0,    0,    0,    0,  115,    0,    0,  112,    0,
    0,    0,    0,    0,    0,    0,   65,  120,    0,    0,
    0,   63,  161,    0,  155,    0,   84,    0,    0,    0,
    0,  111,    0,    0,    0,   97,    0,    0,  107,  106,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  113,
  105,    0,    0,  101,   91,   98,   93,   92,    0,    0,
    0,    0,  162,    0,    0,   90,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  102,
    0,   87,    0,   85,  100,    0,    0,    0,   99,   88,
   86,
};
short yydgoto[] = {                                       2,
   82,  134,   16,   17,   31,  256,  102,   18,   19,   55,
   32,   33,  103,   20,  104,  197,  138,  139,  201,  140,
  141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
  151,  295,  296,  313,  314,   40,  106,  107,   58,    3,
    4,    5,   28,   60,   29,   87,   21,   22,   23,   24,
   25,   26,   42,   43,   75,   47,   48,   50,   51,   36,
   37,  268,  269,   76,
};
short yysindex[] = {                                   -304,
 -290,    0,    0,  145, -219,    0, -307, -290, -235, -292,
 -290, -225, -290, -290, -290,    0, -209, -195, -193,    0,
    0, -179,    0,    0,    0,    0, -290, -141,    0, -290,
    0, -140,  -97, -142,  -95,  -63,    0, -290,    0,    0,
 -249,  -48,    0,    0,    0, -249,  -44,    0,  -51,  -26,
    0,    0,    0, -307,    0,    0,    0,  -74, -290,    0,
   86,    0, -307, -291, -122, -286, -290, -193,  -67,    0,
    0,    0,    0,    0, -249,    0, -290, -249, -290, -290,
 -290,  113,  -11,    0,  -53, -290,    0,  -50, -290,    0,
 1058,    0, 1058, 1058,    0, 1058,  -52, 1058,  -45, 1058,
  -43,    0,    0,    0, 2384,    7,  -88,    0,    8,    0,
    0,  -40,    0,    0,    0,    0,    0,  -37,  350,  350,
 -290, -290,    0, 1058, -290,  -42,  350, 1058, 1058, 1058,
 1058, 1058, 1058,    0,  -35,  -29,  -17,  -25,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3380, -136,    0,    0,  -24,    0,    0, 4111,   13, 4111,
 2627,  -62,   13,  -61, 3380,  -60, 1058,    0, 1058, 1058,
 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058, 1058,
 1058, 1058,  -22,  -22,  494, 3643,    0,   20,    0,  -10,
  192, -248,    0,    2,  -16, 2674,    0,  682,    0, 3380,
 2729, 2784, 2839, 2886, 2933,    0,    0, 3655,    0,  350,
    0,  -16,   18,   24,   25, 4111, 2988,    0,  -21, -129,
 3853, -129, -129, -129, -129, -224,  -21, 4111, -129, 3925,
 3925, -224,   13,   13,   13,   13,   13,   13,  -21, 3853,
    0,    0,    0, 2439,    0, -134, 3380,    0,    0,    0,
   -7, 1058, 1058, 1058,  350,    0, 3380,  -86,    0,   -6,
   -6,   -6,  350,  350,    5, 3380,    0,    0, 1058, 1058,
 1058,    0,    0, 1058,    0, 1058,    0, 3380, 3380, 2486,
   48,    0,  682,  870, -280,    0, -262, -261,    0,    0,
   58, 3035, 3082, 3129, 3184, 3380, 1058, 1058,  350,    0,
    0, 3239, -237,    0,    0,    0,    0,    0, 1058, 1058,
 1058, 1058,    0, 2533, 2580,    0, 1058,   60,  870, 3380,
 3380, 3380, 3380, 1058,  350, 1058,  350, 3380,  271,    0,
 3286,    0, 3333,    0,    0,   17,  350,  350,    0,    0,
    0,
};
short yyrindex[] = {                                      9,
    0,    0,    0,  330,   50,    0,   46,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   30,    0,
    0,    0,    0,    0,    0,    0,   31,    0,    0,    0,
    0,    0, -251,  -69,    0, -179,    0,    0,    0,    0,
 -264,   32,    0,    0,    0, -243,   33,    0,    0, -209,
    0,    0,    0,   71,    0,    0,    0,    0,   31,    0,
   74,    0,   37,    0,    0,    0,    0,   30,    0,    0,
    0,    0,    0,    0, -240,    0,    0, -229,    0,    0,
    0,    0,    0,    0,    0,   31,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  518,  424,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   31,    0,    0,    0,    0,    0,    0, -266,    0,    0,
    0,    0,    0,    0,    0,    0, 1876,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -263, 1804,    0,    0,    0,    0,    0, 3473,  706, 3491,
    0,    0,  800,    0, 3975,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   64,    0,    0,  -47,    0, -258,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  612,    0,    0,    0, 3585,    0,    0, 1458, 1970,
 3771, 2039, 2108, 2177, 2246, 1665, 1527, 3603, 2315, 3739,
 3755, 1734,  894,  988, 1082, 1176, 1270, 1364, 1596, 3864,
    0,    0,    0,    0,    0,    0,  -41,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -31,    0,    0,    0,
    0,    0,    0,    0,    0, -257,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -253, -222,    0,
 -124,    0,  -47,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -19,    0,    0,    0,    0,
    0, -228,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -100,
 4012, 4026, 4044,    0,    0,    0,    0, -139,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
short yygindex[] = {                                      0,
    0,    0,  276,  277, 2057,    0,   16,    0,    0,  292,
  -30,    0,    0,    0,  295,  143,   59,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -23,  -58, -106,    0,   38,    0,   52,   -1,  -54,    0,
  341,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  294,  327,    0,  296,    0,  297,    0,
  312,    0,   89,  126,
};
#define YYTABLESIZE 4458
short yytable[] = {                                       7,
  315,    6,    1,   45,   85,   34,   34,   95,   11,   34,
   67,   34,   34,   34,   27,   96,   68,    6,    6,  317,
  108,  318,    6,   83,   50,   57,  328,   46,   34,   95,
  329,  155,   88,   27,   69,  103,   34,  294,   51,  103,
   27,  105,   70,   30,  170,   95,  171,   45,   67,   71,
   39,  109,   34,   96,   68,  294,  294,   57,  108,   89,
   27,   34,   34,   72,  109,   34,  203,  158,   50,  159,
  160,   46,  161,   73,  163,   34,  165,   34,   34,   34,
  152,  179,   51,   95,   57,   95,   67,   34,   67,  109,
   44,   96,   68,   96,   68,   38,  108,  137,  108,   74,
  206,  262,   52,  263,  210,  211,  212,  213,  214,  215,
  185,  186,  187,  188,  189,  190,   53,  152,  152,   57,
  205,  194,  191,  207,  104,  152,   54,  109,  104,  109,
  220,  285,   56,  286,  137,  137,   59,  204,   91,  170,
   92,  171,  137,  226,   63,  227,  228,  229,  230,  231,
  232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
  242,  243,  244,  245,  246,  247,  248,  249,  250,  194,
   64,  254,  257,   69,   65,  178,  179,  200,  202,  292,
  195,  293,   93,  196,  267,  209,    6,   89,  316,   66,
  316,  316,   94,   95,  276,  184,   60,   96,   60,  152,
  113,   97,   98,  113,   67,  185,  186,  187,  188,  189,
  190,   69,  297,  298,   60,   60,  137,  191,  114,   77,
  114,   99,   60,   79,  156,   89,  156,   89,  195,   60,
  100,  196,  101,   80,  116,  137,  116,   84,  288,  289,
  290,   81,   60,   60,  251,  252,  157,  170,  157,   69,
   60,   69,  112,   60,  153,  302,  303,  304,  154,  261,
  305,  156,  306,  152,  193,  194,  162,  218,  198,  267,
  312,  152,  152,  164,  199,  166,  216,  208,   11,   60,
  137,  170,  217,  324,  325,  258,  219,  221,  137,  137,
  223,  224,  225,   95,  264,  330,  331,  332,  333,   11,
  195,  259,  279,  338,  287,  312,   11,  152,  280,  281,
  341,  294,  343,  185,  186,  187,  188,  189,  190,    7,
  301,  309,  319,  291,  137,    7,  339,    7,  349,    2,
   26,  299,  300,  152,   11,  152,   26,  152,   11,   11,
    7,   24,   37,   42,   47,  152,  152,    7,   26,   11,
  137,    9,  137,   11,  137,    8,  158,  135,  136,  111,
  108,   86,  137,  137,  278,  277,  340,  326,  118,   61,
  114,  119,   78,   91,  115,    7,    9,  117,  110,    7,
    7,  310,    8,   10,  120,    0,    0,    0,    0,    0,
    7,    0,  121,  342,    7,  344,    0,  346,    0,    0,
    0,    0,  122,    0,    0,  350,  351,    0,  123,  124,
   10,   11,    0,  125,    8,   12,   13,   93,    0,    0,
    0,    6,    0,    0,    0,    0,   14,   94,   95,    0,
   15,    0,   96,    0,    0,    9,   97,   98,    0,  126,
  127,  128,   10,    0,  129,  130,  131,  118,    0,    0,
  119,    0,   91,   14,    0,    0,   99,   15,    0,    0,
    0,    0,  132,  120,  133,  100,  260,  101,    0,    0,
   11,    0,    0,    0,   12,   13,    0,    0,    0,    0,
    0,  122,    0,    0,    0,   14,    0,  123,  124,   15,
    0,    0,  125,    0,    0,    0,   93,    0,    0,    0,
    6,    0,    0,    0,    0,    0,   94,   95,    0,    0,
    0,   96,    0,    0,    0,   97,   98,    0,  126,  127,
  128,    0,    0,  129,  130,  131,  118,    0,    0,  119,
    0,   91,    0,    0,    0,   99,    0,    0,    0,    0,
    0,  132,  120,  133,  100,    0,  101,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  122,    0,    0,    0,    0,    0,  123,  124,    0,    0,
    0,  125,    0,    0,    0,   93,    0,    0,    0,    6,
    0,    0,  345,    0,    0,   94,   95,    0,    0,    0,
   96,    0,    0,    0,   97,   98,    0,  126,  127,  128,
    0,    0,  129,  130,  131,  118,    0,    0,  119,    0,
   91,    0,    0,    0,   99,    0,    0,    0,    0,    0,
  132,  120,  133,  100,    0,  101,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  122,
    0,    0,    0,    0,    0,  123,  124,    0,    0,    0,
  125,    0,    0,    0,   93,    0,    0,    0,    6,    0,
    0,    0,    0,    0,   94,   95,    0,    0,    0,   96,
    0,    0,    0,   97,   98,    0,  126,  127,  128,    0,
  158,  129,  130,  131,    0,  158,  158,  158,  158,  158,
  158,  158,  158,   99,  158,  158,  158,  158,    0,  132,
    0,  133,  100,    0,  101,    0,    0,    0,  158,  158,
  158,    0,    0,    0,    0,    0,  158,  158,  158,    0,
    0,    0,    0,    0,    0,  158,  158,    0,  158,  158,
    0,    0,    0,  158,  158,  158,    0,  158,    0,    0,
    0,    0,    0,    0,  158,    0,    0,    0,  158,    0,
    0,    0,    0,    0,   91,    0,  253,    0,  158,  158,
  158,  158,  158,  158,    0,    0,    0,    0,    0,  158,
  158,  158,    0,  158,  163,  158,    0,  158,    0,  163,
  163,  163,  163,  163,  163,  163,  163,    0,  163,  163,
  163,  163,    0,    0,    0,    0,    0,    0,   93,    0,
    0,    0,    6,  163,  163,    0,    0,    0,   94,   95,
  163,  163,  163,   96,    0,    0,    0,   97,   98,  163,
  163,    0,  163,  163,    0,    0,    0,  163,  163,  163,
    0,  163,    0,    0,    0,    0,    0,   99,  163,    0,
    0,    0,  163,    0,    0,    0,  100,    0,  101,    0,
    0,    0,  163,  163,  163,  163,  163,  163,    0,    0,
    0,    0,    0,  163,  163,  163,    0,  163,  119,  163,
    0,  163,    0,  119,  119,  119,  119,  119,  119,  119,
  119,    0,  119,  119,  119,  119,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,  119,    0,
    0,    0,    0,    0,  119,  119,  119,    0,    0,    0,
    0,    0,    0,  119,  119,    0,  119,  119,    0,    0,
    0,  119,  119,  119,    0,  119,    0,    0,    0,    0,
    0,    0,  119,    0,    0,    0,  119,    0,    0,    0,
    0,    0,   91,    0,    0,    0,  119,  119,  119,  119,
  119,  119,    0,    0,    0,    0,    0,  119,  119,  119,
    0,  119,  126,  119,    0,  119,    0,  126,  126,  126,
  126,  126,  126,  126,    0,    0,  126,  126,  126,  126,
    0,    0,    0,    0,    0,    0,   93,    0,    0,    0,
    6,  126,  126,    0,    0,    0,   94,   95,  126,  126,
  126,   96,    0,    0,    0,   97,   98,  126,  126,    0,
  126,  126,    0,    0,    0,  126,  126,  126,    0,  126,
    0,    0,    0,    0,  266,   99,  126,    0,    0,    0,
  126,    0,    0,    0,  100,    0,  101,    0,    0,    0,
  126,  126,  126,  126,  126,  126,    0,    0,    0,    0,
    0,  126,  126,  126,    0,  126,  125,  126,    0,  126,
    0,  125,  125,  125,  125,  125,  125,  125,    0,    0,
  125,  125,  125,  125,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  125,  125,    0,    0,    0,
    0,    0,  125,  125,  125,    0,    0,    0,    0,    0,
    0,  125,  125,    0,  125,  125,    0,    0,    0,  125,
  125,  125,    0,  125,    0,    0,    0,    0,    0,    0,
  125,    0,    0,    0,  125,    0,    0,    0,    0,    0,
   91,    0,    0,    0,  125,  125,  125,  125,  125,  125,
    0,    0,    0,    0,    0,  125,  125,  125,    0,  125,
  133,  125,    0,  125,    0,  133,  133,  133,  133,  133,
  133,  133,    0,    0,  133,  133,  133,  133,    0,    0,
    0,    0,    0,    0,   93,    0,    0,    0,    6,  133,
  133,    0,    0,    0,   94,   95,  133,  133,  133,   96,
    0,  311,    0,   97,   98,  133,  133,    0,  133,  133,
    0,    0,    0,  133,  133,  133,    0,  133,    0,    0,
    0,    0,    0,   99,  133,    0,    0,    0,  133,    0,
    0,    0,  100,    0,  101,    0,    0,    0,  133,  133,
  133,  133,  133,  133,    0,    0,    0,    0,    0,  133,
  133,  133,    0,  133,  135,  133,    0,  133,    0,  135,
  135,  135,  135,  135,  135,  135,    0,    0,  135,  135,
  135,  135,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  135,  135,    0,    0,    0,    0,    0,
  135,  135,  135,    0,    0,    0,    0,    0,    0,  135,
  135,    0,  135,  135,    0,    0,    0,  135,  135,  135,
    0,  135,    0,    0,    0,    0,    0,    0,  135,    0,
    0,    0,  135,    0,    0,    0,    0,    0,   91,    0,
    0,    0,  135,  135,  135,  135,  135,  135,    0,    0,
    0,    0,    0,  135,  135,  135,    0,  135,  137,  135,
    0,  135,    0,  137,  137,  137,  137,  137,  137,  137,
    0,    0,  137,  137,  137,  137,    0,    0,    0,    0,
    0,    0,   93,    0,    0,    0,    6,  137,  137,    0,
    0,    0,   94,   95,  137,  137,  137,   96,    0,    0,
    0,   97,   98,  137,  137,    0,  137,  137,    0,    0,
    0,  137,  137,  137,    0,  137,    0,    0,    0,    0,
    0,   99,  137,    0,    0,    0,  137,    0,    0,    0,
  100,    0,  101,    0,    0,    0,  137,  137,  137,  137,
  137,  137,    0,    0,    0,    0,    0,  137,  137,  137,
    0,  137,  134,  137,    0,  137,    0,  134,  134,  134,
  134,  134,  134,  134,    0,    0,  134,  134,  134,  134,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  134,  134,    0,    0,    0,    0,    0,  134,  134,
  134,    0,    0,    0,    0,    0,    0,  134,  134,    0,
  134,  134,    0,    0,    0,  134,  134,  134,    0,  134,
    0,    0,    0,    0,    0,    0,  134,    0,    0,    0,
  134,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  134,  134,  134,  134,  134,  134,    0,    0,    0,    0,
    0,  134,  134,  134,    0,  134,  136,  134,    0,  134,
    0,  136,  136,  136,  136,  136,  136,  136,    0,    0,
  136,  136,  136,  136,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  136,  136,    0,    0,    0,
    0,    0,  136,  136,  136,    0,    0,    0,    0,    0,
    0,  136,  136,    0,  136,  136,    0,    0,    0,  136,
  136,  136,    0,  136,    0,    0,    0,    0,    0,    0,
  136,    0,    0,    0,  136,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  136,  136,  136,  136,  136,  136,
    0,    0,    0,    0,    0,  136,  136,  136,    0,  136,
  138,  136,    0,  136,    0,  138,  138,  138,  138,  138,
  138,  138,    0,    0,  138,  138,  138,  138,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  138,
  138,    0,    0,    0,    0,    0,  138,  138,  138,    0,
    0,    0,    0,    0,    0,  138,  138,    0,  138,  138,
    0,    0,    0,  138,  138,  138,    0,  138,    0,    0,
    0,    0,    0,    0,  138,    0,    0,    0,  138,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  138,  138,
  138,  138,  138,  138,    0,    0,    0,    0,    0,  138,
  138,  138,    0,  138,  146,  138,    0,  138,    0,  146,
  146,  146,  146,  146,  146,  146,    0,    0,  146,  146,
  146,  146,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  146,  146,    0,    0,    0,    0,    0,
  146,  146,  146,    0,    0,    0,    0,    0,    0,  146,
  146,    0,  146,  146,    0,    0,    0,  146,  146,  146,
    0,  146,    0,    0,    0,    0,    0,    0,  146,    0,
    0,    0,  146,  147,    0,    0,    0,    0,  147,  147,
  147,  147,  147,  147,  147,    0,    0,  147,  147,  147,
  147,    0,    0,  146,  146,  146,    0,  146,    0,  146,
    0,  146,  147,  147,    0,    0,    0,    0,    0,  147,
  147,  147,    0,    0,    0,    0,    0,    0,  147,  147,
    0,  147,  147,    0,    0,    0,  147,  147,  147,    0,
  147,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  147,  145,    0,    0,    0,    0,  145,  145,  145,
  145,  145,  145,  145,    0,    0,  145,  145,  145,  145,
    0,    0,  147,  147,  147,    0,  147,    0,  147,    0,
  147,  145,  145,    0,    0,    0,    0,    0,  145,  145,
  145,    0,    0,    0,    0,    0,    0,  145,  145,    0,
  145,  145,    0,    0,    0,  145,  145,  145,    0,  145,
    0,    0,    0,    0,    0,    0,  145,    0,    0,    0,
  145,  144,    0,    0,    0,    0,  144,  144,  144,  144,
  144,  144,  144,    0,    0,    0,  144,  144,  144,    0,
    0,  145,  145,  145,    0,  145,    0,  145,    0,  145,
  144,  144,    0,    0,    0,    0,    0,  144,  144,  144,
    0,    0,    0,    0,    0,    0,  144,  144,    0,  144,
    0,    0,    0,    0,  144,  144,  144,    0,  144,    0,
    0,    0,    0,    0,    0,  144,    0,    0,    0,  144,
  143,    0,    0,    0,    0,  143,  143,  143,  143,  143,
  143,  143,    0,    0,    0,  143,  143,  143,    0,    0,
  144,    0,  144,    0,  144,    0,  144,    0,  144,  143,
  143,    0,    0,    0,    0,    0,  143,  143,  143,    0,
    0,    0,    0,    0,    0,  143,  143,    0,  143,    0,
    0,    0,    0,  143,  143,  143,    0,  143,    0,    0,
    0,    0,    0,    0,  143,    0,    0,    0,  143,    0,
  158,    0,    0,    0,   35,    0,    0,   41,    0,   45,
   46,   49,  158,    0,  158,    0,    0,  158,    0,  143,
    0,  143,    0,  143,    0,  143,   62,  143,  158,  158,
  158,    0,    0,    0,   68,    0,    0,  158,  158,    0,
    0,    0,    0,    0,    0,  158,  158,    0,  158,  158,
    0,    0,    0,  158,  158,  158,    0,  158,    0,    0,
   90,    0,    0,   35,  158,    0,    0,    0,  158,    0,
    0,    0,  117,   41,    0,   46,  116,   49,  158,  158,
  158,  158,  158,  158,  117,  157,  117,    0,    0,  117,
  158,    0,    0,  158,    0,  158,    0,  158,    0,    0,
    0,  117,  117,    0,    0,    0,    0,    0,    0,  117,
  117,    0,    0,    0,    0,    0,    0,  117,  117,    0,
  117,  117,    0,    0,    0,  117,  117,  117,    0,  117,
    0,    0,    0,    0,    0,    0,  117,    0,    0,    0,
  117,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  117,  117,  117,  117,  117,  117,    0,    0,    0,    0,
    0,    0,  117,    0,    0,  117,  148,  117,    0,  117,
    0,  148,  148,  148,  148,  148,  148,  148,    0,    0,
    0,  148,  148,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  148,  148,    0,    0,    0,
    0,    0,  148,  148,  148,    0,    0,    0,    0,    0,
    0,  148,  148,    0,    0,    0,    0,    0,    0,  148,
  148,  148,    0,  148,    0,    0,    0,    0,    0,    0,
  148,    0,    0,    0,    0,  150,    0,    0,    0,    0,
  150,  150,  150,  150,  150,  150,  150,    0,    0,    0,
  150,  150,  150,    0,    0,  148,    0,  148,    0,  148,
    0,  148,    0,  148,  150,  150,    0,    0,    0,    0,
    0,  150,  150,  150,    0,    0,    0,    0,    0,    0,
  150,  150,    0,    0,    0,    0,    0,    0,  150,  150,
  150,    0,  150,    0,    0,    0,    0,    0,    0,  150,
    0,    0,    0,    0,  152,    0,    0,    0,    0,  152,
  152,  152,  152,  152,  152,  152,    0,    0,    0,  152,
  152,  152,    0,    0,  150,    0,  150,    0,  150,    0,
  150,    0,  150,  152,  152,    0,    0,    0,    0,    0,
  152,  152,  152,    0,    0,    0,    0,    0,    0,  152,
  152,    0,    0,    0,    0,    0,    0,  152,  152,  152,
    0,  152,    0,    0,    0,    0,    0,    0,  152,    0,
    0,    0,    0,  151,    0,    0,    0,    0,  151,  151,
  151,  151,  151,  151,  151,    0,    0,    0,  151,  151,
  151,    0,    0,  152,    0,  152,    0,  152,    0,  152,
    0,  152,  151,  151,    0,    0,    0,    0,    0,  151,
  151,  151,    0,    0,    0,    0,    0,    0,  151,  151,
    0,    0,    0,    0,    0,    0,  151,  151,  151,    0,
  151,    0,    0,    0,    0,    0,    0,  151,    0,    0,
    0,    0,  153,    0,    0,    0,    0,  153,  153,  153,
  153,  153,  153,  153,    0,    0,    0,  153,  153,  153,
    0,    0,  151,    0,  151,    0,  151,    0,  151,    0,
  151,  153,  153,    0,    0,    0,    0,    0,  153,  153,
  153,    0,    0,    0,    0,    0,    0,  153,  153,    0,
    0,    0,    0,    0,    0,  153,  153,  153,    0,  153,
    0,    0,    0,    0,    0,    0,  153,    0,    0,    0,
    0,  149,    0,    0,    0,    0,  149,  149,  149,  149,
  149,  149,  149,    0,    0,    0,  149,  149,  149,    0,
    0,  153,    0,  153,    0,  153,    0,  153,    0,  153,
  149,  149,    0,    0,    0,    0,    0,  149,  149,  149,
    0,    0,    0,    0,    0,    0,  149,  149,    0,    0,
    0,    0,    0,    0,  149,  149,  149,    0,  149,    0,
    0,    0,    0,    0,    0,  149,    0,    0,    0,    0,
  167,    0,    0,    0,    0,    0,  168,    0,    0,    0,
  169,    0,  170,    0,  171,    0,    0,    0,    0,    0,
  149,    0,  149,    0,  149,    0,  149,    0,  149,  172,
  173,    0,    0,    0,    0,    0,    0,  174,  175,    0,
    0,    0,    0,    0,    0,  176,  177,    0,  178,  179,
    0,    0,    0,  180,  181,  167,    0,  182,    0,    0,
    0,  283,    0,    0,  183,  284,    0,  170,  184,  171,
    0,    0,    0,    0,    0,    0,    0,    0,  185,  186,
  187,  188,  189,  190,  172,  173,    0,    0,    0,    0,
  191,    0,  174,  175,    0,    0,    0,  192,    0,    0,
  176,  177,  167,  178,  179,    0,    0,    0,  180,  181,
    0,    0,  182,    0,  170,    0,  171,    0,  307,  183,
    0,    0,    0,  184,    0,    0,    0,    0,    0,    0,
    0,  172,  173,  185,  186,  187,  188,  189,  190,  174,
  175,    0,    0,    0,    0,  191,    0,  176,  177,  167,
  178,  179,  192,    0,  334,  180,  181,    0,    0,  182,
    0,  170,    0,  171,  335,    0,  183,    0,    0,    0,
  184,    0,    0,    0,    0,    0,    0,    0,  172,  173,
  185,  186,  187,  188,  189,  190,  174,  175,    0,    0,
    0,    0,  191,  308,  176,  177,  167,  178,  179,  192,
    0,  336,  180,  181,    0,    0,  182,    0,  170,    0,
  171,  337,    0,  183,    0,    0,    0,  184,    0,    0,
    0,    0,    0,    0,    0,  172,  173,  185,  186,  187,
  188,  189,  190,  174,  175,    0,    0,    0,    0,  191,
    0,  176,  177,  167,  178,  179,  192,    0,    0,  180,
  181,    0,  222,  182,    0,  170,    0,  171,    0,    0,
  183,    0,    0,    0,  184,    0,    0,    0,    0,    0,
    0,    0,  172,  173,  185,  186,  187,  188,  189,  190,
  174,  175,    0,    0,    0,    0,  191,    0,  176,  177,
  167,  178,  179,  192,    0,    0,  180,  181,    0,    0,
  182,    0,  170,    0,  171,    0,    0,  183,    0,    0,
    0,  184,    0,    0,    0,    0,    0,    0,    0,  172,
  173,  185,  186,  187,  188,  189,  190,  174,  175,    0,
    0,    0,    0,  191,    0,  176,  177,    0,  178,  179,
  192,    0,    0,  180,  181,  167,    0,  182,    0,    0,
    0,    0,    0,    0,  183,    0,    0,  170,  184,  171,
    0,    0,    0,    0,    0,    0,    0,    0,  185,  186,
  187,  188,  189,  190,  172,  173,    0,    0,    0,  265,
  191,  270,  174,  175,    0,    0,    0,  192,    0,    0,
  176,  177,    0,  178,  179,    0,    0,    0,  180,  181,
  167,    0,  182,    0,    0,    0,    0,    0,    0,  183,
    0,    0,  170,  184,  171,    0,    0,    0,    0,    0,
    0,    0,    0,  185,  186,  187,  188,  189,  190,  172,
  173,    0,    0,    0,    0,  191,  271,  174,  175,    0,
    0,    0,  192,    0,    0,  176,  177,    0,  178,  179,
    0,    0,    0,  180,  181,  167,    0,  182,    0,    0,
    0,    0,    0,    0,  183,    0,    0,  170,  184,  171,
    0,    0,    0,    0,    0,    0,    0,    0,  185,  186,
  187,  188,  189,  190,  172,  173,    0,    0,    0,    0,
  191,  272,  174,  175,    0,    0,    0,  192,    0,    0,
  176,  177,  167,  178,  179,    0,    0,    0,  180,  181,
    0,    0,  182,    0,  170,    0,  171,  273,    0,  183,
    0,    0,    0,  184,    0,    0,    0,    0,    0,    0,
    0,  172,  173,  185,  186,  187,  188,  189,  190,  174,
  175,    0,    0,    0,    0,  191,    0,  176,  177,  167,
  178,  179,  192,    0,    0,  180,  181,    0,    0,  182,
    0,  170,    0,  171,  274,    0,  183,    0,    0,    0,
  184,    0,    0,    0,    0,    0,    0,    0,  172,  173,
  185,  186,  187,  188,  189,  190,  174,  175,    0,    0,
    0,    0,  191,    0,  176,  177,    0,  178,  179,  192,
    0,    0,  180,  181,  167,    0,  182,    0,    0,    0,
  282,    0,    0,  183,    0,    0,  170,  184,  171,    0,
    0,    0,    0,    0,    0,    0,    0,  185,  186,  187,
  188,  189,  190,  172,  173,    0,    0,    0,    0,  191,
    0,  174,  175,    0,    0,    0,  192,    0,    0,  176,
  177,  167,  178,  179,    0,    0,    0,  180,  181,  320,
    0,  182,    0,  170,    0,  171,    0,    0,  183,    0,
    0,    0,  184,    0,    0,    0,    0,    0,    0,    0,
  172,  173,  185,  186,  187,  188,  189,  190,  174,  175,
    0,    0,    0,    0,  191,    0,  176,  177,  167,  178,
  179,  192,    0,    0,  180,  181,  321,    0,  182,    0,
  170,    0,  171,    0,    0,  183,    0,    0,    0,  184,
    0,    0,    0,    0,    0,    0,    0,  172,  173,  185,
  186,  187,  188,  189,  190,  174,  175,    0,    0,    0,
    0,  191,    0,  176,  177,  167,  178,  179,  192,    0,
    0,  180,  181,  322,    0,  182,    0,  170,    0,  171,
    0,    0,  183,    0,    0,    0,  184,    0,    0,    0,
    0,    0,    0,    0,  172,  173,  185,  186,  187,  188,
  189,  190,  174,  175,    0,    0,    0,    0,  191,    0,
  176,  177,    0,  178,  179,  192,    0,    0,  180,  181,
  167,    0,  182,    0,    0,    0,  323,    0,    0,  183,
    0,    0,  170,  184,  171,    0,    0,    0,    0,    0,
    0,    0,    0,  185,  186,  187,  188,  189,  190,  172,
  173,    0,    0,    0,    0,  191,    0,  174,  175,    0,
    0,    0,  192,    0,    0,  176,  177,    0,  178,  179,
    0,    0,    0,  180,  181,  167,    0,  182,    0,    0,
    0,    0,    0,    0,  183,  327,    0,  170,  184,  171,
    0,    0,    0,    0,    0,    0,    0,    0,  185,  186,
  187,  188,  189,  190,  172,  173,    0,    0,    0,    0,
  191,    0,  174,  175,    0,    0,    0,  192,    0,    0,
  176,  177,  167,  178,  179,    0,    0,    0,  180,  181,
    0,    0,  182,    0,  170,    0,  171,  347,    0,  183,
    0,    0,    0,  184,    0,    0,    0,    0,    0,    0,
    0,  172,  173,  185,  186,  187,  188,  189,  190,  174,
  175,    0,    0,    0,    0,  191,    0,  176,  177,  167,
  178,  179,  192,    0,    0,  180,  181,    0,    0,  182,
    0,  170,    0,  171,  348,    0,  183,    0,    0,    0,
  184,    0,    0,    0,    0,    0,    0,    0,  172,  173,
  185,  186,  187,  188,  189,  190,  174,  175,    0,    0,
    0,    0,  191,    0,  176,  177,  167,  178,  179,  192,
    0,    0,  180,  181,    0,    0,  182,    0,  170,    0,
  171,    0,    0,  183,    0,    0,    0,  184,    0,    0,
    0,    0,    0,    0,    0,  172,  173,  185,  186,  187,
  188,  189,  190,  174,  175,    0,    0,    0,    0,  191,
    0,  176,  177,    0,  178,  179,  192,    0,    0,  180,
  181,    0,    0,  182,    0,    0,    0,    0,    0,    0,
  183,    0,    0,    0,  184,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  185,  186,  187,  188,  189,  190,
    0,    0,    0,    0,    0,    0,  191,    0,    0,  123,
    0,    0,    0,  192,  123,  123,  123,  123,  123,  123,
  123,    0,    0,    0,  123,  123,  123,  122,    0,    0,
    0,    0,  122,  122,  122,  122,  122,  122,  122,  123,
    0,    0,  122,  122,  122,  123,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  122,    0,    0,
    0,    0,  123,  122,  123,    0,  123,    0,    0,    0,
    0,    0,    0,  123,    0,    0,    0,    0,    0,    0,
  122,    0,  122,    0,  122,    0,    0,    0,    0,    0,
    0,  122,    0,    0,    0,    0,    0,    0,  123,    0,
  123,    0,  123,    0,  123,    0,  123,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  122,    0,  122,    0,
  122,  127,  122,    0,  122,    0,  127,  127,  127,  127,
  127,  127,  127,    0,    0,    0,  127,  127,  127,  128,
    0,    0,    0,    0,  128,  128,  128,  128,  128,  128,
  128,  127,    0,    0,  128,  128,  128,  127,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
    0,    0,    0,    0,  127,  128,  127,    0,  127,    0,
    0,    0,    0,   91,    0,  127,    0,    0,  255,    0,
    0,    0,  128,    0,  128,   91,  128,    0,    0,    0,
    0,    0,    0,  128,    0,    0,    0,    0,    0,    0,
  127,    0,  127,    0,  127,    0,  127,    0,  127,    0,
    0,    0,    0,    0,    0,    0,    0,   93,  128,    0,
  128,    6,  128,    0,  128,    0,  128,   94,   95,   93,
    0,    0,   96,    6,    0,    0,   97,   98,    0,   94,
   95,    0,    0,  275,   96,    0,    0,    0,   97,   98,
    0,    0,    0,    0,    0,    0,   99,    0,    0,    0,
    0,    0,    0,    0,    0,  100,    0,  101,   99,    0,
  130,  130,  130,  130,  130,  130,  130,  100,    0,  101,
  130,  130,  130,    0,    0,    0,  129,  129,  129,  129,
  129,  129,  129,    0,    0,  130,  129,  129,  129,    0,
    0,  130,  132,  132,  132,  132,  132,  132,  132,    0,
    0,  129,  132,  132,  132,    0,    0,  129,    0,    0,
  130,    0,  130,    0,    0,    0,    0,  132,    0,  130,
    0,    0,    0,  132,    0,    0,  129,    0,  129,    0,
    0,    0,    0,    0,    0,  129,    0,    0,    0,    0,
    0,    0,  132,    0,  130,    0,  130,    0,  130,    0,
  130,    0,  130,    0,    0,    0,    0,    0,    0,    0,
  129,    0,  129,    0,  129,    0,  129,    0,  129,  167,
    0,    0,    0,    0,    0,    0,  132,    0,  132,    0,
  132,  170,  132,  171,  132,  131,  131,  131,  131,  131,
  131,  131,    0,    0,    0,  131,  131,  131,  172,    0,
    0,    0,    0,    0,    0,    0,  174,  175,    0,    0,
  131,    0,    0,    0,  176,  177,  131,  178,  179,    0,
    0,    0,  180,  181,    0,    0,  182,    0,    0,    0,
    0,    0,    0,  183,    0,  131,    0,  184,    0,    0,
    0,  167,    0,    0,    0,    0,    0,  185,  186,  187,
  188,  189,  190,  170,    0,  171,    0,    0,    0,  191,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  131,
  172,  131,    0,  131,    0,  131,    0,  131,  174,  175,
    0,    0,    0,    0,    0,    0,  176,  177,    0,  178,
  179,    0,    0,    0,  180,  181,  124,  124,  124,  124,
  124,  124,  124,    0,    0,    0,  124,  124,  124,  184,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  185,
  186,  187,  188,  189,  190,    0,    0,  124,    0,    0,
    0,  191,    0,  141,  141,  141,  141,  141,  141,  141,
    0,    0,    0,  141,  141,  141,  124,  139,  139,  139,
  139,  139,  139,  139,    0,    0,    0,  139,  139,  139,
    0,    0,    0,    0,  141,  140,  140,  140,  140,  140,
  140,  140,    0,    0,    0,  140,  140,  140,  139,    0,
  124,    0,  124,  141,  124,    0,  124,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  140,  139,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  140,    0,  141,    0,  141,
    0,  141,    0,  141,    0,    0,    0,    0,    0,    0,
    0,  139,    0,  139,    0,  139,    0,  139,    0,  170,
    0,  171,    0,    0,    0,    0,    0,    0,    0,  140,
    0,  140,    0,  140,    0,  140,  172,    0,    0,    0,
    0,    0,    0,    0,  174,  175,    0,    0,    0,    0,
    0,    0,  176,  177,    0,  178,  179,    0,    0,    0,
    0,  181,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  184,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  185,  186,  187,  188,  189,
  190,    0,    0,    0,    0,    0,    0,  191,
};
short yycheck[] = {                                       1,
  281,  309,  307,  268,   59,    7,    8,  274,    0,   11,
  274,   13,   14,   15,  266,  274,  274,  309,  309,  282,
  274,  283,  309,   54,  268,   27,  264,  268,   30,  316,
  268,   86,   63,  285,  284,  264,   38,  318,  268,  268,
  260,   65,  292,  351,  269,  312,  271,  312,  312,  299,
  343,  274,   54,  312,  312,  318,  318,   59,  312,  351,
  312,   63,   64,  313,   66,   67,  121,   91,  312,   93,
   94,  312,   96,  323,   98,   77,  100,   79,   80,   81,
   82,  306,  312,  350,   86,  352,  350,   89,  352,  312,
  316,  350,  350,  352,  352,  331,  350,   82,  352,  349,
  124,  350,  312,  352,  128,  129,  130,  131,  132,  133,
  335,  336,  337,  338,  339,  340,  312,  119,  120,  121,
  122,  258,  347,  125,  264,  127,  320,  350,  268,  352,
  267,  266,  312,  268,  119,  120,  278,  122,  261,  269,
  263,  271,  127,  167,  285,  169,  170,  171,  172,  173,
  174,  175,  176,  177,  178,  179,  180,  181,  182,  183,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  258,
  268,  195,  196,  274,  317,  305,  306,  119,  120,  266,
  317,  268,  305,  320,  208,  127,  309,  312,  295,  285,
  297,  298,  315,  316,  218,  325,  266,  320,  268,  201,
   75,  324,  325,   78,  268,  335,  336,  337,  338,  339,
  340,  312,  271,  272,  284,  285,  201,  347,  266,  268,
  268,  344,  292,  268,  266,  350,  268,  352,  317,  299,
  353,  320,  355,  285,  266,  220,  268,  312,  262,  263,
  264,  268,  312,  313,  193,  194,  266,  269,  268,  350,
  320,  352,  320,  323,  266,  279,  280,  281,  312,  201,
  284,  312,  286,  265,  258,  258,  319,  285,  309,  293,
  294,  273,  274,  319,  312,  319,  312,  320,  270,  349,
  265,  269,  312,  307,  308,  266,  312,  312,  273,  274,
  353,  353,  353,  316,  293,  319,  320,  321,  322,  291,
  317,  312,  285,  327,  312,  329,  298,  309,  285,  285,
  334,  318,  336,  335,  336,  337,  338,  339,  340,  270,
  316,  274,  265,  265,  309,  276,  267,  278,  312,    0,
  285,  273,  274,  335,  326,  337,  266,  339,  330,  331,
  291,  312,  312,  312,  312,  347,  348,  298,  312,  341,
  335,  278,  337,  345,  339,  270,  293,   82,   82,   68,
   66,  276,  347,  348,  222,  220,  329,  309,  256,   29,
   77,  259,   46,  261,   79,  326,  291,   81,   67,  330,
  331,  293,  270,  298,  272,   -1,   -1,   -1,   -1,   -1,
  341,   -1,  280,  335,  345,  337,   -1,  339,   -1,   -1,
   -1,   -1,  290,   -1,   -1,  347,  348,   -1,  296,  297,
  298,  326,   -1,  301,  270,  330,  331,  305,   -1,   -1,
   -1,  309,   -1,   -1,   -1,   -1,  341,  315,  316,   -1,
  345,   -1,  320,   -1,   -1,  291,  324,  325,   -1,  327,
  328,  329,  298,   -1,  332,  333,  334,  256,   -1,   -1,
  259,   -1,  261,  341,   -1,   -1,  344,  345,   -1,   -1,
   -1,   -1,  350,  272,  352,  353,  275,  355,   -1,   -1,
  326,   -1,   -1,   -1,  330,  331,   -1,   -1,   -1,   -1,
   -1,  290,   -1,   -1,   -1,  341,   -1,  296,  297,  345,
   -1,   -1,  301,   -1,   -1,   -1,  305,   -1,   -1,   -1,
  309,   -1,   -1,   -1,   -1,   -1,  315,  316,   -1,   -1,
   -1,  320,   -1,   -1,   -1,  324,  325,   -1,  327,  328,
  329,   -1,   -1,  332,  333,  334,  256,   -1,   -1,  259,
   -1,  261,   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,
   -1,  350,  272,  352,  353,   -1,  355,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  290,   -1,   -1,   -1,   -1,   -1,  296,  297,   -1,   -1,
   -1,  301,   -1,   -1,   -1,  305,   -1,   -1,   -1,  309,
   -1,   -1,  312,   -1,   -1,  315,  316,   -1,   -1,   -1,
  320,   -1,   -1,   -1,  324,  325,   -1,  327,  328,  329,
   -1,   -1,  332,  333,  334,  256,   -1,   -1,  259,   -1,
  261,   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,
  350,  272,  352,  353,   -1,  355,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,
   -1,   -1,   -1,   -1,   -1,  296,  297,   -1,   -1,   -1,
  301,   -1,   -1,   -1,  305,   -1,   -1,   -1,  309,   -1,
   -1,   -1,   -1,   -1,  315,  316,   -1,   -1,   -1,  320,
   -1,   -1,   -1,  324,  325,   -1,  327,  328,  329,   -1,
  257,  332,  333,  334,   -1,  262,  263,  264,  265,  266,
  267,  268,  269,  344,  271,  272,  273,  274,   -1,  350,
   -1,  352,  353,   -1,  355,   -1,   -1,   -1,  285,  286,
  287,   -1,   -1,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
   -1,   -1,   -1,   -1,  261,   -1,  263,   -1,  335,  336,
  337,  338,  339,  340,   -1,   -1,   -1,   -1,   -1,  346,
  347,  348,   -1,  350,  257,  352,   -1,  354,   -1,  262,
  263,  264,  265,  266,  267,  268,  269,   -1,  271,  272,
  273,  274,   -1,   -1,   -1,   -1,   -1,   -1,  305,   -1,
   -1,   -1,  309,  286,  287,   -1,   -1,   -1,  315,  316,
  293,  294,  295,  320,   -1,   -1,   -1,  324,  325,  302,
  303,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
   -1,  314,   -1,   -1,   -1,   -1,   -1,  344,  321,   -1,
   -1,   -1,  325,   -1,   -1,   -1,  353,   -1,  355,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,   -1,   -1,
   -1,   -1,   -1,  346,  347,  348,   -1,  350,  257,  352,
   -1,  354,   -1,  262,  263,  264,  265,  266,  267,  268,
  269,   -1,  271,  272,  273,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,  287,   -1,
   -1,   -1,   -1,   -1,  293,  294,  295,   -1,   -1,   -1,
   -1,   -1,   -1,  302,  303,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,   -1,  314,   -1,   -1,   -1,   -1,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,   -1,   -1,
   -1,   -1,  261,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,   -1,   -1,   -1,   -1,   -1,  346,  347,  348,
   -1,  350,  257,  352,   -1,  354,   -1,  262,  263,  264,
  265,  266,  267,  268,   -1,   -1,  271,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,  305,   -1,   -1,   -1,
  309,  286,  287,   -1,   -1,   -1,  315,  316,  293,  294,
  295,  320,   -1,   -1,   -1,  324,  325,  302,  303,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,   -1,  314,
   -1,   -1,   -1,   -1,  343,  344,  321,   -1,   -1,   -1,
  325,   -1,   -1,   -1,  353,   -1,  355,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,   -1,   -1,   -1,   -1,
   -1,  346,  347,  348,   -1,  350,  257,  352,   -1,  354,
   -1,  262,  263,  264,  265,  266,  267,  268,   -1,   -1,
  271,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,  287,   -1,   -1,   -1,
   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,
   -1,  302,  303,   -1,  305,  306,   -1,   -1,   -1,  310,
  311,  312,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,
  261,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
   -1,   -1,   -1,   -1,   -1,  346,  347,  348,   -1,  350,
  257,  352,   -1,  354,   -1,  262,  263,  264,  265,  266,
  267,  268,   -1,   -1,  271,  272,  273,  274,   -1,   -1,
   -1,   -1,   -1,   -1,  305,   -1,   -1,   -1,  309,  286,
  287,   -1,   -1,   -1,  315,  316,  293,  294,  295,  320,
   -1,  322,   -1,  324,  325,  302,  303,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,   -1,  314,   -1,   -1,
   -1,   -1,   -1,  344,  321,   -1,   -1,   -1,  325,   -1,
   -1,   -1,  353,   -1,  355,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,   -1,   -1,   -1,   -1,   -1,  346,
  347,  348,   -1,  350,  257,  352,   -1,  354,   -1,  262,
  263,  264,  265,  266,  267,  268,   -1,   -1,  271,  272,
  273,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,  287,   -1,   -1,   -1,   -1,   -1,
  293,  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,
  303,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,  261,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,   -1,   -1,
   -1,   -1,   -1,  346,  347,  348,   -1,  350,  257,  352,
   -1,  354,   -1,  262,  263,  264,  265,  266,  267,  268,
   -1,   -1,  271,  272,  273,  274,   -1,   -1,   -1,   -1,
   -1,   -1,  305,   -1,   -1,   -1,  309,  286,  287,   -1,
   -1,   -1,  315,  316,  293,  294,  295,  320,   -1,   -1,
   -1,  324,  325,  302,  303,   -1,  305,  306,   -1,   -1,
   -1,  310,  311,  312,   -1,  314,   -1,   -1,   -1,   -1,
   -1,  344,  321,   -1,   -1,   -1,  325,   -1,   -1,   -1,
  353,   -1,  355,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,   -1,   -1,   -1,   -1,   -1,  346,  347,  348,
   -1,  350,  257,  352,   -1,  354,   -1,  262,  263,  264,
  265,  266,  267,  268,   -1,   -1,  271,  272,  273,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,  287,   -1,   -1,   -1,   -1,   -1,  293,  294,
  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,   -1,  314,
   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,   -1,   -1,   -1,   -1,
   -1,  346,  347,  348,   -1,  350,  257,  352,   -1,  354,
   -1,  262,  263,  264,  265,  266,  267,  268,   -1,   -1,
  271,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,  287,   -1,   -1,   -1,
   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,
   -1,  302,  303,   -1,  305,  306,   -1,   -1,   -1,  310,
  311,  312,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
   -1,   -1,   -1,   -1,   -1,  346,  347,  348,   -1,  350,
  257,  352,   -1,  354,   -1,  262,  263,  264,  265,  266,
  267,  268,   -1,   -1,  271,  272,  273,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
  287,   -1,   -1,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,   -1,   -1,   -1,   -1,   -1,  346,
  347,  348,   -1,  350,  257,  352,   -1,  354,   -1,  262,
  263,  264,  265,  266,  267,  268,   -1,   -1,  271,  272,
  273,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,  287,   -1,   -1,   -1,   -1,   -1,
  293,  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,
  303,   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,
   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,
   -1,   -1,  325,  257,   -1,   -1,   -1,   -1,  262,  263,
  264,  265,  266,  267,  268,   -1,   -1,  271,  272,  273,
  274,   -1,   -1,  346,  347,  348,   -1,  350,   -1,  352,
   -1,  354,  286,  287,   -1,   -1,   -1,   -1,   -1,  293,
  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,
   -1,  305,  306,   -1,   -1,   -1,  310,  311,  312,   -1,
  314,   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,
   -1,  325,  257,   -1,   -1,   -1,   -1,  262,  263,  264,
  265,  266,  267,  268,   -1,   -1,  271,  272,  273,  274,
   -1,   -1,  346,  347,  348,   -1,  350,   -1,  352,   -1,
  354,  286,  287,   -1,   -1,   -1,   -1,   -1,  293,  294,
  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,   -1,  314,
   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,
  325,  257,   -1,   -1,   -1,   -1,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,  272,  273,  274,   -1,
   -1,  346,  347,  348,   -1,  350,   -1,  352,   -1,  354,
  286,  287,   -1,   -1,   -1,   -1,   -1,  293,  294,  295,
   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,  305,
   -1,   -1,   -1,   -1,  310,  311,  312,   -1,  314,   -1,
   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,  325,
  257,   -1,   -1,   -1,   -1,  262,  263,  264,  265,  266,
  267,  268,   -1,   -1,   -1,  272,  273,  274,   -1,   -1,
  346,   -1,  348,   -1,  350,   -1,  352,   -1,  354,  286,
  287,   -1,   -1,   -1,   -1,   -1,  293,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,  305,   -1,
   -1,   -1,   -1,  310,  311,  312,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  257,   -1,   -1,   -1,    8,   -1,   -1,   11,   -1,   13,
   14,   15,  269,   -1,  271,   -1,   -1,  274,   -1,  346,
   -1,  348,   -1,  350,   -1,  352,   30,  354,  285,  286,
  287,   -1,   -1,   -1,   38,   -1,   -1,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  312,   -1,  314,   -1,   -1,
   64,   -1,   -1,   67,  321,   -1,   -1,   -1,  325,   -1,
   -1,   -1,  257,   77,   -1,   79,   80,   81,  335,  336,
  337,  338,  339,  340,  269,   89,  271,   -1,   -1,  274,
  347,   -1,   -1,  350,   -1,  352,   -1,  354,   -1,   -1,
   -1,  286,  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,
  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,
  305,  306,   -1,   -1,   -1,  310,  311,  312,   -1,  314,
   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,   -1,   -1,   -1,   -1,
   -1,   -1,  347,   -1,   -1,  350,  257,  352,   -1,  354,
   -1,  262,  263,  264,  265,  266,  267,  268,   -1,   -1,
   -1,  272,  273,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,  287,   -1,   -1,   -1,
   -1,   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,
   -1,  302,  303,   -1,   -1,   -1,   -1,   -1,   -1,  310,
  311,  312,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  321,   -1,   -1,   -1,   -1,  257,   -1,   -1,   -1,   -1,
  262,  263,  264,  265,  266,  267,  268,   -1,   -1,   -1,
  272,  273,  274,   -1,   -1,  346,   -1,  348,   -1,  350,
   -1,  352,   -1,  354,  286,  287,   -1,   -1,   -1,   -1,
   -1,  293,  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,
  302,  303,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,
  312,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,  321,
   -1,   -1,   -1,   -1,  257,   -1,   -1,   -1,   -1,  262,
  263,  264,  265,  266,  267,  268,   -1,   -1,   -1,  272,
  273,  274,   -1,   -1,  346,   -1,  348,   -1,  350,   -1,
  352,   -1,  354,  286,  287,   -1,   -1,   -1,   -1,   -1,
  293,  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,
  303,   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,  312,
   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,
   -1,   -1,   -1,  257,   -1,   -1,   -1,   -1,  262,  263,
  264,  265,  266,  267,  268,   -1,   -1,   -1,  272,  273,
  274,   -1,   -1,  346,   -1,  348,   -1,  350,   -1,  352,
   -1,  354,  286,  287,   -1,   -1,   -1,   -1,   -1,  293,
  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,
   -1,   -1,   -1,   -1,   -1,   -1,  310,  311,  312,   -1,
  314,   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,
   -1,   -1,  257,   -1,   -1,   -1,   -1,  262,  263,  264,
  265,  266,  267,  268,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,  346,   -1,  348,   -1,  350,   -1,  352,   -1,
  354,  286,  287,   -1,   -1,   -1,   -1,   -1,  293,  294,
  295,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,
   -1,   -1,   -1,   -1,   -1,  310,  311,  312,   -1,  314,
   -1,   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,
   -1,  257,   -1,   -1,   -1,   -1,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,  272,  273,  274,   -1,
   -1,  346,   -1,  348,   -1,  350,   -1,  352,   -1,  354,
  286,  287,   -1,   -1,   -1,   -1,   -1,  293,  294,  295,
   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,   -1,
   -1,   -1,   -1,   -1,  310,  311,  312,   -1,  314,   -1,
   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,   -1,
  257,   -1,   -1,   -1,   -1,   -1,  263,   -1,   -1,   -1,
  267,   -1,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  346,   -1,  348,   -1,  350,   -1,  352,   -1,  354,  286,
  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,  295,   -1,
   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  257,   -1,  314,   -1,   -1,
   -1,  263,   -1,   -1,  321,  267,   -1,  269,  325,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  286,  287,   -1,   -1,   -1,   -1,
  347,   -1,  294,  295,   -1,   -1,   -1,  354,   -1,   -1,
  302,  303,  257,  305,  306,   -1,   -1,   -1,  310,  311,
   -1,   -1,  314,   -1,  269,   -1,  271,   -1,  273,  321,
   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,  287,  335,  336,  337,  338,  339,  340,  294,
  295,   -1,   -1,   -1,   -1,  347,   -1,  302,  303,  257,
  305,  306,  354,   -1,  262,  310,  311,   -1,   -1,  314,
   -1,  269,   -1,  271,  272,   -1,  321,   -1,   -1,   -1,
  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,  287,
  335,  336,  337,  338,  339,  340,  294,  295,   -1,   -1,
   -1,   -1,  347,  348,  302,  303,  257,  305,  306,  354,
   -1,  262,  310,  311,   -1,   -1,  314,   -1,  269,   -1,
  271,  272,   -1,  321,   -1,   -1,   -1,  325,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,  287,  335,  336,  337,
  338,  339,  340,  294,  295,   -1,   -1,   -1,   -1,  347,
   -1,  302,  303,  257,  305,  306,  354,   -1,   -1,  310,
  311,   -1,  266,  314,   -1,  269,   -1,  271,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  286,  287,  335,  336,  337,  338,  339,  340,
  294,  295,   -1,   -1,   -1,   -1,  347,   -1,  302,  303,
  257,  305,  306,  354,   -1,   -1,  310,  311,   -1,   -1,
  314,   -1,  269,   -1,  271,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
  287,  335,  336,  337,  338,  339,  340,  294,  295,   -1,
   -1,   -1,   -1,  347,   -1,  302,  303,   -1,  305,  306,
  354,   -1,   -1,  310,  311,  257,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,  269,  325,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  286,  287,   -1,   -1,   -1,  346,
  347,  293,  294,  295,   -1,   -1,   -1,  354,   -1,   -1,
  302,  303,   -1,  305,  306,   -1,   -1,   -1,  310,  311,
  257,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,  321,
   -1,   -1,  269,  325,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,  286,
  287,   -1,   -1,   -1,   -1,  347,  293,  294,  295,   -1,
   -1,   -1,  354,   -1,   -1,  302,  303,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  257,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  321,   -1,   -1,  269,  325,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  286,  287,   -1,   -1,   -1,   -1,
  347,  293,  294,  295,   -1,   -1,   -1,  354,   -1,   -1,
  302,  303,  257,  305,  306,   -1,   -1,   -1,  310,  311,
   -1,   -1,  314,   -1,  269,   -1,  271,  272,   -1,  321,
   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,  287,  335,  336,  337,  338,  339,  340,  294,
  295,   -1,   -1,   -1,   -1,  347,   -1,  302,  303,  257,
  305,  306,  354,   -1,   -1,  310,  311,   -1,   -1,  314,
   -1,  269,   -1,  271,  272,   -1,  321,   -1,   -1,   -1,
  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,  287,
  335,  336,  337,  338,  339,  340,  294,  295,   -1,   -1,
   -1,   -1,  347,   -1,  302,  303,   -1,  305,  306,  354,
   -1,   -1,  310,  311,  257,   -1,  314,   -1,   -1,   -1,
  263,   -1,   -1,  321,   -1,   -1,  269,  325,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,
  338,  339,  340,  286,  287,   -1,   -1,   -1,   -1,  347,
   -1,  294,  295,   -1,   -1,   -1,  354,   -1,   -1,  302,
  303,  257,  305,  306,   -1,   -1,   -1,  310,  311,  265,
   -1,  314,   -1,  269,   -1,  271,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,  287,  335,  336,  337,  338,  339,  340,  294,  295,
   -1,   -1,   -1,   -1,  347,   -1,  302,  303,  257,  305,
  306,  354,   -1,   -1,  310,  311,  265,   -1,  314,   -1,
  269,   -1,  271,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,  287,  335,
  336,  337,  338,  339,  340,  294,  295,   -1,   -1,   -1,
   -1,  347,   -1,  302,  303,  257,  305,  306,  354,   -1,
   -1,  310,  311,  265,   -1,  314,   -1,  269,   -1,  271,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,  287,  335,  336,  337,  338,
  339,  340,  294,  295,   -1,   -1,   -1,   -1,  347,   -1,
  302,  303,   -1,  305,  306,  354,   -1,   -1,  310,  311,
  257,   -1,  314,   -1,   -1,   -1,  263,   -1,   -1,  321,
   -1,   -1,  269,  325,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,  286,
  287,   -1,   -1,   -1,   -1,  347,   -1,  294,  295,   -1,
   -1,   -1,  354,   -1,   -1,  302,  303,   -1,  305,  306,
   -1,   -1,   -1,  310,  311,  257,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  267,   -1,  269,  325,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  286,  287,   -1,   -1,   -1,   -1,
  347,   -1,  294,  295,   -1,   -1,   -1,  354,   -1,   -1,
  302,  303,  257,  305,  306,   -1,   -1,   -1,  310,  311,
   -1,   -1,  314,   -1,  269,   -1,  271,  272,   -1,  321,
   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,  287,  335,  336,  337,  338,  339,  340,  294,
  295,   -1,   -1,   -1,   -1,  347,   -1,  302,  303,  257,
  305,  306,  354,   -1,   -1,  310,  311,   -1,   -1,  314,
   -1,  269,   -1,  271,  272,   -1,  321,   -1,   -1,   -1,
  325,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,  287,
  335,  336,  337,  338,  339,  340,  294,  295,   -1,   -1,
   -1,   -1,  347,   -1,  302,  303,  257,  305,  306,  354,
   -1,   -1,  310,  311,   -1,   -1,  314,   -1,  269,   -1,
  271,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,  287,  335,  336,  337,
  338,  339,  340,  294,  295,   -1,   -1,   -1,   -1,  347,
   -1,  302,  303,   -1,  305,  306,  354,   -1,   -1,  310,
  311,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
   -1,   -1,   -1,   -1,   -1,   -1,  347,   -1,   -1,  257,
   -1,   -1,   -1,  354,  262,  263,  264,  265,  266,  267,
  268,   -1,   -1,   -1,  272,  273,  274,  257,   -1,   -1,
   -1,   -1,  262,  263,  264,  265,  266,  267,  268,  287,
   -1,   -1,  272,  273,  274,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  287,   -1,   -1,
   -1,   -1,  310,  293,  312,   -1,  314,   -1,   -1,   -1,
   -1,   -1,   -1,  321,   -1,   -1,   -1,   -1,   -1,   -1,
  310,   -1,  312,   -1,  314,   -1,   -1,   -1,   -1,   -1,
   -1,  321,   -1,   -1,   -1,   -1,   -1,   -1,  346,   -1,
  348,   -1,  350,   -1,  352,   -1,  354,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  346,   -1,  348,   -1,
  350,  257,  352,   -1,  354,   -1,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,  272,  273,  274,  257,
   -1,   -1,   -1,   -1,  262,  263,  264,  265,  266,  267,
  268,  287,   -1,   -1,  272,  273,  274,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  287,
   -1,   -1,   -1,   -1,  310,  293,  312,   -1,  314,   -1,
   -1,   -1,   -1,  261,   -1,  321,   -1,   -1,  266,   -1,
   -1,   -1,  310,   -1,  312,  261,  314,   -1,   -1,   -1,
   -1,   -1,   -1,  321,   -1,   -1,   -1,   -1,   -1,   -1,
  346,   -1,  348,   -1,  350,   -1,  352,   -1,  354,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,  346,   -1,
  348,  309,  350,   -1,  352,   -1,  354,  315,  316,  305,
   -1,   -1,  320,  309,   -1,   -1,  324,  325,   -1,  315,
  316,   -1,   -1,  319,  320,   -1,   -1,   -1,  324,  325,
   -1,   -1,   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  353,   -1,  355,  344,   -1,
  262,  263,  264,  265,  266,  267,  268,  353,   -1,  355,
  272,  273,  274,   -1,   -1,   -1,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,  287,  272,  273,  274,   -1,
   -1,  293,  262,  263,  264,  265,  266,  267,  268,   -1,
   -1,  287,  272,  273,  274,   -1,   -1,  293,   -1,   -1,
  312,   -1,  314,   -1,   -1,   -1,   -1,  287,   -1,  321,
   -1,   -1,   -1,  293,   -1,   -1,  312,   -1,  314,   -1,
   -1,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,   -1,
   -1,   -1,  312,   -1,  346,   -1,  348,   -1,  350,   -1,
  352,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  346,   -1,  348,   -1,  350,   -1,  352,   -1,  354,  257,
   -1,   -1,   -1,   -1,   -1,   -1,  346,   -1,  348,   -1,
  350,  269,  352,  271,  354,  262,  263,  264,  265,  266,
  267,  268,   -1,   -1,   -1,  272,  273,  274,  286,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  294,  295,   -1,   -1,
  287,   -1,   -1,   -1,  302,  303,  293,  305,  306,   -1,
   -1,   -1,  310,  311,   -1,   -1,  314,   -1,   -1,   -1,
   -1,   -1,   -1,  321,   -1,  312,   -1,  325,   -1,   -1,
   -1,  257,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,
  338,  339,  340,  269,   -1,  271,   -1,   -1,   -1,  347,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  346,
  286,  348,   -1,  350,   -1,  352,   -1,  354,  294,  295,
   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,   -1,  305,
  306,   -1,   -1,   -1,  310,  311,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,  272,  273,  274,  325,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,
  336,  337,  338,  339,  340,   -1,   -1,  293,   -1,   -1,
   -1,  347,   -1,  262,  263,  264,  265,  266,  267,  268,
   -1,   -1,   -1,  272,  273,  274,  312,  262,  263,  264,
  265,  266,  267,  268,   -1,   -1,   -1,  272,  273,  274,
   -1,   -1,   -1,   -1,  293,  262,  263,  264,  265,  266,
  267,  268,   -1,   -1,   -1,  272,  273,  274,  293,   -1,
  346,   -1,  348,  312,  350,   -1,  352,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  293,  312,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  312,   -1,  346,   -1,  348,
   -1,  350,   -1,  352,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  346,   -1,  348,   -1,  350,   -1,  352,   -1,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  346,
   -1,  348,   -1,  350,   -1,  352,  286,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  294,  295,   -1,   -1,   -1,   -1,
   -1,   -1,  302,  303,   -1,  305,  306,   -1,   -1,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  325,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,
  340,   -1,   -1,   -1,   -1,   -1,   -1,  347,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 355
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_AND","T_BASE","T_BEGIN",
"T_BEHAVIOR","T_BUF","T_BY","T_CLOSE_ANGLE","T_CLOSE_BRACKET","T_CLOSE_CURLY",
"T_CLOSE_PAREN","T_COLON","T_COMMA","T_CONCAT","T_CONSTANT","T_DIV","T_DO",
"T_DOWNTO","T_ELSE","T_END","T_ENDBEHAVIOR","T_ENDMACRO","T_ENDMODEL",
"T_ENDMODULE","T_ENDROUTINE","T_ENDSELECT","T_ENDSELECTALL","T_ENDSELECTONE",
"T_ENTRY","T_EQ","T_EQL","T_EQV","T_EXIT","T_EXTERNAL","T_FOR","T_FORWARD",
"T_FOURSTATE","T_FROM","T_GEQ","T_GTR","T_HALT","T_IF","T_INFORM","T_INPUT",
"T_INVALID","T_LEAVE","T_LEQ","T_LSS","T_MACRO","T_MINUS","T_MOD","T_MODEL",
"T_MODULE","T_NAME","T_NAND","T_NEQ","T_NEXT","T_NOENTRY","T_NOR","T_NOT",
"T_NUMBER","T_OPEN_ANGLE","T_OPEN_BRACKET","T_OPEN_CURLY","T_OPEN_PAREN","T_OR",
"T_OTHERWISE","T_OUTPUT","T_OXT","T_PLUS","T_PORT","T_PRINT","T_REPEAT",
"T_RETURN","T_REVISION","T_ROUTINE","T_SELECT","T_SELECTALL","T_SELECTONE",
"T_SL0","T_SL1","T_SLR","T_SR0","T_SR1","T_SRR","T_STATE","T_STATIC","T_STRING",
"T_SXT","T_SYNONYM","T_THEN","T_TIMES","T_TO","T_TWOSTATE","T_UNTIL","T_VAR",
"T_WHILE","T_WIDTH","T_XOR","T_ZXT",
};
char *yyrule[] = {
"$accept : model_or_routine",
"model_or_routine : model",
"model_or_routine : behavior_stmts",
"model : model_header behavior model_trailer",
"model_header : T_MODEL name opt_arg_list T_EQ opt_arg_list T_NEXT",
"model_trailer : T_ENDMODEL opt_name T_NEXT",
"behavior : behavior_header behavior_stmts behavior_trailer",
"behavior_header :",
"behavior_header : T_BEHAVIOR opt_name T_NEXT",
"behavior_trailer :",
"behavior_trailer : T_ENDBEHAVIOR opt_name T_NEXT",
"behavior_stmts :",
"behavior_stmts : behavior_stmts behavior_stmt",
"behavior_stmt : global_decl T_NEXT",
"behavior_stmt : insertion T_NEXT",
"global_decl : T_FORWARD T_ROUTINE const_identifier opt_routine_args",
"global_decl : port_decl",
"global_decl : T_REVISION T_NUMBER",
"global_decl : routine",
"global_decl : local_declaration",
"insertion : T_INFORM string",
"routine : routine_header T_NEXT routine_body T_ENDROUTINE opt_name",
"routine_header : routine_head1 opt_routine_args",
"routine_head1 : T_ROUTINE const_identifier",
"opt_routine_args :",
"opt_routine_args : T_OPEN_PAREN opt_arg_list T_CLOSE_PAREN",
"opt_arg_list :",
"opt_arg_list : arg_list",
"arg_list : const_identifier",
"arg_list : T_VAR const_identifier",
"arg_list : arg_list T_COMMA const_identifier",
"arg_list : arg_list T_COMMA T_VAR const_identifier",
"routine_body :",
"routine_body : routine_body routine_stmts",
"routine_stmts : local_declaration T_NEXT",
"routine_stmts : insertion T_NEXT",
"routine_stmts : lstmt T_NEXT",
"opt_name :",
"opt_name : name",
"local_declaration : state_decl",
"local_declaration : const_decl",
"local_declaration : synonym_decl",
"port_decl : T_PORT port_list",
"port_list : port",
"port_list : port_list T_COMMA port",
"port : const_identifier",
"port : const_identifier port_modifiers",
"state_decl : T_STATE state_list",
"state_list : state",
"state_list : state_list T_COMMA state",
"state : const_identifier",
"state : const_identifier port_modifiers",
"synonym_decl : T_SYNONYM synonym_list",
"synonym_list : synonym",
"synonym_list : synonym_list T_COMMA synonym",
"synonym : const_identifier T_EQ const_identifier",
"const_decl : T_CONSTANT const_list",
"const_list : dconstant",
"const_list : const_list T_COMMA dconstant",
"dconstant : const_identifier T_EQ constant",
"const_identifier : name",
"const_identifier : name T_OPEN_ANGLE T_CLOSE_ANGLE",
"const_identifier : name T_OPEN_ANGLE expression T_CLOSE_ANGLE",
"const_identifier : name T_OPEN_ANGLE expression T_COLON expression T_CLOSE_ANGLE",
"lstmt : stmt",
"lstmt : name T_COLON stmt",
"stmt : T_BEGIN stmt_list T_END",
"stmt : expression",
"stmt : identifier T_EQ expression",
"stmt : identifier T_EQ T_OPEN_CURLY T_NUMBER T_CLOSE_CURLY expression",
"stmt : if_statement",
"stmt : select_statement",
"stmt : for_statement",
"stmt : leave_statement",
"stmt : return_statement",
"stmt : print_statement",
"stmt : while_statement",
"stmt : until_statement",
"stmt : do_until_statement",
"stmt : do_while_statement",
"stmt : repeat_statement",
"stmt : T_HALT",
"stmt : error T_NEXT",
"stmt_list : lstmt T_NEXT",
"stmt_list : stmt_list lstmt T_NEXT",
"for_statement : T_FOR identifier T_FROM expression T_TO expression T_DO lstmt",
"for_statement : T_FOR identifier T_FROM expression T_TO expression T_BY expression T_DO lstmt",
"for_statement : T_FOR identifier T_FROM expression T_DOWNTO expression T_DO lstmt",
"for_statement : T_FOR identifier T_FROM expression T_DOWNTO expression T_BY expression T_DO lstmt",
"if_statement : T_IF expression T_THEN lstmt",
"if_statement : T_IF expression T_THEN lstmt T_ELSE lstmt",
"select_statement : T_SELECT expression T_FROM select_list T_ENDSELECT",
"select_statement : T_SELECTONE expression T_FROM select_list T_ENDSELECTONE",
"select_statement : T_SELECTALL expression T_FROM select_list T_ENDSELECTALL",
"leave_statement : T_LEAVE name",
"return_statement : T_RETURN",
"return_statement : T_RETURN expression",
"select_list : select_body",
"select_list : select_list select_body",
"select_body : T_OPEN_BRACKET select_case_list T_CLOSE_BRACKET T_COLON lstmt T_NEXT",
"select_body : T_OPEN_BRACKET select_case_list T_CLOSE_BRACKET T_COLON T_NEXT",
"select_case_list : select_case",
"select_case_list : select_case_list T_COMMA select_case",
"select_case : expression",
"select_case : expression T_COLON expression",
"select_case : T_OTHERWISE",
"while_statement : T_WHILE expression T_DO lstmt",
"until_statement : T_UNTIL expression T_DO lstmt",
"do_until_statement : T_DO lstmt T_UNTIL expression",
"do_while_statement : T_DO lstmt T_WHILE expression",
"repeat_statement : T_REPEAT lstmt",
"print_statement : T_PRINT T_OPEN_PAREN p_list T_CLOSE_PAREN",
"p_list : p_expr",
"p_list : p_list T_COMMA p_expr",
"p_expr :",
"p_expr : T_STRING",
"p_expr : expression",
"expression : identifier",
"expression : constant",
"expression : T_OPEN_PAREN expression T_CLOSE_PAREN",
"expression : T_OPEN_PAREN expression T_CLOSE_PAREN bit_subscripts",
"expression : routine_call",
"expression : T_NOT expression",
"expression : T_BUF expression",
"expression : T_WIDTH expression",
"expression : T_PLUS expression",
"expression : T_MINUS expression",
"expression : expression T_AND expression",
"expression : expression T_NAND expression",
"expression : expression T_OR expression",
"expression : expression T_NOR expression",
"expression : expression T_XOR expression",
"expression : expression T_EQV expression",
"expression : expression T_SL0 expression",
"expression : expression T_SR0 expression",
"expression : expression T_SL1 expression",
"expression : expression T_SR1 expression",
"expression : expression T_SLR expression",
"expression : expression T_SRR expression",
"expression : T_SXT T_OPEN_CURLY T_WIDTH T_EQ expression T_CLOSE_CURLY expression",
"expression : T_ZXT T_OPEN_CURLY T_WIDTH T_EQ expression T_CLOSE_CURLY expression",
"expression : T_OXT T_OPEN_CURLY T_WIDTH T_EQ expression T_CLOSE_CURLY expression",
"expression : expression T_CONCAT expression",
"expression : expression T_PLUS expression",
"expression : expression T_MINUS expression",
"expression : expression T_TIMES expression",
"expression : expression T_DIV expression",
"expression : expression T_MOD expression",
"expression : expression T_EQL expression",
"expression : expression T_NEQ expression",
"expression : expression T_GEQ expression",
"expression : expression T_LEQ expression",
"expression : expression T_GTR expression",
"expression : expression T_LSS expression",
"routine_call : name T_OPEN_PAREN T_CLOSE_PAREN",
"routine_call : name T_OPEN_PAREN expression_list T_CLOSE_PAREN",
"expression_list : expression",
"expression_list : expression_list T_COMMA expression",
"identifier : name",
"identifier : name bit_subscripts",
"bit_subscripts : T_OPEN_ANGLE T_CLOSE_ANGLE",
"bit_subscripts : T_OPEN_ANGLE expression T_CLOSE_ANGLE",
"bit_subscripts : T_OPEN_ANGLE expression T_COLON expression T_CLOSE_ANGLE",
"constant : number",
"constant : number T_BASE number",
"constant : name T_BASE number",
"name : T_NAME",
"number : T_NUMBER",
"string : T_STRING",
"port_modifiers : port_modifier",
"port_modifiers : port_modifiers port_modifier",
"port_modifier : T_INPUT",
"port_modifier : T_OUTPUT",
"port_modifier : T_ENTRY T_OPEN_PAREN T_NAME T_CLOSE_PAREN",
"port_modifier : T_NOENTRY",
"port_modifier : T_TWOSTATE",
"port_modifier : T_FOURSTATE",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
#ifdef __cplusplus
extern "C" { 
char * getenv();
int yylex();
int yyparse();
}

#endif
int
#if defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
#ifndef __cplusplus
    extern char *getenv();
#endif

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 262 "yybdsyn.y"
{got_a_model = 1;}
break;
case 2:
#line 264 "yybdsyn.y"
{got_a_model = 0;}
break;
case 4:
#line 271 "yybdsyn.y"
{node *p;
			 model_name = yyvsp[-4].strval;
			 for(p = yyvsp[-3].expr; p != NIL(node); p = p->next) {
			    yacc_define_symbol(p, T_IS_OUTPUT_PORT);
			 }
			 for(p = yyvsp[-1].expr; p != NIL(node); p = p->next) {
			    yacc_define_symbol(p, T_IS_INPUT_PORT);
			 }
			 input_ports = node_reverse(yyvsp[-1].expr);
			 output_ports = node_reverse(yyvsp[-3].expr);
			}
break;
case 5:
#line 285 "yybdsyn.y"
{if (yyvsp[-1].strval != NIL(char)) {
			    if (upper_strcmp(model_name, yyvsp[-1].strval) != 0) {
			        yyerror("MODEL name and ENDMODEL name should match");
			    }
			    FREE(yyvsp[-1].strval);
			 }
			}
break;
case 8:
#line 299 "yybdsyn.y"
{if (yyvsp[-1].strval != NIL(char)) FREE(yyvsp[-1].strval);}
break;
case 10:
#line 304 "yybdsyn.y"
{if (yyvsp[-1].strval != NIL(char)) FREE(yyvsp[-1].strval);}
break;
case 15:
#line 316 "yybdsyn.y"
{yacc_define_routine(yyvsp[-1].expr, yyvsp[0].expr, /*forward_decl*/ 1);
			 FREE(yyvsp[-1].expr); if (yyvsp[0].expr != NIL(node)) node_dispose(yyvsp[0].expr);
			}
break;
case 20:
#line 326 "yybdsyn.y"
{(void) fprintf(stderr, "%s\n", yyvsp[0].strval); FREE(yyvsp[0].strval); yyval.expr = NIL(node);}
break;
case 21:
#line 334 "yybdsyn.y"
{char buffer[256];
			 if (yyvsp[0].strval != NIL(char)) {
			     if (upper_strcmp(yyvsp[0].strval, yyvsp[-4].expr->un.bdvar.name->name) != 0) {
			         yyerror("ROUTINE name and ENDROUTINE name should match");
			     }
			     FREE(yyvsp[0].strval); 
			 }
			 /* wrap a LABEL around the routine */
			 (void) strcpy(buffer, "_LABEL:");
			 (void) strcat(buffer, routine_name);
			 MAKE_LABEL(yyval.expr, buffer, yyvsp[-2].expr);
			 yyvsp[-4].expr->un.bdvar.name->u.routine.body = yyval.expr;

			 /* save the local symbol table and reset it to NIL */
			 yyvsp[-4].expr->un.bdvar.name->u.routine.locals = local_syms;
			 local_syms = NIL(symbol_table);
			 FREE(yyvsp[-4].expr); 
			 yyval.expr = NIL(node);
			}
break;
case 22:
#line 356 "yybdsyn.y"
{yacc_define_routine(yyvsp[-1].expr, yyvsp[0].expr, /*forward_decl*/ 0);}
break;
case 23:
#line 359 "yybdsyn.y"
{local_syms = symtab_init(LOCAL_SYMTAB_SIZE); 
			 routine_name = yyvsp[0].expr->un.bdvar.name->name;
			 yyval.expr = yyvsp[0].expr;
			}
break;
case 24:
#line 366 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 25:
#line 368 "yybdsyn.y"
{yyval.expr = yyvsp[-1].expr;}
break;
case 26:
#line 372 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 29:
#line 378 "yybdsyn.y"
{yyval.expr = yyvsp[0].expr; yyval.expr->un.bdvar.var = 1;}
break;
case 30:
#line 380 "yybdsyn.y"
{yyval.expr = cons(yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 31:
#line 382 "yybdsyn.y"
{yyval.expr = cons(yyvsp[-3].expr, yyvsp[0].expr); yyvsp[0].expr->un.bdvar.var = 1;}
break;
case 32:
#line 386 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 33:
#line 388 "yybdsyn.y"
{yyval.expr = slow_node_append(yyvsp[-1].expr, yyvsp[0].expr);}
break;
case 37:
#line 396 "yybdsyn.y"
{yyval.strval = NIL(char);}
break;
case 39:
#line 406 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 40:
#line 408 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 41:
#line 410 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 45:
#line 420 "yybdsyn.y"
{FREE(yyvsp[0].expr);}
break;
case 46:
#line 422 "yybdsyn.y"
{FREE(yyvsp[-1].expr);}
break;
case 50:
#line 432 "yybdsyn.y"
{yacc_define_symbol(yyvsp[0].expr, yyvsp[0].expr->type); FREE(yyvsp[0].expr);}
break;
case 51:
#line 434 "yybdsyn.y"
{yacc_define_symbol(yyvsp[-1].expr, yyvsp[-1].expr->type); FREE(yyvsp[-1].expr);}
break;
case 55:
#line 444 "yybdsyn.y"
{yacc_define_synonym(yyvsp[-2].expr, yyvsp[0].expr); FREE(yyvsp[-2].expr); FREE(yyvsp[0].expr);}
break;
case 59:
#line 454 "yybdsyn.y"
{yacc_define_constant(yyvsp[-2].expr, yyvsp[0].expr); FREE(yyvsp[-2].expr); FREE(yyvsp[0].expr);}
break;
case 60:
#line 460 "yybdsyn.y"
{MAKE_VAR(yyval.expr, T_IS_STATE, yyvsp[0].strval, 1, 0, 0); FREE(yyvsp[0].strval);}
break;
case 61:
#line 462 "yybdsyn.y"
{MAKE_VAR(yyval.expr, T_IS_META, yyvsp[-2].strval, 0, 31, 0); FREE(yyvsp[-2].strval);}
break;
case 62:
#line 464 "yybdsyn.y"
{yyval.expr = yacc_make_variable(yyvsp[-3].strval, T_IS_STATE, yyvsp[-1].expr, NIL(node));}
break;
case 63:
#line 466 "yybdsyn.y"
{yyval.expr = yacc_make_variable(yyvsp[-5].strval, T_IS_STATE, yyvsp[-3].expr, yyvsp[-1].expr);}
break;
case 65:
#line 474 "yybdsyn.y"
{MAKE_LABEL(yyval.expr, yyvsp[-2].strval, yyvsp[0].expr);}
break;
case 66:
#line 478 "yybdsyn.y"
{yyval.expr = node_reverse(yyvsp[-1].expr);}
break;
case 67:
#line 480 "yybdsyn.y"
{yyval.expr = yyvsp[0].expr;}
break;
case 68:
#line 482 "yybdsyn.y"
{MAKE_ASSIGNMENT(yyval.expr, yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 69:
#line 484 "yybdsyn.y"
{MAKE_ASSIGNMENT(yyval.expr, yyvsp[-5].expr, yyvsp[0].expr);}
break;
case 81:
#line 497 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 82:
#line 499 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 84:
#line 504 "yybdsyn.y"
{yyval.expr = cons(yyvsp[-2].expr, yyvsp[-1].expr);}
break;
case 85:
#line 510 "yybdsyn.y"
{MAKE_FOR(yyval.expr, T_FOR, yyvsp[-6].expr, yyvsp[-4].expr, yyvsp[-2].expr, NIL(node), yyvsp[0].expr);}
break;
case 86:
#line 513 "yybdsyn.y"
{MAKE_FOR(yyval.expr, T_FOR, yyvsp[-8].expr, yyvsp[-6].expr, yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 87:
#line 516 "yybdsyn.y"
{MAKE_FOR(yyval.expr, T_FOR_DOWN, yyvsp[-6].expr, yyvsp[-4].expr, yyvsp[-2].expr, NIL(node), yyvsp[0].expr);}
break;
case 88:
#line 519 "yybdsyn.y"
{MAKE_FOR(yyval.expr, T_FOR_DOWN, yyvsp[-8].expr, yyvsp[-6].expr, yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 89:
#line 524 "yybdsyn.y"
{MAKE_IF(yyval.expr, yyvsp[-2].expr, yyvsp[0].expr, NIL(node));}
break;
case 90:
#line 526 "yybdsyn.y"
{MAKE_IF(yyval.expr, yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 91:
#line 531 "yybdsyn.y"
{MAKE_SELECT(yyval.expr, T_SELECT, yyvsp[-3].expr, yyvsp[-1].expr);}
break;
case 92:
#line 533 "yybdsyn.y"
{MAKE_SELECT(yyval.expr, T_SELECTONE, yyvsp[-3].expr, yyvsp[-1].expr);}
break;
case 93:
#line 535 "yybdsyn.y"
{if (select_unique) 
			    {MAKE_SELECT(yyval.expr, T_SELECT, yyvsp[-3].expr, yyvsp[-1].expr);}
			 else 
			    {MAKE_SELECT(yyval.expr, T_SELECTALL, yyvsp[-3].expr, yyvsp[-1].expr);}
			}
break;
case 94:
#line 544 "yybdsyn.y"
{MAKE_LEAVE(yyval.expr, yyvsp[0].strval);}
break;
case 95:
#line 549 "yybdsyn.y"
{char buffer[256]; 
			 (void) strcpy(buffer, "_LABEL:");
			 (void) strcat(buffer, routine_name);
			 MAKE_LEAVE(yyval.expr, buffer);
			}
break;
case 96:
#line 555 "yybdsyn.y"
{char buffer[256]; node *ret;
			 (void) strcpy(buffer, "$"); 
			 (void) strcat(buffer, routine_name);
			 MAKE_ASSIGNMENT(ret, yacc_find_symbol(buffer), yyvsp[0].expr);
			 (void) strcpy(buffer, "_LABEL:");
			 (void) strcat(buffer, routine_name);
			 MAKE_LEAVE(ret->next, buffer);
			 yyval.expr = node_create(T_LABEL, yyfile, *yyline);
			 yyval.expr->un.label.name = yacc_lookup("");
			 yyval.expr->un.label.name->type = T_LABEL;
			 yyval.expr->un.label.stmt = ret;
			 yyval.expr->un.label.name->u.label.def = yyval.expr;
			}
break;
case 98:
#line 579 "yybdsyn.y"
{yyval.expr = cons(yyvsp[-1].expr, yyvsp[0].expr);}
break;
case 99:
#line 584 "yybdsyn.y"
{yyval.expr = node_create(T_CASE, yyfile, *yyline);
			yyval.expr->un.select.expr = node_reverse(yyvsp[-4].expr); 
			yyval.expr->un.select.bdcase = yyvsp[-1].expr;}
break;
case 100:
#line 588 "yybdsyn.y"
{yyval.expr = node_create(T_CASE, yyfile, *yyline);
			yyval.expr->un.select.expr = node_reverse(yyvsp[-3].expr); 
			yyval.expr->un.select.bdcase = NIL(node);}
break;
case 102:
#line 595 "yybdsyn.y"
{yyval.expr = cons(yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 104:
#line 600 "yybdsyn.y"
{yyval.expr = select_case_colon(yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 105:
#line 602 "yybdsyn.y"
{yyval.expr = node_create(T_OTHERWISE, yyfile, *yyline);}
break;
case 106:
#line 611 "yybdsyn.y"
{(void) fprintf(stderr, "WHILE ... DO ignored\n"); yyval.expr=NIL(node);}
break;
case 107:
#line 615 "yybdsyn.y"
{(void) fprintf(stderr, "UNTIL ... DO ignored\n"); yyval.expr=NIL(node);}
break;
case 108:
#line 619 "yybdsyn.y"
{(void) fprintf(stderr, "DO ... UNTIL ignored\n"); yyval.expr=NIL(node);}
break;
case 109:
#line 623 "yybdsyn.y"
{(void) fprintf(stderr, "DO ... WHILE ignored\n"); yyval.expr=NIL(node);}
break;
case 110:
#line 627 "yybdsyn.y"
{(void) fprintf(stderr, "REPEAT ignored\n"); yyval.expr=NIL(node);}
break;
case 111:
#line 631 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 119:
#line 649 "yybdsyn.y"
{yyval.expr = yyvsp[-1].expr;}
break;
case 120:
#line 651 "yybdsyn.y"
{yyval.expr = yyvsp[0].expr; yyvsp[0].expr->un.ternary.lexpr = yyvsp[-2].expr;}
break;
case 122:
#line 657 "yybdsyn.y"
{MAKE_UNARY(yyval.expr, T_NOT, yyvsp[0].expr);}
break;
case 123:
#line 659 "yybdsyn.y"
{MAKE_UNARY(yyval.expr, T_BUF, yyvsp[0].expr);}
break;
case 124:
#line 661 "yybdsyn.y"
{MAKE_UNARY(yyval.expr, T_WIDTH, yyvsp[0].expr);}
break;
case 125:
#line 665 "yybdsyn.y"
{MAKE_UNARY(yyval.expr, T_UNARY_PLUS, yyvsp[0].expr);}
break;
case 126:
#line 667 "yybdsyn.y"
{MAKE_UNARY(yyval.expr, T_UNARY_MINUS, yyvsp[0].expr);}
break;
case 127:
#line 671 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_AND, yyvsp[0].expr);}
break;
case 128:
#line 673 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_NAND, yyvsp[0].expr);}
break;
case 129:
#line 675 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_OR, yyvsp[0].expr);}
break;
case 130:
#line 677 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_NOR, yyvsp[0].expr);}
break;
case 131:
#line 679 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_XOR, yyvsp[0].expr);}
break;
case 132:
#line 681 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_EQV, yyvsp[0].expr);}
break;
case 133:
#line 685 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_SL0, yyvsp[0].expr);}
break;
case 134:
#line 687 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_SR0, yyvsp[0].expr);}
break;
case 135:
#line 689 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_SL1, yyvsp[0].expr);}
break;
case 136:
#line 691 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_SR1, yyvsp[0].expr);}
break;
case 137:
#line 693 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_SLR, yyvsp[0].expr);}
break;
case 138:
#line 695 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_SRR, yyvsp[0].expr);}
break;
case 139:
#line 700 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[0].expr, T_SXT, yyvsp[-2].expr);}
break;
case 140:
#line 703 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[0].expr, T_ZXT, yyvsp[-2].expr);}
break;
case 141:
#line 706 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[0].expr, T_OXT, yyvsp[-2].expr);}
break;
case 142:
#line 714 "yybdsyn.y"
{yyvsp[0].expr->conc = yyvsp[-2].expr; yyval.expr = yyvsp[0].expr;}
break;
case 143:
#line 718 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_PLUS, yyvsp[0].expr);}
break;
case 144:
#line 720 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_MINUS, yyvsp[0].expr);}
break;
case 145:
#line 722 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_TIMES, yyvsp[0].expr);}
break;
case 146:
#line 724 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_DIV, yyvsp[0].expr);}
break;
case 147:
#line 726 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_MOD, yyvsp[0].expr);}
break;
case 148:
#line 730 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_EQL, yyvsp[0].expr);}
break;
case 149:
#line 732 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_NEQ, yyvsp[0].expr);}
break;
case 150:
#line 734 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_GEQ, yyvsp[0].expr);}
break;
case 151:
#line 736 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_LEQ, yyvsp[0].expr);}
break;
case 152:
#line 738 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_GTR, yyvsp[0].expr);}
break;
case 153:
#line 740 "yybdsyn.y"
{MAKE_BINARY(yyval.expr, yyvsp[-2].expr, T_LSS, yyvsp[0].expr);}
break;
case 154:
#line 744 "yybdsyn.y"
{yyval.expr = yacc_find_routine(yyvsp[-2].strval, NIL(node));}
break;
case 155:
#line 746 "yybdsyn.y"
{yyval.expr = yacc_find_routine(yyvsp[-3].strval, yyvsp[-1].expr); FREE(yyvsp[-3].strval);}
break;
case 157:
#line 751 "yybdsyn.y"
{yyval.expr = cons(yyvsp[-2].expr, yyvsp[0].expr);}
break;
case 158:
#line 757 "yybdsyn.y"
{yyval.expr = yacc_find_symbol(yyvsp[0].strval); FREE(yyvsp[0].strval);}
break;
case 159:
#line 759 "yybdsyn.y"
{if (yyvsp[0].expr == NIL(node)) {
			    yyval.expr = yacc_find_symbol(yyvsp[-1].strval);
			 } else {
			    yyval.expr = yacc_hackup_tbit(yyvsp[0].expr, yacc_find_symbol(yyvsp[-1].strval));
			 }
			 FREE(yyvsp[-1].strval);
			}
break;
case 160:
#line 771 "yybdsyn.y"
{yyval.expr = NIL(node);}
break;
case 161:
#line 773 "yybdsyn.y"
{MAKE_TERNARY(yyval.expr, T_BIT, NIL(node), yyvsp[-1].expr, NIL(node));}
break;
case 162:
#line 776 "yybdsyn.y"
{MAKE_TERNARY(yyval.expr, T_BIT, NIL(node), yyvsp[-3].expr, yyvsp[-1].expr);}
break;
case 163:
#line 782 "yybdsyn.y"
{int dummy; MAKE_CONST(yyval.expr, yyvsp[0].strval, "10"); FREE(yyvsp[0].strval);}
break;
case 164:
#line 784 "yybdsyn.y"
{int dummy; MAKE_CONST(yyval.expr, yyvsp[-2].strval, yyvsp[0].strval); FREE(yyvsp[-2].strval); FREE(yyvsp[0].strval);}
break;
case 165:
#line 786 "yybdsyn.y"
{int dummy; MAKE_CONST(yyval.expr, yyvsp[-2].strval, yyvsp[0].strval); FREE(yyvsp[-2].strval); FREE(yyvsp[0].strval);}
break;
case 166:
#line 791 "yybdsyn.y"
{yyval.strval = SAVE_YYTEXT;}
break;
case 167:
#line 795 "yybdsyn.y"
{yyval.strval = SAVE_YYTEXT;}
break;
case 168:
#line 799 "yybdsyn.y"
{yyval.strval = SAVE_YYTEXT;}
break;
#line 2176 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
