/* RCS Info: $Revision: 1.1.1.1 $ on $Date: 2002/12/31 15:50:54 $
 *           $Source: /home/cvs/octtools/src/Synthesis/misII/graphics/graphics.h,v $
 * Copyright (c) 1988 Wayne A. Christopher, U. C. Berkeley CAD Group 
 *	 faustus@cad.berkeley.edu, ucbvax!faustus
 * Permission is granted to modify and re-distribute this code in any manner
 * as long as this notice is preserved.  All standard disclaimers apply.
 *
 * Converted to X11 by Rick L. Spickelmier
 *
 */

#ifndef GRAPHICS_H
#define GRAPHICS_H

typedef char plot_t;

typedef struct dg_node_s dg_node;

typedef struct dg_graph_s dg_graph;

typedef struct dg_arc_s dg_arc;

typedef char dg_plot;

typedef enum dg_nodeshape_e {
	DG_NO_SHAPE,
	DG_SQUARE,
	DG_RECTANGLE,
	DG_CIRCLE,
	DG_ELLIPSE,
	DG_TRIANGLE,
	DG_DIAMOND
} dg_nodeshape;

typedef enum dg_nodetype_e {
	DG_INPUT,
	DG_OUTPUT,
	DG_INTERNAL,
	DG_DUMMY,
	DG_UNKNOWN
} dg_nodetype;

typedef enum dg_linestyle_e {
	DG_NO_LINE,
	DG_SOLID,
	DG_DASHED,
	DG_DBLDASHED,
	DG_BAD_STYLE
} dg_linestyle;

typedef enum dg_outtype_e {
	DG_XWINDOW,
	DG_HPGL,
	DG_POSTSCRIPT,
	DG_LPR
} dg_outtype;

extern dg_graph *dg_alloc();
extern void dg_free();
extern dg_node * dg_create_node();
extern void dg_delete_node();
extern void dg_set_node_props();
extern void dg_get_node_props();
extern dg_arc *dg_create_arc();
extern void dg_delete_arc();
extern void dg_set_arc_props();
extern void dg_get_arc_props();
extern dg_plot *dg_draw();
extern void dg_kill();
extern char **makeLines();
extern void freeLines();

extern plot_t *graphics_plot();
extern void graphics_kill();

#endif
