/* RCS Info: $Revision: 1.1.1.1 $ on $Date: 2002/12/31 15:50:54 $
 *           $Source: /home/cvs/octtools/src/Synthesis/misII/graphics/outdev.c,v $
 * Copyright (c) 1988 Wayne A. Christopher, U. C. Berkeley CAD Group 
 *     faustus@cad.berkeley.edu, ucbvax!faustus
 * Permission is granted to modify and re-distribute this code in any manner
 * as long as this notice is preserved.  All standard disclaimers apply.
 *
 * Converted to X11 by Rick L. Spickelmier
 *
 */

#include "port.h"
#include "graphics_int.h"

#ifndef NO_X
extern dg_outdev dg_xwindow_dev;
#endif /* NO_X */

/*
extern dg_outdev dg_hpgl_dev;
extern dg_outdev dg_postscript_dev;
extern dg_outdev dg_lpr_dev;
*/

static dg_outdev *dev = NULL;

void
dg_setdev(type)
    dg_outtype type;
{
    switch (type) {
        case DG_XWINDOW:
#ifndef NO_X
        dev = &dg_xwindow_dev;
#endif /* NO_X */
        break;

        /*
        case DG_HPGL:
        dev = &dg_hpgl_dev;
        break;

        case DG_POSTSCRIPT:
        dev = &dg_postscript_dev;
        break;


        case DG_LPR:
        dev = &dg_lpr_dev;
        break;
    */

        default:
        assert(0);
    }

    return;
}

dg_plot *
dg_open(window, arg, xlo, ylo, xhi, yhi, label)
    dg_plot *window;
    char *arg;
    int xlo, ylo;
    int xhi, yhi;
    char *label;
{
    return ((*dev->open) (window, arg, xlo, ylo, xhi, yhi, label));
}

void
dg_calc_sizes(win, shape, font, numlines, lines, widthp, heightp)
    dg_plot *win;
    dg_nodeshape shape;
    char *font;
    int numlines;
    char **lines;
    int *widthp, *heightp;
{
    (*dev->calc_sizes)(win, shape, font, numlines, lines, widthp, heightp);
    return;
}

void
dg_draw_node(win, xpos, ypos, shape, color, font, numlines, lines,
        width, height)
    dg_plot *win;
    int xpos;
    int ypos;
    dg_nodeshape shape;
    char *color;
    char *font;
    int numlines;
    char **lines;
    int width, height;
{
    (*dev->draw_node)(win, xpos, ypos, shape, color, font, numlines, lines,
            width, height);
    return;
}

void
dg_draw_arc(win, fx, fy, tx, ty, color, style, label, arr, save,
        fromshape, fromwidth, fromheight, toshape, towidth, toheight)
    dg_plot *win;
    int fx, fy;
    int tx, ty;
    char *color;
    dg_linestyle style;
    char *label;
    int arr;
    int save;
{
    (*dev->draw_arc)(win, fx, fy, tx, ty, color, style, label, arr, save,
            fromshape, fromwidth, fromheight, toshape, towidth,
            toheight);
    return;
}

void
dg_update(win)
    dg_plot *win;
{
    (*dev->update)(win);
    return;
}

void
dg_close(win)
    dg_plot *win;
{
    (*dev->close)(win);
    return;
}
